<?php
/**
 * calls_table_active.php
 */
require_once(dirname(__FILE__).'/vo_htmls_plain.php');
require_once(dirname(__FILE__).'/vo_htmls.php');
require_once(dirname(__FILE__).'/include/session.php');
require_once(dirname(__FILE__).'/include/functions.php');

function GenerateCallsTable_Active($calls) {
	global $session;

	if (!function_exists('getTableCellNormalValue')) {
		function getTableCellNormalValue($val, $asint = false, $wrap = false, $colorize = false) {
			$res = $val == '' ? $asint === true ? '0': '&nbsp;' : $val;
			if ($wrap === true)
				$res = wordwrap($res, 100, '<br />');
			//if ($colorize == true)
				//preg_replace("/('[^']*[^\/]')/", "q $2 $1 $3 \\1 \\2 \\3q", $res);
			return $res;
		}
	}
	if ($calls === null) {
?>
		<div class="textquote" style="width:400px;padding:10px;margin:10px;" align="left">
			<span class="sm" style="color: #666;"><img src="images/icon_error_big.gif" width="32" height="32" style="margin: -10px 10px -8px 0;" align="left" alt="">Ошибка при работе с БД статистики! Администратору системы необходимо проверить параметры подключения к БД.</span>
		</div>
<?php
		return false;
	}
?>
	<table class="nb" style="border-bottom:1px solid #ccc;display:none;overflow:scroll;width:700px;" id="tb_calls_active" cellspacing="0">
	<tr>
	<th class="infoTableHeader" width="32px">&nbsp;</th>
	<th class="infoTableHeader" width="40px">Дата/время</th>
	<th class="infoTableHeaderR" width="140px">Вызывающий</th>
	<th class="infoTableHeaderR" width="140px">Вызываемый</th>
	<th class="infoTableHeaderR" width="300px">Направление</th>
	</tr>
<?php
	$rec_num = 0;
	$dates = array();
	$prevdate = '';
	$invalidaccount = false;
	foreach ($calls as $row) {
		/*$serv = $row['log_changetype'];
		if ($serv < 0) {
			$invalidaccount = true;
			$rec_num++;
			break;
		}*/
		if ($rec_num > MAX_CHANGELOG_ROWS) // just in case ;)
			break;
		if (!is_string($row['calltime']))
			continue;

		$dt = date_parse($row['calltime']);
		$calltime = sprintf("%02d:%02d:%02d", $dt['hour'], $dt['minute'], $dt['second']);
		$dt = sprintf("%02d.%02d.%04d", $dt['day'], $dt['month'], $dt['year']);
		if ($dt != $prevdate) {
			$prevdate = $dt;
			$dates[] = array('date_str' => $dt, 'date_cnt' => 0);
			echo "<tr class=\"imglink\" onclick=\"toggleTableRowByCheckBox(null, 'toggle_ca_$prevdate', true, true)\" title=\"Свернуть/развернуть\">" .
				"<td align=\"left\" width=\"32px\">" .
					"<img id=\"imgtoggle_ca_$prevdate\" class=\"imglink\" style=\"margin-bottom:0;\" src=\"images/tree-expand3.gif\" width=\"16\" height=\"16\" alt=\"\">" .
				"</td>" .
				"<td colspan=\"6\">" .
					"<span class=\"imglinkblg hlblack\">$prevdate</span>" .
					"<span id=\"cnt_ca_$prevdate\" class=\"imglink sm vert blue\" style=\"padding-bottom:1px;\">&nbspЗаписей: <img src=\"images/loading_sm.gif\" width=\"10\" height=\"10\"></span>" .
				"</td>" .
				"</tr>";
		}
		echo "<tr id=\"toggle_ca_$prevdate\" class=\"bgsel\" style=\"display:none;\" onMouseOver=\"this.style.backgroundColor='#f5f5f5'\" onMouseOut=\"this.style.backgroundColor='#fff'\">";

		echo "<td>&nbsp</td>";
		echo "<td class=\"infoLineValue\">". getTableCellNormalValue($calltime) ."</td>";
		echo "<td class=\"infoLineValueR\">". getTableCellNormalValue($row['numbera']) ."</td>";
		echo "<td class=\"infoLineValueR\">". getTableCellNormalValue($row['numberb']) ."</td>";
		echo "<td class=\"infoLineValueR\">". getTableCellNormalValue($row['geographyname']) ."</td>";
		echo "</tr>";

		$rec_num++;
		$dates[count($dates) - 1]['date_cnt']++;
	}

	if ($rec_num == 0 || $invalidaccount === true) {
		?>
		</table>
		<?php
		echo GetJavaScriptCodeBlock("var obj = document.getElementById('tb_calls_active');if (obj) obj.parentNode.removeChild(obj);");
				$msg = $rec_num == 0 ?
						"В данный момент вызовы отсутствуют." :
						"Информация недоступна. Офис <span class=\"hlblack underlined\">$session->ofnumber</span> не зарегистрирован в подсистеме биллинга.";
		?>
		<div class="textquote" style="width:380px;padding:10px;margin:10px;" align="left">
			<span class="sm" style="color: #666;"><img src="images/icon_error_big.gif" width="32" height="32" style="margin: -10px 10px -8px 0;" align="left" alt=""><?php echo $msg ?></span>
		</div>
		<?php
	} else {
		echo "<tr><td colspan=\"7\" align=\"right\">&nbsp;</td></tr>";
		echo "<tr><td colspan=\"7\" align=\"right\" class=\"infoLineValueRNB\">Всего записей: <span class=\"hlblack\">$rec_num</span></td></tr>";
		?>
		</table>
		<?php
		//update date event counters
		$script = '';
		foreach ($dates as $dt)
			$script .= "updateDateEventsCounter_CallsActive('{$dt['date_str']}', {$dt['date_cnt']});\n";
		if (strlen($script) > 0) {
			$script = "function updateDateEventsCounter_CallsActive(date_str, date_cnt) {var obj = document.getElementById('cnt_ca_' + date_str);if (obj) obj.innerHTML = '&nbsp;&nbsp;Записей: ' + date_cnt;}\n"
				. $script;
			echo GetJavaScriptCodeBlock($script);
		}

		//restore all toggles first
		$script = '';
		foreach ($dates as $dt)
			$script .= "toggleTableRowByCheckBox(null, 'toggle_ca_{$dt['date_str']}', false, true);\n";
		if (strlen($script) > 0)
			echo GetJavaScriptCodeBlock($script);

		//open last date by default
		$script = '';
		$dt = $dates[count($dates) - 1];
		if ($dt)
			$script .= "toggleTableRowByCheckBox(null, 'toggle_ca_{$dt['date_str']}', true, true, true);\n";
		if (strlen($script) > 0)
			echo GetJavaScriptCodeBlock($script);
	}
	return 'tb_calls_active';
}
?>
