<?php
/**
 * changelog.php
 */
require_once(dirname(__FILE__).'/vo_htmls_plain.php');
require_once(dirname(__FILE__).'/vo_htmls.php');
require_once(dirname(__FILE__).'/changelog_table_office.php');
require_once(dirname(__FILE__).'/changelog_table_menus.php');
require_once(dirname(__FILE__).'/include/session.php');
require_once(dirname(__FILE__).'/include/database_dynmenu.php');
require_once(dirname(__FILE__).'/include/functions.php');

global $session, $database, $database_dynmenu;
if (!$session->db_ok) {
	print(GetClosedPageContent());
	die();
}

// current page properties
$current_page_name = basename($_SERVER['PHP_SELF']); 
foreach($session->userright as $key => $row) {
	if($row['action']==$current_page_name and $row['act_visible']==0){ $current_page_title = $row['act_name']; }
} 
$pagetitle = $current_page_title;
//$pagetitle = "История изменений настроек";

$tabfiles = <<<EOS
<script language="JavaScript" type="text/JavaScript" src="js/tabs.js"></script>
<link rel="stylesheet" type="text/css" href="styles/tabs.css" media="screen">
EOS;

print(GetHTMLHeader($pagetitle, null, $tabfiles));
print(GetPageTop());
?>

<div class="pagemain">

<div class="pageheader">
<table class="pageheader">
<tr>
	<td class="headleft">&nbsp;</td>
	<td class="headnav"><?php print(GetVOHeadMenu()); ?></td>
</tr>
</table>
</div>

<table class="pagecontent">
<tr>
<td class="menu"><?php print(GetVOMenu()); ?></td>
<td class="content">

<?php
//if ($session->logged_in && $session->isAnyAdmin()) {
if ($session->logged_in && $session->checkUserRight($current_page_name,'A')) {
	print(GetPageContentTitle($pagetitle));
?>
	<form name="frmmain_cl_top" action="process.php" method="post" onSubmit="return disableForms();">
		<input type="hidden" name="sub_changelog" value="1">
		<a title="Обновить страницу" onclick="disableForms();this.onclick='';window.location.href=window.location.pathname;">
			<img class="imglink" src="images/btn_refresh.gif" width="83" height="23" alt="Обновить">
		</a>
	</form>
	<div class="tabs" id="tabs-changelog" style="width:720px;">
		<div class="tab-content">
			<h1 class="tab" title="Офис">Офис</h1>
			<?php
				$changelog = $database->getChangelog($session->ofid);
				GenerateChangelogTable_Office($changelog);
			?>
		</div>
		<div class="tab-content">
			<h1 class="tab" title="Сценарий работы">Сценарий работы</h1>
			<?php
				$changelog = $database_dynmenu->getChangelog($session->ofmenuid);
				GenerateChangelogTable_Menus($changelog);
			?>
		</div>
	</div>
	<form name="frmmain_cl_bottom" action="process.php" method="post" onSubmit="return disableForms();">
		<input type="hidden" name="sub_changelog" value="1">
		<a title="Обновить страницу" onclick="disableForms();this.onclick='';window.location.href=window.location.pathname;">
			<img class="imglink" src="images/btn_refresh.gif" width="83" height="23" alt="Обновить">
		</a>
	</form>
	<script type="text/javascript">
	<!--
		BuildTabs('tabs-changelog');
		ActivateTab('tabs-changelog', getCookie('tabs-changelog' + '_activetab', '0'));
		var obj = document.getElementById('tb_changelog_office'); if (obj) obj.style.display = '';
		obj = document.getElementById('tb_changelog_menus'); if (obj) obj.style.display = '';
	//-->
	</script>
<?php
	unset($session->edit_changelog);
} else {
	print(GetPageContentTitle("Вход в систему"));
	print(GetVOLoginForm());
}
?>

</td> <!-- content -->
</tr>
</table> <!-- pagecontent -->
</div> <!-- pagemain -->

<div class="pagefooter">
<table class="pagefooter">
<tr><td class="footleft">&nbsp;</td><td class="footnav">&nbsp;</td></tr>
<tr><td colspan="2" class="footcopyright">&nbsp;<?php echo SITE_COPYRIGHT ?></td></tr>
</table>
</div>
<?php
print(GetHTMLFooter());
?>
