<?php
/**
 * stats_table.php
 */
require_once(dirname(__FILE__).'/vo_htmls_plain.php');
require_once(dirname(__FILE__).'/vo_htmls.php');
require_once(dirname(__FILE__).'/include/session.php');
require_once(dirname(__FILE__).'/include/functions.php');

function GenerateChangelogTable_Menus($changelog) {
	global $session;

	if (!function_exists('getTableCellNormalValue')) {
		function getTableCellNormalValue($val, $asint = false, $wrap = false, $colorize = false) {
			$res = $val == '' ? $asint === true ? '0': '&nbsp;' : $val;
			if ($wrap === true)
				$res = wordwrap($res, 100, '<br />');
			//if ($colorize == true)
				//preg_replace("/('\/?)(\w+)([^']*')/", "<i>'\\2'</i>", $res);
			return $res;
		}
	}
	if ($changelog === null) {
?>
		<div class="textquote" style="width:400px;padding:10px;margin:10px;" align="left">
			<span class="sm" style="color: #666;"><img src="images/icon_error_big.gif" width="32" height="32" style="margin: -10px 10px -8px 0;" align="left">Ошибка при работе с БД статистики! Администратору системы необходимо проверить параметры подключения к БД.</span>
		</div>
<?php
		return;
	}
?>
	<div id="voiceplayer2"></div>

	<form name="frmmain_cl_menus" action="process.php" method="post" onSubmit="return disableForm(this);">
	<input type="hidden" name="sub_changelog" value="1">

	<table class="nb" style="border-bottom:1px solid #ccc;display:none;" id="tb_changelog_menus" cellspacing="0">
	<tr>
	<th class="infoTableHeader" width="32px">&nbsp;</th>
	<th class="infoTableHeader" width="40px">Дата/время</th>
	<th class="infoTableHeader" width="140px">Тип</th>
	<th class="infoTableHeader" width="445px">Описание</th>
	</tr>
<?php
	$rec_num = 0;
	$dates = array();
	$prevdate = '';
	$invalidaccount = false;
	$needplayer = false;
	foreach ($changelog as $row) {
		$serv = $row['log_changetype'];
		if ($serv < 0) {
			$invalidaccount = true;
			$rec_num++;
			break;
		}
		if ($rec_num > MAX_CHANGELOG_ROWS) // just in case ;)
			break;
		if (!is_string($row['log_time']))
			continue;

		$dt = date_parse($row['log_time']);
		$createtime = sprintf("%02d:%02d:%02d", $dt['hour'], $dt['minute'], $dt['second']);
		$dt = sprintf("%02d.%02d.%04d", $dt['day'], $dt['month'], $dt['year']);
		if ($dt != $prevdate) {
			$prevdate = $dt;
			$dates[] = array('date_str' => $dt, 'date_cnt' => 0);
			echo "<tr class=\"imglink\" onclick=\"toggleTableRowByCheckBox(null, 'toggle_menus_$prevdate', true, true)\" title=\"Свернуть/развернуть\">" .
				"<td align=\"left\" width=\"32px\">" .
					"<img id=\"imgtoggle_menus_$prevdate\" class=\"imglink\" style=\"margin-bottom:0;\" src=\"images/tree-expand3.gif\" width=\"16px\" height=\"16px\" alt=\"\">" .
				"</td>" .
				"<td colspan=\"6\">" .
					"<span class=\"imglinkblg hlblack\">$prevdate</span>" .
					"<span id=\"cnt_menus_$prevdate\" class=\"imglink sm vert blue\" style=\"padding-bottom:1px;\">&nbspЗаписей: <img src=\"images/loading_sm.gif\" width=\"10\" height=\"10\"></span>" .
				"</td>" .
				"</tr>";
		}
		echo "<tr id=\"toggle_menus_$prevdate\" class=\"bgsel\" style=\"display:none;\" onMouseOver=\"this.style.backgroundColor='#f5f5f5'\" onMouseOut=\"this.style.backgroundColor='#fff'\">";

		switch ($serv) {
			case DB_TAR_SERVICETYPE_VOICE:
				//$row['recordid'] = 180;//Голосовое сообщение
				if (!empty($row['recordid'])) {
					$record_title = base64_encode(DB_TAR_SERVICETYPE_VOICE.'|'.$row['log_time'].'|'.$row['numbera'].' '.$row['numberb']);
					$rec = "<img class=\"imglink\" src=\"images/icon_voicemail.gif\" width=\"16px\" height=\"16px\" alt=\"Прослушать голосовое сообщение\" title=\"Прослушать голосовое сообщение\" " .
							"onclick=\"playVoice('{$row['recordid']}', '$record_title')\">";
					$rec .= "<img class=\"imglink\" src=\"images/save.gif\" width=\"16px\" height=\"16px\" alt=\"Сохранить голосовое сообщение\" title=\"Сохранить голосовое сообщение\" " .
							"onclick=\"saveVoice('{$row['recordid']}', '$record_title')\">";
					$needplayer = true;
				} else {
					$rec = "<img class=\"imglink\" style=\"margin-right:16px;\" src=\"images/icon_voicemail_dis.gif\" width=\"16px\" height=\"16px\" alt=\"Файл голосового сообщения был удалён из системы\" title=\"Файл голосового сообщения был удалён из системы\">";
				}
				break;
			default:
				$rec = '&nbsp';
		}

		echo "<td>$rec</td>";
		echo "<td class=\"infoLineValue\">". getTableCellNormalValue($createtime) ."</td>";
		echo "<td class=\"infoLineValue\">". getTableCellNormalValue(ChangelogLevelToText($row['log_changetype'])) ."</td>";
		echo "<td class=\"infoLineValueWrap\">". getTableCellNormalValue($row['log_msg'], false, false) ."</td>";
		echo "</tr>\n";

		$rec_num++;
		$dates[count($dates) - 1]['date_cnt']++;
	}

	if ($rec_num == 0 || $invalidaccount === true) {
		?>
		</table>
		<?php
		echo GetJavaScriptCodeBlock("var obj = document.getElementById('tb_changelog_menus');if (obj) obj.parentNode.removeChild(obj);");
		$msg = $rec_num == 0 ?
				"Информация недоступна. По офису <span class=\"hlblack underlined\">$session->ofnumber</span> нет записей." :
				"Информация недоступна. Офис <span class=\"hlblack underlined\">$session->ofnumber</span> не зарегистрирован в подсистеме биллинга.";
		//echo "<table class=\"nbpad\" id=\"emptytablenotice\"><tr><td class=\"iconinfo\">&nbsp;</td><td class=\"note\">$msg</td></tr></table>";
		?>
		<div class="textquote" style="width:480px;padding:10px;margin:10px;" align="left">
			<span class="sm" style="color: #666;"><img src="images/icon_error_big.gif" width="32" height="32" style="margin: -10px 10px -8px 0;" align="left"><?php echo $msg ?></span>
		</div>
		<?php
	} else {
		echo "<tr><td colspan=\"7\" align=\"right\">&nbsp;</td></tr>";
		echo "<tr><td colspan=\"7\" align=\"right\" class=\"infoLineValueRNB\">Всего записей: <span class=\"hlblack\">$rec_num</span></td></tr>";
		?>
		</table>
		<?php
		//update date event counters
		$script = '';
		foreach ($dates as $dt)
			$script .= "updateDateEventsCounter_Menus('{$dt['date_str']}', {$dt['date_cnt']});\n";
		if (strlen($script) > 0) {
			$script = "function updateDateEventsCounter_Menus(date_str, date_cnt) {var obj = document.getElementById('cnt_menus_' + date_str);if (obj) obj.innerHTML = '&nbsp;&nbsp;Записей: ' + date_cnt;}\n"
				. $script;
			echo GetJavaScriptCodeBlock($script);
		}

		//restore all toggles first
		$script = '';
		foreach ($dates as $dt)
			$script .= "toggleTableRowByCheckBox(null, 'toggle_menus_{$dt['date_str']}', false, true);\n";
		if (strlen($script) > 0)
			echo GetJavaScriptCodeBlock($script);

		//open last date by default
		$script = '';
		$dt = $dates[count($dates) - 1];
		if ($dt)
			$script .= "toggleTableRowByCheckBox(null, 'toggle_menus_{$dt['date_str']}', true, true, true);\n";
		if (strlen($script) > 0)
			echo GetJavaScriptCodeBlock($script);
		if ($needplayer) {
?>
			<script type="text/javascript">
			<!--
				if (!IsFlashEnabled()) writeGetFlashImage();
			// -->
			</script>
			<script type="text/javascript">
			<!--
				AudioPlayer.embed("voiceplayer2", {
					soundFile: "intro.mp3", //Для прослушивания записи разговора кликните на соответствующую иконку в строке таблицы
					artists: "",
					titles: "Файл не загружен",
					autostart: "no"
				});
			// -->
			</script>
<?php
		}
?>
		</form>
<?php
	}
	return 'tb_changelog_menus';
}
?>
