<?php
require_once 'System.php';
require_once(dirname(__FILE__).'/include/constants.php');
require_once(dirname(__FILE__).'/include/session.php');
require_once(dirname(__FILE__).'/include/database_dynmenu.php');
require_once(dirname(__FILE__).'/include/database_tar.php');
require_once(dirname(__FILE__).'/include/database.php');
require_once(dirname(__FILE__).'/include/functions.php');
require_once(dirname(__FILE__).'/include/fileserver.php');

$arrRes = array(
	'files' => $_FILES['synthz_add_file'],
	'description' => $_POST['synthz_add_file_description']
);
if (isset($_POST['fax_send_disa'])) {
	$arrRes['fax_send_disa'] = preg_replace('/[^\d\.]/', '', $_POST['fax_send_disa']);
}

function prepareVoiceFileForFileServer($filename, $fileismpeg = false) {
	global $logger;

	$outfile = System::mktemp('aout_');
	$cnvt = AUDIO_CONVERT_CALL_FMT_SAVE;
	$cnvt = str_ireplace('%infile%', $filename, $cnvt);
	$cnvt = str_ireplace('%outfile%', $outfile, $cnvt);
	unlink($outfile);
	$res = exec($cnvt);
	$logger->log("prepareVoiceFileForFileServer($filename)->$cnvt:$res");

	if (is_readable($outfile) && filesize($outfile) > 0) {
		$logger->log("prepareVoiceFileForFileServer($filename)->".filesize($outfile));
		return $outfile;
	}

	if ($fileismpeg) {
		$logger->log("prepareVoiceFileForFileServer($filename)->PROBLEM1->Trying to convert as MPEG");
		$cnvt = AUDIO_CONVERT_CALL_FMT_SAVE_MPEG;
		$cnvt = str_ireplace('%infile%', $filename, $cnvt);
		$cnvt = str_ireplace('%outfile%', $outfile, $cnvt);
		if (file_exists($outfile))
			unlink($outfile);
		$res = exec($cnvt);
		$logger->log("prepareVoiceFileForFileServer($filename, MPEG)->$cnvt:$res");

		if (is_readable($outfile) && filesize($outfile) > 0) {
			$logger->log("prepareVoiceFileForFileServer($filename, MPEG)->".filesize($outfile));
			return $outfile;
		}
	}

	$logger->log("prepareVoiceFileForFileServer($filename)->PROBLEM->Returning source file as result");
	return $filename;
}

function prepareFaxFileForFileServer($filename) {
	global $logger;

	$outfile = System::mktemp('aout_') . '.tiff';
	$cnvt = FAX_CONVERT_CALL_FMT_SAVE;
	$cnvt = str_ireplace('%infile%', $filename, $cnvt);
	$cnvt = str_ireplace('%outfile%', $outfile, $cnvt);
	$res = exec($cnvt);
	$logger->log("prepareFaxFileForFileServer($filename)->$cnvt:$res");

	if (is_readable($outfile) && filesize($outfile) > 0) {
		$logger->log("prepareFaxFileForFileServer($filename)->".filesize($outfile));
		return $outfile;
	} else {
		$logger->log("prepareFaxFileForFileServer($filename)->PROBLEM->Returning source file as result");
		return $filename;
	}
}

function sendDataFile($filename, $filetitle = '') {
	global $logger;
	$logger->log("sendDataFile($filename, '$filetitle')");

	$outfilename = empty($filetitle) ? $filename : $filetitle . '.mp3';

	header('Content-Description: File Transfer');
	header('Content-Type: audio/mpeg');
	header('Content-Disposition: attachment; filename="' . $outfilename . '"');  //basename($filename)
	header('Content-Transfer-Encoding: binary');
	header('Expires: 0');
	header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
	header('Pragma: public');
	header('Content-Length: ' . filesize($filename));

	ob_clean();
	flush();

	if (($fp = fopen($filename, 'r'))) {
		while (!feof($fp)) {
			$buff = fread($fp, 4096);
			print $buff;
		}
		fclose($fp);
		return true;
	}
	return false;
}

global $logger, $session, $database_dynmenu, $database_tar;
//$logger->log("REQUEST(".basename($_SERVER['SCRIPT_NAME']).":\n".print_r($_REQUEST, true));
$logger->log("SYN_UPLOAD:\n".$arrRes['description']."\n".print_r($arrRes['files'], true));

if (($session->db_ok && $session->logged_in  || isset($_COOKIE['office_menuid'])) && $database_dynmenu->db_ok) {
	global $database, $fileserver_control, $upload_errors;

	$mode = isset($_POST['uploadtype']) ? $_POST['uploadtype'] : 'synth';

	if ($arrRes['files']['error'] !== UPLOAD_ERR_OK) {
		$arrRes['status'] = 'error';
		$arrRes['error'] = isset($upload_errors[$arrRes['files']['error']]) ? $upload_errors[$arrRes['files']['error']] : 'Неизвестная ошибка при загрузке файла';
	} elseif (($arrRes['files']['name'] == '') || ($arrRes['files']['size'] <= 0)) {
		$arrRes['status'] = 'error';
		$arrRes['error'] = 'Файл не задан или пуст';
	} elseif ($mode == 'fax' && empty($arrRes['description'])) {
		$arrRes['status'] = 'error';
		$arrRes['error'] = 'Не задан телефонный номер получателя';
	} elseif (($file = System::mktemp('aup_')) && move_uploaded_file($arrRes['files']['tmp_name'], $file)) {
		//sleep(5);
		$fileid = null;
		$mb_filesize = 0;
		switch ($mode) {
			case 'synth':
				$file = prepareVoiceFileForFileServer($file, preg_match('/audio\/(mpeg|mp3)/i', $arrRes['files']['type']));
				$mb_filesize = intval(filesize($file) / FILESERVER_AUDIO_BYTE_SIZE) + 1;
				break;
			case 'fax':
				$file = prepareFaxFileForFileServer($file);
				$mb_filesize = intval(filesize($file) / FILESERVER_FAX_BYTE_SIZE) + 1;
				break;
		}

		$mb_freesize = isset($_REQUEST['ivr_edit']) ?
			2*$mb_filesize :
			$database_tar->getMBFreeSize($session->isAdmin() ? DB_TAR_MB_SYSTEMBOXCOMMONID : $session->ofnumber);
		$mb_wround = $database_tar->getMBWriteType($session->isAdmin() ? DB_TAR_MB_SYSTEMBOXCOMMONID : $session->ofnumber);
		if ($mb_filesize > $mb_freesize && $mb_wround != 1) {
			$arrRes['error'] = 'В почтовом ящике недостаточно места';
		} else {
			$res = $fileserver_control->PlaceFile($file, $fileid, $mode == 'fax', true);
			if ($res == FS_ERROR_OK) {
				if (!isset($_REQUEST['ivr_edit'])) {
					$dbres = $database_tar->addMBMessage($session->isAdmin() ? DB_TAR_MB_SYSTEMBOXCOMMONID : $session->ofnumber,
						($mode == 'synth') ? DB_TAR_MESSAGETYPE_SYNTH:DB_TAR_MESSAGETYPE_FAX,
						$mb_filesize, $fileid);
					//changelog
					if (!$session->isAdmin() && $dbres > 0)
						$database->logOfficeChange(CL_OF_FILE_UPLOAD, $session->ofid, 0, "Загружен файл {$arrRes['files']['name']}, размер в хранилище $mb_filesize, идентификатор $fileid, тип " . (($mode == 'synth') ? DB_TAR_MESSAGETYPE_SYNTH:DB_TAR_MESSAGETYPE_FAX));
				}

				if (!isset($_REQUEST['mb_adm']))
					switch ($mode) {
						case 'synth':
							$filedescription = empty($arrRes['description']) ? 'Без названия' : preg_replace('/\s/', ' ', $arrRes['description']);
							//$menuid = ($session->logged_in && is_numeric($session->ofmenuid)) ? intval($session->ofmenuid) : (isset($_COOKIE['office_menuid']) ? intval($_COOKIE['office_menuid']) : -1);
							if (isset($_REQUEST['ivr_edit']))
								$menuid = isset($_COOKIE['office_menuid']) ? intval($_COOKIE['office_menuid']) : -1;
							else
								$menuid = ($session->logged_in && is_numeric($session->ofmenuid)) ? intval($session->ofmenuid) : -1;
							if ($menuid >= 0)
								$database_dynmenu->addSynth($fileid, 1, $menuid, $filedescription);
							break;
						/*case 'fax':
							$arrRes['description'] = preg_replace('/[^\d,;]/', '', $arrRes['description']);
							$taskid = $database_tar->addFaxSendTask($fileid, $session->ofnumber, $arrRes['description'], $session->ofmainparams['of_number_prefix'], $arrRes['fax_send_disa']);
							$arrRes['msg'] = "Факсимильное сообщение поставлено в очередь на отправку на номер {$arrRes['description']}"
								. ($arrRes['fax_send_disa'] == '' ? '':"({$arrRes['fax_send_disa']})") . '.';
							$database->fax_queue_add($session->ofid, $taskid, $fileid, $arrRes['description'], $arrRes['files']['name'], '', $arrRes['fax_send_disa']);
							break;*/
						case 'fax': // массовая отправка факса на несколько номеров через точку с запятой
							$arrResList = explode(';',$arrRes['description']);
							foreach ($arrResList as $key => $value) {
							$value = preg_replace('/[^\d,;]/', '', $value);
							$taskid = $database_tar->addFaxSendTask($fileid, $session->ofnumber, $value, $session->ofmainparams['of_number_prefix'], $arrRes['fax_send_disa']);
							$arrRes['msg'] = "Факсимильное сообщение поставлено в очередь на отправку на номер {$value}"
								. ($arrRes['fax_send_disa'] == '' ? '':"({$arrRes['fax_send_disa']})") . '.';
							$database->fax_queue_add($session->ofid, $taskid, $fileid, $value, $arrRes['files']['name'], '', $arrRes['fax_send_disa']);
							}
							break;
					}
				$arrRes['status'] = 'ok';
				$arrRes['fileid'] = $fileid;
			} else {
				$arrRes['status'] = 'error';
				switch ($fileserver_control->ErrorDesc) {
					case 'error 133':
						$arrRes['error'] = 'Неизвестный формат файла';
						break;
					case 'error 134':
						$arrRes['error'] = 'Ошибка конвертации файла во внутренний формат';
						break;
					default:
						$arrRes['error'] = 'Внутренняя ошибка FS: ' . $fileserver_control->ErrorDescription($res);
						break;
				}
			}
		}
	} else {
		$arrRes['status'] = 'error';
		$arrRes['error'] = 'Внутренняя ошибка';
	}
} else {
	$arrRes['status'] = 'error';
	$arrRes['error'] = 'Ошибка авторизации';
}

unset($arrRes['files']['tmp_name']);

if (isset($_POST['rawres']) && $_POST['rawres'] == 1)
	print json_encode_safe($arrRes);
else
	print '<textarea>'.json_encode_safe($arrRes).'</textarea>';

?>
