<?php
/**
 * Database Constants
 */
define("DB_HOST_DYNMENU",   '127.0.0.1');
define("DB_FILE_DYNMENU",   '/var/rino/IS-RINO/DB/menus.fdb?charset=UTF8&dialect=3');
define("DB_USER_DYNMENU",   'SYSDBA');
define("DB_PASS_DYNMENU",   'masterkey');
define("DB_ENGINE_DYNMENU", 'ibase(firebird)');

if (!defined('MAX_FILE_SIZE_UPLOAD_VOICE'))
	define("MAX_FILE_SIZE_UPLOAD_VOICE", 32 * 1024 * 1024);

/**
 * PEAR LOGGER
 */
global $logger;
require_once 'Log.php';
if (!$logger) {
	$conf = array('mode' => 0600, 'dirmode' => 0755, 'timeFormat' => '%d.%m.%Y %H:%M:%S');
	$logger = Log::singleton('file', 'dynmenu.log', '', $conf);
}

/**
 * FILE SERVER
 */
if (!defined('FILESERVER_HOST'))
	define('FILESERVER_HOST', '127.0.0.1');
if (!defined('FILESERVER_ADMIN_PORT'))
	define('FILESERVER_ADMIN_PORT', 25001);
if (!defined('FILESERVER_DATA_PORT'))
	define('FILESERVER_DATA_PORT', 25002);

/**
 * DEFAULT AUDIO FILES
 */
if (!defined('VOOS_WIN')) {
	if (substr(PHP_OS, 0, 3) == 'WIN') {
		define('VOOS_WIN', true);
		define('VOOS_NIX', false);
	} else {
		define('VOOS_WIN', false);
		define('VOOS_NIX', true);
	}
}

if (!defined('AUDIO_CONVERT_TOOLS_PATH')) {
	if (VOOS_WIN)
		define("AUDIO_CONVERT_TOOLS_PATH", realpath(dirname(__FILE__).'/../tools') . '\\');
	else
		define('AUDIO_CONVERT_TOOLS_PATH', '');
}
//sox -q -t al -r8000 -c1 "%1" -r8000 -c1 -s -w -t wav - 2>>/dev/null | lame --preset fast standard -m m -b 32 -B 96 -t --quiet - %1.mp3 1>>/dev/null 2>>/dev/null
//define("AUDIO_CONVERT_CALL_FMT", 'sox -q -t al -r8000 -c1 "%infile%" -t wav -r8000 -c1 -s -w - | lame --preset fast standard -m m -b 32 -B 96 -t --quiet - "%outfile%"');
//define("AUDIO_CONVERT_CALL_FMT", AUDIO_CONVERT_TOOLS_PATH.'sox -q -t al -r8000 -c1 "%infile%" -t mp3 "%outfile%"');
//define("AUDIO_CONVERT_CALL_FMT", AUDIO_CONVERT_TOOLS_PATH.'sox -q -t al -r8000 -c1 "%infile%" -t wav -r8000 -c1 -u - | '.AUDIO_CONVERT_TOOLS_PATH.'lame --preset fast standard -m m -b 32 -B 96 -t --quiet --ignore-tag-errors --tt "%title%" --ta "%artist%" - "%outfile%"');

if (!defined('AUDIO_CONVERT_CALL_FMT'))
	//define("AUDIO_CONVERT_CALL_FMT", AUDIO_CONVERT_TOOLS_PATH.'sox -q -t al -r8000 -c1 "%infile%" -t wav -r8000 -c1 -u - | '.AUDIO_CONVERT_TOOLS_PATH.'lame -m m --cbr -b 128 --resample 44.1 -t --quiet --ignore-tag-errors --tg "Speech" --tt "%title%" --ta "%artist%" - "%outfile%"');
	define("AUDIO_CONVERT_CALL_FMT", AUDIO_CONVERT_TOOLS_PATH.'sox -q -t al -r8000 -c 1 "%infile%" -t wav -r8000 -c 1 -e signed-integer - | '.AUDIO_CONVERT_TOOLS_PATH.'lame -m m --cbr -b 128 --resample 44.1 -t --quiet --ignore-tag-errors --tg "Speech" --tt "%title%" --ta "%artist%" - "%outfile%"');

//sox --magic -S -V -G "q.in" -e a-law -t wav -r8000 -c1 --comment "" "q.out" dither -a
if (!defined('AUDIO_CONVERT_CALL_FMT_SAVE'))
	define("AUDIO_CONVERT_CALL_FMT_SAVE", AUDIO_CONVERT_TOOLS_PATH.'sox --magic -q -G "%infile%" -e a-law -t wav -r8000 -c1 --comment "" "%outfile%" dither -a');

if (!defined('AUDIO_ERROR_NOTAUTHORIZED'))
	define('AUDIO_ERROR_NOTAUTHORIZED', 'intro.mp3');
if (!defined('AUDIO_ERROR_FILESERVER'))
	define('AUDIO_ERROR_FILESERVER', 'intro.mp3');

if (!defined('FAX_ERROR_FILESERVER')) {
	if (VOOS_WIN)
		define('FAX_ERROR_FILESERVER', realpath(dirname(__FILE__).'/../images') . '\\404fax.gif');
	else
		define('FAX_ERROR_FILESERVER', realpath(dirname(__FILE__).'/../images') . '/404fax.gif');
}
if (!defined('FAX_CONVERT_TOOLS_PATH')) {
	if (false/*VOOS_WIN*/) {
		//old settings for local IrfanView
		//define('FAX_CONVERT_TOOLS_PATH', realpath(dirname(__FILE__).'/../tools') . '\\');
		//define('FAX_CONVERT_CALL_FMT', FAX_CONVERT_TOOLS_PATH.'convert "%infile%" /resample=(70p,70p) /aspectratio /jpgq=80 /convert="%outfile%"');
		//define('FAX_CONVERT_CALL_FMT_SAVE', FAX_CONVERT_TOOLS_PATH.'convert "%infile%" /tifc=4 /convert="%outfile%"');
	} else {
		define('FAX_CONVERT_TOOLS_PATH', '');
		define('FAX_CONVERT_CALL_FMT', FAX_CONVERT_TOOLS_PATH.'convert "%infile%" -resample "204x196" -quality 18 -sharpen 5 "%outfile%"');
		define('FAX_CONVERT_CALL_FMT2', FAX_CONVERT_TOOLS_PATH.'montage %infile% -geometry +10+10 -quality 18 "%outfile%"');
		define('FAX_CONVERT_CALL_FMT_SAVE', FAX_CONVERT_TOOLS_PATH.'convert -density 204x196 -resize 1728 -monochrome -compress Group4 -units PixelsPerInch -define quantum:polarity=min-is-white "%infile%" "%outfile%"');
	}
}

/**
 * MISC DEFAULT FILES
 */
if (!defined('MENU_FILE_NOMENU'))
	define('MENU_FILE_NOMENU', 'nomenu.svg');

?>
