<?php

function format_money($summ) {
	return number_format($summ, 2, '.', '');
}

function format_duration($dur) {
	//$days = intval(($dur / 60 / 60 / 24) % 60);
	$hours = intval(($dur / 60 / 60) % 60);
	$minutes = intval(($dur / 60) % 60);
	$seconds = intval($dur % 60);

	$res = str_pad($minutes, 2, "0", STR_PAD_LEFT) . ":" . str_pad($seconds, 2, "0", STR_PAD_LEFT);
	if ($hours > 0)
		$res = $hours . ":" . $res;

	return $res;
}

function format_seconds($seconds, $force_hours = false) {
	$minutes = floor($seconds / 60);
	$seconds_left = $seconds % 60;

	$hours = floor($minutes / 60);
	$minutes_left = $minutes % 60;

	$days = floor($hours / 24);
	$hours_left = $hours % 24;

	$res = str_pad($minutes_left, 2, "0", STR_PAD_LEFT) . ":" . str_pad($seconds_left, 2, "0", STR_PAD_LEFT);
	if ($force_hours || $hours_left > 0)
		$res = str_pad($hours_left, 2, "0", STR_PAD_LEFT) . ":" . $res;
	if ($days > 0)
		$res = $days . ":" . $res;

	return $res;
}

function format_bytes($bytes) {
	return format_bytes_precision($bytes);
	/*if (!empty($bytes)) {
		$units = array('байт', 'Кб', 'Мб', 'Гб', 'Тб', 'Пб');

		$bytes = max($bytes, 0);
		$pow = floor(($bytes ? log($bytes) : 0) / log(1024));
		$output = sprintf('%.2f ' . $units[intval($pow)], ($bytes/pow(1024, floor($pow))));
		return $output;
	}
	return $bytes;*/
}

function format_bytes_precision($bytes, $precision = 2) {
	//$units = array('B', 'KB', 'MB', 'GB', 'TB');
	$units = array('байт', 'Кб', 'Мб', 'Гб', 'Тб');

	$bytes = max($bytes, 0);
	$pow = floor(($bytes ? log($bytes) : 0) / log(1024));
	$pow = min($pow, count($units) - 1);

	// Uncomment one of the following alternatives
	$bytes /= pow(1024, $pow);
	//$bytes /= (1 << (10 * $pow));

	//return round($bytes, $precision) . ' ' . $units[$pow];
	return ($pow ? sprintf('%.2f', ($bytes)) : round($bytes, $precision)) . ' ' . $units[$pow];
}

function get_percents($num_amount, $num_total, $precision = 2) {
	return number_format($num_total != 0 ? ($num_amount / $num_total) * 100 : 0, $precision);
}

function adjustlinebreaks($text) {
	return preg_replace("/\r\n|\n|\r/", "\r\n", $text);
}

//http://ru2.php.net/manual/en/function.json-encode.php#72450
//http://ru2.php.net/manual/en/function.json-encode.php#73854
define('DEFAULT_CHARSET', 'cp1251');

function json_encode_safe($var) {
	//return json_encode(json_fix_cyr($var));
	return json_encode($var);
}

function json_fix_cyr($var) {
	if (is_array($var)) {
		$new = array();
		foreach ($var as $k => $v) {
			$new[json_fix_cyr($k)] = json_fix_cyr($v);
		}
		$var = $new;
	} elseif (is_object($var)) {
		$vars = get_obj_vars($var);
		foreach ($vars as $m => $v) {
			$var->$m = json_fix_cyr($v);
		}
	} elseif (is_string($var)) {
		$var = iconv(DEFAULT_CHARSET, 'utf-8', $var);
	}
	return $var;
}

function stripslashes_deep(&$value) {
	$value = is_array($value) ?
			array_map('stripslashes_deep', $value) :
			stripslashes($value);
	return $value;
}

function handle_magic_quotes() {
	if ((function_exists("get_magic_quotes_gpc") && get_magic_quotes_gpc()) ||
	    (ini_get('magic_quotes_sybase') && (strtolower(ini_get('magic_quotes_sybase')) != "off"))) {
		stripslashes_deep($_GET);
		stripslashes_deep($_POST);
		stripslashes_deep($_COOKIE);
	}
}

/**
 * Returns the Julian date of the Windows Excel epoch (1 Jan 1900).
 *
 * @return integer  Julian date
 */
function _GetExcelEpoch() {
	return GregorianToJD(1, 1, 1900); // Windows Excel epoch
}

function date_add_vals($srcdate, $day = 0, $mth = 0, $yr = 0, $fmt = 'd.m.Y') {
	$cd = strtotime($srcdate);
	return date($fmt,
		mktime(0, 0, 0, date('m', $cd) + $mth, date('d', $cd) + $day, date('Y', $cd) + $yr));
}

function stripsiptags($number) {
	return preg_replace("/^SIP:|@(\d+)\.(\d+)\.(\d+)\.(\d+)$/", "", $number);
}

?>
