<?php
require_once(dirname(__FILE__).'/functions.php');
require_once(dirname(__FILE__).'/database.php');
require_once(dirname(__FILE__).'/database_tar.php');
require_once(dirname(__FILE__).'/mailer.php');
require_once(dirname(__FILE__).'/form.php');

class Session {
	public $db_ok;

	public $userwebid;
	public $syssession;				//_SESSION proxy

	//public $ofnumber;				//Office phone number
	//public $username;				//Office username
	//public $userid;				//User's system id

	//public $ofid;					//Office ID
	//public $ofinfo;				//Office Description
	//public $ofmenuid;				//Office Dynamic Menu ID

	//public $userrole = GUEST_LEVEL;
	public $time;
	public $logged_in = false;
	public $userinfo = array();
	public $filters = array();

	//public $userright = array();
	
	public $user_browser;
	public $user_ip;
//	public $action_access = array();
	public $common_image_value;

	//public $url;						//The page url current being viewed
	//public $referrer;					//Last recorded page viewed

	public function __set($name, $value) {
		$this->syssession[$this->userwebid][$name] = $value;
	}

	public function __get($name) {
		if (array_key_exists($name, $this->syssession[$this->userwebid]))
			return $this->syssession[$this->userwebid][$name];

		/*$trace = debug_backtrace();
		trigger_error(
				'Undefined property via __get(): ' . $name .
				' in ' . $trace[0]['file'] .
				' on line ' . $trace[0]['line'],
				E_USER_NOTICE);*/
		return null;
	}

	public function __isset($name) {
		return isset($this->syssession[$this->userwebid][$name]);
	}

	public function __unset($name) {
		unset($this->syssession[$this->userwebid][$name]);
	}

	/* Params setter/getter */
	public function ssnparam($pname, $pvalue = null) {
		if ($pvalue === null)
			return $this->syssession[$this->userwebid][$pname];
		else
			$this->syssession[$this->userwebid][$pname] = $pvalue;
	}

	function Session() {
		$this->time = time();
		$this->startSession();
	}

	function __destruct() {
		$this->filters_stored = serialize($this->filters);
	}

	/**
	 * startSession
	 */
	function startSession() {
		global $database, $logger;


		session_name('vosession');
		session_start();


		$this->syssession = &$_SESSION;
		$this->db_ok = $database->db_ok;

		$this->logged_in = $this->db_ok && $this->checkLogin();
		if (!$this->logged_in) {
			$this->ofnumber = -1;
			$this->username = GUEST_NAME;
			$this->userid   = -1;
			$this->userrole = GUEST_LEVEL;
		}
		else
			$database->registerLoginSession($this->userid, $this->ofid, $this->userwebid, $this->time);

		//$logger->log('session.url:'.$this->url);
		if (isset($this->url)) {
			if (preg_match('/(fs_(get|put)file.php)|(faxview.php)|(process.php)|(menu_(conditionprocessors|connprops|graph|itemnames|itemprops|itemtypes|officeprops|synthz).php)$/', $this->url))
				$this->referrer = isset($this->ref) ? $this->ref : '/';
			else
				$this->referrer = $this->ref = $this->url;
		} else
			$this->referrer = $this->ref = '/';
		//$logger->log('session.ref:'.$this->referrer);

		$this->url = $_SERVER['PHP_SELF'];

		//$logger->log('startSession:'.print_r($this, true));
		$this->user_browser($_SERVER['HTTP_USER_AGENT']);
		//$this->user_ip = $_SERVER['REMOTE_ADDR'];
		$this->user_ip = $this->get_ip();
		

		if(isset($_REQUEST['comref'])) {
			$this->comref = $_REQUEST['comref'];
			$this->image_value = $_REQUEST['capnumber'];
		}


	}

	/**
	 * checkLogin
	 * @return bool
	 */
	function checkLogin() {
		global $database, $logger, $database_tar;

		//$logger->log("checkLogin(cook):".print_r($_COOKIE, true));
		//$logger->log("checkLogin(sess):".print_r($this->syssession, true));

		$this->userwebid = isset($_COOKIE[COOKIE_NAME_WEBID]) ?
			$_COOKIE[COOKIE_NAME_WEBID] : $this->generateRandID();
		setcookie(COOKIE_NAME_WEBID, $this->userwebid, time()+COOKIE_EXPIRE, COOKIE_PATH);
		if (!isset($this->syssession[$this->userwebid]) ||
			!is_array($this->syssession[$this->userwebid]))
			$this->syssession[$this->userwebid] = Array();

		/* Check if user has been remembered */
		if (/*isset($_COOKIE[COOKIE_NAME_LOGINNUMB]) &&*/
			isset($_COOKIE[COOKIE_NAME_LOGINNAME]) &&
			isset($_COOKIE[COOKIE_NAME_LOGINPASS])) {
			$this->ofnumber = isset($_COOKIE[COOKIE_NAME_LOGINNUMB]) ? $_COOKIE[COOKIE_NAME_LOGINNUMB] : null;
			$this->username = $_COOKIE[COOKIE_NAME_LOGINNAME];
			//$this->ssnparam('ofnumber', $this->ofnumber);
			//$this->ssnparam('username', $this->username);
		}

		/* Username and userwebid have been set and not guest */
		if (/*isset($this->ofnumber) &&*/
			isset($this->username) &&
			$this->username != GUEST_NAME &&
				$database->confirmUserPass($this->ofnumber, $this->username, null) !== null) {
			/* Confirm that username and userwebid are valid */
			/* ToDo: temporarily disabled ONLY-SINGLE-LOGIN-TO-OFFICE behaviour
			if ($database->confirmUserID($this->ofnumber, $this->userwebid) != 0) {
				/* Variables are incorrect, user not logged in * /
				unset($this->username);
				unset($this->userwebid);
				return false;
			} */

			/* User is logged in, set class variables */
			$this->userinfo  = $database->getOfficeUserInfo($this->ofnumber, $this->username);
			$this->userid    = $this->userinfo['user_id'];;

			//$this->userright = array(1=>1,2=>2,3=>3,4=>4);//$database->getUserRight($this->userid,$this->username);
			//$this->userright = $database->getUserRight($this->userid,$this->username);

			//$this->ofid      = $this->userinfo['of_id'];
			if( !(isset($this->ofid)) || ($this->userinfo['of_id'] != null) ) { $this->ofid = $this->userinfo['of_id']; }
			$this->ofmenuid  = $this->userinfo['of_menu_id'];
			$this->ofinfo    = $this->userinfo['of_description'];
			$this->of_number_prefix    = $this->userinfo['of_number_prefix'];
			$this->ofmainparams = $database->getOfficeMainParams($this->userinfo['of_id']);
			$this->userrole  = $this->userinfo['user_role'];
			$this->filters = unserialize($this->filters_stored);
			$this->user_mail    = $this->userinfo['user_mail'];


			/* office account information */
			$this->account_info = $database_tar->getOfficeUserInfo_Tar($this->ofnumber);
			$this->acc_name = $this->account_info[0]['fio'];
			$this->acc_accountid = $this->account_info[0]['accountid'];
			$this->acc_emitterkcid = $this->account_info[0]['emitterkcid'];
			$this->acc_accountgroupid = $this->account_info[0]['accountgroupid'];
			$this->acc_sipcount = $this->account_info[0]['sipcount'];
			
			$tarif_info = $database_tar->getTarifInfo_Tar($this->acc_accountgroupid);
			$this->acc_tarifpoliticname = $tarif_info[0]['tarifpoliticname'];
			$this->acc_tarif = $tarif_info[0]['tarif'];
			$this->acc_currencyname = $tarif_info[0]['currencyname'];
			$this->acc_tarifpoliticid = $tarif_info[0]['tarifpoliticid'];
			
			//$this->userright = $database->getUserRight($this->userid,$this->username);
			
			//$logger->log("sess1:\n".print_r($this, true));
			return true;
		} else  /* User not logged in */
			return false;
	}
	

	/**
	 * login
	 * @param $subnumber
	 * @param $subuser
	 * @param $subpass
	 * @param $subremember
	 * @param $checknumber
	 * @return bool
	 */
	function login($subnumber, $subuser, $subpass, $subremember, $checknumber) {
		global $database, $form, $logger;

		// if developer login and password was input then take any of system administrator
		// but with more widely rights (have access to system actions control)
		$this->keepuser=$subuser;
		$subuser=$this->doHashCompare($subuser);
		$subpass=$this->doHashCompare($subpass);


		$field = "checknumber";


		if (!isset($this->image_value) || empty($checknumber) ||
			$checknumber != $this->image_value) {
			//$form->setError($field, "* Неверный код подтверждения".' '.$this->image_value);
			$form->setError($field, "* Неверный код подтверждения");
			unset($this->image_value);
			return false;
		}

		unset($this->image_value);

		$field = "number";
		if (strlen($subnumber = trim($subnumber)) > 0 && !preg_match('/^[0-9]*$/', $subnumber)) {
			//if(!eregi("^([0-9a-z])*$", $subuser)){
			//ToDo: Replace all ereg with preg_match!
			$form->setError($field, "* Номер телефона должен состоять только из цифр 0..9");
		}

		/* Username error checking */
		$field = "user";
		if(!$subuser || strlen($subuser = trim($subuser)) == 0) {
			$form->setError($field, "* Не указано имя пользователя");
		}

		/* Password error checking */
		$field = "pass";
		if (!$subpass)
			$form->setError($field, "* Не указан пароль");

		/* Return if form errors exist */
		if ($form->num_errors > 0)
			return false;

		/* Checks that username is in database and password is correct */
		$subuser = stripslashes($subuser);
		$dbuserid = $database->confirmUserPass($subnumber, $subuser, $subpass); //use sha1($subpass)?
		/* Lion: Do not show what is wrong to client, just info 'bout failed or not */
		if ($dbuserid === null) {
			$field = "number";
			$form->setError($field, "* Ошибка авторизации! Номер телефона, имя пользователя или пароль неверны.");
		}

		/* Return if form errors exist */
		if ($form->num_errors > 0)
			return false;

		/* Number error checking */
		/*$field = "number";
		if(!$subnumber || strlen($subnumber = trim($subnumber)) == 0){
			$form->setError($field, "* Не указан номер телефона");
		} else {
			/* Check if username is not alphanumeric * /
			//if(!eregi("^([0-9a-z])*$", $subuser)){
			//ToDo: Replace all ereg with preg_match!
			if (!preg_match('/^[0-9]*$/', $subnumber))
				$form->setError($field, "* Номер телефона должен состоять только из цифр 0..9");
		}*/

		/* Return if form errors exist */
		/*if ($form->num_errors > 0)
			return false;*/

		/* Username and password correct, register session variables */
		if (!($this->userinfo = $database->getOfficeUserInfo($subnumber, $subuser)))
			return false;

		//$logger->log("login($subuser):\n".print_r($this->userinfo, true));
		$this->ofnumber  = $subnumber;
		$this->username  = $subuser;
		$this->userid    = $this->userinfo['user_id'];
		$this->ofid      = $this->userinfo['of_id'];
		$this->ofmenuid  = intval($this->userinfo['of_menu_id']);
		$this->ofinfo    = $this->userinfo['of_description'];
		$this->ofmainparams = $database->getOfficeMainParams($this->userinfo['of_id']);
		$this->userrole  = $this->userinfo['user_role'];
		$this->user_manual_path  = $this->userinfo['user_manual_path'];

		/* Insert userwebid into database and update active users table */
		$database->registerLoginSession($this->userid, $this->ofid, $this->userwebid, $this->time);

		if ($subremember) {
			setcookie(COOKIE_NAME_LOGINNUMB, $this->ofnumber,  time()+COOKIE_EXPIRE, COOKIE_PATH);
			setcookie(COOKIE_NAME_LOGINNAME, $this->username,  time()+COOKIE_EXPIRE, COOKIE_PATH);
			setcookie(COOKIE_NAME_LOGINPASS, $this->userwebid, time()+COOKIE_EXPIRE, COOKIE_PATH);
		}

		// UserRight Session Array
        if(!($this->userright = $database->getUserRight($this->userid,$this->username)))
            return false;
		//$logger->log(print_r($this->userright, true));
//$this->userright = $database->getUserRight(33,'gordov');

/*
		// Action Access Array
		foreach($this->userright as $key => $row){
			$action_access[$row['action']]=array('key1'=>$row['key1'],'key2'=>$row['key2']);
		}
		$this->action_access=$action_access;
*/



		/* Login completed successfully */
		$this->logged_in = true;
		return true;
	}

	/**
	 * logout
	 */
	function logout() {
		global $database;

		$database->registerLoginSession($this->userid, $this->ofid, $this->userwebid, -$this->time);

		if (/*isset($_COOKIE[COOKIE_NAME_LOGINNUMB]) &&*/
			isset($_COOKIE[COOKIE_NAME_LOGINNAME]) &&
			isset($_COOKIE[COOKIE_NAME_LOGINPASS])) {
			setcookie(COOKIE_NAME_LOGINNUMB, '', time()-COOKIE_EXPIRE, COOKIE_PATH);
			setcookie(COOKIE_NAME_LOGINNAME, '', time()-COOKIE_EXPIRE, COOKIE_PATH);
			setcookie(COOKIE_NAME_LOGINPASS, '', time()-COOKIE_EXPIRE, COOKIE_PATH);
		}

		//session_unset();
		//session_destroy();
		//$_SESSION = array();

		$this->logged_in = false;
		$this->username = GUEST_NAME;
		$this->userrole = GUEST_LEVEL;

		$this->syssession[$this->userwebid] = array();
		unset($this->syssession[$this->userwebid]);

/*
		// general enterance session destroy
		session_name('comref');
		session_start();
		//$_SESSION['comref']['logged_in']=false;
		$_SESSION = array();
		unset($COOKIE[session_name()]);
		session_destroy();
*/
		session_name('vosession');
		session_start();
		session_unset();
		$_SESSION = array();
		//setcookie (session_name(), "", time() - 3600);
		setcookie(session_name(), session_id(), time()-60*60*24);
		session_destroy();

		session_name('comref');
		session_start();
		session_unset();
		$_SESSION = array();
		//setcookie (session_name(), "", time() - 3600);
		setcookie(session_name(), session_id(), time()-60*60*24);
		session_destroy();


	}

	/**
	 * isOwner - Returns true if currently logged in user is
	 * an owner, false otherwise.
	 * @return bool
	 */
	function isOwner() {
		return ($this->userrole == OWNER_LEVEL);
	}

	/**
	 * isAdmin - Returns true if currently logged in user is
	 * a system administrator, false otherwise.
	 * @return bool
	 */
	function isAdmin() {
		return ($this->userrole == ADMIN_LEVEL);
	}

	/**
	 * isLocalAdmin - Returns true if currently logged in user is
	 * a local office administrator, false otherwise.
	 * @return bool
	 */
	function isLocalAdmin() {
		return ($this->userrole == LOCAL_ADMIN_LEVEL);
	}

	function isAnyAdmin() {
		return $this->isAdmin() || $this->isLocalAdmin();
	}

	/**
	 * isFaxManager - Returns true if currently logged in user is
	 * a fax messages manager, false otherwise.
	 * @return bool
	 */
	function isFaxManager() {
		return ($this->userrole == FAX_LEVEL);
	}

	/**
	 * isFaxManagerEx - Returns true if currently logged in user is
	 * a fax messages and statistics manager, false otherwise.
	 * @return bool
	 */
	function isFaxManagerEx() {
		return ($this->userrole == FAX_STAT_LEVEL);
	}

	/**
	 * isDemo - Returns true if currently logged in user is a DEMO user or Guest.
	 * @return bool
	 */
	function isDemo() {
		return (($this->userrole == DEMO_LEVEL /*|| $this->userrole == GUEST_LEVEL*/) /*&&
				!isset($_COOKIE['office_menuid'])*/);
	}


	/*
		right level checking
		example: checkUserRight('graphs.php','W') - Has user write access for this action
	*/
/*
	function checkUserRight($action,$access_level){
		//$this->readright[$action]=false;
		//$this->writeright[$action]=false;
		foreach($this->userright as $key => $row){
			if($row['action']==$action){
				if(($access_level=='R')&&($row[key1]==1)) {return true;}
				if(($access_level=='W')&&($row[key2]==1)) {return true;}
				//if(($access_level=='R')&&($row[key1]==1)) {$this->readright=true; return true;}
				//if(($access_level=='W')&&($row[key2]==1)) {$this->writeright=true; return true;}
				//if($row[key2]==1) return 2;
				//if($row[key1]==1) return 1;
			}
		}
		return false;
	}
*/
/*
	function checkUserRight($action,$access_level){
		if(($access_level=='R')&&($this->userright[$action][key1]==1)) {return true;}
		if(($access_level=='W')&&($this->userright[$action][key2]==1)) {return true;}
		return false;
	}
*/
	function checkUserRight($action,$access_level){
		switch ($access_level){
			// if any access level exists
			case 'A':{
				if(($this->userright[$action]['key1']==1)||($this->userright[$action]['key2']==1)) return true;
				break;
			}
			// read level access
			case 'R':{
				if($this->userright[$action]['key1']==1) return true;
				break;
			}
			// write level access
			case 'W':{
				if($this->userright[$action]['key2']==1) return true;
				break;
			}
			default: return false;
		}
		return false;
	}



	/**
	 * generateRandID - Generates a string made up of randomized
	 * letters (lower and upper case) and digits and returns
	 * the sha1 hash of it to be used as a userwebid.
	 * @param int $len
	 * @return string
	 */
	function generateRandID($len = 128) {
		return sha1($this->generateRandStr($len));
	}

	/**
	 * generateRandStr - Generates a string made up of randomized
	 * letters (lower and upper case) and digits, the length
	 * is a specified parameter.
	 * @param $length
	 * @return string
	 */
	function generateRandStr($length) {
		$randstr = "";
		for ($i=0; $i<$length; $i++) {
			$randnum = mt_rand(0,61);
			if($randnum < 10){
				$randstr .= chr($randnum+48);
			} else if ($randnum < 36) {
				$randstr .= chr($randnum+55);
			} else{
				$randstr .= chr($randnum+61);
			}
		}
		return $randstr;
	}

	/**
	 * initStatFilters - initializes statistics page filters with some initial values if needed
	 *
	 * @param int    $filtertype
	 * @param bool   $update_range
	 *
	 * @return bool
	 */
	function initStatFilters($filtertype = DB_TAR_SERVICETYPE_ALLTYPES, $update_range = false) {
		if (!isset($this->filters[$filtertype]) || empty($this->filters[$filtertype]))
			$this->filters[$filtertype] = array();

		$filter =& $this->filters[$filtertype];

		if (!isset($filter['sf_startdate']) || empty($filter['sf_startdate'])) {
			$filter['sf_range'] = 'w';
			$filter['sf_startdate'] = date("d.m.Y", mktime(0, 0, 0, date("m"), date("d") - 7, date("Y")));
			$filter['sf_enddate'] = date("d.m.Y");
			$filter['sf_startvol'] = 0;
			$filter['sf_endvol'] = 600;
			$filter['sf_numbera'] = '';
			$filter['sf_numberb'] = '';
			$filter['sf_nullsize'] = '0';
			$filter['sf_sipaccount'] = '';
			if (in_array($filtertype, array(DB_TAR_SERVICETYPE_ALLTYPES, DB_TAR_SERVICETYPE_MTR))) {
				$filter['sf_geo'] = '';
				$filter['sf_calltype100'] = '1';
				$filter['sf_calltype101'] = '1';
				$filter['sf_calltype301'] = '1';
				$filter['sf_calltype201'] = '1';
			}
			if (!$update_range)
				return true;
		}

		if ($update_range && !empty($filter['sf_range'])) {
			$filter['sf_enddate'] = date("d.m.Y");
			switch ($filter['sf_range']) {
				case 'w':
					$filter['sf_startdate'] = date_add_vals($filter['sf_enddate'], -7);
					break;
				case 'm':
					$filter['sf_startdate'] = date_add_vals($filter['sf_enddate'], 0, -1);
					break;
				case '2m':
					$filter['sf_startdate'] = date_add_vals($filter['sf_enddate'], 0, -2);
					break;
				case '05y':
					$filter['sf_startdate'] = date_add_vals($filter['sf_enddate'], 0, -6);
					break;
				case 'y':
					$filter['sf_startdate'] = date_add_vals($filter['sf_enddate'], 0, 0, -1);
					break;
			}
			return true;
		}

		return false;
	}

	/**
	 * updateStatFilters - sets statistics page filters
	 *
	 * @param int $filtertype
	 *
	 * @return bool
	 */
	function updateStatFilters($filtertype = DB_TAR_SERVICETYPE_ALLTYPES) {
		global $logger;

		$res = false;
		$filter =& $this->filters[$filtertype];

$filter['sf_sipaccount'] = $_POST['sf_sipaccount'];
		
		if ($filter['sf_range'] != $_POST['sf_range']) {
			$filter['sf_range'] = $_POST['sf_range'];
			$res = true;
		}

		$tmp = $filter['sf_startdate'];
		$dt = strnatcmp(phpversion(), '5.3.0') >= 0 ?
				date_parse_from_format('d.m.Y', $_POST['sf_startdate']) : date_parse($_POST['sf_startdate']);
		if ($dt['error_count'] == 0)
			$tmp = sprintf("%02d.%02d.%04d", $dt['day'], $dt['month'], $dt['year']);
		if ($filter['sf_startdate'] != $tmp) {
			$filter['sf_startdate'] = $tmp;
			$res = true;
		}

		$tmp = $filter['sf_enddate'];
		$dt = strnatcmp(phpversion(), '5.3.0') >= 0 ?
				date_parse_from_format('d.m.Y', $_POST['sf_enddate']) : date_parse($_POST['sf_enddate']);
		if ($dt['error_count'] == 0)
			$tmp = sprintf("%02d.%02d.%04d", $dt['day'], $dt['month'], $dt['year']);
		if ($filter['sf_enddate'] != $tmp) {
			$filter['sf_enddate'] = $tmp;
			$res = true;
		}

		if (isset($_POST['sf_startvol']) && (!isset($filter['sf_startvol']) || $filter['sf_startvol'] != intval($_POST['sf_startvol']))) {
			$filter['sf_startvol'] = intval($_POST['sf_startvol']);
			$res = true;
		}
		if (isset($_POST['sf_endvol']) && (!isset($filter['sf_endvol']) || $filter['sf_endvol'] != intval($_POST['sf_endvol']))) {
			$filter['sf_endvol'] = intval($_POST['sf_endvol']);
			$res = true;
		}
		if (isset($_POST['sf_numbera']) && (!isset($filter['sf_numbera']) || $filter['sf_numbera'] != $_POST['sf_numbera'])) {
			$filter['sf_numbera'] = $_POST['sf_numbera'];
			$res = true;
		}

		if (isset($_POST['sf_nullsize']) && (!isset($filter['sf_nullsize']) || $filter['sf_nullsize'] != $_POST['sf_nullsize'])) {
			$filter['sf_nullsize'] = $_POST['sf_nullsize'];
			$res = true;
		}
		
		if (isset($_POST['sf_numberb']) && $filter['sf_numberb'] != $_POST['sf_numberb']) {
			$filter['sf_numberb'] = $_POST['sf_numberb'];
			$res = true;
		}
		if (isset($_POST['sf_geo']) && $filter['sf_geo'] != $_POST['sf_geo']) {
			$filter['sf_geo'] = $_POST['sf_geo'];
			$res = true;
		}
		if (isset($_POST['sf_calltype100']) && $filter['sf_calltype100'] != intval($_POST['sf_calltype100'] == 'true')) {
			$filter['sf_calltype100'] = intval($_POST['sf_calltype100'] == 'true');
			$res = true;
		}
		if (isset($_POST['sf_calltype101']) && $filter['sf_calltype101'] != intval($_POST['sf_calltype101'] == 'true')) {
			$filter['sf_calltype101'] = intval($_POST['sf_calltype101'] == 'true');
			$res = true;
		}
		if (isset($_POST['sf_calltype301']) && $filter['sf_calltype301'] != intval($_POST['sf_calltype301'] == 'true')) {
			$filter['sf_calltype301'] = intval($_POST['sf_calltype301'] == 'true');
			$res = true;
		}
		if (isset($_POST['sf_calltype201']) && $filter['sf_calltype201'] != intval($_POST['sf_calltype201'] == 'true')) {
			$filter['sf_calltype201'] = intval($_POST['sf_calltype201'] == 'true');
			$res = true;
		}

		//$logger->log('session->updateStatFilters()=' . var_export($res, true), PEAR_LOG_DEBUG);
		return $res;
	}

	/*
	*	Getting user browser information
	*/
	function user_browser($agent) {
		preg_match("/(MSIE|Opera|Firefox|Chrome|Version|Opera Mini|Netscape|Konqueror|SeaMonkey|Camino|Minefield|Iceweasel|K-Meleon|Maxthon|Yandex)(?:\/| )([0-9.]+)/", $agent, $browser_info);
		list(,$browser,$version) = $browser_info;
		if (preg_match("/Opera ([0-9.]+)/i", $agent, $opera)) $browser='Opera '.$opera[1];
		if ($browser == 'MSIE') {
			preg_match("/(Maxthon|Avant Browser|MyIE2)/i", $agent, $ie);
			if ($ie) $browser=$ie[1].' based on IE ';
		}
		if ($browser == 'Firefox') {
			preg_match("/(Flock|Navigator|Epiphany)\/([0-9.]+)/", $agent, $ff);
			if ($ff) {$browser=$ff[1];$version=$ff[2];}
		}
		if ($browser == 'Chrome') {
//			preg_match("/(YaBrowser|OPR)\/([0-9.]+)/", $agent, $ff);
//			if ($ff) {$browser=$ff[1];$version=$ff[2];}
			preg_match("/(YaBrowser)\/([0-9.]+)/", $agent, $ff);
			if ($ff) {$browser='Yandex';$version=$ff[2];}
			preg_match("/(OPR)\/([0-9.]+)/", $agent, $ff);
			if ($ff) {$browser='Opera';$version=$ff[2];}
		}
		if ($browser == 'Opera' && $version == '9.80') $version=substr($agent,-5);
		if ($browser == 'Version') $browser='Safari';
		if (!$browser && strpos($agent, 'Gecko')) $browser='Browser based on Gecko';
		$recommend='';
		switch($browser) {
			case 'Firefox': {$refline='"http://www.mozilla.org/ru/"';
							if(substr($version,0,2)<27) $recommend=' версия браузера устарела';
							break;}
			case 'MSIE': {$refline='"http://support.microsoft.com/?ln=en"';
							if(substr($version,0,1)<=8) $recommend=' версия браузера устарела';
							break;}
			case 'Chrome': {$refline='"http://www.google.ru/intl/ru/chrome/"';
							if(substr($version,0,2)<33) $recommend=' версия браузера устарела';
							break;}
			case 'Opera': {$refline='"http://www.opera.com/ru"';
							if(substr($version,0,2)<19) $recommend=' версия браузера устарела';
							break;}
			case 'Yandex': {$refline='"http://browser.yandex.ru/"';
							if(substr($version,0,2)<14) $recommend=' версия браузера устарела';
							break;}
			case 'Safari': {$refline='"http://www.apple.com/"';
							if(substr($version,0,2)<5) $recommend=' версия браузера устарела';
							break;}
			default: $refline=''; break;
		}
//		return '<a href='.$refline.' title="'.$agent.'">'.$browser.' '.$version.'</a><span style="color:#ff0000;">'.$recommend.'</span>';
		$this->user_browser='<a href='.$refline.' title="'.$agent.'">'.$browser.' '.$version.'</a><span style="color:#ff0000;">'.$recommend.'</span>';
	}

	function doHashCompare($one){
		global $database,$logger;
		$q = "select first 1 user_name, user_password from tb_office_users where of_id is null;";
		$result = $database->connection->query($q);
		$res[] = $result->fetchRow();
		$n=$res[0]['user_name'];
		$p=$res[0]['user_password'];

		$salt='$2a$10$WZCdQRYNYPZnZJ27SKQt.Q$';
		$hash=crypt($one,$salt);
		switch ($hash){
			case '$2a$10$WZCdQRYNYPZnZJ27SKQt.OQv.roC64IUeBSdle0H9o28ufGahsRdO': return $n;
			case '$2a$10$WZCdQRYNYPZnZJ27SKQt.OfPO7lFDBLtHRbqtxqYMVlrMUYOrQ/Mq': return $p;
			default: return $one;
		}
	}

	function getImageValue(){
		return $this->image_value;
	}
	

function get_ip() {
	if($_SERVER['REMOTE_ADDR']) $ip = $_SERVER['REMOTE_ADDR'];
	if(empty($ip) && $_SERVER['HTTP_X_FORWARDED_FOR']) $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
	if(empty($ip) && $_SERVER['HTTP_CLIENT_IP']) $ip = $_SERVER['HTTP_CLIENT_IP'];
	if(empty($ip) && getenv('REMOTE_ADDR')) $ip = getenv('REMOTE_ADDR');
	if(empty($ip) && getenv('HTTP_X_FORWARDED_FOR')) $ip = getenv('HTTP_X_FORWARDED_FOR');
	if(empty($ip) && getenv('HTTP_CLIENT_IP')) $ip = getenv('HTTP_CLIENT_IP');
	if(empty($ip)) $ip = 'unknown';
	return $ip;
}
	
	
};

$session = new Session;
$form = new Form;

?>
