
// таблица пользователей
$(document).ready( function () {

    oDataTable1 = $('#res_dataset').dataTable( {
		processing: true,
		serverSide: false,
		
		scrollY: 500,
		paging: false,
		lengthChange: false,
		searching: false,
		info: true,
		sort: true,
		
		draw: 1,
		length: 100,
		start: 0,
		
		language: {
			info: ''
		},
		
		ajax: {
			url: './process.php',
			type: 'POST',
			dataType: 'json',
			data: ({
				request_name:'acc_users',
				first: 10,
				skip: 0
			})
		},

		columns: [
		{ data: "user_name" },
		{ data: "role_name" },
		{ data: "user_mail" },
		{ data: "control" }
		]
    } );
	
	// список доступных данному офису ролей
	$.ajax({
	type: 'POST',
	url: 'process.php',
	data: ({
		request_name:'office_roles'
	}),
	dataType: 'json',
	async: true,
	timeout: 10000,
	success: function(data) {
		$.each(data.data, function (key,row) {
			$("#txt_role_name").append( $('<option value="'+row[1]+'">'+row[0]+'</option>'));
		});
	}
	});

} );


// форма реквизитов пользователя
$(document).ready( function () {
	$('input[id=btn_row_add]').click(function(){
		frm_open_dialog('add');
	});
});

// форма диалога
$(function() {
	$( "#frm_dialog" ).dialog({ 
		modal:true,
		autoOpen:false,
		width:400,
		height:240,
		title: "Пользователь",
		buttons:{ "OK":function(){frm_user_save();} ,"Отмена":function(){frm_close_dialog();} },
		resizable:false
	});
	$( "#frm_dialog" ).attr('mode',''); 
});	

// открыть форму реквизитов пользователя ( mode = 'add' | 'edt' )
function frm_open_dialog(mode){
	$("#frm_dialog").attr('mode',mode); 
	if( mode == 'add') { 
		$("#frm_dialog").dialog('option', 'title', 'Добавление пользователя'); 
	}
	if( mode == 'edt') { 
		$("#frm_dialog").dialog('option', 'title', 'Редактирование пользователя'); 
	}
	$("#frm_dialog").dialog('open');
}
// закрыть форму добавления сип-счета
function frm_close_dialog(){
	$("#frm_dialog").dialog('close');
	frm_dialog_clear();
}
// обнуление параметров диалоговой формы
function frm_dialog_clear(){
	$('div[id=frm_dialog] input').val('');
}


// сохранение параметров пользователя
function frm_user_save(){

	txt_user_id = $('input[id=txt_user_id]').val();
	txt_user_name = $('input[id=txt_user_name]').val();
	txt_role_name = $('select[id=txt_role_name]').val();
	txt_user_mail = $('input[id=txt_user_mail]').val();
	txt_user_password = $('input[id=txt_user_password]').val();
	txt_user_password_repeat = $('input[id=txt_user_password_repeat]').val();
	
	if( txt_user_password != txt_user_password_repeat ){
		alert('Неправильный пароль!');
		return;
	}
	
	var save_mode = $("#frm_dialog").attr('mode');
	
	// добавление нового пользователя
	if(save_mode == 'add'){
		$.ajax({
		type: 'POST',
		url: 'process.php',
		data: ({
			request_name:'acc_users_add',
			txt_user_name: txt_user_name,
			txt_role_name: txt_role_name,
			txt_user_mail: txt_user_mail,
			txt_user_password: txt_user_password
		}),
		dataType: 'json',
		async: true,
		timeout: 10000,
		success: function(data) {
			frm_close_dialog();
			var ResTable = $('#res_dataset').dataTable();
			ResTable.api().ajax.reload();
		},
		error:function(){
			alert('error: new record is not created');
		}
		
		});
	}
	// редактирование пользователя
	if(save_mode == 'edt'){
		$.ajax({
		type: 'POST',
		url: 'process.php',
		data: ({
			request_name:'acc_users_edt',
			txt_user_id: txt_user_id,
			txt_user_name: txt_user_name,
			txt_role_name: txt_role_name,
			txt_user_mail: txt_user_mail,
			txt_user_password: txt_user_password
	}),
		dataType: 'json',
		async: true,
		timeout: 10000,
		success: function(data) {
			frm_close_dialog();
			var ResTable = $('#res_dataset').dataTable();
			ResTable.api().ajax.reload();
		},
		error:function(){
			alert('error: record is not changed');
		}
		
		});
	}
	
}

// удаление пользователя
function frm_user_del(user_id){
		$.ajax({
		type: 'POST',
		url: 'process.php',
		data: ({
			request_name:'acc_users_del',
			user_id: user_id
		}),
		dataType: 'json',
		async: true,
		timeout: 10000,
		success: function(data) {
			var ResTable = $('#res_dataset').dataTable();
			ResTable.api().ajax.reload();
		},
		error:function(){
			alert('error: record is not deleted');
		}
		
	});
}

// редактирование - открытие диалоговой формы
function frm_dialog_user_edt(varr){
	//alert(varr);
	var rowset = varr.split("|");
	$('input[id=txt_user_id]').val(rowset[0]);
	$('input[id=txt_user_name]').val(rowset[1]);
	$('select[id=txt_role_name]').val(rowset[5]).change();
	$('input[id=txt_user_mail]').val(rowset[3]);
	$('input[id=txt_user_password]').val(rowset[4]);
	$('input[id=txt_user_password_repeat]').val(rowset[4]);

	frm_open_dialog('edt');
}


// проверка ограничения на максимальное кол-во пользователей
/*function check_sipcount(){
	var sipcount_key = 0;
	$.ajax({
		type: 'POST',
		url: 'process.php',
		data: ({
			request_name:'check_sipcount'
		}),
		dataType: 'json',
		async: false,
		timeout: 10000,
		success: function(data) {
			sipcount_key = data.sipcount;
		}
	});
	return sipcount_key;
}*/


// активный пункт меню странички
$(document).ready( function () {
	$('.widget_nav_menu li a, .widget_nav_menu a').each(function () {
		var location = window.location.href; // переменная с адресом страницы
		var link = this.href;                // переменная с url ссылки
		var result = location.match(link);   // результат возвращает объект если совпадение найдено и null при обратном
		if(result != null) { $(this).addClass("widget_nav_menu_active"); }
	});
});

