$(document).ready(function () {
	$("#mblist").flexigrid({
		url: 'process.php',
		params: [
			{name: 'op', value: 'mblist'}
		],
		dataType: 'json',
		colModel: [
			{display: '&nbsp;', name: 'flags', width: 52, sortable: false, align: 'right'},
			{display: '#', name: 'recordid', width: 50, sortable: false, align: 'right'},
			{display: 'Дата размещения', name: 'createdate', width: 100, sortable: false, align: 'right'},
			{display: 'Тип файла', name: 'messagetypeid', width: 160, sortable: false, align: 'right'},
			{display: 'Объем', name: 'messagesize', width: 90, sortable: false, align: 'right'},
			{display: 'Источник', name: 'numbera', width: 85, sortable: false, align: 'right'}
		],
		sortname: "createdate",
		sortorder: "desc",
		title: false,//'<div id="voiceplayer"></div>',
		showToggleBtn: false,
		singleSelect: true,
		striped: false,
		usepager: true,
		useRp: true,
		rp: 50,
		rpOptions: [10, 50, 100, 150, 200],
		showTableToggleBtn: false,
		width: 630,
		height: 300,
		resizable: true,
		errormsg: 'Данные в данный момент недоступны. Попробуйте позже.',
		pagestat: 'Отображены записи с {from} по {to} из {total}',
		pagetext: 'Страница',
		outof: 'из',
		findtext: 'Поиск&nbsp;',
		procmsg: 'Обновление данных...',
		nomsg: 'Данные отсутствуют',
		autoload: false,
		preProcess: function (data) {
			if (data.totalvol)
				$('#stattotals').html('Общий занимаемый объем в файловом хранилище: ' + data.totalvol);

			var icons, icons_json;
			var ic_type, ic_pfunc, ic_sfunc, ic_file;
			$.each(data.rows, function (i, row) {
				icons = '';
				icons_json = jQuery.parseJSON(row.cell[0]);
				if (parseInt(icons_json.recid)) {
					ic_type = null;
					switch (icons_json.typeid) {
						case 0:
							ic_type = 's';
							ic_pfunc = 'playVoice';
							ic_sfunc = 'saveVoice';
							ic_file = 'icon_synth.gif';
							break;
						case 2:
							ic_type = 'v';
							ic_pfunc = 'playVoice';
							ic_sfunc = 'saveVoice';
							ic_file = 'icon_voicemail.gif';
							break;
						case 9:
							ic_type = 'r';
							ic_pfunc = 'playVoice';
							ic_sfunc = 'saveVoice';
							ic_file = 'icon_record.gif';
							break;
						case 1:
							ic_type = 'f';
							ic_pfunc = 'showFax';
							ic_sfunc = 'saveFax';
							ic_file = 'icon_fax3.gif';
							break;
					}
					if (ic_type)
						icons += '<img class="p_ic" src="images/'+ic_file+'" data-type="'+ic_type+'" data-func="'+ic_pfunc+'" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" />'
							+ '<img class="s_ic" src="images/save.gif" data-type="'+ic_type+'" data-func="'+ic_sfunc+'" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" />'
							+ '<img class="d_ic" src="images/icon_closed.gif" data-type="'+ic_type+'" data-func="delFile" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" data-mid="' + icons_json.mid + '" />';
				}
				row.cell[0] = icons;
				row.cell[3] = mb_messagetypes[row.cell[3]];
			});
			return data;
		},
		onSuccess: function () {
			$('.t_ic')
				.attr({width: '16', height: '16', alt: ''})
				.css('margin-left', '4px');
			$('.p_ic, .s_ic, .d_ic')
				.attr({width: '16', height: '16', alt: ''})
				.each(function(){
					switch ($(this).attr('data-type')) {
						case 's':
							$(this).attr('title', 'голосовую фразу');
							break;
						case 'r':
							$(this).attr('title', 'запись разговора');
							break;
						case 'v':
							$(this).attr('title', 'голосовое сообщение');
							break;
						case 'f':
							$(this).attr('title', 'факсимильное сообщение');
							break;
					}
					if ($(this).hasClass('p_ic')) {
						if ($(this).attr('data-type') != 'f')
							$(this).attr('title', 'Прослушать ' + $(this).attr('title'));
						else
							$(this).attr('title', 'Открыть ' + $(this).attr('title'));
					} else if ($(this).hasClass('s_ic')) {
						$(this).attr('title', 'Сохранить ' + $(this).attr('title'));
					} else {
						$(this).attr('title', 'Удалить ' + $(this).attr('title'));
					}
				})
				.addClass('imglink')
				.click(function(){
					setTimeout($(this).attr('data-func') + "('" + $(this).attr('data-recid') + "', '" + $(this).attr('data-rect') + "', '" + $(this).attr('data-mid') + "');", 0);
					return false;
				});
			statcontrols_enable();
		},
		onSubmit: function () {
			$('#stattotals').html('&nbsp;');
			$("#mblist").flexOptions({
				params: [
					{name: 'op', value: 'mblist'},
					{name: 'sf_range', value: $('#sf_range').val()},
					{name: 'sf_startdate', value: $('#sf_startdate').val()},
					{name: 'sf_enddate', value: $('#sf_enddate').val()},
					{name: 'sf_startvol', value: $('#sf_startvol').val()},
					{name: 'sf_endvol', value: $('#sf_endvol').val()},
					{name: 'sf_numbera', value: $('#sf_numbera').val()}/*,
					{name: 'sf_numberb', value: $('#sf_numberb').val()},
					{name: 'sf_geo', value: $('#sf_geo').val()},
					{name: 'sf_calltype100', value: $('#sf_calltype100').is(':checked')},
					{name: 'sf_calltype101', value: $('#sf_calltype101').is(':checked')},
					{name: 'sf_calltype301', value: $('#sf_calltype301').is(':checked')}*/
				]
			});
			statcontrols_disable();
			return true;
		},
		onError: function () {
			statcontrols_enable();
		}
	});

	$('#bt_filters_apply').click(function () {
		$("#mblist").flexReload();
		return false;
	});

	$('#bt_mblist_del').click(function () {
		if (!confirm("Все файлы за указанный период будут удалены из системы безвозвратно. Продолжить?"))
			return false;

		$.blockUI({
			overlayCSS: {
				backgroundColor: '#e5e5e5',
				opacity: 0.3
			},
			css: {
				padding: '10px',
				backgroundColor: '#fff',
				'-webkit-border-radius': '2px',
				'-moz-border-radius': '2px',
				'border-radius': '2px',
				opacity: 0.9,
				color: '#a0a0a0',
				width: '250px'
			},
			message: '<img src="images\/pbari2.gif"><br><span class="lg">&nbsp;Удаление файлов...<\/span>'
		});
		$.ajax({
			type: 'POST',
			url: 'process.php',
			timeout: 300000,
			data: ({
				op: 'mblist_del',
				sf_range: $('#sf_range').val(),
				sf_startdate: $('#sf_startdate').val(),
				sf_enddate: $('#sf_enddate').val(),
				sf_numbera: $('#sf_numbera').val()
			}),
			dataType: 'json',
			success: function (data) {
				if (data.error)
					alert(data.error);
				else {
					$("#mblist").flexReload();
					if (data.total)
						alert("Файлов удалено: " + data.total + ".");
				}
			}
		});
		return false;
	});

	$("input[type=file]").filestyle({
		image: "images/btselectfile.png",
		imagewidth: 107,
		imageheight: 28,
		width: 250
	});

	$('#frm_putfile').iframer({
		returnType: 'jsontext',
		onComplete: function (data) {
			//alert(data); //returned data
			var jsondata = jQuery.parseJSON(data);

			var fmsg = "";
			if (jsondata.files.name)
				fmsg = jsondata.files.name + " (" + jsondata.files.size + " байт):&nbsp;";
			if (jsondata.status == 'ok') {
				//$('#synthz_add_file').reset();
				if (jsondata.msg)
					fmsg += "<span style='color:green;font-weight:bold;'>" + jsondata.msg + "<\/span>";
				else
					fmsg += "<span style='color:green;font-weight:bold;'>OK id=" + jsondata.fileid + "<\/span>";
				$('#bt_filters_apply').click();
			} else
				fmsg += "<span style='color:red;font-weight:bold;'>" + jsondata.error + "<\/span>";

			$('#synthz_upload_progress').hide();
			$('#synthz_upload_result_msg').html(fmsg);
			$('#synthz_upload_results').show();

			$('#synthz_upload_selector input[type="image"]').removeClass('disabled');
		}
	});

	$('#bt_synthz_upload').click(function () {
		if ($('#synthz_add_file').val().length == 0) {
			alert('Не выбран файл для отправки!');
			return false;
		}

		$(this).blur();

		$('#synthz_upload_selector input[type="image"]').addClass('disabled');
		$('#synthz_upload_results').hide();
		$('#synthz_upload_progress').show();

		$('#frm_putfile').submit();

		return false;
	});

});
