/*
 * Style File - jQuery plugin for styling file input elements
 *
 * Copyright (c) 2007-2008 Mika Tuupola
 *
 * Licensed under the MIT license:
 *   http://www.opensource.org/licenses/mit-license.php
 *
 * Based on work by Shaun Inman
 *   http://www.shauninman.com/archive/2007/09/10/styling_file_inputs_with_css_and_the_dom
 *
 * Revision: $Id: jquery.filestyle.js 303 2008-01-30 13:53:24Z tuupola $
 *
 */

(function ($) {
	$.fn.filestyle = function (options) {

		/* TODO: This should not override CSS. */
		var settings = {
			width: 250
		};

		if (options) {
			$.extend(settings, options);
		}

		return this.each(function () {
			var self = this;
			var wrapper = $("<div>")
				.css({
					"width": settings.imagewidth + "px",
					"height": settings.imageheight + "px",
					"background": "url(" + settings.image + ") 0 0 no-repeat",
					"background-position": "right",
					"display": "inline",
					"position": "absolute",
					"overflow": "hidden",
					"cursor": "pointer"
				});

			var filename = $('<input class="file">')
				.addClass($(self).attr("class"))
				.prop('readOnly', true)
				.css({
					"display": "inline",
					"width": settings.width + "px"
				});

			$(self).before(filename);
			$(self).wrap(wrapper);

			$(self).css({
				//"position": "relative",
				"position": "absolute",
				"right": "0",
				"top": "0",
				"height": "100%",//settings.imageheight + "px",
				//"width": settings.width + "px",
				"display": "inline",
				"cursor": "pointer",
				"font-size": "100px",
				"opacity": "0.0",
				"filter": "alpha(opacity = 0)",  /* IE lt 8 */
				"-ms-filter": "alpha(opacity=0)",  /* IE 8 */
				"-khtml-opacity": "0.0",  /* Safari 1.x */
				"-moz-opacity": "0.0"  /* FF lt 1.5, Netscape */
			});

			/*if ($.browser.mozilla) {
				if (/Win/.test(navigator.platform)) {
					$(self).css("margin-left", "-142px");
				} else {
					$(self).css("margin-left", "-168px");
				}
			} else {
				$(self).css("margin-left", settings.imagewidth - settings.width + "px");
			}*/

			$(self).bind("change", function () {
				var val = $(self).val();
				val = val.split('\\');
				val = val[val.length - 1];
				filename.val(val);
			});

		});
	};
})(jQuery);
