$(document).ready(function () {
	var activecalls = $("#activecalls");
	if (activecalls.length > 0) {
		activecalls.flexigrid({
			url: 'process.php',
			params: [
				{name: 'op', value: 'activecalls'}
			],
			dataType: 'json',
			colModel: [
				{display: '&nbsp;', name: 'flags', width: 18, sortable: false, align: 'right'},
				{display: 'Время вызова', name: 'calltime', width: 100, sortable: false, align: 'right'},
				{display: 'Длительность', name: 'realvolume', width: 75, sortable: false, align: 'right'},
				{display: 'Вызывающий', name: 'numbera', width: 85, sortable: false, align: 'right'},
				{display: '&nbsp;', name: 'ingeographyname', width: 195, sortable: false, align: 'left'},
				{display: 'Вызываемый', name: 'numberb', width: 85, sortable: false, align: 'right'}
			],
			sortname: "calltime",
			sortorder: "desc",
			title: "Активные вызовы",
			showToggleBtn: false,
			singleSelect: true,
			striped: false,
			usepager: true,
			useRp: false,
			rp: 500,
			rpOptions: [10, 50, 100, 150, 200],
			showTableToggleBtn: false,
			width: 650,
			height: 100,
			resizable: true,
			errormsg: 'Информация в данный момент недоступна. Попробуйте позже.',
			pagestat: 'Отображены вызовы с {from} по {to} из {total}',
			pagetext: 'Страница',
			outof: 'из',
			findtext: 'Поиск&nbsp;',
			procmsg: 'Обновление данных...',
			nomsg: 'В данный момент вызовы отсутствуют.',
			reloadhint: 'Обновить данные',
			autoload: false,
			preProcess: function (data) {
				if (data.error)
					$('#activecallstotals').html(data.error);
				else {
					$.each(data.rows, function (i, row) {
						if (row.cell[0] == '-1')
							row.cell[0] = '<img src="images/loading8.gif" title="Вызов в процессе дозвона или разговора">';
						else
							row.cell[0] = '<img src="images/icon_call.gif" title="Разговор завершен">';
					});
				}
				return data;
			},
			onSubmit: function () {
				$('#activecallstotals').html('&nbsp;');
				return true;
			}
		});

		activecalls.flexReload();
	}
});
