$(document).ready(function () {
	$("#mblist").flexigrid({
		url: 'process.php',
		params: [
			{name: 'op', value: 'mblist'}
		],
		dataType: 'json',
		colModel: [
			{display: '&nbsp;', name: 'flags', width: 52, sortable: false, align: 'right'},
			{display: '#', name: 'recordid', width: 50, sortable: false, align: 'right'},
			{display: 'Дата размещения', name: 'createdate', width: 100, sortable: false, align: 'right'},
			{display: 'Тип файла', name: 'messagetypeid', width: 160, sortable: false, align: 'right'},
			{display: 'Объем', name: 'messagesize', width: 90, sortable: false, align: 'right'},
			{display: 'Источник', name: 'numbera', width: 85, sortable: false, align: 'right'}
		],
		sortname: "createdate",
		sortorder: "desc",
		title: false,//'<div id="voiceplayer"></div>',
		showToggleBtn: false,
		singleSelect: true,
		striped: false,
		usepager: true,
		useRp: true,
		rp: 50,
		rpOptions: [10, 50, 100, 150, 200],
		showTableToggleBtn: false,
		width: 630,
		height: 300,
		resizable: true,
		errormsg: 'Данные в данный момент недоступны. Попробуйте позже.',
		pagestat: 'Отображены записи с {from} по {to} из {total}',
		pagetext: 'Страница',
		outof: 'из',
		findtext: 'Поиск&nbsp;',
		procmsg: 'Обновление данных...',
		nomsg: 'Данные отсутствуют',
		autoload: false,
		preProcess: function (data) {
			if (data.totalvol)
				$('#stattotals').html('Общий занимаемый объем в файловом хранилище: ' + data.totalvol);

			var icons, icons_json;
			var ic_type, ic_pfunc, ic_sfunc, ic_file;
			$.each(data.rows, function (i, row) {
				icons = '';
				icons_json = jQuery.parseJSON(row.cell[0]);
				if (parseInt(icons_json.recid)) {
					ic_type = null;
					switch (icons_json.typeid) {
						case 0:
							ic_type = 's';
							ic_pfunc = 'playVoice';
							ic_sfunc = 'saveVoice';
							ic_file = 'icon_synth.gif';
							break;
						case 2:
							ic_type = 'v';
							ic_pfunc = 'playVoice';
							ic_sfunc = 'saveVoice';
							ic_file = 'icon_voicemail.gif';
							break;
						case 9:
							ic_type = 'r';
							ic_pfunc = 'playVoice';
							ic_sfunc = 'saveVoice';
							ic_file = 'icon_record.gif';
							break;
						case 1:
							ic_type = 'f';
							ic_pfunc = 'showFax';
							ic_sfunc = 'saveFax';
							ic_file = 'icon_fax3.gif';
							break;
					}
					if (ic_type)
						icons += '<img class="p_ic" src="images/'+ic_file+'" data-type="'+ic_type+'" data-func="'+ic_pfunc+'" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" />'
							+ '<img class="s_ic" src="images/save.gif" data-type="'+ic_type+'" data-func="'+ic_sfunc+'" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" />'
							+ '<img class="d_ic" src="images/icon_closed.gif" data-type="'+ic_type+'" data-func="delFile" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" data-mid="' + icons_json.mid + '" />';
				}
				row.cell[0] = icons;
				row.cell[3] = mb_messagetypes[row.cell[3]];
			});
			return data;
		},
		onSuccess: function () {
			$('.t_ic')
				.attr({width: '16', height: '16', alt: ''})
				.css('margin-left', '4px');
			$('.p_ic, .s_ic, .d_ic')
				.attr({width: '16', height: '16', alt: ''})
				.each(function(){
					switch ($(this).attr('data-type')) {
						case 's':
							$(this).attr('title', 'голосовую фразу');
							break;
						case 'r':
							$(this).attr('title', 'запись разговора');
							break;
						case 'v':
							$(this).attr('title', 'голосовое сообщение');
							break;
						case 'f':
							$(this).attr('title', 'факсимильное сообщение');
							break;
					}
					if ($(this).hasClass('p_ic')) {
						if ($(this).attr('data-type') != 'f')
							$(this).attr('title', 'Прослушать ' + $(this).attr('title'));
						else
							$(this).attr('title', 'Открыть ' + $(this).attr('title'));
					} else if ($(this).hasClass('s_ic')) {
						$(this).attr('title', 'Сохранить ' + $(this).attr('title'));
					} else {
						$(this).attr('title', 'Удалить ' + $(this).attr('title'));
					}
				})
				.addClass('imglink')
				.click(function(){
					setTimeout($(this).attr('data-func') + "('" + $(this).attr('data-recid') + "', '" + $(this).attr('data-rect') + "', '" + $(this).attr('data-mid') + "');", 0);
					return false;
				});
			statcontrols_enable();
		},
		onSubmit: function () {
			$('#stattotals').html('&nbsp;');
			$("#mblist").flexOptions({
				params: [
					{name: 'op', value: 'mblist'},
					{name: 'sf_range', value: $('#sf_range').val()},
					{name: 'sf_startdate', value: $('#sf_startdate').val()},
					{name: 'sf_enddate', value: $('#sf_enddate').val()},
					{name: 'sf_startvol', value: $('#sf_startvol').val()},
					{name: 'sf_endvol', value: $('#sf_endvol').val()},
					{name: 'sf_numbera', value: $('#sf_numbera').val()}/*,
					{name: 'sf_numberb', value: $('#sf_numberb').val()},
					{name: 'sf_geo', value: $('#sf_geo').val()},
					{name: 'sf_calltype100', value: $('#sf_calltype100').is(':checked')},
					{name: 'sf_calltype101', value: $('#sf_calltype101').is(':checked')},
					{name: 'sf_calltype301', value: $('#sf_calltype301').is(':checked')}*/
				]
			});
			statcontrols_disable();
			return true;
		},
		onError: function () {
			statcontrols_enable();
		}
	});

	$('#bt_filters_apply').click(function () {
		$("#mblist").flexReload();
		return false;
	});

	$('#bt_mblist_del').click(function () {
		if (!confirm("Все файлы за указанный период будут удалены из системы безвозвратно. Продолжить?"))
			return false;

		$.blockUI({
			overlayCSS: {
				backgroundColor: '#e5e5e5',
				opacity: 0.3
			},
			css: {
				padding: '10px',
				backgroundColor: '#fff',
				'-webkit-border-radius': '2px',
				'-moz-border-radius': '2px',
				'border-radius': '2px',
				opacity: 0.9,
				color: '#a0a0a0',
				width: '250px'
			},
			message: '<img src="images\/pbari2.gif"><br><span class="lg">&nbsp;Удаление файлов...<\/span>'
		});
		$.ajax({
			type: 'POST',
			url: 'process.php',
			timeout: 300000,
			data: ({
				op: 'mblist_del',
				sf_range: $('#sf_range').val(),
				sf_startdate: $('#sf_startdate').val(),
				sf_enddate: $('#sf_enddate').val(),
				sf_numbera: $('#sf_numbera').val()
			}),
			dataType: 'json',
			success: function (data) {
				if (data.error)
					alert(data.error);
				else {
					$("#mblist").flexReload();
					if (data.total)
						alert("Файлов удалено: " + data.total + ".");
				}
			}
		});
		return false;
	});


	$('#bt_mblist_save_tar').click(function () {
		$('#sf_format').val('tar');
		$('#bt_mblist_save').click();
	});
	$('#bt_mblist_save_zip').click(function () {
		$('#sf_format').val('zip');
		$('#bt_mblist_save').click();
	});

	
	// save all files as one and download it ----------------------------------------------------
	$('#bt_mblist_save').click(function () {
		if (!confirm("Выгрузить все файлы?")) return false;
		var sumvolume = $('#stattotals').html();
		var RegExp = /Общий занимаемый объем в файловом хранилище: /;
		sumvolume = sumvolume.replace(RegExp,'');
		RegExp = / Кб/;
		sumvolume = sumvolume.replace(RegExp,'/1000');
		RegExp = / Мб/;
		sumvolume = sumvolume.replace(RegExp,'');
		RegExp = / Гб/;
		sumvolume = sumvolume.replace(RegExp,'*1000');
		sumvolume = eval(sumvolume);
		if( sumvolume >=100 ) {alert('Суммарный объем выгружаемых файлов не должен превышать 100 Мб!'); return false;}

		$("#frm_wait_load_fromfileserver").dialog('open');
		
		var filename = '';
		var filepath = '';
		$.when( 
			$.ajax({ // upload from fileserver into one file
				type: 'POST',
				url: 'process.php',
				timeout: 300000,
				//athync: false,
				data: ({
					op: 'mblist_save',
					sf_range: $('#sf_range').val(),
					sf_startdate: $('#sf_startdate').val(),
					sf_enddate: $('#sf_enddate').val(),
					sf_numbera: $('#sf_numbera').val(),
					sf_format: $('#sf_format').val()
				}),
				dataType: 'json',
				success: function (data) {
					filename = data.filename;
				}
			})
		).done( 
			function(){
				setTimeout(
				function(){ // download .tar file from host
					var iframe = document.createElement('iframe');
					iframe.id = "IFRAMEID";
					iframe.style.display = 'none';
					document.body.appendChild(iframe);
					iframe.src = filename;
					iframe.addEventListener("load", function () {
						 console.log("FILE LOAD DONE.. Download should start now");
					});				
				}
				,500);

				$("#frm_wait_load_fromfileserver").dialog('close');
			} 
		);
		/*
		$.when( 
			$.ajax({ // upload from fileserver into one file
				type: 'POST',
				url: 'process.php',
				timeout: 300000,
				data: ({
					op: 'mblist_save',
					sf_range: $('#sf_range').val(),
					sf_startdate: $('#sf_startdate').val(),
					sf_enddate: $('#sf_enddate').val(),
					sf_numbera: $('#sf_numbera').val()
				}),
				dataType: 'json',
				success: function (data) {
					filename = data.filename;
				}
			})
		).done( 
			function(){
				$.when(
					setTimeout(
					function(){ // download .tar file from host
						var iframe = document.createElement('iframe');
						iframe.id = "IFRAMEID";
						iframe.style.display = 'none';
						document.body.appendChild(iframe);
						iframe.src = filename;
						iframe.addEventListener("load", function () {
							 //console.log("FILE LOAD DONE.. Download should start now");
							 alert(254);
						});				
					}
					,500)
				).done(function(){ setTimeout( function(){alert('has done');},500); });
			}
		);
		*/

/*		
		// upload files from fileserver, convert them into mp3, packing in .tar file
		var upload_promise = new Promise(function(resolve, reject) {
			$.ajax({ 
				type: 'POST',
				url: 'process.php',
				timeout: 300000,
				data: ({
					op: 'mblist_save',
					sf_range: $('#sf_range').val(),
					sf_startdate: $('#sf_startdate').val(),
					sf_enddate: $('#sf_enddate').val(),
					sf_numbera: $('#sf_numbera').val()
				}),
				dataType: 'json',
				success: function (data) {
					filename = data.filename;
					resolve("result"); // return result when done
				},
				error: function(){
					reject("error"); // reject error
				}
			});
		});

		
		// addEventListener on upload_promise (обработчик событий)
		upload_promise.then(
			result => {
				var div_load = document.createElement('div');
				div_load.style.display = 'none';
				document.body.appendChild(div_load);
				div_load.innerHTML = '<iframe src="'+filename+'" onload="" onreadystatechange=""></iframe>';
			},
			error => {
			  alert("error: In files upload from fileserver");
			}
		);
*/
  
		
	});


});


$(function() {
	$( "#frm_wait_load_fromfileserver" ).dialog({ 
		modal:true,
		autoOpen:false,
		width:250,
		height:80,
		draggable: false,
		resizable:false
	}).siblings('.ui-dialog-titlebar').remove();
});	

