//Player copyright http://wpaudioplayer.com/standalone

//$('html').css('overflow', 'hidden');

/* STARTUP */
var JSdocs = [
	"js/audio-player.js"
];

var CSSdocs = [
	"jsdojo17/dijit/themes/tundra/tundra.css",
	"",
	"styles/menu_styles.css"
];

$(document).ready(function () {
	$("input[type=file]").filestyle({
		image: "images/btselectfile.png",
		imagewidth: 107,
		imageheight: 28,
		width: 250
	});

	$('#frm_putfile').iframer({
		returnType: 'jsontext',
		onComplete: function (data) {
			//alert(data); //returned data
			var jsondata = jQuery.parseJSON(data);

			var fmsg = "";
			if (jsondata.files.name)
				fmsg = jsondata.files.name + " (" + jsondata.files.size + " байт):&nbsp;";
			if (jsondata.status == 'ok') {
				//$('#synthz_add_file').reset();
				if (jsondata.msg)
					fmsg += "<span style='color:green;font-weight:bold;'>" + jsondata.msg + "<\/span>";
				else
					fmsg += "<span style='color:green;font-weight:bold;'>OK id=" + jsondata.fileid + "<\/span>";
				loadSynthzList();
			} else
				fmsg += "<span style='color:red;font-weight:bold;'>" + jsondata.error + "<\/span>";

			$('#synthz_upload_progress').hide();
			$('#synthz_upload_result_msg').html(fmsg);
			$('#synthz_upload_results').show();

			$('#synthz_upload_selector input[type="image"]').removeClass('disabled');
		}
	});

	$('#bt_synthz_upload').click(function () {
		if ($('#synthz_add_file').val().length == 0) {
			alert('Не выбран файл для отправки!');
			return false;
		}

		$(this).blur();

		$('#synthz_upload_selector input[type="image"]').addClass('disabled');
		$('#synthz_upload_results').hide();
		$('#synthz_upload_progress').show();

		$('#frm_putfile').submit();

		return false;
	});

	$('#synthz_upload_selector input[type="image"]').removeClass('disabled');

});

function loadJSFiles() {
	var head = document.getElementsByTagName("head")[0];
	for (var i = 0; i < JSdocs.length; i++) {
		var el = document.createElement("script");
		el.setAttribute("type", "text/javascript");
		el.setAttribute("src", JSdocs[i]);
		head.appendChild(el);
	}
}

function loadCSSFiles() {
	var head = document.getElementsByTagName("head")[0];
	var themed = true;
	for (var i = 0; i < CSSdocs.length; i++) {
		if (CSSdocs[i] == '') {
			themed = false;
			continue;
		}
		var el = document.createElement("link");
		if (themed)
			el.setAttribute("id", "themeStyles");
		el.setAttribute("rel", "stylesheet");
		el.setAttribute("type", "text/css");
		el.setAttribute("href", CSSdocs[i]);
		head.appendChild(el);
	}
}
//window.onload = loadJSFiles;

//loadJSFiles();
//loadCSSFiles();

function InitPlayers(plid) {
	if (!plid)
		AudioPlayer.setup("player.swf", {
			width:280,
			autostart:"no",
			animation:"no",
			remaining:"yes",
			noinfo:"no",
			buffer:10,
			initialvolume:35,
			transparentpagebg:"yes",
			leftbg:"FFFFFF",
			voltrack:"FFFFFF",
			volslider:"FFFFFF",
			rightbg:"FFFFFF",
			rightbghover:"FFFFFF",
			righticon:"FFFFFF",
			righticonhover:"FFFFFF",
			skip:"FFFFFF",
			bg:"FFFFFF",
			left:"FFFFFF",
			lefticon:"FFFFFF"
		});
	else
		AudioPlayer.embed(plid, {
			soundFile:"intro.mp3", //Для прослушивания записи разговора кликните на соответствующую иконку в строке таблицы
			artists:"",
			titles:" ",
			autostart:"no"
		});
}

dojo.addOnLoad(function () {
	var mode = '';
	if (document.getElementById('preloader'))
		mode = 'menu';
	else
	if (document.getElementById('preloader_synths'))
		mode = 'synths';
	else
	if (document.getElementById('preloader_faxupload'))
		mode = 'faxupload';

	if (mode == '')
		return;

	document.body.className = 'tundra';

	//dojo.require("dojo.dnd.Source");
	dojo.require("dojo.data.ItemFileReadStore");

	dojo.require("dojo.io.iframe");

	dojo.require("dijit.dijit"); // optimize: load dijit layer

	dojo.require("dijit.form.Button");
	dojo.require("dijit.form.ValidationTextBox");
	dojo.require("dijit.ProgressBar");
	//dojo.require("dojox.form.FileInputAuto");
	dojo.require("dojox.form.FileInput");
	//dojo.require("dojox.embed.Flash");
	//dojo.require("dojox.embed.Object");
	//dojo.require("dojox.encoding.base64");

	if (mode == 'menu' || mode == 'synths') {
		dojo.require("dijit.form.MultiSelect");
		dojo.require("dijit.Dialog");
		dojo.require("dijit.layout.TabContainer");
		dojo.require("dijit.layout.ContentPane");
		dojo.require("dijit.TitlePane");
		dojo.require("dijit.form.SimpleTextarea");
	}

	if (mode == 'menu') {
		dojo.require("dijit.form.TextBox");
		dojo.require("dijit.form.Textarea");
		dojo.require("dijit.form.FilteringSelect");

		dojo.require("dijit.form.CheckBox");
		dojo.require("dijit.form.RadioButton");

		dojo.require("dijit.form.NumberSpinner");

		dojo.require("dijit.TooltipDialog");
		dojo.require("dijit.Toolbar");
		dojo.require("dijit.ToolbarSeparator");

		dojo.require("dijit.Menu");
		dojo.require("dijit.MenuItem");
		dojo.require("dijit.PopupMenuItem");
		dojo.require("dijit.MenuSeparator");
		dojo.require("dijit.CheckedMenuItem");

		dojo.require("dijit.form.HorizontalSlider");
		dojo.require("dijit.form.HorizontalRuleLabels");
		dojo.require("dijit.form.HorizontalRule");
	}

	dojo.require("dojo.parser");	// scan page for widgets and instantiate them

	dojo.addOnLoad(function () {
		if (mode == 'menu' || mode == 'synths') {
			dojo.declare("dijit.SimTitlePane", dijit.TitlePane, {
				templateString:'<div class="dijitTitlePane">' +
						'    <div class="dijitTitlePaneTitle" dojoAttachPoint="titleBarNode" style="cursor: default;">' +
						'        <div style="display:none;" dojoAttachPoint="focusNode" class="dijitInline"><span dojoAttachPoint="arrowNodeInner" class="dijitArrowNodeInner"></span></div>' +
						'        <div dojoAttachPoint="titleNode" class="dijitTitlePaneTextNode"></div>' +
						'    </div>' +
						'    <div class="dijitTitlePaneContentOuter" dojoAttachPoint="hideNode">' +
						'        <div class="dijitReset" dojoAttachPoint="wipeNode">' +
						'            <div class="dijitTitlePaneContentInner" dojoAttachPoint="containerNode" waiRole="region" tabindex="-1">' +
						'            </div>' +
						'        </div>' +
						'    </div>' +
						'</div>'
			});
			dojo.declare("dijit.form.SimpleTextareaNoWrap", dijit.form.SimpleTextarea, {
				templateString:"<textarea ${nameAttrSetting} dojoAttachPoint='focusNode,containerNode,textbox' autocomplete='off' wrap='off'></textarea>"
			});
		}

		// make dojo.toJson() print dates correctly (this feels a bit dirty)
		Date.prototype.json = function () {
			return dojo.date.stamp.toISOString(this, {selector:'date'});
		};

		dojo.parser.parse();

		dojo.addOnLoad(function () {
			if (mode == 'menu' || mode == 'synths') {
				resetForms();
				loadSynthzList();
				if (mode == 'menu') {
					updateItemNamesControls();
					loadExternalData();
					loadMenuList();
					toolbarToggleMenuControls(office_menuid >= 0);
				}
			}

			//dijit.byId('voice_item_synthez_place').textbox.disabled = true;
			//dijit.byId('condition_processor_name').textbox.disabled = true;
			//dijit.byId('condition_data').textbox.wrap = 'off';
			//dijit.byId('condition_data').attr('wrap', 'off');

			/*dojo.connect(dijit.byId('dlgMenuItemProps_tabs'), 'selectChild', function (page) {
			 //alert(page.id);
			 dojo.style('dlgMenuItemProps_tabs', 'width', ((page.id == 'dlgMenuItemProps_Cond')?'700':'400') + 'px');
			 dojo.style('dlgMenuItemProps_Cond', 'width', '98%');
			 });*/

			/*var synplayer = new dojox.embed.Flash({
			 path: "player.swf",
			 id: "player",
			 width: 400,
			 height: 30
			 }, "synplayer");*/

			if (mode == 'menu' || mode == 'synths') {
				setTimeout('InitPlayers();', 1000);
				setTimeout('InitPlayers("synplayer");', 1500);
				setTimeout('InitPlayers("synplayerg");', 2000);
			}

			if (typeof(window.OnAfterLoad) == 'function')
				OnAfterLoad();

			hideLoader();
		});
	});
});
/* /STARTUP */

/* encoding */
function utf8_encode(string) {
	// http://kevin.vanzonneveld.net
	// +   original by: Webtoolkit.info (http://www.webtoolkit.info/)
	// +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
	// +   improved by: sowberry
	// +    tweaked by: Jack
	// +   bugfixed by: Onno Marsman
	// +   improved by: Yves Sucaet
	// +   bugfixed by: Onno Marsman
	// *     example 1: utf8_encode('Kevin van Zonneveld');
	// *     returns 1: 'Kevin van Zonneveld'

	string = (string + '').replace(/\r\n/g, "\n").replace(/\r/g, "\n");

	var utftext = "";
	var start, end;
	var stringl = 0;

	start = end = 0;
	stringl = string.length;
	for (var n = 0; n < stringl; n++) {
		var c1 = string.charCodeAt(n);
		var enc = null;

		if (c1 < 128) {
			end++;
		} else if ((c1 > 127) && (c1 < 2048)) {
			enc = String.fromCharCode((c1 >> 6) | 192) + String.fromCharCode((c1 & 63) | 128);
		} else {
			enc = String.fromCharCode((c1 >> 12) | 224) + String.fromCharCode(((c1 >> 6) & 63) | 128) + String.fromCharCode((c1 & 63) | 128);
		}
		if (enc != null) {
			if (end > start) {
				utftext += string.substring(start, end);
			}
			utftext += enc;
			start = end = n + 1;
		}
	}

	if (end > start) {
		utftext += string.substring(start, string.length);
	}

	return utftext;
}

function base64_encode(data) {
	// http://kevin.vanzonneveld.net
	// +   original by: Tyler Akins (http://rumkin.com)
	// +   improved by: Bayron Guevara
	// +   improved by: Thunder.m
	// +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
	// +   bugfixed by: Pellentesque Malesuada
	// +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
	// -    depends on: utf8_encode
	// *     example 1: base64_encode('Kevin van Zonneveld');
	// *     returns 1: 'S2V2aW4gdmFuIFpvbm5ldmVsZA=='

	// mozilla has this native
	// - but breaks in 2.0.0.12!
	//if (typeof window['atob'] == 'function') {
	//    return atob(data);
	//}

	var b64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	var o1, o2, o3, h1, h2, h3, h4, bits, i = 0, ac = 0, enc = "", tmp_arr = [];

	if (!data) {
		return data;
	}

	data = utf8_encode(data + '');

	do { // pack three octets into four hexets
		o1 = data.charCodeAt(i++);
		o2 = data.charCodeAt(i++);
		o3 = data.charCodeAt(i++);

		bits = o1 << 16 | o2 << 8 | o3;

		h1 = bits >> 18 & 0x3f;
		h2 = bits >> 12 & 0x3f;
		h3 = bits >> 6 & 0x3f;
		h4 = bits & 0x3f;

		// use hexets to index into b64, and append result to encoded string
		tmp_arr[ac++] = b64.charAt(h1) + b64.charAt(h2) + b64.charAt(h3) + b64.charAt(h4);
	} while (i < data.length);

	enc = tmp_arr.join('');

	switch (data.length % 3) {
		case 1:
			enc = enc.slice(0, -2) + '==';
			break;
		case 2:
			enc = enc.slice(0, -1) + '=';
			break;
	}

	return enc;
}

function encode64(inp) {
	var out = "";
	var chr1, chr2, chr3 = "";
	var enc1, enc2, enc3, enc4 = "";
	var i = 0;

	if (inp)
		do {
			chr1 = inp.charCodeAt(i++);
			chr2 = inp.charCodeAt(i++);
			chr3 = inp.charCodeAt(i++);
			enc1 = chr1 >> 2;
			enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
			enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
			enc4 = chr3 & 63;

			if (isNaN(chr2)) {
				enc3 = enc4 = 64;
			} else if (isNaN(chr3)) {
				enc4 = 64;
			}
			out = out + keyStr.charAt(enc1) + keyStr.charAt(enc2) + keyStr.charAt(enc3) +
					keyStr.charAt(enc4);
			chr1 = chr2 = chr3 = "";
			enc1 = enc2 = enc3 = enc4 = "";

		} while (i < inp.length);

	return out;
}

function decode64(inp) {
	var out = "";
	var chr1, chr2, chr3 = "";
	var enc1, enc2, enc3, enc4 = "";
	var i = 0;
	var base64test = /[^A-Za-z0-9\+\/\=]/g;

//	if (base64test.exec(inp)) {
//		alert("There were invalid base64 characters in the input text.\n" +
//		"Valid base64 characters are A-Z, a-z, 0-9, ?+?, ?/?, and ?=?\n" +
//		"Expect errors in decoding.");
//	}
	inp = inp.replace(/[^A-Za-z0-9\+\/\=]/g, "");

	if (inp)
		do {
			enc1 = keyStr.indexOf(inp.charAt(i++));
			enc2 = keyStr.indexOf(inp.charAt(i++));
			enc3 = keyStr.indexOf(inp.charAt(i++));
			enc4 = keyStr.indexOf(inp.charAt(i++));
			chr1 = (enc1 << 2) | (enc2 >> 4);
			chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
			chr3 = ((enc3 & 3) << 6) | enc4;
			out += String.fromCharCode(chr1);

			if (enc3 != 64) {
				out += String.fromCharCode(chr2);
			}
			if (enc4 != 64) {
				out += String.fromCharCode(chr3);
			}
			chr1 = chr2 = chr3 = "";
			enc1 = enc2 = enc3 = enc4 = "";

		} while (i < inp.length);
	return out;
}
/* /encoding */

function focusFirstInput(what) {
	setTimeout(dojo.hitch(what, function () {
		dijit.focus(dojo.query('input:enabled', what)[0]);
	}), 200);
}

function servicetypeLabelFunc(item, store) {
	//var labelparts = new String(store.getValue(item, 'description'));
	//labelparts = labelparts.split(": ");
	//return labelparts[labelparts.length - 1];
	return '<strong>' + item.id + '</strong>&nbsp;&nbsp;' + item.description;
}

function menuLabelFunc(item, store) {
	var labelparts = new String(store.getValue(item, 'menu_name'));
	labelparts = labelparts.split(": ");
	return labelparts[labelparts.length - 1];
}

function toolbarToggleMenuControls(bEnable) {
	if (dijit.byId('btMenuSynthzDlg')) {
		dijit.byId('btMenuSynthzDlg').attr('disabled', !bEnable);
		dijit.byId('btMenuNewConnDlg').attr('disabled', !bEnable);
		dijit.byId('btMenuNewItemDlg').attr('disabled', !bEnable);
		dijit.byId('btMenuGraphZoomDlg').attr('disabled', !bEnable);
		dijit.byId('btMenuRefreshDlg').attr('disabled', !bEnable);
		if (dijit.byId('btMenuInfoDlg'))
			dijit.byId('btMenuInfoDlg').attr('disabled', !bEnable);

		//dijit.byId('btMenuOfficeSetupDlg').attr('disabled', !bEnable);
		if (bEnable) {
			dijit.byId('btMenuOfficeSetupDlg').domNode.style.color = "#000";
			//dijit.byId('btMenuOfficeSetupDlg').domNode.style.backgroundColor = "transparent";
		} else {
			dijit.byId('btMenuOfficeSetupDlg').domNode.style.color = "#008000";
			//dijit.byId('btMenuOfficeSetupDlg').domNode.style.backgroundColor = "#57d486";
		}
	}
}

var ITEM_PROPS_EMPTY = -1;
var dlgMenuItemProps_ItemId = ITEM_PROPS_EMPTY;

function showMenuItemProps(itemid) {
	//if (dlgMenuItemProps_IsOpened)
	//return;

	var dlg = dijit.byId('dlgMenuItemProps');

	if (dlg.attr('open'))
		return;

	if (itemid == ITEM_PROPS_EMPTY)
		dlg.attr('title', 'Новый элемент сценария');
	else
		dlg.attr('title', 'Свойства элемента #' + itemid);

	dlgMenuItemProps_ItemId = itemid;

	//dojo.style('dlgMenuItemProps_content', 'display', 'none');
	//dojo.style('dlgMenuItemProps_loading', 'display', 'block');
	dojo.style('dlgMenuItemProps_content', {"opacity":0, "filter":"alpha(opacity=0)"});
	dojo.style('lMenuItemProps_loading', 'display', '');

	resetForms();

	dlg.show();
}

var CONN_PROPS_EMPTY = '-1|-1';
var dlgMenuConnProps_ItemId = CONN_PROPS_EMPTY;

function showMenuConnProps(connid_key) {
	//if (dlgMenuConnProps_IsOpened)
	//return;

	var dlg = dijit.byId('dlgMenuConnProps');

	if (dlg.attr('open'))
		return;

	var title = '';
	if (connid_key == CONN_PROPS_EMPTY)
		title = 'Новый переход сценария';
	else {
		var arrconn = new String(connid_key);
		arrconn = arrconn.split("|");
		title = 'Свойства перехода #' + arrconn[0];
	}
	dlg.attr('title', title);

	dlgMenuConnProps_ItemId = connid_key;

	//dojo.style('dlgMenuConnProps_content', 'display', 'none');
	//dojo.style('dlgMenuConnProps_loading', 'display', 'block');
	dojo.style('lMenuConnProps_loading', 'display', '');
	dojo.style('dlgMenuConnProps_content', {"opacity":0, "filter":"alpha(opacity=0)"});

	resetForms();

	dlg.show();
}

/*var
 MX, MY;
 document.onmousemove = getMouseCoordinates;
 function getMouseCoordinates(event) {
 ev = event || window.event;
 MX = ev.pageX;
 MY = ev.pageY;
 }*/

function showMenuSynthz(selectmode) {
	var dlg = dijit.byId('dlgMenuSynthz');

	dlgMenuSynthz_SelectMode = selectmode;

	//dojo.style('dlgMenuSynthz_content', 'display', 'none');
	//dojo.style('dlgMenuSynthz_loading', 'display', 'block');
	dojo.style('lMenuSynthz_loading', 'display', '');
	dojo.style('dlgMenuSynthz_content', {"opacity":0, "filter":"alpha(opacity=0)"});

	dlg.show();
}

function showMessageInfo(msg) {
	dojo.byId('dlgInfoMessage_msg').innerHTML = '&nbsp;' + msg;
	var dlg = dijit.byId('dlgInfoMessage');
	dlg.show();
}

function showMessageError(msg) {
	dojo.byId('dlgErrorMessage_msg').innerHTML = '&nbsp;' + msg;
	var dlg = dijit.byId('dlgErrorMessage');
	dlg.show();
}

function RebuildExtendedSelectControls(list, hlist, reverse) {
	var obj_list = document.getElementById(list);
	var obj_list_sel = document.getElementById(hlist);
	if (obj_list && obj_list_sel) {
		if (reverse) {
			obj_list.length = 0;

			var arrval = new String(obj_list_sel.value);
			arrval = arrval.split(',');
			for (var i in arrval) {
				if (arrval[i]) {
					//fetch synth description
					var descr = '';
					var onItem = function (item) {
						if (item)
							descr = globasynthzstore.getValue(item, 'description', '');
					};
					var onError = function (err) {
						//alert(err);
					};
					globasynthzstore.fetchItemByIdentity({identity:arrval[i], onItem:onItem, onError:onError});

					//create option
					var opt = document.createElement('option');
					if (descr != '')
						descr = ': ' + descr;
					opt.text = arrval[i] + descr;  //': А это текстовое описание синтезатора (ToDo)';
					opt.value = arrval[i];
					opt.className = 'fancyselectoption';
					try {
						obj_list.add(opt, null); // standards compliant; doesn't work in IE
					} catch (ex) {
						obj_list.add(opt); // IE only
					}
				}
			}
		} else {
			var val = "";
			for (var i = 0; i < obj_list.length; i++) {
				if (obj_list.options[i].value != "") {
					if (val == "")
						val = obj_list.options[i].value;
					else
						val = val + "," + obj_list.options[i].value;
				} else {
					break;
				}
			}
			obj_list_sel.value = val;
		}
	}
}

function DeleteSelectedListItems(list, hlist) {
	var obj_list = document.getElementById(list);
	if (obj_list) {
		var selcnt = 0;
		for (var i = obj_list.length - 1; i >= 0; i--)
			if (obj_list.options[i].selected)
				selcnt++;

		if (selcnt > 0) {
			if (!confirm("Элементов выбрано: " + selcnt + "\nУдалить?"))
				return false;

			for (var i = obj_list.length - 1; i >= 0; i--)
				if (obj_list.options[i].selected)
					obj_list.remove(i);

			RebuildExtendedSelectControls(list, hlist);
		} else
			showMessageError("В списке нет выбранных элементов!");
	}
	return true;
}

function GetSelectedListItemsIds(list, reverse, prefix, suffix, addtitle) {
	var res = "";
	var i;
	var obj_list = document.getElementById(list);
	if (obj_list) {
		if (reverse) {
			for (i = obj_list.length - 1; i >= 0; i--)
				if (obj_list.options[i].selected) {
					if (addtitle)
						suf = '&ttl=' + base64_encode(obj_list.options[i].value) + suffix;
					else
						suf = suffix;
					if (res == "")
						res = prefix + obj_list.options[i].value + suf;
					else
						res = res + "," + prefix + obj_list.options[i].value + suf;
				}
		} else {
			for (i = 0; i <= obj_list.length - 1; i++)
				if (obj_list.options[i].selected) {
					if (addtitle)
						suf = '&ttl=' + base64_encode(obj_list.options[i].value) + suffix;
					else
						suf = suffix;
					if (res == "")
						res = prefix + obj_list.options[i].value + suf;
					else
						res = res + "," + prefix + obj_list.options[i].value + suf;
				}
		}
	}
	return res;
}

function MoveSelectedListItems(side, list, hlist) {
	var obj_list = document.getElementById(list);
	//fill an array with values to Up/Down
	var temp1 = new Array();
	var current1 = 0;
	var tmpText;
	var tmpValue;
	var tmpClass;
	var option1;
	var option2;
	var i;

	if (side == "up") {
		for (i = 0; i < obj_list.length; i++) {
			if (obj_list.options[i].selected) {
				temp1[current1++] = i;
				if (i > 0) {
					option1 = obj_list.options[i - 1];
					option2 = obj_list.options[i];
					tmpText = option1.text;
					tmpValue = option1.value;
					tmpClass = option1.className;
					option1.value = option2.value;
					option1.text = option2.text;
					option1.className = option2.className;
					option2.value = tmpValue;
					option2.text = tmpText;
					option2.className = tmpClass;
					obj_list.options[i].selected = false;
				} else {
					break;
				}
			}
		}
	} else {
		for (i = obj_list.length - 1; i >= 0; i--) {
			if (obj_list.options[i].selected) {
				temp1[current1++] = i;
				if (i < (obj_list.length - 1)) {
					option1 = obj_list.options[i];
					option2 = obj_list.options[i + 1];
					tmpText = option1.text;
					tmpValue = option1.value;
					tmpClass = option1.className;
					option1.value = option2.value;
					option1.text = option2.text;
					option1.className = option2.className;
					option2.value = tmpValue;
					option2.text = tmpText;
					option2.className = tmpClass;
					obj_list.options[i].selected = false;
				} else {
					//wall
					break;
				}
			}
		}
	}

	for (i = 0; i < current1; i++) {
		if (side == "up") {
			if (temp1[i] > 0) {
				obj_list.options[temp1[i] - 1].selected = true;
			} else {
				break;
			}
		} else {
			if (temp1[i] < (obj_list.length - 1)) {
				obj_list.options[temp1[i] + 1].selected = true;
			} else {
				break;
			}
		}
	}

	RebuildExtendedSelectControls(list, hlist);
}

var ERR_COMMON = 'Ошибка при получении данных с сервера! Дальнейшая работа может быть нарушена.';

var hideLoader = function () {
	if (dojo.byId('preloader'))
		dojo.style("preloader", "display", "none");
	if (dojo.byId('preloader_synths'))
		dojo.style("preloader_synths", "display", "none");
	if (dojo.byId('preloader_faxupload'))
		dojo.style("preloader_faxupload", "display", "none");
	if (dojo.byId('menugraphcont'))
		dojo.style("menugraphcont", "display", "block");

	$('html').css('overflow', 'auto');

	/*dojo.fadeOut({
	 node:"preloader",
	 duration:500,
	 onEnd: function() {
	 dojo.style("preloader", "display", "none");
	 dojo.style("menugraphcont", "display", "block");
	 // $("#preloader").css("display","none");
	 }
	 }).play();*/
};

function resetForms() {
	//loadSynthzList();

	// dlgMenuItemProps
	/*dojo.byId('ActiveSynthz').innerHTML = '';
	 ActiveSynthzDragSource.clearItems();
	 dojo.byId('AllSynthz').innerHTML = '';
	 AllSynthzDragSource.clearItems();*/

	//dijit.byId('dlgMenuItemProps').attr('value', null);
	if (dijit.byId('dlgMenuItemProps')) {
		//dijit.byId("dlgMenuItemProps_tabs").selectChild("dlgMenuItemProps_Main");
		dijit.byId('dlgMenuItemProps').attr('value', {
			"item_id":null,
			//"item_service_id": 1,
			"item_connection_id":null,
			"item_name":"",
			"item_user_editable":0,
			"voice_item_synthez":"",
			"voice_item_synthez_edit":null,
			"voice_item_synthez_place":1,
			"voice_item_timeout":1000,
			"voice_item_repeat_count":1,
			"voice_item_macro_name":"",
			"condition_processor_name":'SQL_CONDITION',
			//"condition_data_params":"",
			"condition_data":""
		});
		//dijit.byId('dlgMenuItemProps_debug').attr('value', "");
		//dijit.byId('voice_item_synthez_place').attr('value', 1);
		//dijit.byId('voice_item_timeout').attr('value', 1000);
		//dijit.byId('voice_item_repeat_count').attr('value', 0);
		dijit.byId('btMenuItemProps_OK').attr('disabled', true);
		RebuildExtendedSelectControls('voice_item_synthez_edit', 'voice_item_synthez', true);
	}

	if (dijit.byId('dlgUserSynthEdit')) {
		//dijit.byId("dlgMenuItemProps_tabs").selectChild("dlgMenuItemProps_Main");
		dijit.byId('dlgUserSynthEdit').attr('value', {
			"item_id":null,
			//"item_service_id": 1,
			"item_connection_id":null,
			"voice_item_synthez":"",
			"voice_item_synthez_edit":null
		});
		dijit.byId('btUserSynthEdit_OK').attr('disabled', true);
		RebuildExtendedSelectControls('voice_item_synthez_edit', 'voice_item_synthez', true);
	}

	if (dijit.byId('dlgSynthControlEdit')) {
		dijit.byId('dlgSynthControlEdit').attr('value', {
			"item_id":null,
			//"item_service_id": 1,
			"item_connection_id":null,
			"voice_item_synthez":"",
			"voice_item_synthez_edit":null
		});
		dijit.byId('btSynthControlEdit_OK').attr('disabled', true);
		RebuildExtendedSelectControls('voice_item_synthez_edit', 'voice_item_synthez', true);
	}

	// dlgMenuConnProps
	if (dijit.byId('dlgMenuConnProps')) {
		dijit.byId('dlgMenuConnProps').attr('value', {
			"conn_src_item_id":null,
			"conn_dst_item_id":null,
			"conn_item_connection_id":null,
			"conn_item_key":"",
			"conn_item_key_description":""
		});
		//dijit.byId('dlgMenuConnProps_debug').attr('value', "");
		dijit.byId('btMenuConnProps_OK').attr('disabled', true);
	}
}

var globasynthzstore = null;
function loadSynthzList() {
	// summary: for each item in the datastore generate a row in the table
	if (typeof(globasynthzstore) === 'undefined' || !globasynthzstore) {
		globasynthzstore = new dojo.data.ItemFileReadStore({
			jsId:'globasynthzstore',
			url:'menu_synthz.php' + (dojo.byId('ivr_edit') ? '?ivr_edit=1' : ''),
			clearOnClose:true,
			urlPreventCache:true
		});
	}
	var request = {
		query:{ },
		onComplete:function (items, request) {
			//dijit.byId('dlgMenuSynthz_debug').attr('value', dojo.toJson(items, true));
			var dlg = dijit.byId('dlgMenuSynthz');
			if (dlg.attr('open'))
				dlgMenuSynthz_UpdateGlobalSynthzList();
		},
		onError:function (e, request) {
			console.warn(e, request);
			showMessageError(ERR_COMMON);
		}
	};
	if (typeof(globasynthzstore) !== 'undefined' && globasynthzstore) {
		globasynthzstore.close();
		globasynthzstore.fetch(request);
	}
}

//var menuliststore = null;
var office_menuid = -1;
function loadMenuList() {
	// summary: for each item in the datastore generate a row in the table
	//if (!menuliststore) {
	/*if (typeof(menuliststore) === 'undefined' || !menuliststore) {
	 menuliststore = new dojo.data.ItemFileReadStore({
	 jsId: 'menuliststore',
	 url: 'menu_menus.php',
	 clearOnClose: true,
	 urlPreventCache: true
	 });
	 }*/
	var request = {
		query:{ },
		onComplete:function (items, request) {
			var office_exist_name = 'СЦЕНАРИЙ НЕ ВЫБРАН';
			if (office_menuid >= 0) {
				var office_exist = false;
				dojo.forEach(items, function (item) {
					if (office_menuid == item.menu_id) {
						office_exist = true;
						office_exist_name = item.menu_name;
					}
				});
				if (!office_exist) {
					office_menuid = -1;

					setCookie('office_menuid', office_menuid);
					/*if (dojo.byId('err_noofficemenulink'))
					 dojo.style('err_noofficemenulink', 'display', '');*/
					toolbarToggleMenuControls(office_menuid >= 0);
					reloadPic('menugraph');
				}
			}
			if (dijit.byId('office_menuid')) {
				if (office_menuid >= 0)
					dijit.byId('office_menuid').attr('value', office_menuid);
				else
					dijit.byId('office_menuid').attr('value', null);
			}
			dijit.byId('btMenuOfficeSetupDlg').attr('label', office_exist_name);
		},
		onError:function (e, request) {
			console.warn(e, request);
			showMessageError(ERR_COMMON);
		}
	};

	if (typeof(menuliststore) !== 'undefined' && menuliststore) {
		menuliststore.close();
		menuliststore.fetch(request);
	}
}

function updateItemNamesControls(customrequest) {
	if (typeof(itemnamesstore) === 'undefined' || !itemnamesstore) {
		itemnamesstore = new dojo.data.ItemFileReadStore({
			jsId:'itemnamesstore',
			url:'menu_itemnames.php' + (dojo.byId('ivr_edit') ? '?ivr_edit=1' : ''),
			clearOnClose:true,
			urlPreventCache:true
		});
	}
	var request = {
		query:{ }
	};
	if (customrequest)
		request = customrequest;
	if (typeof(itemnamesstore) !== 'undefined' && itemnamesstore) {
		itemnamesstore.close();
		itemnamesstore.fetch(request);
	}

	//dijit.byId('conn_src_item_id').store = itemnamesstore;
	//dijit.byId('conn_dst_item_id').store = itemnamesstore;
}

function loadExternalData() {
	//itemtypes
	var request = {
		query:{ },
		onComplete:function (items, request) {
			if (items && items[0]) {
				//alert(items[0].id + ' = ' + itemtypesstore.getValue(items[0], "description"));
				dijit.byId('item_service_id').attr('value', items[0].id);
				//dijit.byId('item_service_id').textbox.disabled = true;
			}
		},
		onError:function (e, request) {
			console.warn(e, request);
			showMessageError(ERR_COMMON);
		}
	};
	if (typeof(itemtypesstore) !== 'undefined' && itemtypesstore) {
		itemtypesstore.close();
		itemtypesstore.fetch(request);
	}

	//conditionprocessors
	var request2 = {
		query:{ },
		onComplete:function (items, request) {
			if (items && items[0])
				dijit.byId('condition_processor_name').attr('value', items[0].id);
		},
		onError:function (e, request) {
			console.warn(e, request);
			showMessageError(ERR_COMMON);
		}
	};
	if (typeof(conditionprocessorsstore) !== 'undefined' && conditionprocessorsstore) {
		conditionprocessorsstore.close();
		conditionprocessorsstore.fetch(request2);
	}
}

var animcnt;
function animateStatusMsg(msg, is_start) {
	if (msg)
		dojo.byId('resultmsg').innerHTML = msg;
	if (is_start) {
		dojo.style('resultmsg', "display", "block");
		animcnt = -1;
	}
	animcnt += 1;

	var fadein = dojo.fadeIn({
		node:'resultmsg',
		duration:200
	});
	var fadeout = dojo.fadeOut({
		node:'resultmsg',
		duration:1000,
		onEnd:function () {
			if (animcnt >= 5)
				dojo.style('resultmsg', "display", "none");
			else
				setTimeout('animateStatusMsg();', '200');
		}
	});
	dojo.fx.chain([fadein, fadeout]).play();
}

var dlgMenuItemProps_IsOpened = false;

function dlgMenuItemProps_OnShow() {
	//if (dlgMenuItemProps_IsOpened)
	//return true;
	dlgMenuItemProps_IsOpened = true;

	dijit.byId('btMakeStartItem').attr('disabled', dlgMenuItemProps_ItemId == ITEM_PROPS_EMPTY);
	dijit.byId('delitem').attr('disabled', dlgMenuItemProps_ItemId == ITEM_PROPS_EMPTY);

	if (dlgMenuItemProps_ItemId == ITEM_PROPS_EMPTY) {
		dijit.byId("dlgMenuItemProps_tabs").selectChild("dlgMenuItemProps_Main");

		focusFirstInput('dlgMenuItemProps');

		//dojo.style('dlgMenuItemProps_loading', 'display', 'none');
		//dojo.style('dlgMenuItemProps_content', 'display', 'block');
		dojo.style('lMenuItemProps_loading', 'display', 'none');
		//dojo.fadeIn({node: 'dlgMenuItemProps_content', duration: 1000 }).play();
		dojo.style('dlgMenuItemProps_content', {"opacity":1, "filter":"alpha(opacity=100)"});
	} else {
		dojo.xhrPost({
			url:'menu_itemprops.php' + (dojo.byId('ivr_edit') ? '?ivr_edit=1' : ''),
			handleAs:"json",
			load:function (data, ioArgs) {
				//alert(dojo.toJson(data, true));
				dijit.byId('dlgMenuItemProps').attr('value', data);
				//dijit.byId('dlgMenuItemProps_debug').attr('value', dojo.toJson(data, true));

				if (!/^-?\d+$/.test(dijit.byId('voice_item_synthez_place').attr('value')))
					dijit.byId('voice_item_synthez_place').attr('value', 1);
				if (!/^-?\d+$/.test(dijit.byId('voice_item_timeout').attr('value')))
					dijit.byId('voice_item_timeout').attr('value', 1000);
				if (!/^-?\d+$/.test(dijit.byId('voice_item_repeat_count').attr('value')))
					dijit.byId('voice_item_repeat_count').attr('value', 0);
				if (!/^-?.+$/.test(dijit.byId('condition_processor_name').attr('value')))
					dijit.byId('condition_processor_name').attr('value', 'SQL_CONDITION');

				dijit.byId('delitem').attr('disabled', false);
				dijit.byId('btMakeStartItem').attr('disabled', false);

				RebuildExtendedSelectControls('voice_item_synthez_edit', 'voice_item_synthez', true);

				focusFirstInput('dlgMenuItemProps');

				//dojo.style('dlgMenuItemProps_loading', 'display', 'none');
				//dojo.style('dlgMenuItemProps_content', 'display', 'block');
				dojo.style('lMenuItemProps_loading', 'display', 'none');
				dojo.style('dlgMenuItemProps_content', {"opacity":1, "filter":"alpha(opacity=100)"});
				//dojo.fadeIn({node: 'dlgMenuItemProps_content', duration: 500, delay: 5000}).play();
			},
			error:function (data, ioArgs) {
				showMessageError(ERR_COMMON + '&nbsp;&nbsp;' + data);
			},
			content:{itemid:dlgMenuItemProps_ItemId }
		});
	}
}

function dlgMenuItemProps_OnClose(sender) {
	if (sender)
		dijit.byId('dlgMenuItemProps').hide();
	dlgMenuItemProps_ItemId = ITEM_PROPS_EMPTY;
	dlgMenuItemProps_IsOpened = false;
	VoiceItem_SynthPlayerStop();
}

function dlgMenuItemProps_OnSubmit() {
	data = dijit.byId('dlgMenuItemProps').attr('value');
	data.item_id = dlgMenuItemProps_ItemId;
	data.sub_edit_menuitemprops = 'edit';
	//alert('На сервер отправлено:' + dojo.toJson(data, true));

	dojo.xhrPost({
		url:'menu_itemprops.php' + (dojo.byId('ivr_edit') ? '?ivr_edit=1' : ''),
		handleAs:"json",
		load:function (data, ioArgs) {
			if (data.error)
				showMessageError(data.error);
			else if (data.ok) {
				//showMessageInfo(data.ok);
				//animateStatusMsg(data.ok, true);
				reloadPic('menugraph');
				//dijit.byId('dlgMenuItemProps').hide();
				dlgMenuItemProps_OnClose(self);
			} else
				alert(dojo.toJson(data, true));
		},
		error:function (data, ioArgs) {
			showMessageError(ERR_COMMON + '&nbsp;&nbsp;' + data);
		},
		content:data
	});

	return false;
}

function dlgMenuItemProps_OnMakeStartItem() {
	data = dijit.byId('dlgMenuItemProps').attr('value');
	data.item_id = dlgMenuItemProps_ItemId;
	data.sub_edit_menuitemprops = 'edit_setstart';

	dojo.xhrPost({
		url:'menu_itemprops.php' + (dojo.byId('ivr_edit') ? '?ivr_edit=1' : ''),
		handleAs:"json",
		load:function (data, ioArgs) {
			if (data.error)
				showMessageError(data.error);
			else if (data.ok) {
				showMessageInfo(data.ok);
				dijit.byId('btMakeStartItem').attr('disabled', true);
				reloadPic('menugraph');
			} else
				alert(dojo.toJson(data, true));
		},
		error:function (data, ioArgs) {
			showMessageError(ERR_COMMON + '&nbsp;&nbsp;' + data);
		},
		content:data
	});

	return false;
}

function dlgMenuItemProps_OnDeleteItem() {
	data = dijit.byId('dlgMenuItemProps').attr('value');
	data.item_id = dlgMenuItemProps_ItemId;
	data.sub_edit_menuitemprops = 'del';

	if (!confirm("Вы уверены что хотите удалить элемент \"" + data.item_name + "\"?"))
		return false;

	dojo.xhrPost({
		url:'menu_itemprops.php' + (dojo.byId('ivr_edit') ? '?ivr_edit=1' : ''),
		handleAs:"json",
		load:function (data, ioArgs) {
			if (data.error)
				showMessageError(data.error);
			else if (data.ok) {
				//showMessageInfo(data.ok);
				//animateStatusMsg(data.ok, true);
				reloadPic('menugraph');
				//dijit.byId('dlgMenuItemProps').hide();
				dlgMenuItemProps_OnClose(self);
			} else
				alert(dojo.toJson(data, true));
		},
		error:function (data, ioArgs) {
			showMessageError(ERR_COMMON + '&nbsp;&nbsp;' + data);
		},
		content:data
	});

	return false;
}

function dlgMenuItemProps_OnControlsChange(sender) {
	//switch from specific tab
	if (
		(dijit.byId('item_service_id').attr('value') != 1) && dijit.byId('dlgMenuItemProps_Synthz').attr('selected')
			||
			(dijit.byId('item_service_id').attr('value') != 2) && dijit.byId('dlgMenuItemProps_Cond').attr('selected')
		)
		dijit.byId("dlgMenuItemProps_tabs").selectChild("dlgMenuItemProps_Main");

	if (sender) {
		//hide other specific tab
		//FIXME: dirty dojo hack, keyboard still working.
		var buttonTab = dijit.byId("dlgMenuItemProps_tabs").tablist.pane2button['dlgMenuItemProps_Synthz'];
		buttonTab.innerDiv.parentNode.style.display = dijit.byId('item_service_id').attr('value') == 1 ? '' : 'none';
		buttonTab = dijit.byId("dlgMenuItemProps_tabs").tablist.pane2button['dlgMenuItemProps_Cond'];
		buttonTab.innerDiv.parentNode.style.display = dijit.byId('item_service_id').attr('value') == 2 ? '' : 'none';
	}

	dijit.byId('btMenuItemProps_OK').attr('disabled',
		!dijit.byId('item_name').isValid() ||
			!dijit.byId('item_service_id').isValid() ||
			(
				dijit.byId('item_service_id').attr('value') == 1 &&
					(
						!dijit.byId('voice_item_synthez').isValid() ||
							!dijit.byId('voice_item_synthez_place').isValid() ||
							!dijit.byId('voice_item_timeout').isValid() ||
							!dijit.byId('voice_item_repeat_count').isValid()
						)
				)
	);
}

var dlgMenuConnProps_IsOpened = false;

function dlgMenuConnProps_OnShow() {
	//if (dlgMenuConnProps_IsOpened)
	//return true;
	dlgMenuConnProps_IsOpened = true;

	//dijit.byId('conn_src_item_id').attr('disabled', dlgMenuConnProps_ItemId != CONN_PROPS_EMPTY);
	//dijit.byId('conn_dst_item_id').attr('disabled', dlgMenuConnProps_ItemId != CONN_PROPS_EMPTY);
	dijit.byId('btMenuConnProps_DelConn').attr('disabled', dlgMenuConnProps_ItemId == CONN_PROPS_EMPTY);

	if (dlgMenuConnProps_ItemId == CONN_PROPS_EMPTY) {
		/*var itemnamesstore = new dojo.data.ItemFileReadStore({
		 jsId: 'itemnamesstore',
		 url: 'menu_itemnames.php',
		 clearOnClose: true,
		 urlPreventCache: true
		 });*/
		var request = {
			query:{ },
			onComplete:function (items, request) {
				//dijit.byId('dlgMenuConnProps_debug').attr('value', dojo.toJson(items, true));

				focusFirstInput('dlgMenuConnProps');

				//dojo.style('dlgMenuConnProps_loading', 'display', 'none');
				//dojo.style('dlgMenuConnProps_content', 'display', 'block');
				dojo.style('lMenuConnProps_loading', 'display', 'none');
				dojo.style('dlgMenuConnProps_content', {"opacity":1, "filter":"alpha(opacity=100)"});
			},
			onError:function (e, request) {
				console.warn(e, request);
				showMessageError(ERR_COMMON + '&nbsp;&nbsp;' + e);
			}
		};
		/*itemnamesstore.close();
		 itemnamesstore.fetch(request);

		 dijit.byId('conn_src_item_id').store = itemnamesstore;
		 dijit.byId('conn_dst_item_id').store = itemnamesstore;*/

		updateItemNamesControls(request);
	} else {
		updateItemNamesControls(request);
		dojo.xhrPost({
			url:'menu_connprops.php' + (dojo.byId('ivr_edit') ? '?ivr_edit=1' : ''),
			handleAs:"json",
			load:function (data, ioArgs) {
				//alert(dojo.toJson(data, true));
				dijit.byId('dlgMenuConnProps').attr('value', data);
				//dijit.byId('dlgMenuConnProps_debug').attr('value', dojo.toJson(data, true));

				focusFirstInput('dlgMenuConnProps');

				//dojo.style('dlgMenuConnProps_loading', 'display', 'none');
				//dojo.style('dlgMenuConnProps_content', 'display', 'block');
				dojo.style('lMenuConnProps_loading', 'display', 'none');
				dojo.style('dlgMenuConnProps_content', {"opacity":1, "filter":"alpha(opacity=100)"});
			},
			error:function (data, ioArgs) {
				showMessageError(ERR_COMMON + '&nbsp;&nbsp;' + data);
				//dijit.byId('dlgMenuConnProps').hide();
				dlgMenuConnProps_OnClose(self);
			},
			content:{connid_key:dlgMenuConnProps_ItemId}
		});
	}
}

function dlgMenuConnProps_OnClose(sender) {
	if(sender) dijit.byId('dlgMenuConnProps').hide();
	dlgMenuConnProps_ItemId = CONN_PROPS_EMPTY;
	dlgMenuConnProps_IsOpened = false;
}

function dlgMenuConnProps_OnSubmit() {
	data = dijit.byId('dlgMenuConnProps').attr('value');
	data.connid_key = dlgMenuConnProps_ItemId;
	data.sub_edit_menuconnprops = dlgMenuConnProps_ItemId == CONN_PROPS_EMPTY ? 'add' : 'edit';

	dojo.xhrPost({
		url:'menu_connprops.php' + (dojo.byId('ivr_edit') ? '?ivr_edit=1' : ''),
		handleAs:"json",
		load:function (data, ioArgs) {
			if (data.error)
				showMessageError(data.error);
			else if (data.ok) {
				//showMessageInfo(data.ok);
				//animateStatusMsg(data.ok, true);
				reloadPic('menugraph');
				//dijit.byId('dlgMenuConnProps').hide();
				dlgMenuConnProps_OnClose(self);
			} else
				alert(dojo.toJson(data, true));
		},
		error:function (data, ioArgs) {
			showMessageError(ERR_COMMON);
		},
		content:data
	});

	return false;
}

function dlgMenuConnProps_OnDeleteConn() {
	data = dijit.byId('dlgMenuConnProps').attr('value');
	data.connid_key = dlgMenuConnProps_ItemId;
	data.sub_edit_menuconnprops = 'del';

	if (!confirm("Вы уверены что хотите удалить элемент \"" + data.conn_item_key_description + "\"?"))
		return false;

	dojo.xhrPost({
		url:'menu_connprops.php' + (dojo.byId('ivr_edit') ? '?ivr_edit=1' : ''),
		handleAs:"json",
		load:function (data, ioArgs) {
			if (data.error)
				showMessageError(data.error);
			else if (data.ok) {
				//showMessageInfo(data.ok);
				//animateStatusMsg(data.ok, true);
				reloadPic('menugraph');
				//dijit.byId('dlgMenuConnProps').hide();
				dlgMenuConnProps_OnClose(self);
			} else
				alert(dojo.toJson(data, true));
		},
		error:function (data, ioArgs) {
			showMessageError(ERR_COMMON + '&nbsp;&nbsp;' + data);
		},
		content:data
	});

	return false;
}

function dlgMenuConnProps_OnControlsChange() {
	dijit.byId('btMenuConnProps_OK').attr('disabled',
			//!dijit.byId('conn_item_key_description').isValid() ||
			(
					(dlgMenuConnProps_ItemId == CONN_PROPS_EMPTY) &&
							(
									!dijit.byId('conn_src_item_id').isValid() ||
											!dijit.byId('conn_dst_item_id').isValid()
									)
					)
	);
}

var dlgMenuSynthz_IsOpened = false;
var dlgMenuSynthz_SelectMode = false;

function dlgMenuSynthz_UpdateGlobalSynthzList() {
	dojo.xhrGet({
		url:'menu_synthz.php' + (dojo.byId('ivr_edit') ? '?ivr_edit=1' : ''),
		handleAs:"json",
		load:function (data, ioArgs) {
			if (data.error)
				showMessageError(data.error);
			else
			if (data.ok) {
				var obj_list = dojo.byId('synthzlist');
				if (obj_list) {
					obj_list.length = 0;
					dojo.forEach(data.items, function (item) {
						var opt = document.createElement('option');
						opt.text = item.id + ': ' + item.description;
						opt.value = item.id;
						opt.className = 'fancyselectoption';
						//dijit.byId('synthzlist').domNode.appendChild(opt);
						try {
							obj_list.add(opt, null); // standards compliant; doesn't work in IE
						} catch (ex) {
							obj_list.add(opt); // IE only
						}
					});
				}

				//dojo.style('dlgMenuSynthz_loading', 'display', 'none');
				//dojo.style('dlgMenuSynthz_content', 'display', '');
				dojo.style('lMenuSynthz_loading', 'display', 'none');
				dojo.style('dlgMenuSynthz_content', {"opacity":1, "filter":"alpha(opacity=100)"});
			} else
				alert(dojo.toJson(data, true));
			//dijit.byId('dlgMenuSynthz_debug').attr('value', dojo.toJson(data, true));
		},
		error:function (data, ioArgs) {
			showMessageError(ERR_COMMON + '&nbsp;&nbsp;' + data);
		},
		preventCache:true
	});
}

function dlgMenuSynthz_DeleteGlobalSynth(idsynth) {
	postdata = {synth_id:idsynth, synth_operation:'del'};
	dojo.xhrPost({
		url:'menu_synthz.php' + (dojo.byId('ivr_edit') ? '?ivr_edit=1' : ''),
		handleAs:"json",
		load:function (data, ioArgs) {
			if (data.error)
				showMessageError(data.error);
			else
			if (data.ok) {
				showMessageInfo(data.ok);
			} else
				alert(dojo.toJson(data, true));
		},
		error:function (data, ioArgs) {
			showMessageError(ERR_COMMON + '&nbsp;&nbsp;' + data);
		},
		content:postdata
	});

	return false;
}

function dlgMenuSynthz_OnShow() {
	//if (dlgMenuSynthz_IsOpened)
	//return true;
	dlgMenuSynthz_IsOpened = true;

	dlgMenuSynthz_UpdateGlobalSynthzList();

	focusFirstInput('dlgMenuSynthz');
}

function dlgMenuSynthz_OnSubmit() {
	if (dlgMenuSynthz_SelectMode) {
		dijit.byId('voice_item_synthez_edit').addSelected(dijit.byId('synthzlist'));
		RebuildExtendedSelectControls('voice_item_synthez_edit', 'voice_item_synthez', false);
	}
	dlgMenuSynthz_OnClose(self);
}

function dlgMenuSynthz_OnClose(sender) {
	dlgMenuSynthz_SelectMode = false;
	/*dojo.byId('synthz_upload_results').innerHTML =
	 '<br />' +
	 '<label style="margin:0 4px 2px 4px;">Результат загрузки:</label>' +
	 '<br />' +
	 '<span id="synthz_upload_result_msg"></span>';*/
	dojo.byId('synthz_upload_result_msg').innerHTML = '';
	if(sender) dijit.byId('dlgMenuSynthz').hide();
	dlgMenuSynthz_IsOpened = false;
	VoiceItem_SynthPlayerStopGlobal();
}

function dlgMenuOfficeSetup_OnShow() {
	loadMenuList();

	return true;
}

function dlgMenuOfficeSetup_OnClose() {
	dijit.byId('dlgMenuOfficeSetup').onCancel();
	//dijit.byId('office_menuid').attr('value', office_menuid);

	return true;
}

function dlgMenuOfficeSetup_OnMenuItemChange() {
	dijit.byId('dlgMenuOfficeSetup_rbAssign').attr('disabled',
		!dijit.byId('office_menuid').isValid() || office_menuid == dijit.byId('office_menuid').attr('value'));
	dijit.byId('dlgMenuOfficeSetup_rbClone').attr('disabled',
		!dijit.byId('office_menuid').isValid());
	//dijit.byId('dlgMenuOfficeSetup_rbBlank').attr('disabled', false);

	dijit.byId('office_menuname').attr('disabled',
		!(
			dijit.byId('dlgMenuOfficeSetup_rbBlank').attr('checked')
				||
				dijit.byId('dlgMenuOfficeSetup_rbClone').attr('checked') && !dijit.byId('dlgMenuOfficeSetup_rbClone').attr('disabled')
			));

	dijit.byId('btMenuOfficeSetup_OK').attr('disabled',
		!(
			dijit.byId('dlgMenuOfficeSetup_rbBlank').attr('checked')
				||
				dijit.byId('dlgMenuOfficeSetup_rbAssign').attr('checked') && !dijit.byId('dlgMenuOfficeSetup_rbAssign').attr('disabled')
				||
				dijit.byId('dlgMenuOfficeSetup_rbClone').attr('checked') && !dijit.byId('dlgMenuOfficeSetup_rbClone').attr('disabled')
				||
				!dijit.byId('office_menuname').attr('disabled') && dijit.byId('office_menuname').isValid()
			));

	if (dijit.byId('btMenuOfficeSetup_DelMenu'))
		dijit.byId('btMenuOfficeSetup_DelMenu').attr('disabled',
				office_menuid < 0);
}

function dlgMenuOfficeSetup_OnDeleteMenu() {
	if (!confirm("Внимание!\nОткрытый в редакторе сценарий будет удален из системы без возможности восстановления!\n\nДействительно удалить?"))
		return false;

	data = dijit.byId('dlgMenuOfficeSetup').attr('value');
	data.menus_operation = 'delete';
	data.office_menuid = office_menuid;
	dojo.xhrPost({
		url:'menu_menus.php',
		handleAs:"json",
		load:function (data, ioArgs) {
			if (data.error)
				showMessageError(data.error);
			else if (data.ok) {
				dlgMenuOfficeSetup_OnClose();
				loadMenuList();
			} else
				alert(dojo.toJson(data, true));
		},
		error:function (data, ioArgs) {
			showMessageError(ERR_COMMON + '&nbsp;&nbsp;' + data);
		},
		content:data
	});

	return true;
}

function dlgMenuOfficeSetup_OnSubmit() {

	function dlgMenuOfficeSetup_OnSubmit_AssignMenu(mid, mname) {
		postdata = dijit.byId('dlgMenuOfficeSetup').attr('value');
		postdata.sub_officemenusetup = 'edit';
		postdata.office_menuid = mid;
		postdata.office_menuname = mname;
		if (dojo.byId('ivr_edit'))
			postdata.ivr_edit = 1;
		dojo.xhrPost({
			url:'menu_officeprops.php',
			handleAs:"json",
			load:function (data, ioArgs) {
				if (data.error)
					showMessageError(data.error);
				else if (data.ok) {
					office_menuid = mid;
					setCookie('office_menuid', office_menuid);
					if (dojo.byId('err_noofficemenulink'))
						dojo.style('err_noofficemenulink', 'display', 'none');
					dlgMenuOfficeSetup_OnClose();

					var fadeout = dojo.fadeOut({
						node:'btMenuOfficeSetupDlg',
						duration:500,
						onEnd:function () {
							//TODO: fix button label update
							//dijit.byId('btMenuOfficeSetupDlg').attr('label', dijit.byId('office_menuid').attr('displayedValue'));
							if (mname)
								dijit.byId('btMenuOfficeSetupDlg').attr('label', mname);
							dlgMenuOfficeSetup_OnMenuItemChange();
							toolbarToggleMenuControls(office_menuid >= 0);
							loadMenuList();
							updateItemNamesControls();
						}
					});
					var fadein = dojo.fadeIn({
						node:'btMenuOfficeSetupDlg',
						duration:200,
						onEnd:function () {
							reloadPic('menugraph');
						}
					});
					dojo.fx.chain([fadeout, fadein]).play();

					/*dijit.byId('btMenuOfficeSetupDlg').attr('label', dijit.byId('office_menuid').attr('displayedValue'));
					 dlgMenuOfficeSetup_OnMenuItemChange();
					 reloadPic('menugraph');*/
				} else
					alert(dojo.toJson(data, true));
			},
			error:function (data, ioArgs) {
				showMessageError(ERR_COMMON + '&nbsp;&nbsp;' + data);
			},
			content:postdata
		});
	}

	if (dijit.byId('dlgMenuOfficeSetup_rbAssign').attr('checked') && !dijit.byId('dlgMenuOfficeSetup_rbAssign').attr('disabled')) {
		dlgMenuOfficeSetup_OnSubmit_AssignMenu(dijit.byId('office_menuid').attr('value'), dijit.byId('office_menuid').attr('displayedValue'));
	} else
	if (dijit.byId('dlgMenuOfficeSetup_rbClone').attr('checked') && !dijit.byId('dlgMenuOfficeSetup_rbClone').attr('disabled')) {
		data = dijit.byId('dlgMenuOfficeSetup').attr('value');
		data.menus_operation = 'clone';
		dojo.xhrPost({
			url:'menu_menus.php',
			handleAs:"json",
			load:function (data, ioArgs) {
				if (data.error)
					showMessageError(data.error);
				else if (data.ok) {
					dlgMenuOfficeSetup_OnSubmit_AssignMenu(data.out_menuid, dijit.byId('office_menuname').attr('value'));
				} else
					alert(dojo.toJson(data, true));
			},
			error:function (data, ioArgs) {
				showMessageError(ERR_COMMON + '&nbsp;&nbsp;' + data);
			},
			content:data
		});
	} else
	if (dijit.byId('dlgMenuOfficeSetup_rbBlank').attr('checked')) {
		data = dijit.byId('dlgMenuOfficeSetup').attr('value');
		data.menus_operation = 'blank';
		dojo.xhrPost({
			url:'menu_menus.php',
			handleAs:"json",
			load:function (data, ioArgs) {
				if (data.error)
					showMessageError(data.error);
				else if (data.ok) {
					dlgMenuOfficeSetup_OnSubmit_AssignMenu(data.out_menuid, dijit.byId('office_menuname').attr('value'));
				} else
					alert(dojo.toJson(data, true));
			},
			error:function (data, ioArgs) {
				showMessageError(ERR_COMMON + '&nbsp;&nbsp;' + data);
			},
			content:data
		});
	}

	return false;
}

function VoiceItem_SynthPlayerStart() {
	var selids = GetSelectedListItemsIds('voice_item_synthez_edit', false, 'fs_getfile.php?id=', '', true);
	if (selids) {
		try {
			AudioPlayer.load('synplayer', selids, '', '');
			AudioPlayer.open('synplayer');
		} catch (e) {
			alert('Player is not available for some reason. Try reloading the page.');
		}
	}
}

function VoiceItem_SynthPlayerStop() {
	try {
		AudioPlayer.close('synplayer');
	} catch (e) {
		//
	}
}

function VoiceItem_SynthPlayerStartGlobal() {
	selids = GetSelectedListItemsIds('synthzlist', false, 'fs_getfile.php?id=', '', true);
	if (selids) {
		try {
			AudioPlayer.load('synplayerg', selids, '', '');
			AudioPlayer.open('synplayerg');
		} catch (e) {
			alert('Player is not available for some reason. Try reloading the page.');
		}
	}
}

function VoiceItem_SynthPlayerStopGlobal() {
	try {
		AudioPlayer.close('synplayerg');
	} catch (e) {
		//
	}
}

function uploadSynth(nosynthload) {
	if (dijit.byId('synthz_add_file').fileInput.value == '') {
		alert('Не выбран файл для отправки!');
		return;
	}

	dojo.style(dojo.byId('synthz_upload_selector'), "display", "none");
	dojo.style(dojo.byId('synthz_upload_progress'), "display", "inline");
	dojo.style(dojo.byId('synthz_upload_results'), "display", "none");

	dojo.io.iframe.send({
		url:'fs_putfile.php' + (dojo.byId('ivr_edit') ? '?ivr_edit=1' : ''),
		method:'post',
		handleAs:'text',
		form:dojo.byId('frmUploadSynth'),
		handle:function (data, ioArgs) {
			var foo = dojo.fromJson(data);

			dojo.style(dojo.byId('synthz_upload_selector'), "display", "inline");
			dojo.style(dojo.byId('synthz_upload_progress'), "display", "none");
			dojo.style(dojo.byId('synthz_upload_results'), "display", "inline");

			var fmsg = "";
			if (foo.files.name)
				fmsg = foo.files.name + " (" + foo.files.size + " байт):&nbsp;";
			if (foo.status == 'ok') {
				dijit.byId('synthz_add_file').reset();
				if (foo.msg)
					fmsg += "<span style='color:green;font-weight:bold;'>" + foo.msg + "<\/span><br \/>";
				else
					fmsg += "<span style='color:green;font-weight:bold;'>OK id=" + foo.fileid + "<\/span><br \/>";
				var fax_queue = $("#qfax");
				if (fax_queue.length > 0)
					fax_queue.flexReload();
			} else
				fmsg += "<span style='color:red;font-weight:bold;'>" + foo.error + "<\/span><br \/>";
			dojo.byId('synthz_upload_result_msg').innerHTML = fmsg;

			if (!nosynthload)
				loadSynthzList();
		}
	});
}

var SynthzUploadOnComplete = function (data, ioArgs, widgetRef) {
	var foo = dojo.fromJson(data);
	//alert(foo);

	dojo.style(dojo.byId('synthz_upload_results'), "display", "inline");

	var fmsg = foo.files.name + " (" + foo.files.size + " байт)";
	if (foo.status == 'ok') {
		dijit.byId('synthz_add_file_auto').reset();
		fmsg += ":&nbsp;<span style='color:green;font-weight:bold;'>OK<\/span><br \/>";
	} else
		fmsg += ":&nbsp;<span style='color:red;font-weight:bold;'>" + foo.error + "<\/span><br \/>";
	dojo.byId('synthz_upload_result_msg').innerHTML = fmsg;

	loadSynthzList();
}

function DeleteSelectedSynthsGlobal(listid) {
	var obj_list = document.getElementById(listid);
	if (obj_list) {
		var selcnt = 0;
		for (var i = obj_list.length - 1; i >= 0; i--)
			if (obj_list.options[i].selected)
				selcnt++;

		if (selcnt > 0) {
			if (!confirm("Внимание!\nВыбранные синтезаторы будут удалены из системы без возможности восстановления!\n\nСинтезаторов выбрано: " + selcnt + ". Действительно удалить?"))
				return false;

			for (i = obj_list.length - 1; i >= 0; i--)
				if (obj_list.options[i].selected)
				//obj_list.remove(i);
					dlgMenuSynthz_DeleteGlobalSynth(obj_list.options[i].value);

			dlgMenuSynthz_UpdateGlobalSynthzList();
		} else
			showMessageError("В списке нет выбранных элементов!");
	}
	return true;
}

var dlgUserSynthEdit_ItemId = -1;

function showUserSynthEdit(itemid, itemname) {

	var dlg = dijit.byId('dlgUserSynthEdit');

	if (dlg.attr('open'))
		return;

	dlg.attr('title', 'Редактирование голосового сообщения');

	dlgUserSynthEdit_ItemId = itemid;

	//dojo.style('dlgUserSynthEdit_content', 'display', 'none');
	//dojo.style('dlgUserSynthEdit_loading', 'display', 'block');
	dojo.style('dlgUserSynthEdit_content', {"opacity":0, "filter":"alpha(opacity=0)"});
	dojo.style('lUserSynthEdit_loading', 'display', '');

	resetForms();

	dlg.show();
}

function dlgUserSynthEdit_OnShow() {
	dojo.xhrPost({
		url:'menu_itemprops.php' + (dojo.byId('ivr_edit') ? '?ivr_edit=1' : ''),
		handleAs:"json",
		load:function (data, ioArgs) {
			//alert(dojo.toJson(data, true));
			dijit.byId('dlgUserSynthEdit').attr('value', data);
			//dijit.byId('dlgUserSynthEdit_debug').attr('value', dojo.toJson(data, true));

			dijit.byId('dlgUserSynthEdit_title').attr('title', "<span style='font-weight:bold;'>" + data.item_name + "<\/span>");

			RebuildExtendedSelectControls('voice_item_synthez_edit', 'voice_item_synthez', true);

			focusFirstInput('dlgUserSynthEdit');

			//dojo.style('dlgUserSynthEdit_loading', 'display', 'none');
			//dojo.style('dlgUserSynthEdit_content', 'display', 'block');
			dojo.style('lUserSynthEdit_loading', 'display', 'none');
			dojo.style('dlgUserSynthEdit_content', {"opacity":1, "filter":"alpha(opacity=100)"});
			//dojo.fadeIn({node: 'dlgUserSynthEdit_content', duration: 500, delay: 5000}).play();
		},
		error:function (data, ioArgs) {
			showMessageError(ERR_COMMON + '&nbsp;&nbsp;' + data);
		},
		content:{itemid:dlgUserSynthEdit_ItemId }
	});
}

function dlgUserSynthEdit_OnClose(sender) {
	if(sender) dijit.byId('dlgUserSynthEdit').hide();
	dlgUserSynthEdit_ItemId = -1;
	VoiceItem_SynthPlayerStop();
}

function dlgUserSynthEdit_OnSubmit() {
	data = dijit.byId('dlgUserSynthEdit').attr('value');
	data.item_id = dlgUserSynthEdit_ItemId;
	data.sub_edit_menuitemprops = 'edit_synth';
	//alert('На сервер отправлено:' + dojo.toJson(data, true));

	dojo.xhrPost({
		url:'menu_itemprops.php' + (dojo.byId('ivr_edit') ? '?ivr_edit=1' : ''),
		handleAs:"json",
		load:function (data, ioArgs) {
			if (data.error)
				showMessageError(data.error);
			else if (data.ok) {
				dlgUserSynthEdit_OnClose(self);
			} else
				alert(dojo.toJson(data, true));
		},
		error:function (data, ioArgs) {
			showMessageError(ERR_COMMON + '&nbsp;&nbsp;' + data);
		},
		content:data
	});

	return false;
}

function dlgUserSynthEdit_OnControlsChange(sender) {
	dijit.byId('btUserSynthEdit_OK').attr('disabled', false);
}

var dlgSynthControlEdit_ControlId = '';
var dlgSynthControlEdit_SynthPrefix = '';

function showSynthControlEdit(synthname, synthcontrolid) {
	var dlg = dijit.byId('dlgSynthControlEdit');

	if (dlg.attr('open'))
		return;

	dlg.attr('title', 'Редактирование голосового сообщения');

	dlgSynthControlEdit_ControlId = synthcontrolid;
	dijit.byId('dlgSynthControlEdit_title').attr('title', "<span style='font-weight:bold;'>" + synthname + "<\/span>");

	dojo.style('dlgSynthControlEdit_content', {"opacity":0, "filter":"alpha(opacity=0)"});
	dojo.style('lSynthControlEdit_loading', 'display', '');

	resetForms();

	dlg.show();
}

function dlgSynthControlEdit_OnShow() {
	var synthobj = dojo.byId(dlgSynthControlEdit_ControlId);
	var arrsynth = new String(synthobj.value);
	arrsynth = arrsynth.split('~');
	if (arrsynth.length == 1) {
		dlgSynthControlEdit_SynthPrefix = '';
		dijit.byId('voice_item_synthez').attr('value', arrsynth[0].replace(/\|/g, ","));
	} else {
		dlgSynthControlEdit_SynthPrefix = arrsynth[0];
		dijit.byId('voice_item_synthez').attr('value', arrsynth[1].replace(/\|/g, ","));
	}

	RebuildExtendedSelectControls('voice_item_synthez_edit', 'voice_item_synthez', true);

	focusFirstInput('dlgSynthControlEdit');

	dojo.style('lSynthControlEdit_loading', 'display', 'none');
	dojo.style('dlgSynthControlEdit_content', {"opacity":1, "filter":"alpha(opacity=100)"});
}

function dlgSynthControlEdit_OnClose(sender) {
	if(sender) dijit.byId('dlgSynthControlEdit').hide();
	dlgSynthControlEdit_ControlId = '';
	dlgSynthControlEdit_SynthPrefix = '';
	VoiceItem_SynthPlayerStop();
}

function dlgSynthControlEdit_OnSubmit() {
	var synthobj = dojo.byId(dlgSynthControlEdit_ControlId);
	/*if (dlgSynthControlEdit_SynthPrefix)
	 dlgSynthControlEdit_SynthPrefix = dlgSynthControlEdit_SynthPrefix + '~';
	 else*/
	if (dijit.byId('voice_item_synthez').attr('value') != '')
		dlgSynthControlEdit_SynthPrefix = '1~';
	var synstr = new String(dijit.byId('voice_item_synthez').attr('value'));
	synthobj.value = dlgSynthControlEdit_SynthPrefix + synstr.replace(/,/g, "|");
	synthobj.style.backgroundColor = '#FAF0F0';
	synthobj.onchange();
	synthobj.focus();

	dlgSynthControlEdit_OnClose(self);

	return false;
}

function dlgSynthControlEdit_OnControlsChange(sender) {
	dijit.byId('btSynthControlEdit_OK').attr('disabled', false);
}
