$(document).ready(function () {
	$("#statlist").flexigrid({
		url: 'process.php',
		params: [
			{name: 'op', value: 'stats'}
		],
		dataType: 'json',
		colModel: [
			{display: '&nbsp;', name: 'flags', width: 52, sortable: false, align: 'right'},
			{display: 'Дата', name: 'creattime', width: 100, sortable: false, align: 'right'},
			{display: 'Вызывающий', name: 'numbera', width: 85, sortable: false, align: 'right'},
			{display: 'Вызываемый', name: 'numberb', width: 85, sortable: false, align: 'right'},
			{display: 'Длительность', name: 'realvolume', width: 75, sortable: false, align: 'right'},
			{display: 'Объем', name: 'payablevolume', width: 45, sortable: false, align: 'right'},
			{display: 'Стоимость', name: 'pay', width: 58, sortable: false, align: 'right'},
			{display: 'Направление', name: 'geographyname', width: 290, sortable: false, align: 'right'},
			{display: 'Пользователь', name: 'user', width: 170, sortable: false, align: 'right'}
		],
		sortname: "creattime",
		sortorder: "desc",
		title: false,//'<div id="voiceplayer"></div>',
		showToggleBtn: false,
		singleSelect: true,
		striped: false,
		usepager: true,
		useRp: true,
		rp: 50,
		rpOptions: [10, 50, 100, 150, 200],
		showTableToggleBtn: false,
		width: 850,
		height: 300,
		resizable: true,
		errormsg: 'Данные в данный момент недоступны. Попробуйте позже.',
		pagestat: 'Отображены записи с {from} по {to} из {total}',
		pagetext: 'Страница',
		outof: 'из',
		findtext: 'Поиск&nbsp;',
		procmsg: 'Обновление данных...',
		nomsg: 'Данные отсутствуют',
		autoload: false,
		preProcess: function (data) {
			if (data.totalvol)
				$('#stattotals').html('Общее число минут: ' + data.totalvol + ', сумма: ' + data.totalpay);

			var icons, icons_json;
			$.each(data.rows, function (i, row) {
				icons = '';
				icons_json = jQuery.parseJSON(row.cell[0]);
				switch (icons_json.serv) {
					case 11:
						if (parseInt(icons_json.recid)) {
							icons += '<img class="p_ic" src="images/icon_record.gif" data-type="r" data-func="playVoice" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" />'
								+ '<img class="s_ic" src="images/save.gif" data-type="r" data-func="saveVoice" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" />';
						}
						break;
					case 3:
					case 4:
						if (parseInt(icons_json.recid)) {
							icons += '<img class="p_ic" src="images/icon_voicemail.gif" data-type="v" data-func="playVoice" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" />'
								+ '<img class="s_ic" src="images/save.gif" data-type="v" data-func="saveVoice" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" />';
						}
						break;
					case 1:
					case 2:
						if (parseInt(icons_json.recid)) {
							icons += '<img class="p_ic" src="images/icon_fax3.gif" data-type="f" data-func="showFax" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" />'
								+ '<img class="s_ic" src="images/save.gif" data-type="f" data-func="saveFax" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" />';
						}
						break;
				}
				switch (icons_json.ct) {
					case 100:
						icons += '<img class="t_ic" src="images/icon_call_missed.gif" title="Пропущенный вызов">';
						break;
//					case 101:
//						icons += '<img class="t_ic" src="images/icon_call.gif" title="Успешный вызов">';
					case 201:
						icons += '<img class="t_ic" src="images/icon_call.gif" title="Исходящий вызов">';
						break;
					case 301:
						icons += '<img class="t_ic" src="images/icon_call_incoming.gif" title="Входящий вызов">';
						break;
				}
				row.cell[0] = icons;
			});
			return data;
		},
		onSuccess: function () {
			$('.t_ic')
				.attr({width: '16', height: '16', alt: ''})
				.css('margin-left', '4px');
			$('.p_ic, .s_ic, .d_ic')
				.attr({width: '16', height: '16', alt: ''})
				.each(function(){
					switch ($(this).attr('data-type')) {
						case 'r':
							$(this).attr('title', 'запись разговора');
							break;
						case 'v':
							$(this).attr('title', 'голосовое сообщение');
							break;
						case 'f':
							$(this).attr('title', 'факсимильное сообщение');
							break;
					}
					if ($(this).hasClass('p_ic')) {
						if ($(this).attr('data-type') != 'f')
							$(this).attr('title', 'Прослушать ' + $(this).attr('title'));
						else
							$(this).attr('title', 'Открыть ' + $(this).attr('title'));
					} else if ($(this).hasClass('s_ic')) {
						$(this).attr('title', 'Сохранить ' + $(this).attr('title'));
					} else {
						$(this).attr('title', 'Удалить ' + $(this).attr('title'));
					}
				})
				.addClass('imglink')
				.click(function(){
					setTimeout($(this).attr('data-func') + "('" + $(this).attr('data-recid') + "', '" + $(this).attr('data-rect') + "');", 0);
					return false;
				});
			statcontrols_enable();
		},
		onSubmit: function () {
			$('#stattotals').html('&nbsp;');
			$("#statlist").flexOptions({
/*				params: [
					{name: 'op', value: 'stats'},
					{name: 'sf_range', value: $('#sf_range').val()},
					{name: 'sf_startdate', value: $('#sf_startdate').val()},
					{name: 'sf_enddate', value: $('#sf_enddate').val()},
					{name: 'sf_startvol', value: $('#sf_startvol').val()},
					{name: 'sf_endvol', value: $('#sf_endvol').val()},
					{name: 'sf_numbera', value: $('#sf_numbera').val()},
					{name: 'sf_numberb', value: $('#sf_numberb').val()},
					{name: 'sf_geo', value: $('#sf_geo').val()},
					{name: 'sf_calltype100', value: $('#sf_calltype100').is(':checked')},
					{name: 'sf_calltype101', value: $('#sf_calltype101').is(':checked')},
					{name: 'sf_calltype301', value: $('#sf_calltype301').is(':checked')}
				]*/
				params: [
					{name: 'op', value: 'stats'},
					{name: 'sf_range', value: $('#sf_range').val()},
					{name: 'sf_startdate', value: $('#sf_startdate').val()},
					{name: 'sf_enddate', value: $('#sf_enddate').val()},
					{name: 'sf_startvol', value: $('#sf_startvol').val()},
					{name: 'sf_endvol', value: $('#sf_endvol').val()},
					{name: 'sf_numbera', value: $('#sf_numbera').val()},
					{name: 'sf_numberb', value: $('#sf_numberb').val()},
					{name: 'sf_geo', value: $('#sf_geo').val()},
/*					{name: 'sf_calltype100', value: $('#sf_calltype100').is(':checked')},
					{name: 'sf_calltype101', value: $('#sf_calltype101').is(':checked')},
					{name: 'sf_calltype301', value: $('#sf_calltype301').is(':checked')},
					{name: 'sf_calltype201', value: $('#sf_calltype201').is(':checked')}*/
					{name: 'sf_calltype100', value: $('#sf_calltype100').is(':checked')},
					{name: 'sf_calltype201', value: $('#sf_calltype201').is(':checked')},
					{name: 'sf_calltype301', value: $('#sf_calltype301').is(':checked')}
					
				]
				
			});
			statcontrols_disable();
			return true;
		},
		onError: function () {
			statcontrols_enable();
		}
	});

	$('#bt_filters_apply').click(function () {
		$("#statlist").flexReload();
		return false;
	});
	
	// если не нужна последняя колонка, то раскомментировать
	//if( $('input[id=stats_wide]').val() == 0 ) { $("th[axis='col8']")[0].remove(); }
	
});
