$(document).ready(function () {
	$("#statlist").flexigrid({
		url: 'process.php',
		dataType: 'json',
		colModel: [
			{display: '&nbsp;', name: 'flags', width: 34, sortable: false, align: 'right'},
			{display: 'Дата', name: 'creattime', width: 100, sortable: false, align: 'right'},
			{display: 'Номер отправителя', name: 'numbera', width: 120, sortable: false, align: 'right'},
			{display: 'Длительность', name: 'realvolume', width: 75, sortable: false, align: 'right'},
			{display: 'Стоимость', name: 'pay', width: 58, sortable: false, align: 'right'},
			{display: 'Направление', name: 'geographyname', width: 230, sortable: false, align: 'right'}
		],
		sortname: "creattime",
		sortorder: "desc",
		title: false,
		showToggleBtn: false,
		singleSelect: true,
		striped: false,
		usepager: true,
		useRp: true,
		rp: 50,
		rpOptions: [10, 50, 100, 150, 200],
		showTableToggleBtn: false,
		width: 710,
		height: 300,
		resizable: true,
		errormsg: 'Данные в данный момент недоступны. Попробуйте позже.',
		pagestat: 'Отображены записи с {from} по {to} из {total}',
		pagetext: 'Страница',
		outof: 'из',
		findtext: 'Поиск&nbsp;',
		procmsg: 'Обновление данных...',
		nomsg: 'Данные отсутствуют',
		autoload: false,
		preProcess: function (data) {
			var icons, icons_json;
			$.each(data.rows, function (i, row) {
				icons = '';
				icons_json = jQuery.parseJSON(row.cell[0]);
				switch (icons_json.serv) {
					case 11:
						if (parseInt(icons_json.recid)) {
							icons += '<img class="p_ic" src="images/icon_record.gif" data-type="r" data-func="playVoice" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" />'
								+ '<img class="s_ic" src="images/save.gif" data-type="r" data-func="saveVoice" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" />';
						}
						break;
					case 3:
					case 4:
						if (parseInt(icons_json.recid)) {
							icons += '<img class="p_ic" src="images/icon_voicemail.gif" data-type="v" data-func="playVoice" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" />'
								+ '<img class="s_ic" src="images/save.gif" data-type="v" data-func="saveVoice" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" />';
						}
						break;
					case 1:
					case 2:
						if (parseInt(icons_json.recid)) {
							icons += '<img class="p_ic" src="images/icon_fax3.gif" data-type="f" data-func="showFax" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" />'
								+ '<img class="s_ic" src="images/save.gif" data-type="f" data-func="saveFax" data-recid="' + icons_json.recid + '" data-rect="' + icons_json.rect + '" />';
						}
						break;
				}
				row.cell[0] = icons;
			});
			return data;
		},
		onSuccess: function () {
			$('.p_ic, .s_ic, .d_ic')
				.attr({width: '16', height: '16', alt: ''})
				.each(function () {
					switch ($(this).attr('data-type')) {
						case 'r':
							$(this).attr('title', 'запись разговора');
							break;
						case 'v':
							$(this).attr('title', 'голосовое сообщение');
							break;
						case 'f':
							$(this).attr('title', 'факсимильное сообщение');
							break;
					}
					if ($(this).hasClass('p_ic')) {
						if ($(this).attr('data-type') != 'f')
							$(this).attr('title', 'Прослушать ' + $(this).attr('title'));
						else
							$(this).attr('title', 'Открыть ' + $(this).attr('title'));
					} else if ($(this).hasClass('s_ic')) {
						$(this).attr('title', 'Сохранить ' + $(this).attr('title'));
					} else {
						$(this).attr('title', 'Удалить ' + $(this).attr('title'));
					}
				})
				.addClass('imglink')
				.click(function () {
					setTimeout($(this).attr('data-func') + "('" + $(this).attr('data-recid') + "', '" + $(this).attr('data-rect') + "');", 0);
					return false;
				});
			statcontrols_enable();
		},
		onSubmit: function () {
			$("#statlist").flexOptions({
				params: [
					{name: 'op', value: 'stats'},
					{name: 'serv', value: 3},
					{name: 'sf_range', value: $('#sf_range').val()},
					{name: 'sf_startdate', value: $('#sf_startdate').val()},
					{name: 'sf_enddate', value: $('#sf_enddate').val()},
					{name: 'sf_startvol', value: $('#sf_startvol').val()},
					{name: 'sf_endvol', value: $('#sf_endvol').val()},
					{name: 'sf_numbera', value: $('#sf_numbera').val()}
				]
			});
			statcontrols_disable();
			return true;
		},
		onError: function () {
			statcontrols_enable();
		}
	});

	$('#bt_filters_apply').click(function () {
		$("#statlist").flexReload();
		return false;
	});
});
