<?php
/*
 * Created on 22.10.2008
 *
 */
require_once(dirname(__FILE__).'/include/session.php');
require_once(dirname(__FILE__).'/include/database_dynmenu.php');
require_once(dirname(__FILE__).'/include/functions.php');

global $database_dynmenu, $logger, $session;

$jsonresErr = array('error' => 'Ошибка при обработке перехода!');

function getConnProps($connid, $connkey) {
	global $database_dynmenu, $logger;

	$q = "select * from menu_get_conn_props($connid, '$connkey')";
	//$result = $database_dynmenu->getQueryResultAsArray($q);
	$pq = $database_dynmenu->prepare("select * from menu_get_conn_props(?, ?)",
							array('integer', 'text'));
	$result = $database_dynmenu->execute($pq, array($connid, $connkey));
	if (PEAR::isError($result)) {
		$logger->log("getConnProps($q):ERR=". getPEARErrorInfo($result));
		return null;
	} else {
		//$logger->log("getConnProps($q):".print_r($result, true));
		return $result[0];
	}
}

function setConnProps($connid, $connkey, $srcid, $dstid, $item_key, $item_key_description) {
	global $session, $database_dynmenu, $logger;

	if ($session->isDemo())
		return $connid;

	$q = "select * from menu_set_conn_props($connid, '$connkey', $srcid, $dstid, '$item_key', '$item_key_description')";
	//$result = $database_dynmenu->getQueryResultAsArray($q);
	$pq = $database_dynmenu->prepare("select * from menu_set_conn_props(?, ?, ?, ?, ?, ?)",
							array('integer', 'text', 'integer', 'integer', 'text', 'text'));
	$result = $database_dynmenu->execute($pq, array($connid, $connkey, $srcid, $dstid, $item_key, $item_key_description));
	if (PEAR::isError($result)) {
		$logger->log("setConnProps($q):ERR=". getPEARErrorInfo($result));
		return null;
	} else {
		$logger->log("setConnProps($q):".print_r($result, true));
		return $result[0]['out_id'];
	}
}

function delConn($connid, $connkey) {
	global $session, $database_dynmenu, $logger;

	if ($session->isDemo())
		return $connid;

	$q = "select * from menu_del_conn($connid, '$connkey')";
	//$result = $database_dynmenu->getQueryResultAsArray($q);
	$pq = $database_dynmenu->prepare("select * from menu_del_conn(?, ?)",
							array('integer', 'text'));
	$result = $database_dynmenu->execute($pq, array($connid, $connkey));
	if (PEAR::isError($result)) {
		$logger->log("delConn($q):ERR=". getPEARErrorInfo($result));
		return null;
	} else {
		$logger->log("delConn($q):".print_r($result, true));
		return $result[0]['out_id'];
	}
}

handle_magic_quotes();

$logger->log("POST(".basename($_SERVER['SCRIPT_NAME']).":\n".print_r($_POST, true));

header("Content-Type: text/plain");
if ($database_dynmenu->db_ok) {
	if (isset($_POST['sub_edit_menuconnprops'])) {
		$mode = $_POST['sub_edit_menuconnprops']; //edit/del/new
		//$menuid = ($session->logged_in && is_numeric($session->ofmenuid)) ? intval($session->ofmenuid) : (isset($_COOKIE['office_menuid']) ? intval($_COOKIE['office_menuid']) : -1);
		if (isset($_REQUEST['ivr_edit']))
			$menuid = isset($_COOKIE['office_menuid']) ? intval($_COOKIE['office_menuid']) : -1;
		else
			$menuid = ($session->logged_in && is_numeric($session->ofmenuid)) ? intval($session->ofmenuid) : -1;
		if ($mode == 'add') {
			$srcid = $_POST['conn_src_item_id'];
			$dstid = $_POST['conn_dst_item_id'];
			$item_key = $_POST['conn_item_key'];
			$item_key_description = $_POST['conn_item_key_description'];

			$out_item_id = setConnProps(-1, '-1', $srcid, $dstid, $item_key, $item_key_description);
			if ($out_item_id == -2) {
				$msg = "Переход с указанным ключом уже существует!";
				echo json_encode_safe(array('error' => $msg));
			} elseif ($out_item_id != null) {
				$msg = "Переход '$item_key_description' создан успешно";
				echo json_encode_safe(array('ok' => $msg));
				//changelog
				$database_dynmenu->logMenuChange(CL_MENUS_CONNNEW, $menuid, 0,
					"Переход из $srcid в $dstid СОЗДАН: ключ '$item_key', описание: '$item_key_description'.");
			} else
				echo json_encode_safe($jsonresErr);
		} elseif ($mode == 'edit') {
			list($connid, $connkey, $srcid, $dstid) = explode("|", $_POST['connid_key']);
			$item_key = $_POST['conn_item_key'];
			$item_key_description = $_POST['conn_item_key_description'];
			$srcid_new = $_POST['conn_src_item_id'];
			$dstid_new = $_POST['conn_dst_item_id'];

			if ($srcid != $srcid_new || $dstid != $dstid_new) {
				//delete old connection
				$out_item_id = delConn($connid, base64_decode($connkey));
				if ($out_item_id != null && $out_item_id != -1) {
					//changelog
					$database_dynmenu->logMenuChange(CL_MENUS_CONNDELETE, $menuid, 0,
						"Переход УДАЛЕН: ключ: '$connkey'.");
					//create new connection
					$out_item_id = setConnProps(-1, '-1', $srcid_new, $dstid_new, $item_key, $item_key_description);
					if ($out_item_id == -2) {
						$msg = "С указанным ключом уже существует другой переход из этого же ($srcid_new) элемента!";
						echo json_encode_safe(array('error' => $msg));
					} elseif ($out_item_id != null && $out_item_id != -1) {
						$msg = "Переход изменён успешно";
						echo json_encode_safe(array('ok' => $msg));
						//changelog
						$database_dynmenu->logMenuChange(CL_MENUS_CONNCHANGE, $menuid, 0,
							"Переход из $srcid_new в $dstid_new СОЗДАН: ключ '$item_key', описание: '$item_key_description'.");
					} else
						echo json_encode_safe($jsonresErr);
				} else
					echo json_encode_safe($jsonresErr);
			} else {
				$out_item_id = setConnProps($connid, base64_decode($connkey), $srcid, $dstid, $item_key, $item_key_description);
				if ($out_item_id == -2) {
					$msg = "С указанным ключом уже существует другой переход из этого же элемента!";
					echo json_encode_safe(array('error' => $msg));
				} elseif ($out_item_id != null && $out_item_id != -1) {
					$msg = "Переход изменён успешно";
					echo json_encode_safe(array('ok' => $msg));
					//changelog
					$database_dynmenu->logMenuChange(CL_MENUS_CONNCHANGE, $menuid, 0,
						"Переход из $srcid в $dstid ИЗМЕНЕН: ключ '$item_key', описание: '$item_key_description'.");
				} else
					echo json_encode_safe($jsonresErr);
			}
		} elseif ($mode == 'del') {
			list($connid, $connkey) = explode("|", $_POST['connid_key']);
			$item_key_description = $_POST['conn_item_key_description'];
			$out_item_id = delConn($connid, base64_decode($connkey));
			if ($out_item_id != null && $out_item_id != -1) {
				$msg = "Переход удалён успешно";
				echo json_encode_safe(array('ok' => $msg));
				//changelog
				$database_dynmenu->logMenuChange(CL_MENUS_CONNDELETE, $menuid, 0,
					"Переход УДАЛЕН: описание: '$item_key_description'.");
			} else
				echo json_encode_safe($jsonresErr);
		}
	} elseif (isset($_POST['connid_key'])) {
		//getting props
		list($connid, $connkey) = explode("|", $_POST['connid_key']);
		$conndata = getConnProps($connid, base64_decode($connkey));
		if (is_array($conndata) && $conndata['conn_item_connection_id'] != -1)
			echo json_encode_safe($conndata);
		else
			echo json_encode_safe($jsonresErr);
	} else {
		echo json_encode_safe($jsonresErr);
	}
} else {
	echo json_encode_safe($jsonresErr);
}
?>
