<?php
require_once(dirname(__FILE__).'/vo_htmls_plain.php');
require_once(dirname(__FILE__).'/vo_htmls.php');
require_once(dirname(__FILE__).'/include/database_dynmenu.php');
require_once(dirname(__FILE__).'/menu_graph.php');

global $database_dynmenu;
if (!$database_dynmenu->db_ok) {
	print(GetClosedPageContent());
	die();
}

$preheadcode = <<<EOS
<script type="text/javascript" src="jsdojo17/dojo/dojo.js"
	dojoConfig="parseOnLoad: false, isDebug: false, locale: 'ru-ru'">
</script>
<script language="JavaScript" type="text/JavaScript" src="js/audio-player.js"></script>
<script language="JavaScript" type="text/JavaScript" src="js/menu_services.js"></script>
<script type="text/javascript" src="js/jquery/jquery.tools.min.js"></script>
<script type="text/javascript" src="js/jquery/flexigrid.js" charset="UTF-8"></script>
<link href="styles/jquery/flexigrid.css" rel="stylesheet" type="text/css" media="screen"/>
<script type="text/javascript" src="js/jquery/jquery.iframer.js"></script>
<script type="text/javascript" src="js/jquery/jquery.filestyle.js"></script>
<script type="text/javascript" src="js/jquery/jquery.download.js"></script>
EOS;

$addheadcode = <<<EOS
<link href="styles/bootstrap.css" rel="stylesheet">
<script type="text/javascript" src="js/bootstrap.js"></script>
<link rel="stylesheet" href="styles/menu_styles.css">
<link rel="stylesheet" href="styles/ctrls.css">
<script type="text/javascript" src="js/ivr.js"></script>
EOS;

$pagetitle = "!IVR-Kit (Редактор Динамических Сценариев)";

print(GetHTMLHeader($pagetitle, null, $addheadcode, $preheadcode, ''));
//print(GetPageTop());
?>

<div id="preloader"></div><div id="ivr_edit"></div>
<div style="clear:both;margin:10px 0 0 0"></div>
<div class="pagemain">
	<div dojoType="dijit.Dialog" id="dlgMenuItemProps" title="Свойства элемента"
		onCancel="dlgMenuItemProps_OnClose();"
		onShow="dlgMenuItemProps_OnShow();"
		>
		<!-- <div dojoType="dijit.layout.ContentPane" id="dlgMenuItemProps_loading" style="width: 400px; height: 440px;">
			<label><span><img src="images/loading.gif" width="16" height="16">&nbsp;Загрузка...</span></label>
		</div> -->
		<label id="lMenuItemProps_loading"><span style="color:red;font-weight:bold;"><img src="images/loading16.gif" width="16" height="16" alt="">&nbsp;Загрузка...</span></label>
		<div dojoType="dijit.layout.ContentPane" id="dlgMenuItemProps_content">
			<div dojoType="dijit.layout.TabContainer" id="dlgMenuItemProps_tabs" style="width: 700px; height: 450px;">

				<div dojoType="dijit.layout.ContentPane" id="dlgMenuItemProps_Main" title="Основные">
					<div dojoType="dijit.SimTitlePane" title="<span style='font-weight:bold;'>Основные свойства</span>" open="false" toggleable="false"></div>
					<br />
					<table>
						<tr>
							<td><label for="item_name">Название</label></td>
							<td>
								<input dojoType="dijit.form.ValidationTextBox"
									name="item_name"
									id="item_name"
									required="true"
									Q_promptMessage="Задайте название"
									missingMessage="Название не задано!"
									invalidMessage="Название не задано!"
									Q_regExp="[0-9a-Zа-яА-Я]+"
									intermediateChanges="true"
									type="text"
									tabindex="0"
									onKeyUp="dlgMenuItemProps_OnControlsChange()"
									onKeyDown="dlgMenuItemProps_OnControlsChange()"
									onKeyPress="dlgMenuItemProps_OnControlsChange()"
									onChange="dlgMenuItemProps_OnControlsChange()"
									style="width: 320px">
							</td>
						</tr>
						<tr>
							<td><label for="item_service_id">Тип</label></td>
							<td>
								<div dojoType="dojo.data.ItemFileReadStore" jsId="itemtypesstore" url="menu_itemtypes.php" urlPreventCache="true" clearOnClose="true"></div>
								<select dojoType="dijit.form.FilteringSelect"
										name="item_service_id"
										id="item_service_id"
										required="true"
										autoComplete="true"
										readOnly="false"
										ignoreCase="true"
										store="itemtypesstore"
										searchAttr="description"
										labelAttr="description"
										labelFunc="servicetypeLabelFunc"
										labelType="html"
										onKeyUp="dlgMenuItemProps_OnControlsChange(self)"
										onKeyDown="dlgMenuItemProps_OnControlsChange(self)"
										onKeyPress="dlgMenuItemProps_OnControlsChange(self)"
										onChange="dlgMenuItemProps_OnControlsChange(self)"
										style="width: 320px">
									<option value="1">Сервис голосового меню</option>
								</select>
							</td>
						</tr>
						<tr>
							<td colspan="2">&nbsp;</td>
						</tr>
						<tr>
							<td colspan="2">
								&nbsp;
								<input dojoType="dijit.form.CheckBox"
									name="item_user_editable"
									id="item_user_editable"
									value="1">
								<label for="item_user_editable">Элемент доступен для редактирования из внешних систем</label>
							</td>
						</tr>
						<tr>
							<td colspan="2" align="center">
								<button dojoType="dijit.form.Button" id="btMakeStartItem" name="btMakeStartItem" iconClass="homeIcon" style="margin:40px 0 40px 0;"
									title="Сделать этот элемент стартовым элементом сценария" onClick="return dlgMenuItemProps_OnMakeStartItem();">
									Сделать стартовым элементом сценария
								</button>
							</td>
						</tr>
					</table>
				</div>

				<div dojoType="dijit.layout.ContentPane" id="dlgMenuItemProps_Synthz" title="Синтезаторы">
					<div dojoType="dijit.SimTitlePane" title="<span style='font-weight:bold;'>Настройки сервиса типа 'Голосовое меню'</span>" open="false" toggleable="false"></div>
					<br />
					<table>
						<tr>
							<td><label for="voice_item_synthez">Список</label></td>
							<td>
								<input dojoType="dijit.form.ValidationTextBox"
									invalidMessage="Список синтезаторов пуст!"
									Q_regExp="[\d\w\s]+"
									intermediateChanges="true"
									type="text"
									name="voice_item_synthez"
									id="voice_item_synthez"
									style="width: 280px">
							</td>
						</tr>
						<tr>
							<td><label for="voice_item_synthez_place">Расположение</label></td>
							<td>
								<select dojoType="dijit.form.FilteringSelect"
										name="voice_item_synthez_place"
										id="voice_item_synthez_place"
										required="true"
										autoComplete="true"
										readOnly="false"
										ignoreCase="true"
										onKeyUp="dlgMenuItemProps_OnControlsChange()"
										onKeyDown="dlgMenuItemProps_OnControlsChange()"
										onKeyPress="dlgMenuItemProps_OnControlsChange()"
										onChange="dlgMenuItemProps_OnControlsChange()"
										style="width: 280px">
									<option value="0">На плате оборудования</option>
									<option value="1">На голосовом сервере</option>
								</select>
							</td>
						</tr>
						<tr>
							<td><label for="voice_item_timeout">Таймаут, мс</label></td>
							<td>
								<input dojoType="dijit.form.NumberSpinner"
									required="true"
									invalidMessage="Значение не задано!"
									constraints="{min:0,max:1000000,places:0,pattern:'#####0.00'}"
									smallDelta="1000"
									largeDelta="10000"
									intermediateChanges="true"
									name="voice_item_timeout"
									id="voice_item_timeout"
									onKeyUp="dlgMenuItemProps_OnControlsChange()"
									onKeyDown="dlgMenuItemProps_OnControlsChange()"
									onKeyPress="dlgMenuItemProps_OnControlsChange()"
									onChange="dlgMenuItemProps_OnControlsChange()"
									style="width: 280px">
							</td>
						</tr>
						<tr>
							<td><label for="voice_item_repeat_count">Кол-во повторов</label></td>
							<td>
								<input dojoType="dijit.form.NumberSpinner"
									required="true"
									invalidMessage="Значение не задано!"
									constraints="{min:0,max:1000,places:0}"
									smallDelta="1"
									largeDelta="10"
									intermediateChanges="true"
									type="text"
									name="voice_item_repeat_count"
									id="voice_item_repeat_count"
									onKeyUp="dlgMenuItemProps_OnControlsChange()"
									onKeyDown="dlgMenuItemProps_OnControlsChange()"
									onKeyPress="dlgMenuItemProps_OnControlsChange()"
									onChange="dlgMenuItemProps_OnControlsChange()"
									style="width: 280px">
							</td>
						</tr>
						<tr>
							<td><label for="voice_item_macro_name">Имя макроса</label></td>
							<td>
								<input dojoType="dijit.form.ValidationTextBox"
									intermediateChanges="true"
									type="text"
									name="voice_item_macro_name"
									id="voice_item_macro_name"
									onKeyUp="dlgMenuItemProps_OnControlsChange()"
									onKeyDown="dlgMenuItemProps_OnControlsChange()"
									onKeyPress="dlgMenuItemProps_OnControlsChange()"
									onChange="dlgMenuItemProps_OnControlsChange()"
									style="width: 280px">
							</td>
						</tr>
						<tr>
							<td colspan="2">
								<table>
								<tr>
									<td style="text-align:center;vertical-align:text-top;">
										<button dojoType="dijit.form.Button" showLabel="false" iconClass="itemaddIcon" id="voice_item_add" title="Добавить синтезатор из общего списка синтезаторов системы (в открывшемся окне выделите требуемые синтезаторы и нажмите OK)" onClick="showMenuSynthz(true);">
										</button>
										<br />
										<button dojoType="dijit.form.Button" showLabel="false" iconClass="itemdelIcon" id="voice_item_del" title="Удалить выбранные синтезаторы из списка" onClick="DeleteSelectedListItems('voice_item_synthez_edit', 'voice_item_synthez');">
										</button>
										<br /><br />
										<button dojoType="dijit.form.Button" showLabel="false" iconClass="itemupIcon" id="voice_item_up" title="Переместить выбранные элементы списка вверх" onClick="MoveSelectedListItems('up', 'voice_item_synthez_edit', 'voice_item_synthez');">
										</button>
										<br />
										<button dojoType="dijit.form.Button" showLabel="false" iconClass="itemdnIcon" id="voice_item_dn" title="Переместить выбранные элементы списка вниз" onClick="MoveSelectedListItems('down', 'voice_item_synthez_edit', 'voice_item_synthez');">
										</button>
									</td>
									<td>
										<select dojoType="dijit.form.MultiSelect" id="voice_item_synthez_edit" name="voice_item_synthez_edit" multiple class="selectw" style="width:340px;height:170px;"
											OnDblClick="VoiceItem_SynthPlayerStart();">
											<!-- <option value="1" class="fancyselectoption">1</option>
											<option value="2" class="fancyselectoption">2</option>
											<option value="3" class="fancyselectoption">3</option> -->
										</select>
									</td>
								</tr>
								</table>
							</td>
						</tr>
						<tr>
							<td colspan="2">
								<table width="100%">
								<tr>
									<td width="80%">
										<div id="synplayer"></div>
									</td>
									<td style="text-align:right;vertical-align:text-top;">
										<button dojoType="dijit.form.Button" showLabel="false" iconClass="itemplaystartIcon" id="voice_item_playstart" title="Прослушать выбранный синтезатор" onClick="VoiceItem_SynthPlayerStart();">
										</button>
										<button dojoType="dijit.form.Button" showLabel="false" iconClass="itemplaystopIcon" id="voice_item_playstop" title="Остановить прослушивание" onClick="VoiceItem_SynthPlayerStop();">
										</button>
									</td>
								</tr>
								</table>
							</td>
						</tr>
					</table>
					<!-- <br />
					<div style="float:left;margin-right:8px;">
						<label for="ActiveSynthz">Активные</label>
						<div dojoType="dojo.dnd.Source" class="container" id="ActiveSynthz" name="ActiveSynthz" jsId="ActiveSynthzDragSource" style="width:160px;"></div>
					</div>
					<div style="float:left;">
						<label for="AllSynthz">Общий список</label>
						<div dojoType="dojo.dnd.Source" class="container" id="AllSynthz" name="AllSynthz" jsId="AllSynthzDragSource" selfAccept="false" copyOnly="true" style="width:160px;"></div>
					</div> -->
				</div>

				<div dojoType="dijit.layout.ContentPane" id="dlgMenuItemProps_Cond" title="Условие перехода">
					<div dojoType="dijit.SimTitlePane" title="<span style='font-weight:bold;'>Настройки сервиса типа 'Условное меню'</span>" open="false" toggleable="false"></div>
					<br />
					<table>
						<tr>
							<td><label for="condition_processor_name">Обработчик условия</label></td>
							<td>
								<div dojoType="dojo.data.ItemFileReadStore" jsId="conditionprocessorsstore" url="menu_conditionprocessors.php" urlPreventCache="true" clearOnClose="true"></div>
								<select dojoType="dijit.form.FilteringSelect"
										name="condition_processor_name"
										id="condition_processor_name"
										invalidMessage="Неизвестный обработчик!"
										required="true"
										autoComplete="true"
										readOnly="false"
										ignoreCase="true"
										store="conditionprocessorsstore"
										searchAttr="description"
										style="width: 260px">
									<option value="SQL_CONDITION">SQL-процессор</option>
									<option value="SQL_CONDITION_1">SQL-процессор 1</option>
									<option value="SQL_CONDITION_2">SQL-процессор 2</option>
									<option value="SQL_CONDITION_3">SQL-процессор 3</option>
									<option value="SQL_CONDITION_4">SQL-процессор 4</option>
									<option value="PHP_CONDITION">PHP-процессор</option>
								</select>
							</td>
						</tr>
					</table>
					<textarea dojoType="dijit.form.SimpleTextareaNoWrap"
						name="condition_data"
						id="condition_data"
						style="width:99%;height:83%;font-family:courier,monospace;">
-->SUBSTITUTION
InCall.NumberIn
<--
-->SQL
Select *
from OFFICE_SELECT('%InCall.NumberIn%')
<--
</textarea>
					<!--<textarea dojoType="dijit.form.SimpleTextareaNoWrap"
							title="Список параметров для условия"
							name="condition_data_params"
							id="condition_data_params"
							style="width:99%;height:25%;font-family:courier,monospace;">
InCall.NumberIn
</textarea>
					<textarea dojoType="dijit.form.SimpleTextareaNoWrap"
							title="Текст условия"
							name="condition_data"
							id="condition_data"
							style="width:99%;height:58%;font-family:courier,monospace;">
select * from OFFICE_SELECT('%InCall.NumberIn%')
</textarea>-->
				</div>
			</div>

			<table style="width:100%;">
				<tr>
					<td align="left" width="80%">
						<button dojoType="dijit.form.Button" iconClass="delitemIcon" id="delitem" title="Удалить этот элемент" onClick="return dlgMenuItemProps_OnDeleteItem();">
							<span>Удалить элемент</span>
						</button>
					</td>
					<td align="right">
						<button dojoType="dijit.form.Button" id="btMenuItemProps_OK" iconClass="dummyIcon" title="Сохранить изменения" onClick="return dlgMenuItemProps_OnSubmit();">
							&nbsp;&nbsp;&nbsp;&nbsp;OK&nbsp;&nbsp;&nbsp;&nbsp;
						</button>
					</td>
					<td align="right">
						<button dojoType="dijit.form.Button" iconClass="dummyIcon" onClick="dlgMenuItemProps_OnClose(self);">
							Отмена
						</button>
					</td>
				</tr>
			</table>
		</div>
	</div>

	<div dojoType="dijit.Dialog" id="dlgMenuConnProps" title="Свойства перехода"
		style="display: none;"
		onCancel="dlgMenuConnProps_OnClose();"
		onShow="dlgMenuConnProps_OnShow()">
		<!-- <div dojoType="dijit.layout.ContentPane" id="dlgMenuConnProps_loading" style="width: 400px; height: 430px;">
			<label><span><img src="images/loading.gif" width="16" height="16">&nbsp;Загрузка...</span></label>
		</div> -->
		<label id="lMenuConnProps_loading"><span style="color:red;font-weight:bold;"><img src="images/loading.gif" width="16" height="16" alt="">&nbsp;Загрузка...</span></label>
		<div dojoType="dijit.layout.ContentPane" id="dlgMenuConnProps_content">
			<div dojoType="dijit.layout.TabContainer" style="width: 400px; height: 300px;">
				<div dojoType="dijit.layout.ContentPane" title="Основные">
					<div dojoType="dijit.SimTitlePane" title="<span style='font-weight:bold;'>Основные свойства</span>" open="false" toggleable="false"></div>
					<br />
					<label for="conn_src_item_id" style="margin:0 4px 2px 4px;">Начальный элемент перехода</label>
					<br />
					<div dojoType="dojo.data.ItemFileReadStore" jsId="itemnamesstore" url="menu_itemnames.php?ivr_edit=1" urlPreventCache="true" clearOnClose="true"></div>
					<select dojoType="dijit.form.FilteringSelect"
							name="conn_src_item_id"
							id="conn_src_item_id"
							required="true"
							Q_promptMessage="Выберите элемент"
							missingMessage="Не выбран элемент перехода!"
							invalidMessage="Не выбран элемент перехода!"
							autoComplete="true"
							readOnly="false"
							ignoreCase="true"
							store="itemnamesstore"
							searchAttr="item_name"
							onKeyUp="dlgMenuConnProps_OnControlsChange()"
							onKeyDown="dlgMenuConnProps_OnControlsChange()"
							onKeyPress="dlgMenuConnProps_OnControlsChange()"
							onChange="dlgMenuConnProps_OnControlsChange()"
							style="width:380px;margin:2px 4px 0 4px;">
					</select>
					<br />
					<label for="conn_dst_item_id" style="margin:0 4px 2px 4px;">Конечный элемент перехода</label>
					<br />
					<select dojoType="dijit.form.FilteringSelect"
							name="conn_dst_item_id"
							id="conn_dst_item_id"
							required="true"
							Q_promptMessage="Выберите элемент"
							missingMessage="Не выбран элемент перехода!"
							invalidMessage="Не выбран элемент перехода!"
							autoComplete="true"
							readOnly="false"
							ignoreCase="true"
							store="itemnamesstore"
							searchAttr="item_name"
							onKeyUp="dlgMenuConnProps_OnControlsChange()"
							onKeyDown="dlgMenuConnProps_OnControlsChange()"
							onKeyPress="dlgMenuConnProps_OnControlsChange()"
							onChange="dlgMenuConnProps_OnControlsChange()"
							style="width:380px;margin:2px 4px 0 4px;">
					</select>
					<br />
					<label for="conn_item_key_description" style="margin:0 4px 2px 4px;">Описание</label>
					<br />
					<input dojoType="dijit.form.ValidationTextBox"
						name="conn_item_key_description"
						id="conn_item_key_description"
						required="false"
						Q_promptMessage="Задайте описание перехода"
						missingMessage="Не задано описание перехода!"
						invalidMessage="Не задано описание перехода!"
						Q_regExp="[0-9a-Zа-яА-Я_]+"
						intermediateChanges="true"
						type="text"
						tabindex="0"
						onKeyUp="dlgMenuConnProps_OnControlsChange()"
						onKeyDown="dlgMenuConnProps_OnControlsChange()"
						onKeyPress="dlgMenuConnProps_OnControlsChange()"
						onChange="dlgMenuConnProps_OnControlsChange()"
						style="width:380px;margin:2px 4px 0 4px;">
					<br />
					<label for="conn_item_key" style="margin:0 4px 2px 4px;">Ключ перехода</label>
					<br />
					<input dojoType="dijit.form.TextBox"
						intermediateChanges="true"
						type="text"
						name="conn_item_key"
						id="conn_item_key"
						style="width:380px;margin:2px 4px 0 4px;">
				</div>
			</div>

			<table style="width:100%;">
				<tr>
					<td align="left" width="80%">
						<button dojoType="dijit.form.Button" id="btMenuConnProps_DelConn" iconClass="delconnIcon" title="Удалить этот переход" onClick="return dlgMenuConnProps_OnDeleteConn();">
							<span>Удалить переход</span>
						</button>
					</td>
					<td align="right">
						<button dojoType="dijit.form.Button" id="btMenuConnProps_OK" iconClass="dummyIcon" title="Сохранить изменения" onClick="return dlgMenuConnProps_OnSubmit();">
							&nbsp;&nbsp;&nbsp;&nbsp;OK&nbsp;&nbsp;&nbsp;&nbsp;
						</button>
					</td>
					<td align="right">
						<button dojoType="dijit.form.Button" iconClass="dummyIcon" onClick="dlgMenuConnProps_OnClose(self);">
							Отмена
						</button>
					</td>
				</tr>
			</table>
		</div>
	</div>

	<div dojoType="dijit.Dialog" id="dlgMenuSynthz" title="Синтезаторы системы"
		onCancel="dlgMenuSynthz_OnClose();"
		onShow="dlgMenuSynthz_OnShow();"
		>
		<!-- <div dojoType="dijit.layout.ContentPane" id="dlgMenuSynthz_loading" style="width: 400px; height: 530px;">
			<label><span><img src="images/loading.gif" width="16" height="16">&nbsp;Загрузка...</span></label>
		</div> -->
		<label id="lMenuSynthz_loading"><span style="color:red;font-weight:bold;"><img src="images/loading.gif" width="16" height="16" alt="">&nbsp;Загрузка...</span></label>
		<div dojoType="dijit.layout.ContentPane" id="dlgMenuSynthz_content">
			<div dojoType="dijit.layout.TabContainer" style="width:400px;height:500px;">
				<div dojoType="dijit.layout.ContentPane" title="Список">
					<div dojoType="dijit.SimTitlePane" title="<span style='font-weight:bold;'>Список синтезаторов системы</span>" open="false" toggleable="false"></div>
					<table>
						<tr>
							<td>
								<table>
								<tr>
									<td style="text-align:center;vertical-align:text-top;">
										<button dojoType="dijit.form.Button" showLabel="false" iconClass="itemdelIcon" id="voice_item_del_global" title="Удалить выбранные синтезаторы" onClick="DeleteSelectedSynthsGlobal('synthzlist');">
										</button>
									</td>
									<td>
										<select dojoType="dijit.form.MultiSelect" id="synthzlist" name="synthzlist" multiple class="selectw" style="width:345px;height:380px;margin:2px 4px 0 0;"
											OnDblClick="VoiceItem_SynthPlayerStartGlobal();">
											<!-- <option value="1" class="fancyselectoption">1</option>
											<option value="2" class="fancyselectoption">2</option>
											<option value="3" class="fancyselectoption">3</option> -->
										</select>
									</td>
								</tr>
								</table>
							</td>
						</tr>
						<tr>
							<td>
								<table width="100%">
								<tr>
									<td width="80%">
										<div id="synplayerg"></div>
									</td>
									<td style="text-align:right;vertical-align:text-top;">
										<button dojoType="dijit.form.Button" showLabel="false" iconClass="itemplaystartIcon" id="voice_item_playstart_global" title="Прослушать выбранный синтезатор" onClick="VoiceItem_SynthPlayerStartGlobal();">
										</button>
										<button dojoType="dijit.form.Button" showLabel="false" iconClass="itemplaystopIcon" id="voice_item_playstop_global" title="Остановить прослушивание" onClick="VoiceItem_SynthPlayerStopGlobal();">
										</button>
									</td>
								</tr>
								</table>
							</td>
						</tr>
					</table>
				</div>

				<div dojoType="dijit.layout.ContentPane" title="Загрузка">
					<div dojoType="dijit.SimTitlePane" title="<span style='font-weight:bold;'>Загрузка синтезаторов в систему</span>" open="false" toggleable="false"></div>
					<div id="synthz_upload_selector">
						<form id="frm_putfile" enctype="multipart/form-data" action="fs_putfile.php" method="post">
							<input type="hidden" name="rawres" value="1">
							<input type="hidden" name="ivr_edit" value="1">
							<input type="hidden" name="MAX_FILE_SIZE" value="<?php echo MAX_FILE_SIZE_UPLOAD_FAX ?>">
							<label for="synthz_add_file">Выберите локальный аудио-файл для загрузки (wav, mp3, ...)</label>
							<input type="file" name="synthz_add_file" id="synthz_add_file" accept="audio/*">
							<label for="synthz_add_file_description">Текстовое описание синтезатора</label>
							<input type="text" name="synthz_add_file_description" id="synthz_add_file_description">
						</form>
						<input type="image" class="button" id="bt_synthz_upload" value="Отправить" src="images/btsend.gif" />
					</div>
					<div id="synthz_upload_progress" style="display:none;">
						<img src="images/pbari2.gif" alt="" width="208" height="13">
					</div>
					<div id="synthz_upload_results" style="display:none;">
						<label>Результат отправки:&nbsp;</label>
						<span id="synthz_upload_result_msg"></span>
					</div>
				</div>
			</div>

			<table style="width:100%;">
				<tr>
					<td width="90%">
					</td>
					<td align="right">
						<button dojoType="dijit.form.Button" iconClass="dummyIcon" onClick="dlgMenuSynthz_OnSubmit();">
							&nbsp;&nbsp;&nbsp;&nbsp;OK&nbsp;&nbsp;&nbsp;&nbsp;
						</button>
					</td>
					<td align="right">
						<button dojoType="dijit.form.Button" iconClass="dummyIcon" onClick="dlgMenuSynthz_OnClose(self);">
							Отмена
						</button>
					</td>
				</tr>
			</table>
		</div>
	</div>

	<div dojoType="dijit.Dialog" id="dlgInfoMessage" title="Редактор сценариев" style="display: none;"
			q_onfocus="setTimeout(function(){dijit.byId('dlgInfoMessage').hide();},'10000')">
		<div dojoType="dijit.layout.ContentPane">
			<img src="images/icon_info.gif" width="16" height="16" alt="">
			<span id="dlgInfoMessage_msg">&nbsp;Всё нормально!</span>
			<table style="width:600px;margin-top:10px; border-top:1px #ccc solid;">
				<tr>
					<td width="90%">
					</td>
					<td align="right">
						<button dojoType="dijit.form.Button" iconClass="dummyIcon" onClick="dijit.byId('dlgInfoMessage').hide();">
							&nbsp;&nbsp;&nbsp;&nbsp;OK&nbsp;&nbsp;&nbsp;&nbsp;
						</button>
					</td>
				</tr>
			</table>
		</div>
	</div>

	<div dojoType="dijit.Dialog" id="dlgErrorMessage" title="Редактор сценариев" style="display: none;"
			q_onfocus="setTimeout(function(){dijit.byId('dlgErrorMessage').hide();},'10000')">
		<div dojoType="dijit.layout.ContentPane">
			<img src="images/icon_error2.gif" width="16" height="16" alt="">
			<span id="dlgErrorMessage_msg">&nbsp;Всё плохо!</span>
			<table style="width:600px;margin-top:10px; border-top:1px #ccc solid">
				<tr>
					<td width="90%">
					</td>
					<td align="right">
						<button dojoType="dijit.form.Button" iconClass="dummyIcon" onClick="dijit.byId('dlgErrorMessage').hide();">
							&nbsp;&nbsp;&nbsp;&nbsp;OK&nbsp;&nbsp;&nbsp;&nbsp;
						</button>
					</td>
				</tr>
			</table>
		</div>
	</div>

	<div id="resultmsg" style="display:none;margin-top:4px;position:absolute;top:95%;left:20px;">
		Всё плохо плохо плохо плохо плохо плохо плохо плохо плохо плохо плохо!
	</div>

	<script type="text/javascript">
	<!--
		if (!IsFlashEnabled()) writeGetFlashImage();
	// -->
	</script>

	<div id="toolbar" dojoType="dijit.Toolbar" style="position:fixed;left:1px;top:1px;">
		<script type="text/javascript">
			<?php
			$omid = isset($_COOKIE['office_menuid']) && is_numeric($_COOKIE['office_menuid']) ? intval($_COOKIE['office_menuid']) : -1;
			$_COOKIE['office_menuid'] = $omid;
			?>
			office_menuid = <?php echo $omid; ?>;
		</script>
		<div dojoType="dijit.form.Button" id="btMenuOfficeSetupDlg" name="btMenuOfficeSetupDlg" iconClass="openIcon" showLabel="true" title="Управление сценариями" onClick="show_projectprops(office_menuid);">
			<span><?php
				global $database_dynmenu;
				$omid = isset($_COOKIE['office_menuid']) ? intval($_COOKIE['office_menuid']) : -1;
				if ($omid >= 0) echo $database_dynmenu->getMenuInfo($omid); else echo 'СЦЕНАРИЙ НЕ ВЫБРАН';
				?></span>
		</div>

		<span dojoType="dijit.ToolbarSeparator"></span>

		<div dojoType="dijit.form.Button" id="btMenuRefreshDlg" name="btMenuRefreshDlg" title="Обновить схему" iconClass="reloadIcon" onClick="reloadPic('menugraph');">
			<span>Обновить схему</span>
		</div>

		<span dojoType="dijit.ToolbarSeparator"></span>

		<div dojoType="dijit.form.DropDownButton" id="btMenuGraphZoomDlg" name="btMenuGraphZoomDlg" iconClass="zoominIcon" showLabel="true" title="Настроить масшаб отображения схемы">
			<span>Масштаб</span>
			<div dojoType="dijit.TooltipDialog" id="dlgMenuGraphZoom" style="width: 450px;">
				<div dojoType="dijit.SimTitlePane" style="margin-bottom:10px;" title="<span style='font-weight:bold;'>Настройка масштаба отображения схемы</span>" open="false" toggleable="false"></div>
				<div dojoType="dijit.form.HorizontalSlider"
					onChange="dojo.byId('menugraphzoomvalue').innerHTML = dojo.number.format(arguments[0]/100,{places:1,pattern:'<b>#%</b>'});zoomPic('menugraph', arguments[0]);"
					id="menugraphzoom"
					name="menugraphzoom"
					value="100"
					maximum="500"
					minimum="1"
					pageIncrement="10"
					showButtons="true"
					intermediateChanges="true"
					slideDuration="500"
					style="width:90%;height:20px;">
				<div dojoType="dijit.form.HorizontalRule" container="topDecoration" count="10" style="height:5px;"></div>
				<div dojoType="dijit.form.HorizontalRule" container="bottomDecoration" count="3" style="height:5px;"></div>
					<ol dojoType="dijit.form.HorizontalRuleLabels" container="bottomDecoration" style="height:1em;font-size:75%;">
						<li>минимум</li>
						<li>оригинальный</li>
						<li>максимум</li>
					</ol>
				</div>
				<label for="menugraphzoom" id="menugraphzoomvalue" style="float:right;margin-top:-33px"><b>100%</b></label>
			</div>
		</div>

		<span dojoType="dijit.ToolbarSeparator"></span>

		<div dojoType="dijit.form.Button" id="btMenuNewItemDlg" name="btMenuNewItemDlg" title="Добавить новый элемент в сценарий" iconClass="additemIcon" onClick="showMenuItemProps(-1);">
			<span>Новый элемент</span>
		</div>
		<div dojoType="dijit.form.Button" id="btMenuNewConnDlg" name="btMenuNewConnDlg" title="Добавить новый переход между элементами сценария" iconClass="addconnIcon" onClick="showMenuConnProps('-1|-1');">
			<span>Новый переход</span>
		</div>
		<div dojoType="dijit.form.Button" id="btMenuSynthzDlg" name="btMenuSynthzDlg" title="Открыть окно настройки синтезаторов системы" iconClass="synthzIcon" onClick="showMenuSynthz();">
			<span>Синтезаторы</span>
		</div>
	</div>
	<div dojoType="dojo.data.ItemFileReadStore" jsId="menuliststore" url="menu_menus.php?ivr_edit=1" urlPreventCache="true" clearOnClose="true"></div>
<?php
	$rnd1 = session_name();
	$rnd2 = session_id();
?>
	<br>
<?php
	$omid = isset($_COOKIE['office_menuid']) && is_numeric($_COOKIE['office_menuid']) ? intval($_COOKIE['office_menuid']) : -1;
	if ($omid >= 0) {
?>
	<div id="menugraphcont" style="display:none">
		<?php /* <!-- <embed id="menugraph" name="menugraph" src="menu_graph.php?ivr_edit=1&--><?php //echo $rnd1 ?><!--=--><?php //echo $rnd2 ?><!--&dummy=.svg" type="image/svg+xml" pluginspage="http://www.adobe.com/svg/viewer/install/" /> --> */ ?>
		<object id="menugraph" name="menugraph" data="menu_graph.php?ivr_edit=1&<?php echo $rnd1 ?>=<?php echo $rnd2 ?>&dummy=.svg" type="image/svg+xml">Ваш браузер староват'с!</object>
	</div>
<?php
	} else {
?>
	<div id="menugraphcont" style="display:none">
		<object id="menugraph" name="menugraph" data="menu_graph.php?ivr_edit=1&nomenu=1&dummy=.svg" type="image/svg+xml">Ваш браузер староват'с!</object>
	</div>
<?php
	}
?>

	<script type="text/javascript">
	<!--
		var menugraph_w = -1, menugraph_h = -1;
		function procPicSize(picname, restoreonly) {
			if (office_menuid < 0)
				return false;
			var obj = document.getElementById(picname);
			if (obj) {
				if (restoreonly) {
					var ww = intval(getCookie('menugraph_'+office_menuid+'_w'));
					var hh = intval(getCookie('menugraph_'+office_menuid+'_h'));
					var pp = intval(getCookie('menugraph_'+office_menuid+'_p'));
					if (ww > 100 && pp > 0) {
						obj.style.setProperty('width', (ww*pp)/100 + 'px', 'important');
						obj.style.setProperty('height', (hh*pp)/100 + 'px', 'important');
						return true;
					}
					return false;
				}

				menugraph_w = obj.clientWidth;
				menugraph_h = obj.clientHeight;
				setCookie('menugraph_'+office_menuid+'_w', menugraph_w);
				setCookie('menugraph_'+office_menuid+'_h', menugraph_h);

				return true;
			}
			return false;
		}
		function reloadPic(picname) {
			//if (office_menuid < 0)
				//return false;
			procPicSize(picname, true);
			var obj = document.getElementById(picname);
			if (obj) {
				var now = new Date();
				if (office_menuid < 0)
					obj.data = "menu_graph.php?ivr_edit=1&nomenu=1&dummy=.svg";
				else {
					var scr = getScrollXY();
					setTimeout("window.scrollTo("+scr[0]+","+scr[1]+");", 3000);
					obj.data = "menu_graph.php?ivr_edit=1&<?php echo $rnd1 ?>=<?php echo $rnd2 ?>" + "&t=" + now.getTime() + "&dummy=.svg";
				}
				return true;
			}
			return false;
		}
		function zoomPic(picname, perc) {
			if (office_menuid < 0)
				return false;
			if (menugraph_w < 0)
				procPicSize(picname);
			var obj = document.getElementById(picname);
			if (obj) {
				obj.style.setProperty('width', (menugraph_w*perc)/100 + 'px', 'important');
				obj.style.setProperty('height', (menugraph_h*perc)/100 + 'px', 'important');
				setCookie('menugraph_'+office_menuid+'_p', perc);
				return true;
			}
			return false;
		}
		procPicSize('menugraph', true);
	// -->
	</script>
	<div id="dialogmenus"></div>
</div> <!-- pagemain -->

<div class="pagefooter">
<table class="pagefooter">
<tr><td class="footleft">&nbsp;</td><td class="footnav">&nbsp;</td></tr>
<tr><td colspan="2" class="footcopyright">&nbsp;<?php echo SITE_COPYRIGHT ?></td></tr>
</table>
</div>

<?php
print(GetHTMLFooter());
?>
