<?php
require_once(dirname(__FILE__).'/include/session.php');
require_once(dirname(__FILE__).'/include/database_dynmenu.php');
require_once(dirname(__FILE__).'/include/functions.php');

$jsonresErr = array('error' => 'Internal error!');

global $session, $database_dynmenu, $logger;

function getItemPropsJSON($itemid) {
	global $database_dynmenu, $logger;

	$q = "select * from menu_get_item_props($itemid)";
	$result = $database_dynmenu->getQueryResultAsArray($q, true);
	if (PEAR::isError($result)) {
		$logger->log("getItemPropsJSON($q):ERR=". getPEARErrorInfo($result));
		return null;
	} else {
		//$condition_data_decoded = $database_dynmenu->menu_condition_decode($result['condition_data']);
		//$result['condition_data'] = $condition_data_decoded['condition_data'];
		//$result['condition_data_params'] = $condition_data_decoded['condition_data_params'];
		return json_encode_safe($result);
	}
}

function setItemProps($menu_id, $item_id, $item_service_id, $item_name,
			$voice_item_synthez, $voice_item_synthez_place, $voice_item_timeout,
			$voice_item_repeat_count, $voice_item_macro_name,
			$condition_processor_name, $condition_data, $item_user_editable) {
	global $session, $database_dynmenu, $logger;

	if ($session->isDemo())
		return $item_id;

//	$q = "select * from menu_set_item_props($menu_id, $item_id, $item_service_id, '$item_name', ".
//			"'$voice_item_synthez', $voice_item_synthez_place, $voice_item_timeout, ".
//			"$voice_item_repeat_count, '$voice_item_macro_name', ".
//			"'$condition_processor_name', '$condition_data')";
//	//setResultTypes
//	$result = $database_dynmenu->getQueryResultAsArray($q, array('condition_data' => array('type' => 'blob')));

	$q = "select * from menu_set_item_props($menu_id, $item_id, $item_service_id, '$item_name', ".
			"'$voice_item_synthez', $voice_item_synthez_place, $voice_item_timeout, ".
			"$voice_item_repeat_count, '$voice_item_macro_name', ".
			"'$condition_processor_name', ?, $item_user_editable)";
	$pq = $database_dynmenu->prepare("select * from menu_set_item_props(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)",
							array('integer', 'integer', 'integer', 'text',
								'text', 'integer', 'integer',
								'integer', 'text',
								'text', 'text', 'integer'));  //'text', 'blob', 'integer'));
	$result = $database_dynmenu->execute($pq, array($menu_id, $item_id, $item_service_id, $item_name,
			$voice_item_synthez, $voice_item_synthez_place, $voice_item_timeout,
			$voice_item_repeat_count, $voice_item_macro_name,
			$condition_processor_name, $condition_data, $item_user_editable));

	if (PEAR::isError($result)) {
		$logger->log("setItemProps($q):ERR=". getPEARErrorInfo($result));
		return null;
	} else {
		$logger->log("setItemProps($q):".print_r($result, true));
		return intval($result[0]['out_item_id']);
	}
}

function setItemAsStart($item_id) {
	global $session, $database_dynmenu, $logger;

	if ($session->isDemo())
		return $item_id;

	$q = "select * from menu_set_start_item($item_id)";
	$result = $database_dynmenu->getQueryResultAsArray($q);
	if (PEAR::isError($result)) {
		$logger->log("setItemAsStart($q):ERR=\n". getPEARErrorInfo($result));
		return null;
	} else {
		$logger->log("setItemAsStart($q):\n".print_r($result, true));
		if (is_array($result) && !empty($result))
			return intval($result[0]['out_item_id']);
		else
			return null;
	}
}

function setItemSynth($item_id, $voice_item_synthez) {
	global $session, $database_dynmenu, $logger;

	if ($session->isDemo())
		return $item_id;

	$q = "select * from menu_set_item_synth($item_id, '$voice_item_synthez')";
	$result = $database_dynmenu->getQueryResultAsArray($q);
	if (PEAR::isError($result)) {
		$logger->log("setItemSynth($q):ERR=". getPEARErrorInfo($result));
		return null;
	} else {
		$logger->log("setItemSynth($q):".print_r($result, true));
		if (is_array($result) && !empty($result))
			return intval($result[0]['out_item_id']);
		else
			return null;
	}
}

function delItem($item_id) {
	global $session, $database_dynmenu, $logger;

	if ($session->isDemo())
		return $item_id;

	$q = "select * from menu_del_item($item_id)";
	$result = $database_dynmenu->getQueryResultAsArray($q);
	if (PEAR::isError($result)) {
		$logger->log("delItem($q):ERR=". getPEARErrorInfo($result));
		return null;
	} else {
		$logger->log("delItem($q):".print_r($result, true));
		if (is_array($result) && !empty($result))
			return intval($result[0]['out_item_id']);
		else
			return null;
	}
}

handle_magic_quotes();

$logger->log("POST(".basename($_SERVER['SCRIPT_NAME']).":\n".print_r($_POST, true));

header("Content-Type: text/plain");
if ($database_dynmenu->db_ok) {
	if (isset($_POST['sub_edit_menuitemprops'])) {
		$mode = $_POST['sub_edit_menuitemprops']; //edit/del

		$item_id = intval($_POST['item_id']);
		$item_name = $_POST['item_name'];

		//$menuid = ($session->logged_in && is_numeric($session->ofmenuid)) ? intval($session->ofmenuid) : (isset($_COOKIE['office_menuid']) ? intval($_COOKIE['office_menuid']) : -1);
		if (isset($_REQUEST['ivr_edit']))
			$menuid = isset($_COOKIE['office_menuid']) ? intval($_COOKIE['office_menuid']) : -1;
		else
			$menuid = ($session->logged_in && is_numeric($session->ofmenuid)) ? intval($session->ofmenuid) : -1;

		if ($mode == 'edit') {
			$item_service_id = intval($_POST['item_service_id']);
			$item_user_editable = isset($_POST['item_user_editable']) ? intval($_POST['item_user_editable']) : 0;
			$voice_item_synthez = $_POST['voice_item_synthez'];
			$voice_item_synthez_place = intval($_POST['voice_item_synthez_place']);
			$voice_item_timeout = intval($_POST['voice_item_timeout']);
			$voice_item_repeat_count = intval($_POST['voice_item_repeat_count']);
			$voice_item_macro_name = $_POST['voice_item_macro_name'];
			$condition_processor_name = $_POST['condition_processor_name'];
			//$condition_data_params = adjustlinebreaks($_POST['condition_data_params']);
			$condition_data = adjustlinebreaks($_POST['condition_data']);
			//$condition_data = $database_dynmenu->menu_condition_encode($condition_processor_name, $condition_data_params, $condition_data);

			$out_item_id = setItemProps($menuid, $item_id, $item_service_id, $item_name,
				$voice_item_synthez, $voice_item_synthez_place, $voice_item_timeout,
				$voice_item_repeat_count, $voice_item_macro_name,
				$condition_processor_name, $condition_data, $item_user_editable);
			if ($out_item_id != null) {
				$msg = $item_id < 0 ? "Элемент '$item_name' создан успешно" : "Элемент '$item_name' изменён успешно";
				echo json_encode_safe(array('ok' => $msg));
				//changelog
				$database_dynmenu->logMenuChange($item_id < 0 ? CL_MENUS_ITEMNEW : CL_MENUS_ITEMCHANGE, $menuid, 0,
					$item_id < 0 ? "Элемент '$item_name' создан." : "Элемент '$item_name' изменён.");
			} else
				echo json_encode_safe(array('error' => 'Ошибка изменения элемента!'));
		} elseif ($mode == 'edit_setstart') {
			$out_item_id = setItemAsStart($item_id);
			if ($out_item_id != null) {
				$msg = "Элемент '$item_name' успешно сделан стартовым элементом";
				echo json_encode_safe(array('ok' => $msg));
				//changelog
				$database_dynmenu->logMenuChange(CL_MENUS_ITEMSETSTART, $menuid, 0,
					"Элемент '$item_name' сделан стартовым элементом.");
			} else
				echo json_encode_safe(array('error' => 'Ошибка при изменении свойств элемента!'));
		} elseif ($mode == 'edit_synth') {
			$voice_item_synthez = $_POST['voice_item_synthez'];
			$out_item_id = setItemSynth($item_id, $voice_item_synthez);
			if ($out_item_id != null) {
				$msg = "Голосовое сообщение '$item_name' успешно изменено";
				echo json_encode_safe(array('ok' => $msg));
				//changelog
				$database_dynmenu->logMenuChange(CL_MENUS_ITEMSETSTART, $menuid, 0,
					"Голосовое сообщение '$item_name' успешно изменено.");
			} else
				echo json_encode_safe(array('error' => 'Ошибка изменения голосового сообщения!'));
		} elseif ($mode == 'del') {
			$out_item_id = delItem($item_id);
			if ($out_item_id != null && $out_item_id >= 0) {
				$msg = "Элемент '$item_name' удалён успешно";
				echo json_encode_safe(array('ok' => $msg));
				//changelog
				$database_dynmenu->logMenuChange(CL_MENUS_ITEMDELETE, $menuid, 0,
					"Элемент '$item_name' удалён.");
			} else
				echo json_encode_safe(array('error' => 'Ошибка удаления элемента! Возможно присутствуют активные переходы.'));
		}
	} elseif (isset($_POST['itemid'])) {
		//getting props
		$itemid = $_POST['itemid'];
		$json = getItemPropsJSON($itemid);
		//$logger->log("getItemPropsJSON($itemid):\n".print_r($json, true));
		if ($json)
			echo $json;
		else
			echo json_encode_safe(array('error' => 'Ошибка при получении информации об элементе!'));
	} else {
		echo json_encode_safe(array('error' => 'Неизвестная команда!'));
	}
} else {
	echo json_encode_safe($jsonresErr);
}
?>
