<?php
require_once(dirname(__FILE__).'/vo_htmls_plain.php');
require_once(dirname(__FILE__).'/vo_htmls.php');
require_once(dirname(__FILE__).'/include/session.php');

global $session, $database, $logger;
if (!$session->db_ok) {
	print(GetClosedPageContent());
	die();
}

$preheadcode = <<<EOS
<script language="JavaScript" type="text/JavaScript" src="js/tabs.js"></script>
EOS;

$addheadcode = <<<EOS
<link rel="stylesheet" type="text/css" href="styles/tabs.css" media="screen">
EOS;

// current page properties
$current_page_name = basename($_SERVER['PHP_SELF']); 
foreach($session->userright as $key => $row) {
	if($row['action']==$current_page_name and $row['act_visible']==0){ $current_page_title = $row['act_name']; }
} 
$pagetitle = $current_page_title;
//$pagetitle = "Настройки :: Черный и белый списки";

print(GetHTMLHeader($pagetitle, null, $addheadcode, $preheadcode));
print(GetPageTop());
?>

<div class="pagemain">

<div class="pageheader">
<table class="pageheader">
<tr>
	<td class="headleft">&nbsp;</td>
	<td class="headnav"><?php print(GetVOHeadMenu()); ?></td>
</tr>
</table>
</div>

<table class="pagecontent">
<tr>
<td class="menu"><?php print(GetVOMenu()); ?></td>
<td class="content">

<?php
//if ($session->logged_in) {
if ($session->logged_in && $session->checkUserRight($current_page_name,'A')) {
	// access level control
	if(isset($session->only_read_message)) {
		echo "<script type='text/javascript' language='javascript'> alert('".$session->only_read_message."'); </script>";
		unset($session->only_read_message);
	}
	print(GetPageContentTitle($pagetitle));
	?>
	<div class="textquoteinfo" style="width:650px;padding:10px;margin:10px 10px 10px 0;" align="left">
		<img src="images/icon_info_big.gif" width="32" height="32" style="margin: -2px 10px -8px 0; padding-bottom:1px;" align="left">
		<span class="sm" style="color: #666;display:block;">
			На этой странице настраиваются черный и белый списки абонентов офиса.
			Абоненты включенные в черный список не смогут дозвониться до номеров офиса.
			Если включен белый список, то никто кроме абонентов из этого списка не сможет дозвониться до номеров офиса.
			<br>
			Точное совпадение: для включения в список всех абонентов с номерами начинающимися на 8495, достаточно задать номер 8495 и снять флаг точного совпадения.
		</span>
	</div>
	<?php
	$q = "select * from of_get_numbersbw($session->ofid)";
	$result = $database->query($q);
	if (PEAR::isError($result)) {
		$logger->log($session->url.":". getPEARErrorInfo($result));
	} else {
		$ofparams = $database->getOfficeParams($session->ofid);
	?>
		<form name="frmmain" action="process.php" method="post" onSubmit="return disableForm(this);">
		<input type="hidden" name="sub_edit_numbers_bw" value="1">
		<input type="hidden" name="hidChangedNumberIDHolder" id="hidChangedNumberIDHolder" value="">

		<div class="tabs" id="tabs-bwlist" style="width:340px;">
			<div class="tab-content">
				<h1 class="tab" title="Черный">Черный</h1>
				<input type="checkbox"
					id="<?php echo PARAM_BLACKLIST_ENABLED ?>" name="<?php echo PARAM_BLACKLIST_ENABLED ?>"
					onkeypress="return bwnumberShowSaveControls()"
					onkeyup="return bwnumberShowSaveControls()"
					value="1"
					<?php echo (isset($ofparams[PARAM_BLACKLIST_ENABLED]) && $ofparams[PARAM_BLACKLIST_ENABLED]['pvalue'] > 0) ? 'checked' : '' ?>
					<?php echo $session->isAnyAdmin() ? '' : 'disabled' ?>
				>
				<a class="imglinkb" onclick="ToggleCheckBox('<?php echo PARAM_BLACKLIST_ENABLED ?>')" title="">
					Список активен
				</a>
				<div class="spacer"></div>
				<table class="nb" style="border-bottom:1px solid #ccc;" id="tb_numbers_black" cellspacing="0">
				<tr>
				<td width="180px" class="infoTableHeader">Телефонный номер</td>
				<td width="120px" class="infoTableHeader">Точное совпадение?</td>
				<td width="16px" class="infoTableHeader">&nbsp;</td>
				</tr>
				</table>
				<table class="nbpad" id="emptytablenotice_black" style="display:none"><tr><td class="iconinfo">&nbsp;</td><td class="note">Нет записей.</td></tr></table>
				<a class="imglinkbsm" onclick="bwnumberCreate('black')" title="Добавить номер">
					<img class="imglink" style="vertical-align:middle" src="images/icon_add.gif" width="14" height="13" alt="Добавить номер">
					&nbsp;Добавить номер</a><br><br>
			</div>
			<div class="tab-content">
				<h1 class="tab" title="Белый">Белый</h1>
				<input type="checkbox"
					id="<?php echo PARAM_WHITELIST_ENABLED ?>" name="<?php echo PARAM_WHITELIST_ENABLED ?>"
					onkeypress="return bwnumberShowSaveControls()"
					onkeyup="return bwnumberShowSaveControls()"
					value="1"
					<?php echo (isset($ofparams[PARAM_WHITELIST_ENABLED]) && $ofparams[PARAM_WHITELIST_ENABLED]['pvalue'] > 0) ? 'checked' : '' ?>
					<?php echo $session->isAnyAdmin() ? '' : 'disabled' ?>
				>
				<a class="imglinkb" onclick="ToggleCheckBox('<?php echo PARAM_WHITELIST_ENABLED ?>')" title="">
					Список активен
				</a>
				<div class="spacer"></div>
				<table class="nb" style="border-bottom:1px solid #ccc;" id="tb_numbers_white" cellspacing="0">
				<tr>
				<td width="180px" class="infoTableHeader">Телефонный номер</td>
				<td width="120px" class="infoTableHeader">Точное совпадение?</td>
				<td width="16px" class="infoTableHeader">&nbsp;</td>
				</tr>
				</table>
				<table class="nbpad" id="emptytablenotice_white" style="display:none"><tr><td class="iconinfo">&nbsp;</td><td class="note">Нет записей.</td></tr></table>
				<a class="imglinkbsm" onclick="bwnumberCreate('white')" title="Добавить номер">
					<img class="imglink" style="vertical-align:middle" src="images/icon_add.gif" width="14" height="13" alt="Добавить номер">
					&nbsp;Добавить номер</a><br><br>
			</div>
		</div>

		<input type="hidden" name="last_bwnumber_id" id="last_bwnumber_id" value="0">
		<input class="inputbt" type="submit" id="btsubmit_main" name="btsubmit_main" value="Сохранить изменения">
		</form>
		<script type="text/javascript">
		<!--
			BuildTabs('tabs-bwlist');
			ActivateTab('tabs-bwlist', getCookie('tabs-bwlist' + '_activetab', '0'));
		//-->
		</script>
		<?php
		$rec_num = array('black' => 0, 'white' => 0);
		$gen_bwnumber_id = 0;
		$script = "";
		while (($row = $result->fetchRow())) {
			$gen_bwnumber_id++;
			$script .= sprintf("bwnumberCreate('%s', %d, \"%s\", %d);",
								$row['listname'],
								$gen_bwnumber_id,
								addslashes(htmlspecialchars($row['caller_id'])),
								intval($row['exactmatch'])
								);
			$rec_num[$row['listname']]++;
		}
		$script .= "var gen_bwnumber_id=$gen_bwnumber_id;";
		if ($rec_num['black'] == 0)
			$script .= "var obj=document.getElementById('emptytablenotice_black'); if (obj) obj.style.display='block';";
		if ($rec_num['white'] == 0)
			$script .= "var obj=document.getElementById('emptytablenotice_white'); if (obj) obj.style.display='block';";
		$script .= "var obj=document.getElementById('last_bwnumber_id'); if (obj) obj.value=$gen_bwnumber_id;";
		echo GetJavaScriptCodeBlock($script);
	}
	unset($session->edit_numbers_bw);
} else {
	print(GetPageContentTitle("Вход в систему"));
	print(GetVOLoginForm());
}
?>

</td> <!-- content -->
</tr>
</table> <!-- pagecontent -->
</div> <!-- pagemain -->

<div class="pagefooter">
<table class="pagefooter">
<tr><td class="footleft">&nbsp;</td><td class="footnav">&nbsp;</td></tr>
<tr><td colspan="2" class="footcopyright">&nbsp;<?php echo SITE_COPYRIGHT ?></td></tr>
</table>
</div>
<?php
print(GetHTMLFooter());
?>
