<?php
/**
 * numbers_ext.php
 */
require_once(dirname(__FILE__).'/vo_htmls_plain.php');
require_once(dirname(__FILE__).'/vo_htmls.php');
require_once(dirname(__FILE__).'/include/session.php');

global $session, $database, $logger;
if (!$session->db_ok) {
	print(GetClosedPageContent());
	die();
}

// current page properties
$current_page_name = basename($_SERVER['PHP_SELF']); 
foreach($session->userright as $key => $row) {
	if($row['action']==$current_page_name and $row['act_visible']==0){ $current_page_title = $row['act_name']; }
} 
$pagetitle = $current_page_title;
//$pagetitle = "Настройки :: Внешние номера";

print(GetHTMLHeader($pagetitle));
print(GetPageTop());
?>

<div class="pagemain">

<div class="pageheader">
<table class="pageheader">
<tr>
	<td class="headleft">&nbsp;</td>
	<td class="headnav"><?php print(GetVOHeadMenu()); ?></td>
</tr>
</table>
</div>

<table class="pagecontent">
<tr>
<td class="menu"><?php print(GetVOMenu()); ?></td>
<td class="content">

<?php
//if ($session->logged_in) {
if ($session->logged_in && $session->checkUserRight($current_page_name,'A')) {
	// access level control
	if(isset($session->only_read_message)) {
		echo "<script type='text/javascript' language='javascript'> alert('".$session->only_read_message."'); </script>";
		unset($session->only_read_message);
	}
	print(GetPageContentTitle($pagetitle));
	?>
	<div class="textquoteinfo" style="width:650px;padding:10px;margin:10px 10px 10px 0;" align="left">
		<img src="images/icon_info_big.gif" width="32px" height="32px" style="margin: -2px 10px -8px 0; padding-bottom:1px;" align="left">
		<span class="sm" style="color: #666;display:block;">
			На этой странице настраиваются внешние номера офиса на которые будут выходить абоненты офиса набирая предлагаемые им <a class="smb" href="numbers_int.php">внутренние номера</a>.
		</span>
	</div>
	<?php
	$q = "SELECT * from OF_GET_NUMBERS($session->ofid)";
	$result = $database->query($q);
	if (PEAR::isError($result)) {
		$logger->log($session->url.":". getPEARErrorInfo($result));
	} else {
		$rec_num = 0;
		$gen_number_id = 0;
		$script = "";

		//echo GetJavaScriptCodeBlock($database->getIntNumbersList_htmlcode_ex($arr_int_numbers));

		echo "<form name=\"frmmain\" action=\"process.php\" method=\"post\" onSubmit=\"return disableForm(this);\">";
		echo "<input type=\"hidden\" name=\"sub_edit_numbers_ext\" value=\"1\">";
		echo "<input type=\"hidden\" name=\"hidChangedNumberIDHolder\" id=\"hidChangedNumberIDHolder\" value=\"\">";

		echo "<table class=\"nb\" style=\"border-bottom:1px solid #ccc;\" id=\"tb_numbers\" cellspacing=\"0\">";

		echo "<tr>";
		echo "<td width=\"180px\" class=\"infoTableHeader\">Внешний телефонный номер</td>";
		echo "<td width=\"436px\" class=\"infoTableHeader\">Описание номера</td>";
		echo "<td width=\"16px\" class=\"infoTableHeader\">&nbsp;</td>";
		echo "</tr>";

		while (($row = $result->fetchRow())) {
			$main_id = $row['number_id'];
			$gen_number_id = max($gen_number_id, $main_id);
			$script .= sprintf("extnumberCreate(%d, \"%s\", \"%s\");",
								$main_id,
								addslashes(htmlspecialchars($row['external_number'])),
								addslashes(htmlspecialchars($row['about']))
								);
			$rec_num++;
		}

		echo GetJavaScriptCodeBlock("gen_number_id = $gen_number_id");
		echo GetJavaScriptCodeBlock($script);

		echo "</table>";

		if ($rec_num == 0) {
			echo "<table class=\"nbpad\" id=\"emptytablenotice\"><tr><td class=\"iconinfo\">&nbsp;</td><td class=\"note\">Нет записей.</td></tr></table>";
		}

		echo "<a class=\"imglinkbsm\" onclick=\"extnumberCreate()\" title=\"Добавить внешний номер\">" .
			"<img class=\"imglink\" style=\"vertical-align:middle\" src=\"images/icon_add.gif\" width=\"14px\" height=\"13px\" alt=\"Добавить внешний номер\">" .
			"&nbsp;Добавить внешний номер</a><br><br>";

		echo "<input type=\"hidden\" name=\"last_number_id\" value=\"$gen_number_id\">";
		echo "<input class=\"inputbt\" type=\"submit\" id=\"btsubmit_main\" name=\"btsubmit_main\" value=\"Сохранить изменения\">";
		echo "</form>";
	}

	unset($session->edit_numbers_ext);
} else {
	print(GetPageContentTitle("Вход в систему"));
	print(GetVOLoginForm());
}
?>

</td> <!-- content -->
</tr>
</table> <!-- pagecontent -->
</div> <!-- pagemain -->

<div class="pagefooter">
<table class="pagefooter">
<tr><td class="footleft">&nbsp;</td><td class="footnav">&nbsp;</td></tr>
<tr><td colspan="2" class="footcopyright">&nbsp;<?php echo SITE_COPYRIGHT ?></td></tr>
</table>
</div>
<?php
print(GetHTMLFooter());
?>
