<?php
require_once(dirname(__FILE__).'/vo_htmls_plain.php');
require_once(dirname(__FILE__).'/vo_htmls.php');
require_once(dirname(__FILE__).'/include/session.php');

global $session, $database, $logger;
if (!$session->db_ok) {
	print(GetClosedPageContent());
	die();
}

// current page properties
$current_page_name = basename($_SERVER['PHP_SELF']); 
foreach($session->userright as $key => $row) {
	if($row['action']==$current_page_name and $row['act_visible']==0){ $current_page_title = $row['act_name']; }
} 
$pagetitle = $current_page_title;
//$pagetitle = "Настройки :: Внутренние номера";

print(GetHTMLHeader($pagetitle));
print(GetPageTop());
?>

<div class="pagemain">

<div class="pageheader">
<table class="pageheader">
<tr>
	<td class="headleft">&nbsp;</td>
	<td class="headnav"><?php print(GetVOHeadMenu()); ?></td>
</tr>
</table>
</div>

<table class="pagecontent">
<tr>
<td class="menu"><?php print(GetVOMenu()); ?></td>
<td class="content">

<?php
//if ($session->logged_in) {
if ($session->logged_in && $session->checkUserRight($current_page_name,'A')) {
	// access level control
	if(isset($session->only_read_message)) {
		echo "<script type='text/javascript' language='javascript'> alert('".$session->only_read_message."'); </script>";
		unset($session->only_read_message);
	}
	print(GetPageContentTitle($pagetitle));
	?>
	<div class="textquoteinfo" style="width:650px;padding:10px;margin:10px 10px 10px 0;" align="left">
		<img src="images/icon_info_big.gif" width="32px" height="32px" style="margin: 6px 10px -8px 0; padding-bottom:30px;" align="left">
		<span class="sm" style="color: #666;display:block;">
			На этой странице создаются внутренние номера, которые должны предлагаться для набора до абонентов офиса.
			Входящий вызов на какой-либо из этих номеров будет автоматически переведен на один или несколько <a class="smb" href="numbers_ext.php">внешних номеров</a>, в соответствии с выбранным <a class="smb" href="dials.php">списком дозвона</a>.
			Внутренние номера могут быть любыми, главное чтобы не было совпадения начальных цифр номера с цифрами переходов в сценарии работы офиса.
		</span>
	</div>
	<?php
	$arr_diallists = $database->getDialListsByOfficeID($session->ofid);
	if (!empty($arr_diallists)) {
		$q = "select * from OF_GET_INT_NUMBERS($session->ofid)";
		$result = $database->query($q);
		if (PEAR::isError($result)) {
			$logger->log($session->url.":". getPEARErrorInfo($result));
		} else {
			$rec_num = 0;
			$gen_number_id = 0;
			//$gen_department_id = 0;
			$script = "";

			echo GetJavaScriptCodeBlock($database->getDialLists_htmlcode_ex($arr_diallists));

			echo "<form name=\"frmmain\" action='process.php' method=\"post\" onSubmit=\"return disableForm(this);\">";
			echo "<input type=\"hidden\" name=\"sub_edit_numbers_int\" value=\"1\">";
			echo "<input type=\"hidden\" name=\"hidChangedNumberIDHolder\" id=\"hidChangedNumberIDHolder\" value=\"\">";

			echo "<table class=\"nb\" style=\"border-bottom:1px solid #ccc;\" id=\"tb_int_numbers\" cellspacing=\"0\">";

			echo "<tr>";
			echo "<td width=\"120px\" class=\"infoTableHeader\">Внутренний номер</td>";
			echo "<td width=\"270px\" class=\"infoTableHeader\">Список дозвона на внешние номера</td>";
			echo "<td width=\"220px\" class=\"infoTableHeader\">Описание номера</td>";
			echo "<td width=\"16px\" class=\"infoTableHeader\">&nbsp;</td>";
			echo "</tr>";

			while (($row = $result->fetchRow())) {
				/*if ($rec_num == 0 && !$session->isAnyAdmin()) {
					$rec_num++;
					continue;  //hide first number from non-admin users
				}*/
				$main_id = $row['internal_number_id'];
				$gen_number_id = max($gen_number_id, $main_id);

				$script .= sprintf("intnumberCreate(%d, \"%s\", %d, %d, \"%s\");",
									$main_id + ((OPTION_DISABLE_FIRST_INT_NUMBER_4_OWNER && /*$session->ofnumber == DB_OFFICE_DEBUG_NUMBER &&*/ $rec_num == 0 && !$session->isAnyAdmin()) ? rand(10000, 20000) : 0),
									addslashes(htmlspecialchars($row['internal_number'])),
									$row['dials'],
									$row['ignore_graph'],
									addslashes(htmlspecialchars($row['about'])));

				$rec_num++;
			}

			echo GetJavaScriptCodeBlock("gen_number_id = $gen_number_id;");
			echo GetJavaScriptCodeBlock($script);

			if (OPTION_DISABLE_FIRST_INT_NUMBER_4_OWNER && !$session->isAnyAdmin()/* && $session->ofnumber == DB_OFFICE_DEBUG_NUMBER*/) {
				//disable first number from non-admin users
				$dummy = <<<EOS
$(function(){/*you do not see this text*/
var r=$('#tb_int_numbers tbody tr').eq(1);
$(r).find('input').prop('disabled', true);
$(r).find('select').prop('disabled', true);
$(r).find('.imglink').remove();});
EOS;
				echo GetJavaScriptCodeBlock($dummy);
			}

			echo "</table>";

			if ($rec_num == 0) {
				echo "<table class=\"nbpad\" id=\"emptytablenotice\"><tr><td class=\"iconinfo\">&nbsp;</td><td class=\"note\">Нет записей.</td></tr></table>";
			}

			echo "<a class=\"imglinkbsm\" onclick=\"intnumberCreate(-1)\" title=\"Добавить внутренний номер\">" .
				"<img class=\"imglink\" style=\"vertical-align:middle\" src=\"images/icon_add.gif\" width=\"14\" height=\"13\" alt=\"Добавить внутренний номер\">" .
				"&nbsp;Добавить внутренний номер</a><br><br>";

			echo "<input type=\"hidden\" name=\"last_number_id\" value=\"$gen_number_id\">";
			echo "<input class=\"inputbt\" type=\"submit\" id=\"btsubmit_main\" name=\"btsubmit_main\" value=\"Сохранить изменения\">";
			echo "</form>";
		}
	} else {
		//echo "<table class=\"nbpad\"><tr><td class=\"iconerror\">&nbsp;</td><td class=\"note\">Не настроены <a href=\"numbers_int.php\">Внутренние номера</a>!</td></tr></table>";
		?>
		<div class="textquote" style="width:400px;padding:10px;margin:10px;" align="left">
			<span class="sm" style="color: #666;"><img src="images/icon_error_big.gif" width="32" height="32" style="margin: -10px 10px -8px 0;" align="left">Не настроены <a class="smb" href="dials.php">Списки дозвона</a>!</span>
		</div>
		<?php
	}

	/*if (isset($session->edit_numbers_int) && $session->edit_numbers_int) {
		print("<font color=\"#00ff00\"><b>Изменения сохранены (кажись)</b></font><br>");
	}*/
	unset($session->edit_numbers_int);
} else {
	print(GetPageContentTitle("Вход в систему"));
	print(GetVOLoginForm());
}
?>

</td> <!-- content -->
</tr>
</table> <!-- pagecontent -->
</div> <!-- pagemain -->

<div class="pagefooter">
<table class="pagefooter">
<tr><td class="footleft">&nbsp;</td><td class="footnav">&nbsp;</td></tr>
<tr><td colspan="2" class="footcopyright">&nbsp;<?php echo SITE_COPYRIGHT ?></td></tr>
</table>
</div>
<?php
print(GetHTMLFooter());
?>
