<?php
require_once(dirname(__FILE__).'/vo_htmls_plain.php');
require_once(dirname(__FILE__).'/vo_htmls.php');
require_once(dirname(__FILE__).'/include/session.php');
require_once(dirname(__FILE__).'/include/database_tar.php');

global $session, $database, $logger;
if (!$session->db_ok) {
	print(GetClosedPageContent());
	die();
}

// current page properties
$current_page_name = basename($_SERVER['PHP_SELF']); 
foreach($session->userright as $key => $row) {
	if($row['action']==$current_page_name and $row['act_visible']==0){ $current_page_title = $row['act_name']; }
} 
$pagetitle = $current_page_title;
//$pagetitle = "Настройки :: Группы дней";

$calendarfiles = <<<EOS
<script type="text/javascript" src="js/jquery/jquery.datepick.pack.js" charset="UTF-8"></script>
<script type="text/javascript" src="js/jquery/jquery.datepick.ext.pack.js" charset="UTF-8"></script>
<script type="text/javascript" src="js/jquery/jquery.datepick-ru.js" charset="UTF-8"></script>
<link href="styles/jquery/jquery.datepick.css" rel="stylesheet" type="text/css" media="screen"/>
<link href="styles/jquery/themes/flick/jquery-ui-1.8.12.custom.css" rel="stylesheet" type="text/css" media="screen"/>
<link href="styles/jquery/ui-flick.datepick.css" rel="stylesheet" type="text/css" media="screen"/>
EOS;

print(GetHTMLHeader($pagetitle, null, $calendarfiles));
print(GetPageTop());
?>

<div class="pagemain">

<div class="pageheader">
<table class="pageheader">
<tr>
	<td class="headleft">&nbsp;</td>
	<td class="headnav"><?php print(GetVOHeadMenu()); ?></td>
</tr>
</table>
</div>

<table class="pagecontent">
<tr>
<td class="menu"><?php print(GetVOMenu()); ?></td>
<td class="content">

<div class="hidden">
	<img id="calendar_picker" src="images/calendar.gif" alt="" title="Выбрать дату" class="imglink trigger">
</div>

<?php
//echo var_dump($session->userright);

if ($session->logged_in && $session->checkUserRight($current_page_name,'A')) {
	// access level control
	if(isset($session->only_read_message)) {
		echo "<script type='text/javascript' language='javascript'> alert('".$session->only_read_message."'); </script>";
		unset($session->only_read_message);
	}

	print(GetPageContentTitle($pagetitle));
?>
	
	
	<div class="textquoteinfo" style="width:650px;padding:10px;margin:10px 10px 10px 0;" align="left">
		<img src="images/icon_info_big.gif" width="32" height="32" style="margin: 6px 10px -8px 0; padding-bottom:1px;" align="left" alt="">
		<span class="sm" style="color: #666;display:block;">
			На этой странице настраиваются группы дней с учетом дней недели, например рабочие и выходные дни.
			В каждой группе существует возможность задать праздничные дни или иные особые даты.
			Группы дней участвуют в построении <a class="smb" href="pbx_graphs.php">временн<b>ы</b>х графиков</a>.
		</span>
	</div>
	<?php
	
	$q = "select daygroupid, daygroupname from tbdaygroups";
	$arr_daygroups = $database_tar->getQueryResultAsArray($q);
	
	$q = "select daygroupid,hollydate,hollydayname from tbhollydays order by daygroupid,hollydate";
	$result = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($result)) {
			$logger->log('DAYGROUPS ERROR: '. getPEARErrorInfo($result));
		} else {
			$rec_num = 0;
			$gen_daygroup_id = 0;
			$gen_id = 0;
			$script = "";
	?>
			<form name="frmmain" action="process.php" method="post" onSubmit="return disableForm(this);">
			<input type="hidden" name="pbx_sub_edit_daygroups" value="1">
			<input type="hidden" name="hidChangedIDHolder" id="hidChangedIDHolder" value="">
			<input type="hidden" name="hidChangedIDHolderEx" id="hidChangedIDHolderEx" value="">
			<a id="btCreateTop" class="imglinkb" style="display:none;" onclick="pbx_daygroupsCreateDayGroup()" title="Добавить группу дней">
				<img class="imglink" style="vertical-align:middle" src="images/icon_add.gif" width="14" height="13" alt="Добавить группу дней">
				&nbsp;Добавить группу дней</a>
			<div class="spacer"></div><div class="spacer"></div>
	<?php
			foreach ($arr_daygroups as $row) {
				$gen_daygroup_id = max($gen_daygroup_id, $row['daygroupid']);
				$script .= sprintf("pbx_daygroupsCreateDayGroup(%d, \"%s\");",
									$row['daygroupid'],
									addslashes(htmlspecialchars($row['daygroupname'])));
			}

			foreach ($arr_daygroups as $row) {
				$gdid = $row['daygroupid'];
				$q = "select * from int_get_weekdaysmask($gdid)";
				$wd = $database_tar->getQueryResultAsArray($q);
				//echo $wd[0]['weekdays_mask'].'<br>';
				for ($day_id = 0; $day_id <= 6; $day_id++) {
					if ($wd[0]['weekdays_mask'] & pow(2, $day_id))
						$script .= sprintf("pbx_daygroupsCheckWeekDay(%d, %d);",
											$row['daygroupid'],
											$day_id);
				}
			}

			/*
			//$script .= print_r($result, true);
			while (($row = $result->fetchRow())) {
				$tstmp = strtotime($row['hollydate']);
				$script .= sprintf("pbx_daygroupsCreate(%d, %d, \"%s\", \"%s\");",
									++$gen_id,
									$row['daygroupid'],
									date('d.m.Y', $tstmp),  //$row['hollyday'],
									addslashes(htmlspecialchars($row['hollydayname'])));
				$rec_num++;
				//$script .= print_r($row, true);
			}*/

//			if ($rec_num == 0) {
//				echo "<table class=\"nbpad\" id=\"emptytablenotice\"><tr><td class=\"iconinfo\">&nbsp;</td><td class=\"note\">Нет записей.</td></tr></table>";
//			}
	?>
			<input type="hidden" name="last_db_daygroup_id" value="<?php echo $gen_daygroup_id; ?>">
			<input type="hidden" name="last_daygroup_id" id="last_daygroup_id" value="<?php echo $gen_daygroup_id; ?>">
			<input type="hidden" name="last_id" id="last_id" value="<?php echo $gen_id ?>">
			<a class="imglinkb" onclick="pbx_daygroupsCreateDayGroup()" title="Добавить группу дней">
				<img class="imglink" style="vertical-align:middle" src="images/icon_add.gif" width="14" height="13" alt="Добавить группу дней">
				&nbsp;Добавить группу дней</a>
			<div class="spacer"></div><div class="spacer"></div>
			<input class="inputbt" type="submit" id="btsubmit_main" name="btsubmit_main" value="Сохранить изменения">
			</form>
	<?php
			$script = "gen_daygroup_id=$gen_daygroup_id;gen_id=$gen_id;$script";
			echo GetJavaScriptCodeBlock($script);
		}
	
	
	/*if (isset($session->edit_daygroups) && $session->edit_daygroups) {
		print("<font color=\"#00ff00\"><b>Изменения сохранены (кажись)</b></font><br>");
	}*/
	unset($session->edit_daygroups);
} else {
	print(GetPageContentTitle("Вход в систему"));
	print(GetVOLoginForm());
}
?>

</td> <!-- content -->
</tr>
</table> <!-- pagecontent -->
</div> <!-- pagemain -->

<div class="pagefooter">
<table class="pagefooter">
<tr><td class="footleft">&nbsp;</td><td class="footnav">&nbsp;</td></tr>
<tr><td colspan="2" class="footcopyright">&nbsp;<?php echo SITE_COPYRIGHT ?></td></tr>
</table>
</div>
<?php
print(GetHTMLFooter());
?>
