<?php
require_once(dirname(__FILE__).'/vo_htmls_plain.php');
require_once(dirname(__FILE__).'/vo_htmls.php');
require_once(dirname(__FILE__).'/include/session.php');
require_once(dirname(__FILE__).'/include/database.php');
require_once(dirname(__FILE__).'/include/database_dynmenu.php');
require_once(dirname(__FILE__).'/include/database_tar.php');

global $session, $database, $database_tar, $database_dynmenu, $form, $logger;
if (!$session->db_ok) {
	print(GetClosedPageContent());
	die();
}

// current page properties
$current_page_name = basename($_SERVER['PHP_SELF']); 
foreach($session->userright as $key => $row) {
	if($row['action']==$current_page_name and $row['act_visible']==0){ $current_page_title = $row['act_name']; }
} 
$pagetitle = $current_page_title;

$preheadcode = <<<EOS
<script language="JavaScript" type="text/JavaScript" src="js/pbx_department.js"></script>
<link rel="stylesheet" href="js/jquery11/jquery-ui.css">
<script src="js/jquery11/jquery-1.10.2.js"></script>
<script src="js/jquery11/jquery-ui.js"></script>
<link href="js/DataTables-1.10.3/media/css/jquery.dataTables.css" rel="stylesheet" type="text/css" media="screen"/>
<script type="text/javascript" src="js/DataTables-1.10.3/media/js/jquery.dataTables.js" charset="UTF-8"></script>
<script type="text/javascript">
$(document).ready(function() {});
</script>
EOS;

print(GetHTMLHeader($pagetitle, null, $preheadcode));
print(GetPageTop());
?>

<div class="pagemain">

<div class="pageheader">
<table class="pageheader">
<tr>
	<td class="headleft">&nbsp;</td>
	<td class="headnav"><?php print(GetVOHeadMenu()); ?></td>
</tr>
</table>
</div>

<table class="pagecontent">
<tr>
<td class="menu"><?php print(GetVOMenu()); ?></td>
<td class="content">

<?php
//if ($session->logged_in && $session->isAdmin()) {
if ($session->logged_in && $session->checkUserRight($current_page_name,'A')) {
	print(GetPageContentTitle($pagetitle));
	// access level control
	if(isset($session->only_read_message)) {
		echo "<script type='text/javascript' language='javascript'> alert('".$session->only_read_message."'); </script>";
		unset($session->only_read_message);
	}

	
	
		
	$userrolelist = $database->getUserRoleList();
	echo GetJavaScriptCodeBlock($database->getUserRoleList_htmlcode($userrolelist));
		
	$script = "";

	?>
	<form name="frmmain" id="frmmain" action="process.php" method="post" onSubmit="return disableForms();">
	<!-- input type="hidden" name="sub_edit_adminuser" id="sub_edit_adminuser" value="save">
	<input type="hidden" name="hidUserCounterHolder" id="hidUserCounterHolder" value=0 -->
	
	<div class="textquoteinfo" style="width:650px;padding:10px;margin:10px 10px 10px 0;" align="left">
		<img src="images/icon_info_big.gif" width="32" height="32" style="margin: 6px 10px -8px 0; padding-bottom:1px;" align="left" alt="">
		<span class="sm" style="color: #666;display:block;">
			Доступ пользователя IP-PBX к информации по сип-аккаунтам обеспечивается включением его в соответсвующую группу.
			Объединение сип-аккаунтов в группы произвольно. Например, оно может отражать структуру организации предприятия.
		</span>
	</div>

	
	<div style="width:100%">
	<!-- table style="width:100%;border-collapse:collapse;cell-spacing:0;cell-padding:0;" -->
	<table style="width:650px;border-collapse:collapse;cell-padding:0;">
	<tr>
	<td width="200px" style="vertical-align:top;"><ul id="ul_accessgroup" class="vlist"></ul></td>
	<td style="vertical-align:top;background:#d7e4ed;">
		<div style="100%;background:#d7e4ed;padding:0 20px 20px 20px;margin:0;">
		<table><tr>
		<td style="vertical-align:top;">
		<table id="tab_sip_accessgroup" class="display" width="100%" cellspacing="0">
			<thead>
				<tr>
					<td width="150px" style="enable:false">SIP-аккаунты группы</td>
					<td style="display:none;"></td>
				</tr>
			</thead>
		</table>
		<input id="btn_sip_accessgroup" type="button" class="sysbutton" value="Выбрать ..." onclick="frm_open_sip_dialog()">
		</td>
		<td style="vertical-align:top;padding-left:20px">
		<table id="tab_user_accessgroup" class="display" width="100%" cellspacing="0">
			<thead>
				<tr>
					<td width="160px">Пользователи группы</td>
					<td style="display:none;"></td>
				</tr>
			</thead>
		</table>
		<input id="btn_user_accessgroup" type="button" class="sysbutton" value="Выбрать ..." onclick="frm_open_user_dialog()">
		</td>
		</tr></table>
		</div>
	</td>
	</tr>
	</table>
	</div>
	
	<br>
	
	<div class="spacer"></div>

	</form>
	<?php
	
//	echo GetJavaScriptCodeBlock($script);

} else {
	print(GetPageContentTitle("Вход в систему"));
	print(GetVOLoginForm());
}
?>

	<?php
	if (strlen($form->error("admuser_table_error")) > 0) {
	?>
		<div class="enote sm" style="margin:10px 0 0 20px;"><?php echo $form->error("admuser_table_error"); ?></div>
	<?php
	}
	?>



</td> <!-- content -->
</tr>
</table> <!-- pagecontent -->
</div> <!-- pagemain -->



<div id="frm_accessgroup" title="Группа">
<table width="100%">
<tr>
<td width="80px"><div class="syslabel">Группа</div></td>
<td><div><input id="txt_accessgroup_name" type="text" class="systext"  style="width:100%" value=""></div></td>
</tr>
</table>
<input id="txt_accessgroup_id" type="hidden" value="">
</div>



<div id="frm_sip_accessgroup" title="Формирование списка">
<div style="width:100%;">
<table id="sip_list" class="display" width="100%" cellspacing="0">
        <thead>
            <tr>
                <td width="250px">SIP-аккаунты группы</td>
                <td><input type="checkbox" id="sip_allcheck_flag" onclick="if(this.checked) this.value=1; else this.value=0; doAll_SIP_AccountCheck(this.value);">&nbsp;</td>
                <td style="display:none;"></td>
            </tr>
        </thead>
</table>
</div>
</div>

<div id="frm_user_accessgroup" title="Формирование списка">
<div style="width:100%;">
<table id="user_list" class="display" width="100%" cellspacing="0">
        <thead>
            <tr>
                <td width="250px">Пользователи группы</td>
                <td><input type="checkbox" id="user_allcheck_flag" onclick="if(this.checked) this.value=1; else this.value=0; doAll_User_AccountCheck(this.value);">&nbsp;</td>
                <!-- td style="display:none;"></td -->
            </tr>
        </thead>
</table>
</div>
</div>




<div class="pagefooter">
<table class="pagefooter">
<tr><td class="footleft">&nbsp;</td><td class="footnav">&nbsp;</td></tr>
<tr><td colspan="2" class="footcopyright">&nbsp;<?php echo SITE_COPYRIGHT ?></td></tr>
</table>
</div>
<?php
print(GetHTMLFooter());
?>

