<?php
/**
 * graphs.php
 */
require_once(dirname(__FILE__).'/vo_htmls_plain.php');
require_once(dirname(__FILE__).'/vo_htmls.php');
require_once(dirname(__FILE__).'/include/session.php');

global $session, $database, $logger;
if (!$session->db_ok) {
	print(GetClosedPageContent());
	die();
}

// current page properties
$current_page_name = basename($_SERVER['PHP_SELF']); 
foreach($session->userright as $key => $row) {
	if($row['action']==$current_page_name and $row['act_visible']==0){ $current_page_title = $row['act_name']; }
} 
$pagetitle = $current_page_title;
//$pagetitle = "Настройки :: Временные графики";

print(GetHTMLHeader($pagetitle));
print(GetPageTop());
?>

<div class="pagemain">

<div class="pageheader">
<table class="pageheader">
<tr>
	<td class="headleft">&nbsp;</td>
	<td class="headnav"><?php print(GetVOHeadMenu()); ?></td>
</tr>
</table>
</div>

<table class="pagecontent">
<tr>
<td class="menu"><?php print(GetVOMenu()); ?></td>
<td class="content">

<?php
//if ($session->logged_in) {
if ($session->logged_in && $session->checkUserRight($current_page_name,'A')) {

//var_dump($current_page_name);
//var_dump('RO = '.$session->only_read_message);
	// access level control
	if(isset($session->only_read_message)) {
		echo "<script type='text/javascript' language='javascript'> alert('".$session->only_read_message."'); </script>";
		unset($session->only_read_message);
	}
	print(GetPageContentTitle($pagetitle));
	?>
	<div class="textquoteinfo" style="width:650px;padding:10px;margin:10px 10px 10px 0;" align="left">
		<img src="images/icon_info_big.gif" width="32" height="32" style="margin: 6px 10px -8px 0; padding-bottom:1px;" align="left">
		<span class="sm" style="color: #666;display:block;">
			На этой странице настраивается расписание активности маршрута.
			Одному маршруту может быть сопоставлен один временной график.
			Временной график определяется днями и интервалами времени.
		</span>
	</div>
	<?php
	$arr_graphlists = $database_tar->getGraphListsByOfficeID($session->ofid);
	$arr_daygroups = $database_tar->getDayGroupsByOfficeID($session->ofid);
	if (!empty($arr_daygroups)) {
		//$q = "SELECT * from OF_GET_GRAPHS($session->ofid, null)";
		$q = "SELECT * from OF_GET_GRAPHS(null)";
		$result = $database_tar->getQueryResultAsArray($q);
		//$result = $database_tar->query($q);
	
//		var_dump($result);
//		var_dump($arr_graphlists);
		
		if (PEAR::isError($result)) {
			//$logger->log($session->url.":". getPEARErrorInfo($result));
			$logger->log("$q :error=". getPEARErrorInfo($result));
		} else {
			$rec_num = 0;
			$gen_graph_id = 0;
			$gen_id = 0;
			$script = "";
			//var_dump($arr_daygroups);
			echo GetJavaScriptCodeBlock($database_tar->getDayGroups_htmlcode_ex($arr_daygroups));

			echo "<form name=\"frmmain\" action=\"process.php\" method=\"post\" onSubmit=\"return disableForm(this);\">\n";
			echo "<input type=\"hidden\" name=\"pbx_sub_edit_graphs\" value=\"1\">\n";
			echo "<input type=\"hidden\" name=\"hidChangedIDHolder\" id=\"hidChangedIDHolder\" value=\"\">\n";
			echo "<input type=\"hidden\" name=\"hidChangedIDHolderEx\" id=\"hidChangedIDHolderEx\" value=\"\">\n";

			echo "<a class=\"imglinkb\" onclick=\"pbx_graphsCreateGraphList()\" title=\"Добавить график\">" .
				"<img class=\"imglink\" style=\"vertical-align:middle\" src=\"images/icon_add.gif\" width=\"14px\" height=\"13px\" alt=\"Добавить график\">" .
				"&nbsp;Добавить график</a><br><br>\n";

			foreach ($arr_graphlists as $row) {
				$gen_graph_id = max($gen_graph_id, $row['graphid']);
				$script .= sprintf("pbx_graphsCreateGraphList(%d, \"%s\");\n",
									$row['graphid'],
									addslashes(htmlspecialchars($row['graphname'])));
			}

			foreach ($result as $row) {
				//var_dump($row);
				$script .= sprintf("pbx_graphsCreate(%d, %d, %d, %d, %d);\n",
									++$gen_id,
									$row['graph_id'],
									$row['daygroup_id'],
									$row['start_time'],
									$row['end_time']);
				$rec_num++;
			}


			/*while (($row = $result->fetchRow())) {
				$script .= sprintf("pbx_graphsCreate(%d, %d, %d, %d, %d);\n",
									++$gen_id,
									$row['graph_id'],
									$row['daygroup_id'],
									$row['start_time'],
									$row['end_time']);
				$rec_num++;
			}*/

//			if ($rec_num == 0) {
//				echo "<table class=\"nbpad\" id=\"emptytablenotice\"><tr><td class=\"iconinfo\">&nbsp;</td><td class=\"note\">Нет записей.</td></tr></table>";
//			}

			echo "<input type=\"hidden\" name=\"last_db_graph_id\" value=\"$gen_graph_id\">\n";
			echo "<input type=\"hidden\" name=\"last_graph_id\" id=\"last_graph_id\" value=\"$gen_graph_id\">\n";
			echo "<input type=\"hidden\" name=\"last_id\" id=\"last_id\" value=\"$gen_id\">\n";

			echo "<a class=\"imglinkb\" onclick=\"graphsCreateGraphList()\" title=\"Добавить график\">" .
				"<img class=\"imglink\" style=\"vertical-align:middle\" src=\"images/icon_add.gif\" width=\"14px\" height=\"13px\" alt=\"Добавить график\">" .
				"&nbsp;Добавить график</a><br><br>\n";

			echo "<input class=\"inputbt\" type=\"submit\" name=\"btsubmit_main\" id=\"btsubmit_main\" value=\"Сохранить изменения\">";
			echo "</form>\n";

			echo GetJavaScriptCodeBlock("gen_graph_id = $gen_graph_id");
			echo GetJavaScriptCodeBlock("gen_id = $gen_id");
			echo GetJavaScriptCodeBlock($script);
		}
	} else {
		?>
		<div class="textquote" style="width:400px;padding:10px;margin:10px;" align="left">
			<span class="sm" style="color: #666;"><img src="images/icon_error_big.gif" width="32" height="32" style="margin: -10px 10px -8px 0;" align="left">Не настроены <a class="smb" href="daygroups.php">Группы дней</a>!</span>
		</div>
		<?php
	}

	/*if (isset($session->edit_graphs) && $session->edit_graphs) {
		print("<font color=\"#00ff00\"><b>Изменения сохранены (кажись)</b></font><br>");
	}*/
	unset($session->edit_graphs);
} else {
	print(GetPageContentTitle("Вход в систему"));
	print(GetVOLoginForm());
}
?>

<!-- input class="inputbt" type="submit" name="btsubmit_main" id="btsubmit_main" value="Test" onclick="alert(<?php echo $last_graph_id; ?>)">
<input class="inputbt" type="submit" name="btsubmit_main" id="btsubmit_main" value="Test" onclick="alert(gen_graph_id);">
<input class="inputbt" type="submit" name="btsubmit_main" id="btsubmit_main" value="Test" onclick="var obj_holder = document.getElementById('hidChangedIDHolderEx'); alert(obj_holder.value);" -->



</td> <!-- content -->
</tr>
</table> <!-- pagecontent -->
</div> <!-- pagemain -->

<div class="pagefooter">
<table class="pagefooter">
<tr><td class="footleft">&nbsp;</td><td class="footnav">&nbsp;</td></tr>
<tr><td colspan="2" class="footcopyright">&nbsp;<?php echo SITE_COPYRIGHT ?></td></tr>
</table>
</div>
<?php
print(GetHTMLFooter());
?>
