<?php
require_once(dirname(__FILE__).'/include/constants.php');
require_once(dirname(__FILE__).'/vo_htmls_plain.php');
require_once(dirname(__FILE__).'/vo_htmls.php');
require_once(dirname(__FILE__).'/include/session.php');
require_once(dirname(__FILE__).'/include/database_tar.php');
require_once(dirname(__FILE__).'/include/functions.php');

global $session, $database, $form, $database_tar;
if (!$session->db_ok) {
	print(GetClosedPageContent());
	die();
}

// current page properties
$current_page_name = basename($_SERVER['PHP_SELF']); 
foreach($session->userright as $key => $row) {
	if($row['action']==$current_page_name and $row['act_visible']==0){ $current_page_title = $row['act_name']; }
} 
$pagetitle = $current_page_title;


$addheadcode = <<<EOS

<link rel="stylesheet" href="js/jquery11/jquery-ui.css">
<script src="js/jquery11/jquery-1.10.2.js"></script>
<script src="js/jquery11/jquery-ui.js"></script>

<script type="text/javascript" src="js/pbx_router.js" charset="UTF-8"></script>

<link href="js/DataTables-1.10.3/media/css/jquery.dataTables.css" rel="stylesheet" type="text/css" media="screen"/>
<script type="text/javascript" src="js/DataTables-1.10.3/media/js/jquery.dataTables.js" charset="UTF-8"></script>

<script type="text/javascript" src="js/jquery/datepick/jquery.plugin.js"></script> 
<script type="text/javascript" src="js/jquery/datepick/jquery.datepick.js"></script>
<script type="text/javascript" src="js/jquery/datepick/jquery.datepick.ext.js" charset="UTF-8"></script>
<script type="text/javascript" src="js/jquery/datepick/jquery.datepick.lang.js"></script>
<script type="text/javascript" src="js/jquery/datepick/jquery.datepick-ru.js"></script>
<link rel="stylesheet" type="text/css" href="js/jquery/datepick/jquery.datepick.css"> 
<link rel="stylesheet" type="text/css" href="js/jquery/datepick/ui-flick.datepick.css"> 


EOS;

print(GetHTMLHeader($pagetitle, null, $addheadcode, $preheadcode));
print(GetPageTop());

?>


<div class="pagemain">

<div class="pageheader">
<table class="pageheader">
<tr>
	<td class="headleft">&nbsp;</td>
	<td class="headnav"><?php print(GetVOHeadMenu()); ?></td>
</tr>
</table>
</div>

<table class="pagecontent">
<tr>
<td class="menu"><?php print(GetVOMenu()); ?></td>
<td class="content">


<?php

//echo var_dump($session);
//echo var_dump($session->ofmainparams);
//echo $session->ofmainparams['of_number_prefix'].$session->ofnumber;
//echo var_dump($session->userright);
//var_dump($session->acc_name);


if ($session->logged_in && $session->checkUserRight($current_page_name,'A')) {
	// access level control
	if(isset($session->only_read_message)) {
		echo "<script type='text/javascript' language='javascript'> alert('".$session->only_read_message."'); </script>";
		unset($session->only_read_message);
	}
	print(GetPageContentTitle($pagetitle));

	
?>

	<!-- div class="textquoteinfo" align="left">
		<img class="textquoteinfo_icon" src="images/icon_info_big.gif" align="left" alt="">
		<span class="sm">
			Настройка таблиц маршрутизации.<br>&nbsp;
			
		</span>
	</div -->



<!------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------>

<div style="width:720px;margin-top:30px;padding:4px;border:solid 1px #ccc;border-radius:6px;">

<div style="width:100%;border-radius:6px;opacity: 0.7;">
<table style="width:100%;"><tr>
<td><span class="syslabel">Таблица маршрутизации</span></td>
<td style="text-align:right;">
<input id="btn_router_add" type="button" class="sysbutton" value="Добавить">
</td>
</tr></table>
</div>

<div style="width:100%;">
<table id="router_list" class="display" width="100%" cellspacing="0">
        <thead>
            <tr>
                <th>Название</th>
                <th nowrap width="60px">&nbsp;</th>
                <th style="display:none;">ID таблицы маршрутизации</th>
            </tr>
        </thead>
</table>
</div>

</div>


<div style="width:720px;margin-top:30px;padding:4px;border:solid 1px #ccc;border-radius:6px;">

<div style="width:100%;border-radius:6px;opacity: 0.7;">
<table style="width:100%;"><tr>
<td><span class="syslabel">Маршрут</span></td>
<td style="text-align:right;">
<input id="btn_path_add" type="button" class="sysbutton" value="Добавить">
</td>
</tr></table>
</div>

<div style="width:100%;">
<table id="path_list" class="display" width="100%" cellspacing="0">
        <thead>
            <tr>
                <td width="30px">&nbsp;</td>
                <td width="100px">Номер</td>
                <td width="80px">Трансляция номера</td>
                <td width="100px">АОН</td>
                <td width="80px">Трансляция АОН</td>
                <td width="50px">График</td>
                <td style="display:none;"></td>
                <td style="display:none;"></td>
                <td style="display:none;"></td>
                <td style="display:none;"></td>
                <td nowrap width="60px">&nbsp;</td>
            </tr>
        </thead>
</table>
</div>

</div>






<!------------------------------------------------------------------------------------------------------------------>
<div id="tableInfo"></div>	

<div id="frm_router" title="Таблица маршрутизации">
<table width="100%">
<tr>
<td width="80px"><div class="syslabel">Название таблицы</div></td>
<td><div><input id="txt_router_name" type="text" class="systext"  style="width:100%" value=""></div></td>
</tr>
</table>
<input id="txt_router_id" type="hidden" value="1">
</div>

<div id="frm_path" title="Маршрут">


<table width="100%">

<tr>
<td width="80px"><div class="syslabel">Шаблон номера</div></td>
<td><div><input id="txt_number" type="text" class="systext"  style="width:320px" value=""></div></td>
</tr>
<tr>
<td width="80px"><div class="syslabel">Трансляция номера</div></td>
<td><div><input id="txt_number_out" type="text" class="systext"  style="width:320px" value=""></div></td>
</tr>

<tr>
<td colspan=2 width="100%;">

<!-- тест номера -->
<fieldset id="numfield" class="sysfield_up">
<legend style="cursor:pointer" onclick="fieldset_slide(this)"><div class="sysfield_name">Тестирование номера >></div></legend>
<div id="numfield_inside">
<div class="syslabel_tiny" style="float:left;width=140px;height:80%;padding-top:19px;">
<span>Номер</span><br>
<input id="txt_test_number" type="text" class="systext_tiny"  style="width:130px" value="">
</div>
<div  class="syslabel_tiny" style="float:both;width=28px;height:80%;">
<input id="btn_number_test" type="button" class="sysbutton_tiny" value=">>" style="margin-top:28px;">
</div>

<div  class="syslabel_tiny" style="float:left;height:80%;">
<div style="clear:both;">
<span>Блоки номера по шаблону</span><br>
<input id="txt_test_number_block" type="text" class="systext_tiny"  style="width:260px" value="">
</div>
<div style="clear:both;">
<span>Преобразованный номер</span><br>
<input id="txt_test_number_out" type="text" class="systext_tiny"  style="width:260px" value="">
</div>
</div>
</div>
</fieldset>
<!-- end тест номера -->

</td>
</tr>


<tr>
<td width="80px"><div class="syslabel">Шаблон АОН</div></td>
<td><div><input id="txt_aon" type="text" class="systext"  style="width:320px" value=""></div></td>
</tr>
<tr>
<td width="80px"><div class="syslabel">Трансляция АОН</div></td>
<td><div><input id="txt_aon_out" type="text" class="systext"  style="width:320px" value=""></div></td>
</tr>

<tr>
<td colspan=2 width="100%;">

<!-- тест аон -->
<fieldset id="aonfield" class="sysfield_up">
<legend style="cursor:pointer" onclick="fieldset_slide(this)"><div class="sysfield_name">Тестирование АОН >></div></legend>
<div id="aonfield_inside">

<div class="syslabel_tiny" style="float:left;width=140px;height:80%;padding-top:19px;">
<span>АОН</span><br>
<input id="txt_test_aon" type="text" class="systext_tiny"  style="width:130px" value="">
</div>
<div  class="syslabel_tiny" style="float:both;width=28px;height:80%;">
<input id="btn_aon_test" type="button" class="sysbutton_tiny" value=">>" style="margin-top:28px;">
</div>

<div  class="syslabel_tiny" style="float:left;height:80%;">
<div style="clear:both;">
<span>Блоки АОН по шаблону</span><br>
<input id="txt_test_aon_block" type="text" class="systext_tiny"  style="width:260px" value="">
</div>
<div style="clear:both;">
<span>Преобразованный АОН</span><br>
<input id="txt_test_aon_out" type="text" class="systext_tiny"  style="width:260px" value="">
</div>
</div>

</div>
</fieldset>
<!-- end тест аон -->



</td>
</tr>

<tr>
<td width="80px"><div class="syslabel">График</div></td>
<td colspan="2"><div>
<select id="txt_graph" type="text" class="systext" style="width:100%" value="" onchange="get_template_param()">
</select>
</div></td>
</tr>

<tr>
<td colspan=2 width="100%;">

<!-- параметры маршрута -->
<fieldset id="paramfield" class="sysfield_up">
<legend style="cursor:pointer" onclick="fieldset_slide(this)"><div class="sysfield_name">Параметры маршрута >></div></legend>
<div id="paramfield_inside">

<table class="systable_mark">
<tr>
<td style="width:250px"><div class="syslabel_wrap">Метод обзвона</div></td>
<td><select id="select_dialmode" type="text" class="systext" style="width:150px;" value="1" onchange="get_template_param()">
<option value="1" selected>Последовательно</option>
<option value="2">Одновременно</option>
</select></td>
</tr>
<tr>
<td><div class="syslabel_wrap">Время ожидания ответа, сек</div></td>
<td><input id="txt_answer_pause" type="text" class="systext"  style="width:100px" value=""></td>
</tr>
<tr>
<td><div class="syslabel_wrap">Пауза перед очередной попыткой прозвонить список, сек</div></td>
<td><input id="txt_redial_pause" type="text" class="systext"  style="width:100px" value=""></td>
</tr>
<tr>
<td><div class="syslabel_wrap">Количество попыток прозвонить список</div></td>
<td><input id="txt_redial_count" type="text" class="systext"  style="width:100px" value=""></td>
</tr>
<tr>
<td><div class="syslabel_wrap">Запись разговора</div></td>
<td><input id="txt_recording" type="checkbox" value="1" checked></td>
</tr>

</table>

</div>
</fieldset>
<!-- end параметры маршрута -->

</td>
</tr>

<tr>
<td style="width:250px"><div class="syslabel_wrap">Тип соединения</div></td>
<td colspan="2"><div>
<select id="select_out_type" type="text" class="systext" style="width:100%" value="1" onchange="get_output_list(this)">
<option value="1" selected>SIP-аккаунт</option>
<option value="2">Сервис</option>
</select>
</div></td>
</tr>

<tr id="tr_menu_list">
<td style="width:250px"><div class="syslabel_wrap">Сервис</div></td>
<td colspan="2"><div>
<select id="select_menu_list" type="text" class="systext" style="width:100%" value="">
</select>
</div></td>
</tr>


</table>
<input id="txt_path_id" type="hidden" value="1">


<!-- div style="width:100%;"-->
<table id="peer_list" class="display" width="100%" cellspacing="0">
        <thead>
            <tr>
                <td width="250px">SIP-аккаунт</td>
                <!-- td>&nbsp;</td -->
                <td><input type="checkbox" id="allcheck_flag" onclick="if(this.checked) this.value=1; else this.value=0; doAllAccountCheck(this.value);">&nbsp;</td>
                <td style="display:none;"></td>
                <td style="display:none;"></td>
            </tr>
        </thead>
</table>
<!-- /div -->

</div>


<div id="frm_routerview" title="Параметры маршрута">
<table width="100%">
<tr>
<td width="100px" valign="top"><div class="syslabel" style="white-space:normal;">Доступные SIP-аккаунты</div></td>
<td><div id="sip_account_view"></div></td>
</tr>
</table>
</div>

<div id="frm_sipview" title="Параметры таблицы">
<table width="100%">
<tr>
<td width="100px" valign="top"><div class="syslabel" style="white-space:normal;">SIP-счета</div></td>
<td><div id="table_sip_view"></div></td>
</tr>
</table>
</div>



<!------------------------------------------------------------------------------------------------------------------>


<?php
} else {
	print(GetPageContentTitle("Вход в систему"));
	print(GetVOLoginForm());
}
?>

</td>  <!-- content -->

</tr>
</table> <!-- pagecontent -->
</div> <!-- pagemain -->






<!-- input id="txt_number_id" type="hidden" value="">
<input id="txt_numberperiod_id" type="hidden" value="">
</div -->























<div class="pagefooter">
<table class="pagefooter">
<tr><td class="footleft">&nbsp;</td><td class="footnav">&nbsp;</td></tr>
<tr><td colspan="2" class="footcopyright">&nbsp;<?php echo SITE_COPYRIGHT ?></td></tr>
</table>
</div>









<?php
print(GetHTMLFooter());
?>