<?php
/*
 * Created on 22.11.2010
 *
 */
require_once(dirname(__FILE__).'/include/session.php');
require_once(dirname(__FILE__).'/include/database.php');
require_once(dirname(__FILE__).'/include/database_tar.php');
require_once(dirname(__FILE__).'/include/functions.php');

global $session, $logger;

$jsonresErr = array('page' => 1);
$jsonresErr['total'] = 0;
$jsonresErr['rows'] = array();

function get_queue_list() {
	global $session, $database, $database_tar, $logger;

	$q = 'select * from tb_queue_fax where of_id=' . $session->ofid . ' order by addtime desc';
	$result = $database->getQueryResultAsArray($q);
	if (PEAR::isError($result)) {
		$logger->log("get_queue_list:ERR=". getPEARErrorInfo($result));
		return null;
	} else {
		if ($result) {
			$tasks_done = array();
			foreach ($result as &$queueitem) {
				$queueitem['taskparams'] = $database_tar->get_tm_task_props($queueitem['tm_task_id']);
				$queueitem['taskstats'] = $database_tar->get_tm_task_stats($queueitem['tm_task_id']);
				if ($queueitem['taskparams']['tm_task_status'] == TMS_STATUS_COMPLETE)
					$tasks_done[] = $queueitem['tm_task_id'];
			}

			function filter_blocked_tasks($item) {
				return ($item['taskparams']['tm_task_status'] !== TMS_STATUS_STOP_BLOCKING);
			}
			$result = array_filter($result, 'filter_blocked_tasks');

		    if (!empty($tasks_done)) {
			    $q = 'delete from tb_queue_fax where of_id=' . $session->ofid . ' and tm_task_id in ('.implode(',', $tasks_done).') and addtime+1 < \'Now\'';
			    //$logger->log("get_queue_list:DONETASKS=$q\n".print_r($tasks_done, true));
			    $database->query($q);
		    }
		}
		//$logger->log("get_queue_list:result=\n".print_r($result, true), PEAR_LOG_DEBUG);
		return $result;
	}
}

function del_queue_tasks($idlist) {
	global $session, $database, $database_tar, $logger;

	//$logger->log('del_queue_tasks().DATA='.print_r($idlist, true), PEAR_LOG_DEBUG);

	if (empty($idlist))
		return null;

	//clear queue
	$pq = 'delete from tb_queue_fax where of_id=' . $session->ofid . ' and tm_task_id = ?';
	$result = $database->connection->prepare($pq);
	if (PEAR::isError($result)) {
		$logger->log('del_queue_tasks(QUEUE).PREPARE.ERR='. getPEARErrorInfo($result), PEAR_LOG_ERR);
		return null;
	}
	$database->connection->extended->executeMultiple($result, array_chunk($idlist, 1));
	if (PEAR::isError($result)) {
		$logger->log('del_queue_tasks(QUEUE).EXEC.ERR='. getPEARErrorInfo($result), PEAR_LOG_ERR);
		return null;
	}
	$result->free();

	//set tasks status
	$pq = 'update tm_task_list set tm_task_status = ' . TMS_STATUS_STOP_BLOCKING . ' where tm_task_id = ?';
	$result = $database_tar->connection->prepare($pq);
	if (PEAR::isError($result)) {
		$logger->log('del_queue_tasks(TM).PREPARE.ERR='. getPEARErrorInfo($result), PEAR_LOG_ERR);
		return null;
	}
	$database_tar->connection->extended->executeMultiple($result, array_chunk($idlist, 1));
	if (PEAR::isError($result)) {
		$logger->log('del_queue_tasks(TM).EXEC.ERR='. getPEARErrorInfo($result), PEAR_LOG_ERR);
		return null;
	}
	$result->free();

	//delete file records in billing
	//foreach ($idlist as $id)
		//$database_tar->deleteMBMessage($id);

	return true;
}

function del_queue_tasks_all() {
	global $session, $database, $database_tar, $logger;

	//$logger->log('del_queue_tasks_all()', PEAR_LOG_DEBUG);

	//get queue
	$q = 'select tm_task_id from tb_queue_fax where of_id=' . $session->ofid;
	$idlist = $database->getQueryResultAsArray($q);
	if (PEAR::isError($idlist)) {
		$logger->log("del_queue_tasks_all(GETQUEUE).ERR=". getPEARErrorInfo($idlist));
		return null;
	} else {
		$idl = array();
		foreach ($idlist as $id)
			$idl[] = $id['tm_task_id'];
		$idlist = array_chunk($idl, 1);
		$logger->log("IDLIST=".print_r($idlist, true));

		if (is_array($idlist) && !empty($idlist)) {
			//set tasks status
			$pq = 'update tm_task_list set tm_task_status = ' . TMS_STATUS_STOP_BLOCKING . ' where tm_task_id = ?';
			$result = $database_tar->connection->prepare($pq);
			if (PEAR::isError($result)) {
				$logger->log('del_queue_tasks_all(TM).PREPARE.ERR='. getPEARErrorInfo($result), PEAR_LOG_ERR);
				return null;
			}
			$database_tar->connection->extended->executeMultiple($result, $idlist);
			if (PEAR::isError($result)) {
				$logger->log('del_queue_tasks_all(TM).EXEC.ERR='. getPEARErrorInfo($result), PEAR_LOG_ERR);
				return null;
			}
			$result->free();

			//clear queue
			$q = 'delete from tb_queue_fax where of_id=' . $session->ofid;
			$result = $database->query($q);
			if (PEAR::isError($result)) {
				$logger->log('del_queue_tasks_all(QUEUE).ERR='. getPEARErrorInfo($result), PEAR_LOG_ERR);
				return null;
			}

			//delete file records in billing
			//foreach ($idlist as $id)
				//$database_tar->deleteMBMessage($id[0]);

			return true;
		}
	}

	return null;
}

//$logger->log("POST(".basename($_SERVER['SCRIPT_NAME']).":\n".print_r($_POST, true));

//header("Content-Type: text/plain");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . "GMT");
header("Cache-Control: no-cache, must-revalidate");
header("Pragma: no-cache");
//header("Content-type: text/x-json");
header("Content-Type: application/json; Charset=UTF-8");

if ($session->db_ok && $session->logged_in) {
	$mode = isset($_POST['op']) ? $_POST['op'] : 'list';
	//$session->ofid

	//$logger->log("mode=$mode");
	switch ($mode) {
		case 'del_list':
			$dbres = del_queue_tasks(explode(',', $_POST['items']));
			if ($dbres === true)
				$jsonresErr['ok'] = true;
			else
				$jsonresErr['error'] = 'При удалении возникли ошибки!';
			echo json_encode_safe($jsonresErr);
			break;
		case 'del_all':
			$dbres = del_queue_tasks_all();
			if ($dbres === true)
				$jsonresErr['ok'] = true;
			else
				$jsonresErr['error'] = 'При удалении возникли ошибки!';
			echo json_encode_safe($jsonresErr);
			break;
		case 'del_done':
			$dbres = del_queue_tasks(explode(',', $_POST['items']));
			if ($dbres === true)
				$jsonresErr['ok'] = true;
			else
				$jsonresErr['error'] = 'При удалении возникли ошибки!';
			echo json_encode_safe($jsonresErr);
			break;
		case 'list':
			$dbres = get_queue_list();
			if (is_array($dbres)) {
				$jsonresErr['total'] = count($dbres);
				foreach ($dbres as $row) {
					$starttime = '';
					$stats = '';
					foreach ($row['taskstats'] as $statrow) {
						if (empty($stats))
							$starttime = $statrow['tm_task_start_time'];
						$stats .= (empty($stats) ? '' : '<br>')
							. $statrow['tm_task_start_time']
							. ': '
							. addslashes(tm_task_status_str($statrow['tm_task_status']))
							. ' >>> '
							. addslashes(tm_dial_status_str($statrow['tm_task_dial_status']));
					}
					$statustext = addslashes(tm_task_status_str($row['taskparams']['tm_task_status']));
					$flagsout = "<img src='images/icon_clock.gif' width='16' height='16' alt='$statustext' title='$statustext'>";
					/*switch ($row['flagsout']) {
						case DB_SERVICEID_MTR:
							$flagsout = '<img src="images/icon_mtr.gif" width="16" height="14" alt="Телефонный звонок" title="Телефонный звонок">';
							break;
						case DB_SERVICEID_MSG_OUT:
							$flagsout = '<img src="images/icon_msg_out.gif" width="16" height="14" alt="Отправка сообщения" title="Отправка сообщения">';
							$volume = $row['payablevolume'];
							break;
					}*/
					$jsonresErr['rows'][] = array(
						'id' => $row['tm_task_id'],// . '_' . $session->generateRandStr(16),
						'cell' => array(
							$flagsout,
							$row['addtime'],
							$row['numberb'],
							$row['filename'],
							$starttime,
							$row['taskparams']['tm_task_try_count'],
							$statustext,
							//nl2br($row['taskparams']['tm_task_params']),
							$stats
						)
					);
				}
				//$logger->log('fax queue:' . print_r(json_encode_safe($jsonresErr), true));
				echo json_encode_safe($jsonresErr);
			} else
				echo json_encode_safe($jsonresErr);
			break;
		default:
			echo json_encode_safe($jsonresErr);
	}
} else {
	echo json_encode_safe($jsonresErr);
}
?>
