<?php
require_once(dirname(__FILE__).'/vo_htmls_plain.php');
require_once(dirname(__FILE__).'/vo_htmls.php');
require_once(dirname(__FILE__).'/include/session.php');
require_once(dirname(__FILE__).'/include/database.php');
require_once(dirname(__FILE__).'/include/database_dynmenu.php');

global $session, $database, $database_dynmenu, $form, $logger;
if (!$session->db_ok) {
	print(GetClosedPageContent());
	die();
}

// current page properties
$current_page_name = basename($_SERVER['PHP_SELF']); 
foreach($session->userright as $key => $row) {
	if($row['action']==$current_page_name and $row['act_visible']==0){ $current_page_title = $row['act_name']; }
} 
$pagetitle = $current_page_title;

$preheadcode = <<<EOS
<script language="JavaScript" type="text/JavaScript" src="js/right_user.js"></script>
<script type="text/javascript" src="js/jquery/jquery.tools.min.js"></script>
<script type="text/javascript">
$(document).ready(function() {});
</script>
EOS;

print(GetHTMLHeader($pagetitle, null, $preheadcode));
print(GetPageTop());
?>

<div class="pagemain">

<div class="pageheader">
<table class="pageheader">
<tr>
	<td class="headleft">&nbsp;</td>
	<td class="headnav"><?php print(GetVOHeadMenu()); ?></td>
</tr>
</table>
</div>

<table class="pagecontent">
<tr>
<td class="menu"><?php print(GetVOMenu()); ?></td>
<td class="content">

<?php
//if ($session->logged_in && $session->isAdmin()) {
if ($session->logged_in && $session->checkUserRight('right_user.php','A')) {
	print(GetPageContentTitle($pagetitle));
	// access level control
	if(isset($session->only_read_message)) {
		echo "<script type='text/javascript' language='javascript'> alert('".$session->only_read_message."'); </script>";
		unset($session->only_read_message);
	}

	
	$userrolelist = $database->getUserRoleList();
	echo GetJavaScriptCodeBlock($database->getUserRoleList_htmlcode($userrolelist));
		
	$script = "";

	?>
	<form name="frmmain" id="frmmain" action="process.php" method="post" onSubmit="return disableForms();">
	<input type="hidden" name="sub_edit_adminuser" id="sub_edit_adminuser" value="save">
	<input type="hidden" name="hidUserCounterHolder" id="hidUserCounterHolder" value=0>
	
	<div class="textquoteinfo" style="width:650px;padding:10px;margin:10px 10px 10px 0;" align="left">
		<img src="images/icon_info_big.gif" width="32" height="32" style="margin: 6px 10px -8px 0; padding-bottom:1px;" align="left" alt="">
		<span class="sm" style="color: #666;display:block;">
			Пользователи системы - это пользователи, не имеющие привязки ни к одному из офисов.<br>
			Права доступа пользователя к функциям системы определяются ролью.
		</span>
	</div>

	
	<?php
	if ($group_selected>=0) {
		$script .= sprintf("createRowUserHeader(\"%s\");","tb_user");

		$res = $database->getUsersByOfficeID(null);
		
		foreach ($res as $row) {
			$script .= sprintf("createRowUser('%s', '%d', '%d', '%s', '%s', '%s');",
								addslashes(htmlspecialchars($row['user_name'])),
								$row['user_role'],
								$row['user_id'],
								addslashes(htmlspecialchars($row['user_password'])),
								addslashes(htmlspecialchars($row['user_mail'])),
								'view'
								);
		}

		echo "<input type=\"hidden\" name=\"lastaction_id\" id=\"lastaction_id\">";
	} 
	?>

	<div class="spacer"></div>

	</form>
	<?php
	
	echo GetJavaScriptCodeBlock($script);

} else {
	print(GetPageContentTitle("Вход в систему"));
	print(GetVOLoginForm());
}
?>

	<?php
	if (strlen($form->error("admuser_table_error")) > 0) {
	?>
		<div class="enote sm" style="margin:10px 0 0 20px;"><?php echo $form->error("admuser_table_error"); ?></div>
	<?php
	}
	?>



</td> <!-- content -->
</tr>
</table> <!-- pagecontent -->
</div> <!-- pagemain -->

<div class="pagefooter">
<table class="pagefooter">
<tr><td class="footleft">&nbsp;</td><td class="footnav">&nbsp;</td></tr>
<tr><td colspan="2" class="footcopyright">&nbsp;<?php echo SITE_COPYRIGHT ?></td></tr>
</table>
</div>
<?php
print(GetHTMLFooter());
?>

