<?php
require_once(dirname(__FILE__).'/vo_htmls_plain.php');
require_once(dirname(__FILE__).'/vo_htmls.php');
require_once(dirname(__FILE__).'/include/session.php');
require_once(dirname(__FILE__).'/include/database.php');
require_once(dirname(__FILE__).'/include/functions.php');

function GenerateOwnerTableAsXLS($repname, $report, $sendbymail = false) {
	global $session, $database, $logger, $database_tar;

	//create XLS
	require_once('Spreadsheet/Excel/Writer.php');

	if ($sendbymail) {
		require_once 'System.php';
		$outfile = System::mktemp('aoutmail_');
		$excel = new Spreadsheet_Excel_Writer($outfile);
	} else {
		$excel = new Spreadsheet_Excel_Writer();
		$excel->send("Реквизиты абонента.xls");
//		$excel->send("Статистика работы офиса {$session->ofnumber} с {$session->filters[DB_TAR_SERVICETYPE_ALLTYPES]['sf_startdate']} по {$session->filters[DB_TAR_SERVICETYPE_ALLTYPES]['sf_enddate']}.csv");
	}

	$excel->setVersion(8);
	
	//$sheet =& $excel->addWorksheet(iconv('utf-8', 'cp1251', "Офис {$session->ofnumber}"));
	$sheet =& $excel->addWorksheet("Офис {$session->ofnumber}");
	if (PEAR::isError($sheet)) {
		$logger->log("excel->addWorksheet ERROR:". getPEARErrorInfo($sheet));
		$excel->close();
		return;
	}
	//$sheet->setInputEncoding('UTF-8');
	 $sheet->setInputEncoding('cp1251');

	$sheet->setColumn(0, 0, 12.0);
	$sheet->setColumn(1, 1, 64.0);
	$sheet->setColumn(2, 2, 64.0);
	$sheet->setColumn(3, 3, 64.0);
	$sheet->setColumn(4, 4, 64.0);

	//create data formats
	$fmt =& $excel->addFormat(array('NumFormat' => '@'));
	$fmtR =& $excel->addFormat(array('Align' => 'right', 'NumFormat' => '@'));
	$fmtMoneyR =& $excel->addFormat(array('Align' => 'right', 'NumFormat' => '0.00'));
	$fmtDateTimeR =& $excel->addFormat(array('Align' => 'right', 'NumFormat' => 'DD.MM.YYYY hh:mm:ss'));
	$fmtDateR =& $excel->addFormat(array('Align' => 'right', 'NumFormat' => 'DD.MM.YYYY'));
	$fmtTimeR =& $excel->addFormat(array('Align' => 'right', 'NumFormat' => 'hh:mm:ss'));
	$fmtBold =& $excel->addFormat(array('Bold' => 1, 'NumFormat' => '@'));
	$fmtBoldR =& $excel->addFormat(array('Bold' => 1, 'Align' => 'right', 'NumFormat' => '@'));

	//header
	$sheet->write(0, 0, iconv('utf-8', 'cp1251', 'счет'), $fmtBold);
	$sheet->write(0, 1, iconv('utf-8', 'cp1251', 'ФИО'), $fmtBold);
	$sheet->write(0, 2, iconv('utf-8', 'cp1251', 'Адрес'), $fmtBold);
	$sheet->write(0, 3, iconv('utf-8', 'cp1251', 'Документ'), $fmtBold);
	$sheet->write(0, 4, iconv('utf-8', 'cp1251', 'Номер'), $fmtBold);
	
	//data
	$rowCount = 1;
	foreach ($report as $row) {

		$q = "select numbera from tbphones where accountid = ".$row['accountid'];
		$account_number = $database_tar->getQueryResultAsArray($q);
		$number = '';
		foreach ($account_number as $rownum) {
			$number.=$rownum['numbera'].', ';
		}

		$sheet->writeString($rowCount, 0, iconv('utf-8', 'cp1251', stripsiptags($row['accountgts'])), $fmt);
		$sheet->writeString($rowCount, 1, iconv('utf-8', 'cp1251', stripsiptags($row['fio'])), $fmt);
		$sheet->writeString($rowCount, 2, iconv('utf-8', 'cp1251', $row['address']), $fmt);
		$sheet->writeString($rowCount, 3, iconv('utf-8', 'cp1251', $row['document']), $fmt);
		$sheet->writeString($rowCount, 4, iconv('utf-8', 'cp1251', $number), $fmt);
		$rowCount++;
	}

	//finita!
	if ($excel->close() !== true)
		$logger->log('GenerateStatsTableAsXLS: error XLS!');

}

function GenerateOwnerTableAsPDF($repname, $report, $sendbymail = false) {
	global $session, $database;

	/*if ($sendbymail) {
		$ofparams = $database->getOfficeParams($session->ofid);
		if (!isset($ofparams[PARAM_EMAIL_STATS_ADDRESS]['pvalue']) || empty($ofparams[PARAM_EMAIL_STATS_ADDRESS]['pvalue'])) {
			header('Content-Type: text/plain; charset=utf-8');
			echo 'Не настроен адрес электронной почты для получения отчетов.';
			return;
		}
	}

	$total_time = 0;
	$total_pay = 0.0;
	//prepare report
	foreach ($report as &$row) {
		if ($row['flagsout'] < 0) {
			if ($sendbymail) {
				header('Content-Type: text/plain; charset=utf-8');
				echo 'Статистика пуста. Попробуйте изменить фильтры.';
			}
			return false;
		}

		$total_time += intval($row['payablevolume']);
		$total_pay += $row['pay'];

		$dt = date_parse($row['creattime']);
		$row['creattime'] = sprintf("%02d.%02d.%04d %02d:%02d:%02d",
			$dt['day'], $dt['month'], $dt['year'], $dt['hour'], $dt['minute'], $dt['second']);
		$row['numbera'] = stripsiptags($row['numbera']);
		$row['numberb'] = stripsiptags($row['numberb']);
		$row['realvolume'] = format_seconds($row['realvolume']);
		$row['pay'] = format_money($row['pay']);
		if (strlen(utf8_decode($row['geographyname'])) > 39)
			$row['geographyname'] = '<' . substr($row['geographyname'], -68);
	}
	unset($row);*/

	require_once(dirname(__FILE__).'/include/fpdf/array2table.php');

	class PDF extends PDF_Array_2_Table {
		var $angle = 0;

		function Header() {
			global $session;
			//Title
			$this->SetFont('DejaVu','',12);
			$this->Cell(0,4,"Реквизиты абонента",0,1,'C');
			$this->Ln();

			$this->SetFont('DejaVu','',50);
			$this->SetTextColor(250,250,250);
			$this->RotatedText(12,230,'В И Р Т У А Л Ь Н Ы Й  О Ф И С',45);
			$this->SetTextColor(0,0,0);

			parent::Header();
		}

		function Footer() {
			//Go to 1.5 cm from bottom
			$this->SetY(-10);
			$this->SetFont('DejaVu','',6);
			//Print centered page number
			$this->Cell(0,10,'Страница '.$this->PageNo().' / {nb}',0,0,'C');
			parent::Footer();
		}

		function Rotate($angle,$x=-1,$y=-1) {
			if ($x==-1)
				$x=$this->x;
			if ($y==-1)
				$y=$this->y;
			if ($this->angle!=0)
				$this->_out('Q');
			$this->angle=$angle;
			if ($angle!=0) {
				$angle*=M_PI/180;
				$c=cos($angle);
				$s=sin($angle);
				$cx=$x*$this->k;
				$cy=($this->h-$y)*$this->k;
				$this->_out(sprintf('q %.5F %.5F %.5F %.5F %.2F %.2F cm 1 0 0 1 %.2F %.2F cm',$c,$s,-$s,$c,$cx,$cy,-$cx,-$cy));
			}
		}

		function _endpage() {
			if ($this->angle!=0) {
				$this->angle=0;
				$this->_out('Q');
			}
			parent::_endpage();
		}

		function RotatedText($x, $y, $txt, $angle) {
			//Text rotated around its origin
			$this->Rotate($angle,$x,$y);
			$this->Text($x,$y,$txt);
			$this->Rotate(0);
		}
	}

	$pdf = new PDF();
	$pdf->AddFont('DejaVu', '', 'dejavusans.php', true);
	//$pdf->AddFont('Tahoma', 'B', 'tahomabd.php');
	$pdf->SetTitle("Реквизиты абонента", true);
	$pdf->SetSubject("Реквизиты абонента", true);
	$pdf->SetAuthor('VO');
	$pdf->SetCreator('VO');
	$pdf->AddPage();
	$pdf->AliasNbPages();
	//First table: put all columns automatically
	//$pdf->Table('select * from country order by name');
	//$pdf->AddPage();
	//Second table: specify columns
	$pdf->SetFont('DejaVu', '', 8);

	$pdf->AddCol('accountgts',$pdf->GetStringWidth(str_pad('8', 16, '8')), 'счет', 'R');
	$pdf->AddCol('fio',$pdf->GetStringWidth(str_pad('8', 32, '8')), 'ФИО', 'R');
	$pdf->AddCol('address',$pdf->GetStringWidth(str_pad('8', 32, '8')), 'Адрес', 'R');
	$pdf->AddCol('document',$pdf->GetStringWidth(str_pad('8', 32, '8')), 'Документ', 'R');
	$prop = array('HeaderColor' => array(219,219,219),
				'color1' => array(255,255,255),
				'color2' => array(238,238,238),
				'padding' => 1);
	$pdf->Table($report, $prop);

	$pdf->Output("Реквизиты абонента.pdf", 'D');
}




function GenerateOwnerTableAsText($repname, $report) {
	global $database_tar, $session;

	header('Content-Type: text/plain; charset=utf-8');
	header('Content-Disposition: attachment; filename="Реквизиты абонента.txt"');
	header('Content-Transfer-Encoding: 8bit');
	header('Content-Description: File Transfer');

	if (!function_exists('getTextNormalValueForReport')) {
		function getTextNormalValueForReport($val, $custompad = 20, $asint = false) {
		//function getTextNormalValueForReport($val, $custompad, $asint = false) {
			//$res = $val == '' ? $asint === true ? '0': '' : $val;
			//return str_pad($res, $custompad, " ", STR_PAD_LEFT);
			return str_pad($val, $custompad, " ", STR_PAD_RIGHT);
		}
	}

	echo getTextNormalValueForReport(iconv('utf-8', 'cp1251', 'счет'), 12) .
		getTextNormalValueForReport(iconv('utf-8', 'cp1251', 'ФИО'), 64) .
		getTextNormalValueForReport(iconv('utf-8', 'cp1251', 'Адрес'), 256) .
		getTextNormalValueForReport(iconv('utf-8', 'cp1251', 'Документ'), 64) .
		getTextNormalValueForReport(iconv('utf-8', 'cp1251', 'Номер'), 128) .
		"\r\n";
		
	foreach ($report as $row) {

		$q = "select numbera from tbphones where accountid = ".$row['accountid'];
		$account_number = $database_tar->getQueryResultAsArray($q);
		$number = '';
		foreach ($account_number as $rownum) {
			$number.=$rownum['numbera'].', ';
		}

		echo getTextNormalValueForReport(iconv('utf-8', 'cp1251', stripsiptags($row['accountgts'])), 12) .
			getTextNormalValueForReport(iconv('utf-8', 'cp1251', stripsiptags($row['fio'])), 64) .
			getTextNormalValueForReport(iconv('utf-8', 'cp1251', stripsiptags($row['address'])), 256) .
			getTextNormalValueForReport(iconv('utf-8', 'cp1251', stripsiptags($row['document'])), 64) .
			getTextNormalValueForReport(iconv('utf-8', 'cp1251', stripsiptags($number)), 128) .
			"\r\n";
	}
}



function GenerateStatsTable($repname, $report, $singleservicetype = -1, $hidedeleted = false) {
	global $session;

	if (!function_exists('getTableCellNormalValue')) {
		function getTableCellNormalValue($val, $asint = false) {
			$res = $val == '' ? $asint === true ? '0': '&nbsp;' : $val;
			return $res;
		}
	}
	?>
	<!-- <form name="frmmain2" action="process.php" method="post" onSubmit="return disableForm(this);"> -->
	<input type="hidden" name="sub_stats" value="1">
	<ul class="sf-menu">
		<li>
			<img id="bt_filters_apply" class="imglink" style="margin-right:4px;" src="images/btn_refresh.gif" title="Применить фильтры и обновить статистику" alt="" width="83" height="23">
		</li>
	<?php
		if ($singleservicetype == -1) {
		?>
			<li>
				<img class="imglink" style="margin-right:4px;" src="images/btn_save.gif" title="Сохранить статистику в определенном формате" alt="Сохранить статистику в определенном формате" width="88px" height="23px">
				<ul>
					<li>
						<a title="Сохранить в простом текстовом формате" class="bt_stat_saveas" rel="astext">
							<img src="images/icon_file_txt.gif" style="float:left;margin:-2px 8px 0 -3px;" width="16" height="16" alt="">
							В текстовом формате
						</a>
					</li>
					<li>
						<a title="Сохранить в формате PDF" class="bt_stat_saveas" rel="aspdf">
							<img src="images/icon_file_pdf.gif" style="float:left;margin:-2px 8px 0 -3px;" width="16" height="16" alt="">
							В формате PDF
						</a>
					</li>
					<li>
						<a title="Сохранить в формате Microsoft Excel (XLS)" class="bt_stat_saveas" rel="asxls">
							<img src="images/icon_file_xls.gif" style="float:left;margin:-2px 8px 0 -3px;" width="16" height="16" alt="">
							В формате Microsoft Excel (XLS)
						</a>
					</li>
				</ul>
			</li>
			<li>
				<img class="imglink" style="margin-right:4px;" src="images/btn_tomail.gif" title="Переслать статистику на электронную почту" alt="Переслать статистику на электронную почту" width="138px" height="23px">
				<ul>
					<li>
						<a title="Отправить в простом текстовом формате" class="asmail" rel="astxtmail">
							<img src="images/icon_file_txt.gif" style="float:left;margin:-2px 8px 0 -3px;" width="16" height="16" alt="">
							В текстовом формате</a>
					</li>
					<li>
						<a title="Отправить в формате PDF" class="asmail" rel="aspdfmail">
							<img src="images/icon_file_pdf.gif" style="float:left;margin:-2px 8px 0 -3px;" width="16" height="16" alt="">
							В формате PDF
						</a>
					</li>
					<li>
						<a title="Отправить в формате Microsoft Excel (XLS)" class="asmail" rel="asxlsmail">
							<img src="images/icon_file_xls.gif" style="float:left;margin:-2px 8px 0 -3px;" width="16" height="16" alt="">
							В формате Microsoft Excel (XLS)
						</a>
					</li>
				</ul>
			</li>
		<?php
		}
	?>
	</ul>
	<!-- </form> -->
	<?php
	if ($report === null) {
		?>
		<div class="textquote" style="width:400px;padding:10px;margin:10px;" align="left">
			<span class="sm" style="color: #666;"><img src="images/icon_error_big.gif" width="32" height="32" align="left" alt="">Ошибка при работе с БД Биллинга! Администратору системы необходимо проверить параметры подключения к БД.</span>
		</div>
		<?php
		return;
	}
	?>
	<div class="spacer"></div>
	<div id="voiceplayer2"></div>

	<table class="nb" style="border-bottom:1px solid #ccc;" id="tb_stats_<?php echo $repname ?>" cellspacing="0">
	<tr>
		<th class="infoTableHeader" width="32px">&nbsp;</th>
		<th class="infoTableHeader" width="140px">Дата/время</th>
		<?php
		switch ($singleservicetype) {
			case DB_TAR_SERVICETYPE_FAX:
			case DB_TAR_SERVICETYPE_VOICE:
				echo "<th class='infoTableHeaderR' width='200px'>Номер отправителя</th>";
				break;
			case DB_TAR_SERVICETYPE_FAX_SENT:
			case DB_TAR_SERVICETYPE_VOICE_SENT:
				echo "<th class='infoTableHeaderR' width='200px'>Номер получателя</th>";
				break;
			default:
				echo "<th class='infoTableHeaderR' width='100px'>НомерА</th>"
					."<th class='infoTableHeaderR' width='100px'>НомерБ</th>";
		}
		?>
		<th class="infoTableHeaderR" width="50px">Длительность</th>
		<th class="infoTableHeaderR" width="50px">Стоимость</th>
		<th class="infoTableHeaderR">Направление</th>
	</tr>
	<?php
	$rec_num = 0;
	$fax_num = 0;
	$voice_num = 0;
	$dates = array();
	$dur = 0;
	$summ = 0;
	$prevdate = '';
	$prevsess = null;
	$sesgroups = array();
	$invalidaccount = false;
	$needplayer = false;
	foreach ($report as $row) {
		$serv = $row['flagsout'];
		if ($serv < 0) {
			$invalidaccount = true;
			$rec_num++;
			break;
		}
		if ($rec_num > MAX_STATISTICS_ROWS) // just in case ;)
			break;
		if (!is_string($row['creattime']))
			continue;
		if ($hidedeleted && empty($row['recordid']))
			continue;

		$dur = $dur + $row['realvolume'];
		$summ = $summ + $row['pay'];

		$dt = date_parse($row['creattime']);
		$createtime = sprintf("%02d:%02d:%02d", $dt['hour'], $dt['minute'], $dt['second']);
		$dt = sprintf("%02d.%02d.%04d", $dt['day'], $dt['month'], $dt['year']);
		if ($dt != $prevdate) {
			$prevdate = $dt;
			$datehash = $repname.'_'.$prevdate;
			$dates[] = array('date_str' => $dt, 'date_cnt' => 0, 'date_hash' => $datehash);
			echo "<tr class=\"imglink\" onclick=\"toggleTableRowByCheckBox(null, 'toggle_$datehash', true, true)\" title=\"Свернуть/развернуть\">" .
					"<td align=\"left\" width=\"32px\">" .
					"<img id=\"imgtoggle_$datehash\" class=\"imglink\" style=\"margin-bottom:0;\" src='images/tree-expand3.gif' width='16' height='16' alt=''>" .
					"</td>" .
					"<td colspan=\"6\">" .
					"<span class=\"imglinkblg hlblack\">$prevdate</span>" .
					"<span id=\"cnt_$datehash\" class=\"imglink sm vert blue\" style=\"padding-bottom:1px;\">&nbspЗаписей: <img src='images/loading_sm.gif' width='10' height='10' alt=''></span>" .
					"</td>" .
					"</tr>";
		}

		if ($prevsess == $row['sessionid'])
			$sesgroups[$prevsess] = true;

		echo "<tr id=\"toggle_$datehash\" class=\"bgsel\" style=\"display:none;\">";

		$rec = '';
		if (isset($row['calltype']))
			switch ($row['calltype']) {
				case 100:
					$rec .= '<img src="images/icon_call_missed.gif" style="margin-left:4px;" width="16" height="16" alt="Пропущенный вызов" title="Пропущенный вызов">';
					break;
				case 101:
					$rec .= '<img src="images/icon_call.gif" style="margin-left:4px;" width="16" height="16" alt="Успешный вызов" title="Успешный вызов">';
					break;
				case 301:
					$rec .= '<img src="images/icon_call_incoming.gif" style="margin-left:4px;" width="16" height="16" alt="Входящий вызов" title="Входящий вызов">';
					break;
				default:
					$rec .= '<span style="width:20px;"></span>';
			}

		switch ($serv) {
			case DB_TAR_SERVICETYPE_MTR:
				//$row['recordid'] = 180;//Запись разговора
				if (!empty($row['recordid'])) {
					$record_title = base64_encode($serv.'|'.$row['creattime'].'|'.$row['numbera'].' '.$row['numberb']);
					$rec .= '<img class="imglink" src="images/icon_record.gif" width="16" height="16" alt="Прослушать запись разговора" title="Прослушать запись разговора" ' .
							"onclick=\"playVoice('{$row['recordid']}', '$record_title')\">";
					$rec .= '<img class="imglink" src="images/save.gif" width="16" height="16" alt="Сохранить запись разговора" title="Сохранить запись разговора" ' .
							"onclick=\"saveVoice('{$row['recordid']}', '$record_title')\">";
					$needplayer = true;
				} else {
					//$rec = "<img class=\"imglink\" style=\"margin-right:16px;\" src=\"images/icon_record_dis.gif\" width=\"16px\" height=\"16px\" alt=\"Файл записи разговора был удалён из системы\" title=\"Файл записи разговора был удалён из системы\">";
					$rec .= '<span style="width:16px;"></span>';
				}
				break;
			case DB_TAR_SERVICETYPE_VOICE:
				//$row['recordid'] = 180;//Голосовое сообщение
				if (!empty($row['recordid'])) {
					$record_title = base64_encode($serv.'|'.$row['creattime'].'|'.$row['numbera'].' '.$row['numberb']);
					$rec .= '<img class="imglink" src="images/icon_voicemail.gif" width="16" height="16" alt="Прослушать голосовое сообщение" title="Прослушать голосовое сообщение" ' .
							"onclick=\"playVoice('{$row['recordid']}', '$record_title')\">";
					$rec .= '<img class="imglink" src="images/save.gif" width="16" height="16" alt="Сохранить голосовое сообщение" title="Сохранить голосовое сообщение" ' .
							"onclick=\"saveVoice('{$row['recordid']}', '$record_title')\">";
					$needplayer = true;
				} else {
					//$rec = "<img class=\"imglink\" style=\"margin-right:16px;\" src=\"images/icon_voicemail_dis.gif\" width=\"16px\" height=\"16px\" alt=\"Файл голосового сообщения был удалён из системы\" title=\"Файл голосового сообщения был удалён из системы\">";
					$rec .= '<span style="width:16px;"></span>';
				}
				break;
			case DB_TAR_SERVICETYPE_FAX:
			case DB_TAR_SERVICETYPE_FAX_SENT:
				//$row['recordid'] = 95;//Факсимильное сообщение
				if (!empty($row['recordid'])) {
					$record_title = base64_encode($serv.'|'.$row['creattime'].'|'.$row['numbera'].' '.$row['numberb']);
					$rec .= '<img class="imglink" src="images/icon_fax3.gif" width="16" height="16" alt="Посмотреть факсимильное сообщение" title="Посмотреть факсимильное сообщение" ' .
							"onclick=\"showFax('{$row['recordid']}', '$record_title')\">";
					$rec .= '<img class="imglink" src="images/save.gif" width="16" height="16" alt="Сохранить факсимильное сообщение" title="Сохранить факсимильное сообщение" ' .
							"onclick=\"saveFax('{$row['recordid']}', '$record_title')\">";
				} else {
					//$rec = "<img class=\"imglink\" style=\"margin-right:16px;\" src=\"images/icon_fax3_dis.gif\" width=\"16px\" height=\"16px\" alt=\"Файл факсимильного сообщения был удалён из системы\" title=\"Файл факсимильного сообщения был удалён из системы\">";
					$rec .= '<span style="width:16px;"></span>';
				}
				break;
			default:
				$rec .= '&nbsp';
		}

		echo "<td class='ses${row['sessionid']}'>$rec</td>";
		echo "<td class=\"infoLineValue\">". getTableCellNormalValue($createtime) ."</td>";
		switch ($singleservicetype) {
			case DB_TAR_SERVICETYPE_FAX:
			case DB_TAR_SERVICETYPE_VOICE:
				echo "<td class=\"infoLineValueR\">". getTableCellNormalValue($row['numbera']) ."</td>";
				break;
			case DB_TAR_SERVICETYPE_FAX_SENT:
			case DB_TAR_SERVICETYPE_VOICE_SENT:
				echo "<td class=\"infoLineValueR\">". getTableCellNormalValue($row['numberb']) ."</td>";
				break;
			default:
				echo "<td class=\"infoLineValueR\">". getTableCellNormalValue($row['numbera']) ."</td>";
				echo "<td class=\"infoLineValueR\">". getTableCellNormalValue($row['numberb']) ."</td>";
		}
		echo "<td class=\"infoLineValueR\">". getTableCellNormalValue(format_seconds($row['realvolume']), true) ."</td>";
		echo "<td class=\"infoLineValueR\">". getTableCellNormalValue(format_money($row['pay'])) ."</td>";
		echo "<td class=\"infoLineValueR\">". getTableCellNormalValue($row['geographyname']) ."</td>";
		echo "</tr>";

		$rec_num++;
		$voice_num += intval(($serv == DB_TAR_SERVICETYPE_VOICE || $serv == DB_TAR_SERVICETYPE_VOICE_SENT));
		$fax_num += intval(($serv == DB_TAR_SERVICETYPE_FAX || $serv == DB_TAR_SERVICETYPE_FAX_SENT));
		$dates[count($dates) - 1]['date_cnt']++;
		$prevsess = $row['sessionid'];
	}

	if ($rec_num == 0 || $invalidaccount === true) {
		?>
		</table>
		<?php
		echo GetJavaScriptCodeBlock("var obj = document.getElementById('tb_stats_$repname');if (obj) obj.parentNode.removeChild(obj);");
		$msg = $rec_num == 0 ?
				"Информация недоступна. По офису <span class=\"hlblack underlined\">$session->ofnumber</span> нет " . ($singleservicetype == -1 ? 'записей ' : 'сообщений ') . 'удовлетворяющих критериям поиска.' :
				"Информация недоступна. Офис <span class=\"hlblack underlined\">$session->ofnumber</span> не зарегистрирован в подсистеме биллинга.";
		//echo "<table class=\"nbpad\" id=\"emptytablenotice\"><tr><td class=\"iconinfo\">&nbsp;</td><td class=\"note\">$msg</td></tr></table>";
		?>
		<div class="textquote" style="width:600px;padding:10px;margin:10px;" align="left">
			<span class="sm" style="color: #666;"><img src="images/icon_error_big.gif" width="32" height="32" style="margin: -10px 10px -8px 0;" align="left" alt=""><?php echo $msg ?></span>
		</div>
		<?php
	} else {
		echo "<tr><td colspan=\"7\" align=\"right\">&nbsp;</td></tr>";
		switch ($singleservicetype) {
			case DB_TAR_SERVICETYPE_VOICE:
			case DB_TAR_SERVICETYPE_VOICE_SENT:
				echo "<tr><td colspan=\"7\" align=\"right\" class=\"infoLineValueRNB\">" .
						"Итого голосовых сообщений: <span class=\"hlblack\">$voice_num</span></td></tr>";
				echo "<tr><td colspan=\"7\" align=\"right\" class=\"infoLineValueRNB\">Общая длительность: <span class=\"hlblack\">$dur</span> секунд (<span class=\"hlblack\">". format_seconds($dur) ."</span>)" .
						"</td></tr>";
				break;
			case DB_TAR_SERVICETYPE_FAX:
			case DB_TAR_SERVICETYPE_FAX_SENT:
				echo "<tr><td colspan=\"7\" align=\"right\" class=\"infoLineValueRNB\">" .
						"Итого факсимильных сообщений: <span class=\"hlblack\">$fax_num</span></td></tr>";
				break;
			default:
				echo "<tr><td colspan=\"7\" align=\"right\" class=\"infoLineValueRNB\">" .
						"Итого разговоров: <span class=\"hlblack\">$rec_num</span> на сумму <span class=\"hlblack\">".format_money($summ)."</span></td></tr>";
				echo "<tr><td colspan=\"7\" align=\"right\" class=\"infoLineValueRNB\">Общая длительность: <span class=\"hlblack\">$dur</span> секунд (<span class=\"hlblack\">". format_seconds($dur) ."</span>)" .
						"</td></tr>";
				if ($voice_num > 0)
					echo "<tr><td colspan=\"7\" align=\"right\" class=\"infoLineValueRNB\">из них голосовых сообщений: <span class=\"hlblack\">$voice_num</span></td></tr>";
				if ($fax_num > 0)
					echo "<tr><td colspan=\"7\" align=\"right\" class=\"infoLineValueRNB\">из них факсимильных сообщений: <span class=\"hlblack\">$fax_num</span></td></tr>";
		}
		?>
		</table>
		<?php
		//update date event counters
		$script = '';
		foreach ($dates as $dt)
			$script .= "updateDateEventsCounter('{$dt['date_str']}', {$dt['date_cnt']}, '{$dt['date_hash']}');";
		if (strlen($script) > 0) {
			$script = "if (typeof(updateDateEventsCounter) != 'function') function updateDateEventsCounter(date_str, date_cnt, date_hash) {var obj = document.getElementById('cnt_' + date_hash);if (obj) obj.innerHTML = '&nbsp;&nbsp;Записей: ' + date_cnt;}"
					. $script;
			echo GetJavaScriptCodeBlock($script);
		}

		//restore all toggles first
		$script = '';
		foreach ($dates as $dt)
			$script .= "toggleTableRowByCheckBox(null, 'toggle_{$dt['date_hash']}', false, true);";
		if (strlen($script) > 0)
			echo GetJavaScriptCodeBlock($script);

		//coloring
		$script = <<<EOS
			$(function(){
				$('.bgsel').mouseover(function(){
					$(this).css({'background-color':'#f5f5f5'});
				}).mouseout(function(){
					$(this).css({'background-color':'#fff'});
				});
			});
EOS;
		echo GetJavaScriptCodeBlock($script);

		//session groups
		/*$script = '';
		foreach ($sesgroups as $sid => $dummy)
			$script .= ($script ? ',' : '') . $sid;
		if (strlen($script) > 0) {
			$script = <<<EOS
			$(function(){
				var sids=new Array($script);
				$.each(sids, function(){
					$('.ses'+this).each(function(){
						$(this).css({'border-left':'2px solid #cfcfcf'});
					});
					$('.ses'+this+':first').css({'border-top':'1px solid #cfcfcf'});
					$('.ses'+this+':last').css({'border-bottom':'1px solid #cfcfcf'});
				});
				$('.bgsel').mouseover(function(){
					$(this).css({'background-color':'#f5f5f5'});
				}).mouseout(function(){
					$(this).css({'background-color':'#fff'});
				});
			});
EOS;
			echo GetJavaScriptCodeBlock($script);
		}*/

		//open last date by default
		$script = '';
		$dt = $dates[count($dates) - 1];
		if ($dt)
			$script .= "toggleTableRowByCheckBox(null, 'toggle_{$dt['date_hash']}', true, true, true);";
		if (strlen($script) > 0)
			echo GetJavaScriptCodeBlock($script);
		if ($needplayer) {
			?>
			<script type="text/javascript">
				<!--
				if (!IsFlashEnabled()) writeGetFlashImage();
				// -->
			</script>
			<script type="text/javascript">
				<!--
				AudioPlayer.embed("voiceplayer2", {
					soundFile: "intro.mp3",
					artists: "",
					titles: "Файл не загружен",
					autostart: "no"
				});
				// -->
			</script>
			<?php
		}
		?>
		<br>
		<a onclick="disableForms();this.onclick='';window.location.href=window.location.pathname;">
			<img class="imglink" src="images/btn_refresh.gif" width="83" height="23" alt="Обновить">
		</a>
		<!-- </form> -->
		<?php
	}
}
?>
