<?php
require_once(dirname(__FILE__).'/vo_htmls_plain.php');
require_once(dirname(__FILE__).'/vo_htmls.php');
require_once(dirname(__FILE__).'/stats_table.php');
require_once(dirname(__FILE__).'/include/session.php');
require_once(dirname(__FILE__).'/include/database_tar.php');
require_once(dirname(__FILE__).'/include/functions.php');




global $session, $database_tar;
if (!$session->db_ok) {
	print(GetClosedPageContent());
	die();
}

if ($session->logged_in && isset($_REQUEST['exp'])) {
	if ($_REQUEST['exp'] == 'astext') {
		$report = $database_tar->get_stats(DB_TAR_SERVICETYPE_ALLTYPES, 1, MAX_STATISTICS_ROWS, null, null, null, null, $cnt, $tvol, $tpay);
		GenerateStatsTableAsText('stats', $report);
		exit(0);
	}

	if (in_array($_REQUEST['exp'], array('aspdf', 'aspdfmail', 'astxtmail'))) {
		$report = $database_tar->get_stats(DB_TAR_SERVICETYPE_ALLTYPES, 1, MAX_STATISTICS_ROWS, null, null, null, null, $cnt, $tvol, $tpay);
		GenerateStatsTableAsPDF('stats', $report, in_array($_REQUEST['exp'], array('aspdfmail', 'astxtmail')));
		exit(0);
	}

	if (in_array($_REQUEST['exp'], array('asxls', 'asxlsmail'))) {
		$report = $database_tar->get_stats(DB_TAR_SERVICETYPE_ALLTYPES, 1, MAX_STATISTICS_ROWS, null, null, null, null, $cnt, $tvol, $tpay);
		GenerateStatsTableAsXLS('stats', $report, $_REQUEST['exp'] == 'asxlsmail');
		exit(0);
	}
}

$addheadcode = <<<EOS
<link href="styles/jquery/themes/smoothness/jquery-ui-1.8.6.custom.css" rel="stylesheet" type="text/css">
<script type="text/javascript" src="js/jquery/jquery.tools.min.js"></script>
<script type="text/javascript" src="js/jquery/jquery-ui-1.8.6.custom.min.js"></script>
<script type="text/javascript" src="js/jquery/jquery.blockUI.js"></script>
<script type="text/javascript" src="js/jquery/jquery.download.js" charset="UTF-8"></script>
<script type="text/javascript" src="js/jquery/flexigrid.js" charset="UTF-8"></script>
<link href="styles/jquery/flexigrid.css" rel="stylesheet" type="text/css" media="screen"/>
<link href="styles/jquery/superfish.css" rel="stylesheet" media="screen">
<script type="text/javascript" src="js/jquery/superfish.js"></script>
<script type="text/javascript" src="js/jquery/supersubs.js"></script>
<script type="text/javascript" src="js/jquery/date.js" charset="UTF-8"></script>
<script type="text/javascript" src="js/jquery/date_ru_utf8.js" charset="UTF-8"></script>
<script type="text/javascript" src="js/jquery/jquery.datepick.pack.js" charset="UTF-8"></script>
<script type="text/javascript" src="js/jquery/jquery.datepick.ext.pack.js" charset="UTF-8"></script>
<script type="text/javascript" src="js/jquery/jquery.datepick-ru.js" charset="UTF-8"></script>
<link href="styles/jquery/jquery.datepick.css" rel="stylesheet" type="text/css" media="screen"/>
<link href="styles/jquery/themes/flick/jquery-ui-1.8.12.custom.css" rel="stylesheet" type="text/css" media="screen"/>
<link href="styles/jquery/ui-flick.datepick.css" rel="stylesheet" type="text/css" media="screen"/>
<script type="text/javascript" src="js/audio-player.js"></script>
<script type="text/javascript">
	AudioPlayer.setup("player.swf", {
		width: 529,
		autostart: "no",
		animation: "no",
		remaining: "yes",
		noinfo: "no",
		buffer: 10,
		initialvolume: 35,
		transparentpagebg: "yes",
		left: "000000",
		lefticon: "FFFFFF"
	});
</script>
<script type="text/javascript" src="js/stats.js"></script>
<script type="text/javascript" src="js/stats_common.js"></script>
EOS;

// current page properties
$current_page_name = basename($_SERVER['PHP_SELF']); 
foreach($session->userright as $key => $row) {
	if($row['action']==$current_page_name and $row['act_visible']==0){ $current_page_title = $row['act_name']; }
} 
$pagetitle = $current_page_title;
//$pagetitle = "Статистика";

print(GetHTMLHeader($pagetitle, null, $addheadcode));
print(GetPageTop());


if (!($session->logged_in && $session->checkUserRight($current_page_name,'A'))) { 
	print(GetPageContentTitle("Вход в систему"));
	print(GetVOLoginForm());
	die(); 
}




?>

<div class="pagemain">

<div class="pageheader">
<table class="pageheader">
<tr>
	<td class="headleft">&nbsp;</td>
	<td class="headnav"><?php print(GetVOHeadMenu()); ?></td>
</tr>
</table>
</div>

<table class="pagecontent">
<tr>
<td class="menu"><?php print(GetVOMenu()); ?></td>
<td class="content">

<div class="hidden">
	<img id="calendar_picker" src="images/calendar.gif" alt="" title="Выбрать дату" class="imglink trigger">
</div>

<?php
if ($session->logged_in) {
	print(GetPageContentTitle($pagetitle));
	$session->initStatFilters(DB_TAR_SERVICETYPE_ALLTYPES, true);
	
	// for wide columns show (use in stats.js, turn on/off in user roles)
	if ($session->checkUserRight('stats_wide','A')) { echo "<input type=\"hidden\" id=\"stats_wide\" value=\"1\">\n"; }
	else { echo "<input type=\"hidden\" id=\"stats_wide\" value=\"0\">\n"; }
?>
	<div style="display:none;" id="dlgStats" title="Отправка статистики на электронную почту">
		<p>
			<span id="dlgStats_icon" class="ui-icon ui-icon-circle-check" style="float:left;margin:0 7px 20px 0;"></span>
			<span id="dlgStats_msg">Статус неизвестен</span>
		</p>
	</div>
	<div class="groupboxfilters">
		<table class="statlist_filters">
			<tr>
				<td class="infoLineParam blue" style="width:120px;">Дата</td>
				<td class="infoLineValue" style="width:100px;">
					<span style="margin-right:4px;">с</span>
					<input class="datefield inputmw" style="width:90px;" type="text" id="sf_startdate" data-rangectrl="sf_range"
					       value="<?php echo $session->filters[DB_TAR_SERVICETYPE_ALLTYPES]['sf_startdate']; ?>"
					/>
					<span style="margin-left:4px;">по</span>
					<input class="datefield inputmw" style="width:90px;" type="text" id="sf_enddate" data-rangectrl="sf_range"
					       value="<?php echo $session->filters[DB_TAR_SERVICETYPE_ALLTYPES]['sf_enddate']; ?>"
					/>
				</td>
				<td class="infoLineValue">
					<input type="hidden" id="sf_range" class="rangefield" value="<?php echo $session->filters[DB_TAR_SERVICETYPE_ALLTYPES]['sf_range']; ?>"/>
					<a class="datectrl first" rel="w,sf_startdate,sf_enddate" title="За неделю">неделя</a>
					<a class="datectrl" rel="m,sf_startdate,sf_enddate" title="За месяц">месяц</a>
					<a class="datectrl" rel="2m,sf_startdate,sf_enddate" title="За два месяца">2 месяца</a>
					<a class="datectrl" rel="05y,sf_startdate,sf_enddate" title="За полгода">полгода</a>
					<a class="datectrl" rel="y,sf_startdate,sf_enddate" title="За год">год</a>
				</td>
			</tr>
			<tr>
				<td class="infoLineParam blue">Длительность</td>
				<td class="infoLineValue">
					<span style="margin-right:4px;">от</span>
					<input class="inputmw" style="width:40px;" type="text" id="sf_startvol"
					       value="<?php echo $session->filters[DB_TAR_SERVICETYPE_ALLTYPES]['sf_startvol']; ?>"
					/>
					<span style="margin-left:4px;">до</span>
					<input class="inputmw" style="width:40px;" type="text" id="sf_endvol"
					       value="<?php echo $session->filters[DB_TAR_SERVICETYPE_ALLTYPES]['sf_endvol']; ?>"
					/>
					<span style="margin-left:4px;">минут</span>
				</td>
				<td class="infoLineValue">
					<a class="volctrl first" rel="1,sf_startvol,sf_endvol" title="Звонки длительностью меньше минуты">меньше минуты</a>
					<a class="volctrl" rel="2,sf_startvol,sf_endvol" title="Звонки длительностью от минуты до пяти минут">1-5 минут</a>
					<a class="volctrl" rel="3,sf_startvol,sf_endvol" title="Звонки длительностью больше пяти минут">больше 5 минут</a>
				</td>
			</tr>
			<tr>
				<td class="infoLineParam blue">Номер</td>
				<td class="infoLineValue" colspan="2">
					НомерА
					<input class="inputmw" style="width:150px;" type="text" id="sf_numbera"
					       value="<?php echo $session->filters[DB_TAR_SERVICETYPE_ALLTYPES]['sf_numbera']; ?>"
					/>
					<span style="margin-left:4px;">НомерБ</span>
					<input class="inputmw" style="width:150px;" type="text" id="sf_numberb"
					       value="<?php echo $session->filters[DB_TAR_SERVICETYPE_ALLTYPES]['sf_numberb']; ?>"
					/>
				</td>
			</tr>
			<tr>
				<td class="infoLineParam blue">Направление</td>
				<td class="infoLineValue" colspan="2">
					<input class="inputmw" style="width:220px;" type="text" id="sf_geo"
					       value="<?php echo $session->filters[DB_TAR_SERVICETYPE_ALLTYPES]['sf_geo']; ?>"
					/>
					<span style="margin-left:4px;"></span>
					<select class="inputmw" style="width:260px;" id="sf_geostrict">
						<option>&lt;&nbsp;Полный список направлений</option>
						<?php echo $database_tar->get_stats_geographys_htmlcode($database_tar->get_stats_geographys(), '-'); ?>
					</select>
				</td>
			</tr>
			<!-- tr>
				<td class="infoLineParam blue">Типы вызовов</td>
				<td class="infoLineValue" colspan="2">
					<input type="checkbox" id="sf_calltype100" onchange="" <?php echo $session->filters[DB_TAR_SERVICETYPE_ALLTYPES]['sf_calltype100'] == '1' ? 'checked' : '' ?>/>
					<label for="sf_calltype100" class="imglink noundertext" title="">Пропущенные вызовы</label> &nbsp;
					<input type="checkbox" id="sf_calltype101" onchange="" <?php echo $session->filters[DB_TAR_SERVICETYPE_ALLTYPES]['sf_calltype101'] == '1' ? 'checked' : '' ?>/>
					<label for="sf_calltype101" class="imglink noundertext" title="">Успешные вызовы</label> &nbsp;
					<input type="checkbox" id="sf_calltype301" onchange="" <?php echo $session->filters[DB_TAR_SERVICETYPE_ALLTYPES]['sf_calltype301'] == '1' ? 'checked' : '' ?>/>
					<label for="sf_calltype301" class="imglink noundertext" title="">Входящие вызовы</label> &nbsp;
				</td>
			</tr -->
			
			<tr>
				<td class="infoLineParam blue">Вызовы</td>
				<td class="infoLineValue" colspan="2">
				<input type="checkbox" id="sf_calltype301" onchange="" <?php echo $session->filters[DB_TAR_SERVICETYPE_ALLTYPES]['sf_calltype301'] == '1' ? 'checked' : '' ?>/>
				<label for="sf_calltype301" class="imglink noundertext" title="">Входящие</label> &nbsp;
				<input type="checkbox" id="sf_calltype201" onchange="" <?php echo $session->filters[DB_TAR_SERVICETYPE_ALLTYPES]['sf_calltype201'] == '1' ? 'checked' : '' ?>/>
				<label for="sf_calltype201" class="imglink noundertext" title="">Исходящие</label> &nbsp;
				<input type="checkbox" id="sf_calltype100" onchange="" <?php echo $session->filters[DB_TAR_SERVICETYPE_ALLTYPES]['sf_calltype100'] == '1' ? 'checked' : '' ?>/>
				<label for="sf_calltype100" class="imglink noundertext" title="">Пропущенные</label> &nbsp;
				</td>
			</tr>
			
		</table>
	</div>
	<div class="spacer"></div>
	<ul class="sf-menu">
		<li>
			<img id="bt_filters_apply" class="imglink" style="margin-right:4px;" src="images/btn_refresh.gif" title="Применить фильтры и обновить данные" alt="" width="83" height="23">
		</li>
		<li>
			<img class="imglink" style="margin-right:4px;" src="images/btn_save.gif" title="Сохранить статистику в определенном формате" alt="Сохранить статистику в определенном формате" width="88px" height="23px">
			<ul>
				<li>
					<a title="Сохранить в простом текстовом формате" class="bt_stat_saveas" rel="astext"> <img src="images/icon_file_txt.gif" style="float:left;margin:-2px 8px 0 -3px;" width="16" height="16" alt=""> В текстовом формате </a>
				</li>
				<li>
					<a title="Сохранить в формате PDF" class="bt_stat_saveas" rel="aspdf"> <img src="images/icon_file_pdf.gif" style="float:left;margin:-2px 8px 0 -3px;" width="16" height="16" alt=""> В формате PDF </a>
				</li>
				<li>
					<a title="Сохранить в формате Microsoft Excel (XLS)" class="bt_stat_saveas" rel="asxls"> <img src="images/icon_file_xls.gif" style="float:left;margin:-2px 8px 0 -3px;" width="16" height="16" alt=""> В формате Microsoft Excel (XLS) </a>
				</li>
			</ul>
		</li>
		<li>
			<img class="imglink" style="margin-right:4px;" src="images/btn_tomail.gif" title="Переслать статистику на электронную почту" alt="Переслать статистику на электронную почту" width="138px" height="23px">
			<ul>
				<li>
					<a title="Отправить в простом текстовом формате" class="asmail" rel="astxtmail"> <img src="images/icon_file_txt.gif" style="float:left;margin:-2px 8px 0 -3px;" width="16" height="16" alt=""> В текстовом формате</a>
				</li>
				<li>
					<a title="Отправить в формате PDF" class="asmail" rel="aspdfmail"> <img src="images/icon_file_pdf.gif" style="float:left;margin:-2px 8px 0 -3px;" width="16" height="16" alt=""> В формате PDF </a>
				</li>
				<li>
					<a title="Отправить в формате Microsoft Excel (XLS)" class="asmail" rel="asxlsmail"> <img src="images/icon_file_xls.gif" style="float:left;margin:-2px 8px 0 -3px;" width="16" height="16" alt=""> В формате Microsoft Excel (XLS) </a>
				</li>
			</ul>
		</li>
	</ul>
	<div id="voiceplayer"></div>
	<div class="spacer"></div>
	<table id="statlist" style="display:none"></table>
	<div class="spacer"></div>
	<div class="stattotals" id="stattotals"></div>
<?php
} else {
	print(GetPageContentTitle("Вход в систему"));
	print(GetVOLoginForm());
}
?>

</td> <!-- content -->
</tr>
</table> <!-- pagecontent -->
</div> <!-- pagemain -->

<div class="pagefooter">
<table class="pagefooter">
<tr><td class="footleft">&nbsp;</td><td class="footnav">&nbsp;</td></tr>
<tr><td colspan="2" class="footcopyright">&nbsp;<?php echo SITE_COPYRIGHT ?></td></tr>
</table>
</div>

<?php
print(GetHTMLFooter());
?>
