<?php
require_once(dirname(__FILE__) . '/include/session.php');

global $session, $database;
if (!$session->db_ok) {
	print('database not ok');
	die();
}
?>

<script type="text/javascript">
	var dialogmenus_external_menuid = null;
	var dialogmenus_menuid = null;
	var global_menu_list = [];

	function dialogmenus_init(menuid) {
		dialogmenus_external_menuid = menuid;
		dialogmenus_menuid = dialogmenus_external_menuid;
		$('#menus').flexReload();
		return true;
	}

	function dialogmenus_assignmenu(mid, mname) {
		if (!mid)
			return;

		var postdata = {
			sub_officemenusetup: 'edit',
			office_menuid: mid,
			office_menuname: mname
		};
		if ($('#ivr_edit').length > 0)
			postdata.ivr_edit = 1;

		$.ajax({
			type: 'POST',
			url: 'menu_officeprops.php',
			data: postdata,
			dataType: 'json',
			success: function (data) {
				if (data.ok) {
					office_menuid = mid;
					setCookie('office_menuid', office_menuid);
					if ($('#err_noofficemenulink').length > 0)
						$('#err_noofficemenulink').hide();

					$('#dialogmenus').overlay().close();

					if (mname)
						$('#btMenuOfficeSetupDlg_label').html(mname);
					toolbarToggleMenuControls(office_menuid >= 0);
					loadMenuList();
					updateItemNamesControls();

					reloadPic('menugraph');
				}
				else
				if (data.error)
					alert(data.error);
				else
					alert(data);
			},
			error: function (jqXHR, textStatus, errorThrown) {
				alert(errorThrown);
			}
		});
	}

	function menus_toolbar_cmd(cmdname, grid, cmdid) {
		switch (cmdid) {
			case 'menus_toolbar_refresh':
				$('#menus').flexReload();
				return true;
				break;
		}

		var selection = $('.trSelected', grid);
		if (selection.length == 0)
			return false;
		var menuid = selection[0].id.substr(3);
		var recs = selection.children('td');
		var menuname = $(recs[1]).children('div').html();

		switch (cmdid) {
			case 'menus_toolbar_delete':
				if (confirm(cmdname + ' "' + menuname + '"?')) {
					$.ajax({
						type: 'POST',
						url: 'menu_menus.php',
						data: {
							menus_operation: 'delete',
							office_menuid: dialogmenus_menuid
						},
						dataType: 'json',
						success: function (data) {
							if (data.ok) {
								dialogmenus_menuid = (dialogmenus_menuid == dialogmenus_external_menuid) ? -1 : dialogmenus_external_menuid;
								$('#menus').flexReload();
								loadMenuList();
							} else
							if (data.error)
								alert(data.error);
							else
								alert(data);
						},
						error: function (jqXHR, textStatus, errorThrown) {
							alert(errorThrown);
						}
					});
				}
				break;
		}
		return true;
	}

	$(document).ready(function() {
		$('#dialogmenus').overlay().load();

		$('#dialogmenus .close, #dialogmenus #dialog_close').click(function() {
			$('#dialogmenus').overlay().close();
			return false;
		});

		$('#dialogmenus').bind('onClose', function(event) {
			//$('#projectparams_badbillingmsg').html('').hide();
		});

		if ($('#ivr_edit').length > 0)
			$('#ivr_edit_notice').remove();

		$('#menus').flexigrid({
			url: 'menu_menus.php',
			params: [
				{name: 'menus_operation', value: 'gridlist'}
			],
			dataType: 'json',
			colModel: [
				{display: '#', name: 'menu_id', width: 30, sortable: true, align: 'right'},
				{display: 'Название', name: 'menu_name', width: 275, sortable: true, align: 'left'}
			],
			buttons: [
				{name: 'Обновить список', cmd: 'menus_toolbar_refresh', bclass: 'btrefresh', onpress: menus_toolbar_cmd},
				{name: 'Удалить сценарий', cmd: 'menus_toolbar_delete', bclass: 'btdel', onpress: menus_toolbar_cmd}
			],
			sortname: "menu_name",
			sortorder: "desc",
			showToggleBtn: false,
			singleSelect: true,
			striped: false,
			usepager: false,
			useRp: false,
			rp: 30,
			rpOptions: [10, 20, 25, 30, 50, 90],
			showTableToggleBtn: false,
			width: 350,
			height: 350,
			resizable: false,
			title: false,
			errormsg: 'Список в данный момент недоступен.',
			pagestat: 'Отображены записи с {from} по {to} из {total}',
			pagetext: 'Страница',
			outof: 'из',
			findtext: 'Поиск&nbsp;',
			procmsg: 'Чтение...',
			nomsg: 'Список пуст',
			autoload: false,
			preProcess: function (data) {
				global_menu_list.length = 0;
				if (data.total > 0)
					$.each(data.rows, function(i, row) {
						global_menu_list.push(row.cell[0] + ': ' + row.cell[1])
					});
				return data;
			},
			onSuccess: function () {
				if (dialogmenus_menuid !== null)
					$('#row' + dialogmenus_menuid).addClass('trSelected');
			},
			onSubmit: function () {
				return true;
			},
			onClick: function (row) {
				dialogmenus_menuid = $(row).hasClass('trSelected') ? row.id.substr(3) : null;
			},
			onDblClick: function (row) {
				dialogmenus_menuid = $(row).hasClass('trSelected') ? row.id.substr(3) : null;
				//if (dialogmenus_menuid != dialogmenus_external_menuid)
					$('#dialogmenus #bt_menu_open').click();
			}
		});

		/*$('#bt_menu_open').popover({
			placement: 'left',
			title: 'Внимание!',
			content: 'Открытый сценарий будет выбран в качестве рабочего сценария этого офиса!'
		});*/


		$('#dialogmenus a.accordion-toggle').css('font-weight','bold');

		$('.collapse').collapse({
			parent: '#menu_tools_list',
			toggle: false
		});

		$('.collapse').on('show hide', function() {
			$(this).siblings('.accordion-heading').find('.accordion-toggle').blur();
		}).on('show', function() {
			$(this).css('background-color', '#f5f5f5');//f2f1ef
			$(this).siblings('.accordion-heading').css('background-color', '#f5f5f5');
		}).on('hide', function() {
			$(this).css('background-color', '#fff');
			$(this).siblings('.accordion-heading').css('background-color', '#fff');
		});

		$('.collapse:first').collapse('show');


		$('#dialogmenus button[id^="bt_menu_"]')
			.addClass('btn-primary')
			.click(function() {
				$(this).blur();
				//$(this).addClass('disabled');
				//$(this).button('loading');
				//setTimeout("$('button[id^=\"bt_menu_\"]').removeClass('disabled').button('reset');", 3000);
			});

		$('#dialogmenus input[type="text"]').css('padding','4px');

		$('#dialogmenus #ed_menu_insert').typeahead({
			source: global_menu_list,
			items: 16/*,
			matcher: function (item) {
				return ~item.toLowerCase().indexOf(this.query.toLowerCase())
			}*/
		});

		$('#dialogmenus #bt_menu_open').click(function() {
			$(this).addClass('disabled').button('loading');
			dialogmenus_assignmenu(dialogmenus_menuid, $('#dialogmenus #row' + dialogmenus_menuid).find('div:last').html());
			$(this).removeClass('disabled').button('reset');
			return false;
		});

		$('#dialogmenus #bt_menu_rename').click(function() {
			var menuname = $('#dialogmenus #ed_menu_rename').val();
			if (menuname.length > 0) {
				$(this).addClass('disabled').button('loading');
				$.ajax({
					type: 'POST',
					url: 'menu_menus.php',
					data: {
						menus_operation: 'rename',
						office_menuname: menuname,
						office_menuid: dialogmenus_menuid
					},
					dataType: 'json',
					success: function (data) {
						if (data.ok) {
							//dialogmenus_assignmenu(data.out_menuid, menuname);
							if (dialogmenus_menuid == dialogmenus_external_menuid)
								$('#btMenuOfficeSetupDlg_label').html(menuname);
							$('#menus').flexReload();
						} else
						if (data.error)
							alert(data.error);
						else
							alert(data);
						$('#dialogmenus #bt_menu_rename').removeClass('disabled').button('reset');
					},
					error: function (jqXHR, textStatus, errorThrown) {
						alert(errorThrown);
						$('#dialogmenus #bt_menu_rename').removeClass('disabled').button('reset');
					}
				});
			}
			return false;
		});

		$('#dialogmenus #bt_menu_create').click(function() {
			var menuname = $('#dialogmenus #ed_menu_create').val();
			if (menuname.length > 0) {
				$(this).addClass('disabled').button('loading');
				$.ajax({
					type: 'POST',
					url: 'menu_menus.php',
					data: {
						menus_operation: 'blank',
						office_menuname: menuname
					},
					dataType: 'json',
					success: function (data) {
						if (data.ok)
							dialogmenus_assignmenu(data.out_menuid, menuname);
						else
						if (data.error)
							alert(data.error);
						else
							alert(data);
						$('#dialogmenus #bt_menu_create').removeClass('disabled').button('reset');
					},
					error: function (jqXHR, textStatus, errorThrown) {
						alert(errorThrown);
						$('#dialogmenus #bt_menu_create').removeClass('disabled').button('reset');
					}
				});
			}
			return false;
		});

		$('#dialogmenus #bt_menu_clone').click(function() {
			var menuname = $('#dialogmenus #ed_menu_clone').val();
			if (menuname.length > 0) {
				$(this).addClass('disabled').button('loading');
				$.ajax({
					type: 'POST',
					url: 'menu_menus.php',
					data: {
						menus_operation: 'clone',
						office_menuname: menuname,
						office_menuid: dialogmenus_menuid
					},
					dataType: 'json',
					success: function (data) {
						if (data.ok)
							dialogmenus_assignmenu(data.out_menuid, menuname);
						else
						if (data.error)
							alert(data.error);
						else
							alert(data);
						$('#dialogmenus #bt_menu_clone').removeClass('disabled').button('reset');
					},
					error: function (jqXHR, textStatus, errorThrown) {
						alert(errorThrown);
						$('#dialogmenus #bt_menu_clone').removeClass('disabled').button('reset');
					}
				});
			}
			return false;
		});

		$('#dialogmenus #bt_menu_insert').click(function() {
			var menuid_dst = $('#dialogmenus #ed_menu_insert').val();
			if (menuid_dst.length > 0) {
				menuid_dst = menuid_dst.split(": ");
				menuid_dst = (menuid_dst.length >= 1) ? menuid_dst[0] : null;
				if (menuid_dst == null || $('#dialogmenus #row' + menuid_dst).length == 0) {
					alert('Не задан сценарий назначения!');
					return false;
				}
				$(this).addClass('disabled').button('loading');
				$.ajax({
					type: 'POST',
					url: 'menu_menus.php',
					data: {
						menus_operation: 'insert',
						office_menuid: dialogmenus_menuid,
						office_menuid2: menuid_dst
					},
					dataType: 'json',
					success: function (data) {
						if (data.ok)
							dialogmenus_assignmenu(data.out_menuid, $('#dialogmenus #row' + data.out_menuid).find('div:last').html());
						else
						if (data.error)
							alert(data.error);
						else
							alert(data);
						$('#dialogmenus #bt_menu_insert').removeClass('disabled').button('reset');
					},
					error: function (jqXHR, textStatus, errorThrown) {
						alert(errorThrown);
						$('#dialogmenus #bt_menu_insert').removeClass('disabled').button('reset');
					}
				});
			}
			return false;
		});

		$('#dialogmenus #bt_menu_export').click(function() {
			$(this).addClass('disabled').button('loading');
			setTimeout("$('#dialogmenus #bt_menu_export').removeClass('disabled').button('reset');", 10000);
			var menuname = $('#dialogmenus #ed_menu_export').val();
			$.download('menu_menus.php', {
				menus_operation: 'export',
				office_menuid: dialogmenus_menuid,
				office_menuname: menuname
			});
			return false;
		});

		$("#dialogmenus input[type=file]").filestyle({
			image: "images/btselectfile.png",
			imagewidth: 107,
			imageheight: 28,
			width: 200
		});

		$('#dialogmenus #frm_menuimport').iframer({
			returnType: 'jsontext',
			onComplete: function (data) {
				data = $(data).clone().find('pre').replaceWith(function() { return this.innerHTML; }).end().html();
				var jdata = jQuery.parseJSON(data);
				if (jdata.ok) {
					//dialogmenus_assignmenu(data.out_menuid, $('#dialogmenus #row' + data.out_menuid).find('div:last').html());
					$('#menus').flexReload();
					alert('Сценарий успешно импортирован.');
				} else
				if (jdata.error)
					alert(jdata.error);
				else
					alert(jdata);
				$('#dialogmenus #bt_menu_import').removeClass('disabled').button('reset');
			}
		});

		$('#dialogmenus #bt_menu_import').click(function () {
			if ($('#menu_import_file').val().length == 0) {
				alert('Не выбран файл для импорта!');
				return false;
			}
			$(this).addClass('disabled').button('loading');
			$('#frm_menuimport').submit();
			return false;
		});
	});
</script>
<div class="modal" style="position: relative; top: 0; left: 0; margin: 0; z-index: 1; width: 100%;">
	<div class="modal-header">
		<button class="close" data-dismiss="modal">&times;</button>
		<h3>Управление сценариями</h3>
	</div>
	<div class="modal-body">
		<div class="row-fluid">
			<div class="span6">
				<table id="menus" style="display:none"></table>
			</div>
			<div class="span6">
				<div class="accordion" id="menu_tools_list">
					<div class="accordion-group">
						<div class="accordion-heading">
							<a class="accordion-toggle" data-toggle="collapse" data-parent="#menu_tools_list" href="#coll_menu_open">
								Открыть
							</a>
						</div>
						<div id="coll_menu_open" class="accordion-body collapse">
							<div class="accordion-inner">
								<button id="bt_menu_open" class="btn" type="button" data-loading-text="...."><i class="icon-folder-open icon-white"></i> Открыть выбранный сценарий в редакторе</button>
								<div id="ivr_edit_notice">
									<div class="spacer"></div>
									<div class="alert alert-info" style="margin-bottom:4px;">
										<!--<button class="close" data-dismiss="alert">×</button>-->
										<strong>Внимание!</strong> Открытый сценарий будет выбран в качестве рабочего сценария этого офиса!
									</div>
								</div>
							</div>
						</div>
					</div>
					<div class="accordion-group">
						<div class="accordion-heading">
							<a class="accordion-toggle" data-toggle="collapse" data-parent="#menu_tools_list" href="#coll_menu_rename">
								Переименовать
							</a>
						</div>
						<div id="coll_menu_rename" class="accordion-body collapse">
							<div class="accordion-inner">
								Переименовать выбранный в списке сценарий
								<div class="spacer"></div>
								<form class="form-inline">
									<fieldset>
										<div class="input-append">
											<input id="ed_menu_rename" class="input-large" type="text" placeholder="Новое название сценария">
											<button id="bt_menu_rename" class="btn" type="button" data-loading-text="....">Выполнить</button>
										</div>
									</fieldset>
								</form>
							</div>
						</div>
					</div>
					<div class="accordion-group">
						<div class="accordion-heading">
							<a class="accordion-toggle" data-toggle="collapse" data-parent="#menu_tools_list" href="#coll_menu_create">
								Создать новый
							</a>
						</div>
						<div id="coll_menu_create" class="accordion-body collapse">
							<div class="accordion-inner">
								<form class="form-inline">
									<fieldset>
										<div class="input-append">
											<input id="ed_menu_create" class="input-large" type="text" placeholder="Название нового сценария">
											<button id="bt_menu_create" class="btn" type="button" data-loading-text="....">Создать</button>
										</div>
									</fieldset>
								</form>
							</div>
						</div>
					</div>
					<div class="accordion-group">
						<div class="accordion-heading">
							<a class="accordion-toggle" data-toggle="collapse" data-parent="#menu_tools_list" href="#coll_menu_clone">
								Создать копию
							</a>
						</div>
						<div id="coll_menu_clone" class="accordion-body collapse">
							<div class="accordion-inner">
								Создать копию выбранного в списке сценария
								<div class="spacer"></div>
								<form class="form-inline">
									<fieldset>
										<div class="input-append">
											<input id="ed_menu_clone" class="input-large" type="text" placeholder="Название копии сценария">
											<button id="bt_menu_clone" class="btn" type="button" data-loading-text="....">Копировать</button>
										</div>
									</fieldset>
								</form>
							</div>
						</div>
					</div>
					<div class="accordion-group">
						<div class="accordion-heading">
							<a class="accordion-toggle" data-toggle="collapse" data-parent="#menu_tools_list" href="#coll_menu_insert">
								Вставить
							</a>
						</div>
						<div id="coll_menu_insert" class="accordion-body collapse">
							<div class="accordion-inner">
								Вставить содержимое выбранного в списке сценария в другой существующий сценарий
								<div class="spacer"></div>
								<form class="form-inline">
									<fieldset>
										<div class="input-append">
											<input id="ed_menu_insert" class="input-large" type="text" placeholder="Название сценария назначения">
											<button id="bt_menu_insert" class="btn" type="button" data-loading-text="....">Вставить</button>
										</div>
									</fieldset>
								</form>
							</div>
						</div>
					</div>
					<div class="accordion-group">
						<div class="accordion-heading">
							<a class="accordion-toggle" data-toggle="collapse" data-parent="#menu_tools_list" href="#coll_menu_export">
								Экспорт
							</a>
						</div>
						<div id="coll_menu_export" class="accordion-body collapse">
							<div class="accordion-inner">
								Сценарий будет экспортирован в виде SQL-скрипта в текстовом файле. Если в поле задано новое название то сценарий будет экспортирован с этим названием.
								<div class="spacer"></div>
								<form class="form-inline">
									<fieldset>
										<div class="input-append">
											<input id="ed_menu_export" class="input-large" type="text" placeholder="Новое название сценария">
											<button id="bt_menu_export" class="btn" type="button" data-loading-text="....">Выполнить</button>
										</div>
									</fieldset>
								</form>
							</div>
						</div>
					</div>
					<div class="accordion-group">
						<div class="accordion-heading">
							<a class="accordion-toggle" data-toggle="collapse" data-parent="#menu_tools_list" href="#coll_menu_import">
								Импорт
							</a>
						</div>
						<div id="coll_menu_import" class="accordion-body collapse">
							<div class="accordion-inner">
								Для импорта сценария необходим файл SQL-скрипта, полученный ранее с помощью функции Экспорта
								<div class="spacer"></div>
								<div class="uploader-body">
									<form class="form-inline" id="frm_menuimport" enctype="multipart/form-data" action="menu_menus.php" method="post">
										<fieldset>
											<input type="hidden" name="menus_operation" value="import">
											<input type="hidden" name="MAX_FILE_SIZE" value="<?php echo MAX_FILE_SIZE_UPLOAD_FAX ?>">
											<input type="file" name="menu_import_file" id="menu_import_file">
											<div class="spacer"></div>
											<button id="bt_menu_import" class="btn" type="button" data-loading-text="....">Импортировать</button>
										</fieldset>
									</form>
								</div>
							</div>
						</div>
					</div>
				</div>

            </div>
		</div>
	</div>
	<div class="modal-footer">
		<a class="btn" id="dialog_close">Закрыть</a>
	</div>
</div>