<?php
require_once(dirname(__FILE__).'/include/constants.php');
require_once(dirname(__FILE__).'/include/functions.php');
require_once(dirname(__FILE__).'/include/session.php');
require_once(dirname(__FILE__).'/include/database.php');
require_once(dirname(__FILE__).'/include/database_tar.php');
require_once(dirname(__FILE__).'/include/database_dynmenu.php');
require_once(dirname(__FILE__).'/include/fileserver.php');

require_once 'Archive/Tar.php';
require_once 'Archive/Zip.php';
require_once 'System.php';


class Process {
	function Process() {
		global $session, $logger;

		/* User submitted login form */
		if (isset($_REQUEST['sublogin']))
			$this->procLogin();
		/* Main office params */
		elseif (isset($_POST['sub_edit_main']))
			$this->procEditOfficeParams();
		/* Notify office params */
		elseif (isset($_POST['sub_edit_notify']))
			$this->procEditOfficeNotifyParams();
		/* Numbers: edit external number list */
		elseif (isset($_POST['sub_edit_numbers_ext']))
			$this->procEditNumbersExt();
		elseif (isset($_POST['sub_edit_numbers_bw']))
			$this->procEditNumbersBlackWhite();
		/* Numbers: edit internal number list */
		elseif (isset($_POST['sub_edit_numbers_int']))
			$this->procEditNumbersInt();
		/* Dials: edit dials list */
		elseif (isset($_POST['sub_edit_dials']))
			$this->procEditDials();
		/* Graphs: edit graphics list */
		elseif (isset($_POST['sub_edit_graphs']))
			$this->procEditGraphs();
		elseif (isset($_POST['pbx_sub_edit_graphs']))
			$this->proc_pbx_EditGraphs();
		/* DayGroups: edit day groups list */
		elseif (isset($_POST['sub_edit_daygroups']))
			$this->procEditDayGroups();
		/* Something with the Statistics */
		elseif (isset($_POST['sub_changelog']))
			$this->procChangelog();
		/* Offices: adm office */
		elseif (isset($_POST['sub_edit_offices']))
			$this->procEditOffices($_POST['sub_edit_offices']);
		/* Administration: admin users */
		elseif (isset($_POST['sub_edit_admusers']))
			$this->procEditAdminUsers();
		/* Administration: admin users */
		elseif (isset($_POST['sub_edit_info']))
			$this->procEditInfo($_POST['sub_edit_info']);
		/* Menu: user action group */
		elseif (isset($_POST['sub_edit_rightgroup']))
			$this->procEditUserActionGroup($_POST['sub_edit_rightgroup']);
		/* Menu: user action */
		elseif (isset($_POST['sub_edit_useraction']))
			$this->procEditUserAction($_POST['sub_edit_useraction']);
		/* Menu: user role */
		elseif (isset($_POST['sub_edit_userrole']))
			$this->procEditUserRole($_POST['sub_edit_userrole']);
		/* Menu: user role */
		elseif (isset($_POST['sub_edit_adminuser']))
			$this->procEditUserAdmin();
		elseif (isset($_POST['pbx_sub_edit_daygroups']))
			$this->procPbxEditDayGroups();
		elseif (isset($_POST['pbx_sub_edit_adminuser']))
			$this->procEditUserAdmin_pbx();

		elseif( $_REQUEST['request_name'] == 'check_sipcount' ) $this->check_sipcount();

		elseif( $_REQUEST['request_name'] == 'user_sipaccount' ) $this->proc_user_sipaccount();
		elseif( $_REQUEST['request_name'] == 'user_sipaccount_del' ) $this->proc_user_sipaccount_del();
		elseif( $_REQUEST['request_name'] == 'user_sipaccount_add' ) $this->proc_user_sipaccount_add();
		elseif( $_REQUEST['request_name'] == 'user_sipaccount_edt' ) $this->proc_user_sipaccount_edt();
		elseif( $_REQUEST['request_name'] == 'user_sipaccount_freenumber' ) $this->proc_user_sipaccount_freenumber();
		elseif( $_REQUEST['request_name'] == 'user_sipaccount_getnumber' ) $this->proc_user_sipaccount_getnumber();
		elseif( $_REQUEST['request_name'] == 'user_sipaccount_password' ) $this->proc_user_sipaccount_password();
		elseif( $_REQUEST['request_name'] == 'user_sipaccount_act' ) $this->proc_user_sipaccount_act();
		elseif( $_REQUEST['request_name'] == 'user_sipaccount_exists' ) $this->proc_user_sipaccount_exists();
		elseif( $_REQUEST['request_name'] == 'user_sip_template_list' ) $this->proc_user_sip_template_list();
		elseif( $_REQUEST['request_name'] == 'user_sip_template' ) $this->proc_user_sip_template();

		elseif( $_REQUEST['request_name'] == 'user_sipaccount_full' ) $this->proc_user_sipaccount_full();
		elseif( $_REQUEST['request_name'] == 'user_sipaccount_add_full' ) $this->proc_user_sipaccount_add_full();
		elseif( $_REQUEST['request_name'] == 'user_sipaccount_edt_full' ) $this->proc_user_sipaccount_edt_full();
		
		elseif( $_REQUEST['request_name'] == 'user_sipaccount_def' ) $this->proc_user_sipaccount_def();
		elseif( $_REQUEST['request_name'] == 'user_sipaccount_add_def' ) $this->proc_user_sipaccount_add_def();
		elseif( $_REQUEST['request_name'] == 'user_sipaccount_edt_def' ) $this->proc_user_sipaccount_edt_def();
		elseif( $_REQUEST['request_name'] == 'user_sipaccount_del_def' ) $this->proc_user_sipaccount_del_def();

		// Пользователи
		elseif( $_REQUEST['request_name'] == 'acc_users' ) $this->proc_acc_users();
		elseif( $_REQUEST['request_name'] == 'acc_users_add' ) $this->proc_acc_users_add();
		elseif( $_REQUEST['request_name'] == 'acc_users_edt' ) $this->proc_acc_users_edt();
		elseif( $_REQUEST['request_name'] == 'acc_users_del' ) $this->proc_acc_users_del();
		elseif( $_REQUEST['request_name'] == 'office_roles' ) $this->proc_office_roles();

		
		elseif( $_REQUEST['request_name'] == 'rpt_account_owner' ) $this->proc_rpt_account_owner();
		elseif( $_REQUEST['request_name'] == 'rpt_name_owner' ) $this->proc_rpt_name_owner();
		elseif( $_REQUEST['request_name'] == 'rpt_account_phone' ) $this->proc_rpt_account_phone();
		elseif( $_REQUEST['request_name'] == 'rpt_client_payment' ) $this->proc_rpt_client_payment();
		elseif( $_REQUEST['request_name'] == 'rpt_client_connection' ) $this->proc_rpt_client_connection();
		elseif( $_REQUEST['request_name'] == 'rpt_external_number' ) $this->proc_rpt_external_number();
		elseif( $_REQUEST['request_name'] == 'rpt_account_status' ) $this->proc_rpt_account_status();
		
		// router
		elseif( $_REQUEST['request_name'] == 'pbx_router_table' ) $this->proc_pbx_router_table();
		elseif( $_REQUEST['request_name'] == 'pbx_routerpath_table' ) $this->proc_pbx_routerpath_table();
		elseif( $_REQUEST['request_name'] == 'pbx_graph_list' ) $this->proc_pbx_graph_list();
		elseif( $_REQUEST['request_name'] == 'pbx_router_add' ) $this->proc_pbx_router_add();
		elseif( $_REQUEST['request_name'] == 'pbx_router_edt' ) $this->proc_pbx_router_edt();
		elseif( $_REQUEST['request_name'] == 'pbx_router_del' ) $this->proc_pbx_router_del();
		elseif( $_REQUEST['request_name'] == 'pbx_routerpath_add' ) $this->proc_pbx_routerpath_add();
		elseif( $_REQUEST['request_name'] == 'pbx_routerpath_edt' ) $this->proc_pbx_routerpath_edt();
		elseif( $_REQUEST['request_name'] == 'pbx_routerpath_del' ) $this->proc_pbx_routerpath_del();
		elseif( $_REQUEST['request_name'] == 'pbx_pathnumber_test' ) $this->proc_pbx_pathnumber_test();
		elseif( $_REQUEST['request_name'] == 'pbx_numbertranslate_test' ) $this->proc_pbx_numbertranslate_test();
		elseif( $_REQUEST['request_name'] == 'pbx_pathpeer_table' ) $this->proc_pbx_pathpeer_table();
		elseif( $_REQUEST['request_name'] == 'pbx_routerpath_moveup' ) $this->proc_pbx_routerpath_moveup();
		elseif( $_REQUEST['request_name'] == 'pbx_routerpath_movedown' ) $this->proc_pbx_routerpath_movedown();
		elseif( $_REQUEST['request_name'] == 'pbx_routerpath_view' ) $this->proc_pbx_routerpath_view();
		elseif( $_REQUEST['request_name'] == 'pbx_sip_route_list' ) $this->proc_pbx_sip_route_list();
		elseif( $_REQUEST['request_name'] == 'pbx_sip_route_edt' ) $this->proc_pbx_sip_route_edt();

		elseif( $_REQUEST['request_name'] == 'pbx_user_sipaccount_full' ) $this->proc_pbx_user_sipaccount_full();
		elseif( $_REQUEST['request_name'] == 'pbx_user_sip_template_list' ) $this->proc_pbx_user_sip_template_list();
		
		elseif( $_REQUEST['request_name'] == 'pbx_table_sip_view' ) $this->proc_pbx_table_sip_view();
		elseif( $_REQUEST['request_name'] == 'pbx_menu_list' ) $this->proc_pbx_menu_list();
		elseif( $_REQUEST['request_name'] == 'pbx_accessgroup_list' ) $this->proc_pbx_accessgroup_list();
		elseif( $_REQUEST['request_name'] == 'pbx_sip_accessgroup' ) $this->proc_pbx_sip_accessgroup();
		elseif( $_REQUEST['request_name'] == 'pbx_user_accessgroup' ) $this->proc_pbx_user_accessgroup();
		elseif( $_REQUEST['request_name'] == 'pbx_accessgroup_del' ) $this->proc_pbx_accessgroup_del();
		
		elseif( $_REQUEST['request_name'] == 'pbx_accessgroup_add' ) $this->proc_pbx_accessgroup_add();
		elseif( $_REQUEST['request_name'] == 'pbx_accessgroup_edt' ) $this->proc_pbx_accessgroup_edt();
		elseif( $_REQUEST['request_name'] == 'pbx_sip_accessgroup_table' ) $this->proc_pbx_sip_accessgroup_table();
		elseif( $_REQUEST['request_name'] == 'pbx_sip_accessgroup_add' ) $this->proc_pbx_sip_accessgroup_add();
		elseif( $_REQUEST['request_name'] == 'pbx_user_accessgroup_table' ) $this->proc_pbx_user_accessgroup_table();
		elseif( $_REQUEST['request_name'] == 'pbx_user_accessgroup_add' ) $this->proc_pbx_user_accessgroup_add();

		elseif( $_REQUEST['request_name'] == 'pbx_user_sipaccount_del' ) $this->proc_pbx_user_sipaccount_del();
		
		
		elseif (isset($_POST['op'])) {
			$this->jsonres = array(
				'op' => $_POST['op'],
				'auth' => $session->logged_in
			);

			if (!$session->logged_in && !in_array($_REQUEST['op'], array('auth', 'deauth'))) {
				$this->jsonres['error'] = 'NotAuthorized!';
				$this->jsonres['page'] = 1;
				$this->jsonres['rows'] = array();
				$this->jsonres['total'] = 0;

				$this->int_send_array_as_json($this->jsonres);
			} else
				switch ($_REQUEST['op']) {
					case 'stats':
						$this->proc_stats();
						break;
					case 'pbx_stats':
						$this->proc_pbx_stats();
						break;
					case 'mblist':
						$this->proc_mblist();
						break;
					case 'mblist_del':
						$this->proc_mblist_del();
						break;
					case 'mblist_save':
						$this->proc_mblist_save();
						break;
					case 'activecalls':
						$this->proc_activecalls();
						break;
					case 'delfile':
						$this->proc_delfile();
						break;
					default:
						$logger->log("process: unknown op request ({$_REQUEST['op']}) -> ignore", PEAR_LOG_ALERT);
				}
		}
		elseif($session->logged_in)
			$this->procLogout();
		else
			header("Location: main.php");
	}

	/**
	 * int_send_json
	 * @param $arr
	 */
	function int_send_array_as_json($arr) {
		global $logger;

		//$logger->log('process:int_send_array_as_json=' . print_r($arr, true), PEAR_LOG_DEBUG);

		//mb_internal_encoding("UTF-8");
		header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
		header("Last-Modified: " . gmdate("D, d M Y H:i:s") . "GMT");
		header("Cache-Control: no-cache, must-revalidate");
		header("Pragma: no-cache");
		//header("Content-type: text/x-json");
		header("Content-Type: application/json; Charset=UTF-8");
		$json = json_encode_safe($arr);
		//$logger->log('process:int_send_array_as_json=' . print_r($json, true), PEAR_LOG_DEBUG);
		echo $json;
	}

	/**
	 * procLogin - Processes the user submitted login form, if errors
	 * are found, the user is redirected to correct the information,
	 * if not, the user is effectively logged in to the system.
	 */
	function procLogin() {
		global $session, $database, $form/*, $logger*/;

		$session->cehost = $_REQUEST['cehost'];

		//$logger->log("procLogin:post=".print_r($session->syssession, true));

//		$retval = $session->login($_POST['number'], $_POST['user'], $_POST['pass'],
//			isset($_POST['remember']), $_POST['checknumber']);
		$retval = $session->login($_REQUEST['number'], $_REQUEST['user'], $_REQUEST['pass'],
			isset($_REQUEST['remember']), $_REQUEST['checknumber']);
		if ($retval) {
			//changelog
			$database->logOfficeChange(CL_OF_UAC_LOGIN, $session->ofid, 0, "Успешная авторизация.");

		} else {
			$database->logOfficeChange(CL_OF_UAC_LOGIN_FAIL, -1, 0, "Неуспешная попытка авторизации под пользователем '{$_REQUEST['user']}' в офисе '{$_REQUEST['number']}'.");
			$session->value_array = $_REQUEST;
			$session->error_array = $form->getErrorArray();
		}



		if($session->comref){
//		if($_REQUEST['comref']){
//			if ($retval) {
			$this->jsonres = array('ok' => true);
//			} else {
//			$this->jsonres = array('ok' => false);
//			}
			//$this->int_send_array_as_json($this->jsonres);
			$json = json_encode($this->jsonres);
			echo $_REQUEST['callback'].'('.$json.')';
		} else {
			header("Location: ".$session->referrer);
		}



	}

	/**
	* procLogout - Simply attempts to log the user out of the system
	* given that there is no logout form to process.
	*/
	function procLogout() {
		global $session, $database, $logger;

		//$logger->log("procLogout:post=".print_r($_POST, true));
		//$logger->log("procLogout:sess=".print_r($session->syssession, true));

		//changelog
		$database->logOfficeChange(CL_OF_UAC_LOGOUT, $session->ofid, 0, "Разавторизация.");

		$cehost = $session->cehost;
		if($session->comref){
			$session->logout();

/*			// general enterance session destroy
			session_name('comref');
			session_start();
			$_SESSION = array();
			unset($COOKIE[session_name()]);
			session_destroy();*/

			//header("Location: ".CE_HOST."/index.php");
			//header("Location: ".CE_HOST_IDX);
			header("Location: ".$cehost);
			
		} else {
			$session->logout();
			header("Location: main.php");
		}
	}

	/**
	* procEditNumbersExt - Edit external office numbers page.
	*/
	function procEditNumbersExt(){
		global $database, $session, $form, $logger;

		// access level control
		if(!($session->checkUserRight('numbers_ext.php','W'))){
			$session->only_read_message=MSG_READONLY;
			header("Location: ".$session->referrer);
			return;
		}

		/* edit attempt */
		//$retval = $session->editNumbers($_POST['curpass'], $_POST['newpass'], $_POST['email']);
		$retval = true;

		/* edit successful */
		if ($retval) {
			$session->edit_numbers_ext = true;
			//$logger->log("procEditNumbersExt:ref=".$session->referrer);
			//$logger->log("procEditNumbersExt:post=".print_r($_POST, true));

			$last_db_number_id = $_POST["last_number_id"];
			$arrIDs = explode(",", trim($_POST['hidChangedNumberIDHolder'], ','));
			//$logger->log("procEditNumbersExt:arrIDs=".print_r($arrIDs, true));
			foreach ($arrIDs as $id) {
				//if (eregi("^([-|+]?)([0-9])+$", $ext_num_id)) {
				if (preg_match('/^([-]*\d+)$/', $id) === 1) {
					//detect mode
					if ($id[0] == '-')
						$mode = abs($id) > $last_db_number_id ? 'NONE' : 'DELETE';
					else
						$mode = abs($id) > $last_db_number_id ? 'ADD' : 'UPDATE';

					//mode-related actions
					//$id = str_ireplace("-", "", $id);
					$id = abs($id);
					$db_id = (int)$id;
					$ext_number = stripslashes($_POST["ext_number_$id"]);
					switch ($mode) {
						case 'NONE':
							continue 2;
						case 'ADD':
							$db_id = -1;
							break;
						case 'DELETE':
							$ext_number = "";
							break;
					}
					//$logger->log("procEditNumbersExt:MODE=".$mode);

					$database->updateNumberExt($session->ofid,
												$db_id,
												preg_replace('/\s[\s]+/', '', $ext_number),
												preg_replace('/\s\s+/u', ' ', stripslashes($_POST["ext_number_about_$id"])));
				}
			}
		} else {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}
		header("Location: ".$session->referrer);
	}

	/**
	* procEditNumbersInt - Edit internal office numbers page.
	*/
	function procEditNumbersInt(){
		global $database, $session, $form, $logger;

		// access level control
		if(!($session->checkUserRight('numbers_int.php','W'))){
			$session->only_read_message=MSG_READONLY;
			header("Location: ".$session->referrer);
			return;
		}

		$retval = true;

		if ($retval) {
			$session->edit_numbers_int = true;
			//$logger->log("procEditNumbersInt:ref=".$session->referrer);
			//$logger->log("procEditNumbersInt:post=".print_r($_POST, true));

			$last_db_number_id = $_POST["last_number_id"];

			//create/update internal numbers
			$arrIDs = explode(',', trim($_POST['hidChangedNumberIDHolder'], ','));
			//$logger->log("procEditNumbersInt:arrIDs=".print_r($arrIDs, true));
			foreach ($arrIDs as $id_ex) {
				//if (eregi("^([-|+]?)([0-9])+$", $ext_num_id)) {
				if (preg_match('/^([-]*\d+)$/', $id_ex) === 1) {
					$id = $id_ex;
					//$logger->log("id=$id");
					//detect mode
					if ($id[0] == '-') {
						if (abs($id) > $last_db_number_id) {
							$mode = 'NONE';
						} else {
							$mode = 'DELETE';
						}
					} else
					if (abs($id) > $last_db_number_id) {
						$mode = 'ADD';
					} else {
						$mode = 'UPDATE';
					}

					//mode-related actions
					//$id = str_ireplace("-", "", $id);
					$id = abs($id);
					$db_id = (int)$id;
					$int_number = stripslashes($_POST["int_number_$id"]);
					switch ($mode) {
						case 'NONE':
							continue 2;
						case 'ADD':
							$db_id = -1;
							break;
						case 'DELETE':
							$int_number = "";
							break;
					}
					//$logger->log("procEditNumbersInt:MODE=".$mode);

					$database->updateNumberInt($session->ofid,
												$db_id,
												preg_replace('/\s[\s]+/', '', $int_number),
												$_POST["dials_$id"],
												$_POST["ignore_graph_$id"],
												preg_replace('/\s\s+/u', ' ', stripslashes($_POST["int_number_about_$id"])));
				}
			}
		} else {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}
		header("Location: ".$session->referrer);
	}

	/**
	* procEditNumbersBlackWhite - Edit black and white numbers lists.
	*/
	function procEditNumbersBlackWhite() {
		global $database, $session, $form, $logger;

		// access level control
		if(!($session->checkUserRight('numbers_bw.php','W'))){
			$session->only_read_message=MSG_READONLY;
			header("Location: ".$session->referrer);
			return;
		}

		/* edit attempt */
		$retval = true;

		//$logger->log("procEditNumbersBlackWhite:ref=".$session->referrer);
		//$logger->log("procEditNumbersBlackWhite:post=".print_r($_POST, true));

		/* edit successful */
		if ($retval) {
			$session->edit_numbers_bw = true;

			if ($session->isAnyAdmin()) {
				$database->setOfficeParam($session->ofid,
								PARAM_BLACKLIST_ENABLED,
								intval(isset($_POST[PARAM_BLACKLIST_ENABLED]) && $_POST[PARAM_BLACKLIST_ENABLED] != 0));
				$database->setOfficeParam($session->ofid,
								PARAM_WHITELIST_ENABLED,
								intval(isset($_POST[PARAM_WHITELIST_ENABLED]) && $_POST[PARAM_WHITELIST_ENABLED] != 0));
			}
			//empty LISTS
			$database->query("delete from tb_numbers_black where of_id={$session->ofid}");
			$database->query("delete from tb_numbers_white where of_id={$session->ofid}");

			$last_db_number_id = $_POST["last_bwnumber_id"];
			$arrDelIDs = explode(",", trim($_POST['hidChangedNumberIDHolder'], ','));
			//$logger->log("procEditNumbersBlackWhite:arrDelIDs=".print_r($arrDelIDs, true));
			for ($id=0;$id<=$last_db_number_id;$id++) {
				//ToDo: check if id in deleted list
				if (in_array("-$id", $arrDelIDs))
					continue;

				if (isset($_POST["bw_number_black_$id"])) {
					$listname = 'black';
					$bwnumber = $_POST["bw_number_black_$id"];
					$exactmatch = intval(isset($_POST["exactmatch_black_$id"]) && $_POST["exactmatch_black_$id"] != 0);
				} elseif (isset($_POST["bw_number_white_$id"])) {
					$listname = 'white';
					$bwnumber = $_POST["bw_number_white_$id"];
					$exactmatch = intval(isset($_POST["exactmatch_white_$id"]) && $_POST["exactmatch_white_$id"] != 0);
				} else
					continue;

				$database->updateNumberBW($session->ofid, preg_replace('/\s[\s]+/', '', $bwnumber), $exactmatch, $listname);
			}
		} else {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}
		header("Location: ".$session->referrer);
	}

	/**
	* procEditDials - Edit office dial lists page.
	*/
	function procEditDials(){
		global $database, $session, $form, $logger;

		// access level control
		if(!($session->checkUserRight('dials.php','W'))){
			$session->only_read_message=MSG_READONLY;
			header("Location: ".$session->referrer);
			return;
		}


		//$session->referrer = '/dials.php';
		//$logger->log("procEditDials:POST=".print_r($_POST, true));

		$retval = true;

		if ($retval) {
			$session->edit_dials = true;

			$last_id = $_POST["last_id"];
			$last_dials_id = $_POST["last_dials_id"];
			$last_db_dials_id = $_POST["last_db_dials_id"];

			//get deleted dials
			$arrDeletedDialIDs = array();
			$arrTmp = explode(',', trim($_POST['hidChangedIDHolder'], ','));
			//$logger->log("arrDeletedDialIDs PRE=".print_r($arrTmp, true));
			foreach ($arrTmp as $id_ex) {
				if (preg_match('/^(?P<id>[-]*\d+)_(\d+)$/', $id_ex, $matches) === 1 && $matches['id'] < 0)
					$arrDeletedDialIDs[abs($matches['id'])] = true;
			}
			//$logger->log("arrDeletedDialIDs=".print_r($arrDeletedDialIDs, true));

			//create new dials_lists
			$arrChangedDials = explode(',', trim($_POST['hidChangedIDHolderEx'], ','));
			$arrDialListIDs = array();
			for ($i = 0; $i <= $last_dials_id; $i++) {
				if (isset($_POST["dials_name_$i"]) &&
					in_array($i, $arrChangedDials) || in_array(-$i, $arrChangedDials)) {
					if ((strlen(trim($_POST["dials_name_$i"])) == 0) && ($i > $last_db_dials_id))
						continue;
						
					// take current values from base if is not defined (not visible in GUI), else from GUI
					// если нет прав на изменение данных параметров, то их значения берутся из базы				
					$dials_id = $i > $last_db_dials_id ? -1 : $i;
					$res = $database->getQueryResultAsArray("select first 1 * from tb_dials_list where dials_id = $dials_id");
					if ($res) {
						$do_recording_curval = $session->userright['dials_record']['act_visible'] == 1 ? $_POST["dialslistoption_do_recording_$i"] : intval($res[0]['do_recording']);
						$call_is_owner_curval = $session->userright['call_is_owner']['act_visible'] == 1 ? $_POST["dialslistoption_call_is_owner_$i"] : intval($res[0]['call_is_owner']);
						$can_redirect_curval = $session->userright['can_redirect']['act_visible'] == 1 ? $_POST["dialslistoption_can_redirect_$i"] : intval($res[0]['can_redirect']);
						$can_conference_curval = $session->userright['can_conference']['act_visible'] == 1 ? $_POST["dialslistoption_can_conference_$i"] : intval($res[0]['can_conference']);
					} else {
						$do_recording_curval = $session->userright['dials_record']['act_visible'] == 1 ? $_POST["dialslistoption_do_recording_$i"] : 0;
						$call_is_owner_curval = $session->userright['call_is_owner']['act_visible'] == 1 ? $_POST["dialslistoption_call_is_owner_$i"] : 0;
						$can_redirect_curval = $session->userright['can_redirect']['act_visible'] == 1 ? $_POST["dialslistoption_can_redirect_$i"] : 0;
						$can_conference_curval = $session->userright['can_conference']['act_visible'] == 1 ? $_POST["dialslistoption_can_conference_$i"] : 0;
					}

					
					$dbres = $database->updateDialList($session->ofid,
						$i > $last_db_dials_id ? -1 : $i,
						isset($_POST["dials_name_$i"]) ? trim(stripslashes($_POST["dials_name_$i"])) : null,
						isset($_POST["dialslistoption_dial_mode_$i"]) ? $_POST["dialslistoption_dial_mode_$i"] : null,
						isset($_POST["dialslistoption_wait_answer_pause_$i"]) ? $_POST["dialslistoption_wait_answer_pause_$i"] : null,
						isset($_POST["dialslistoption_redial_pause_$i"]) ? $_POST["dialslistoption_redial_pause_$i"] : null,
						isset($_POST["dialslistoption_redial_count_$i"]) ? $_POST["dialslistoption_redial_count_$i"] : null,
						isset($_POST["dialslistoption_wait_answer_phrase_$i"]) ? trim(stripslashes($_POST["dialslistoption_wait_answer_phrase_$i"])) : null,
						isset($_POST["dialslistoption_wait_redial_phrase_$i"]) ? trim(stripslashes($_POST["dialslistoption_wait_redial_phrase_$i"])) : null,
						isset($_POST["dialslistoption_say_aon_$i"]) ? $_POST["dialslistoption_say_aon_$i"] : 0,
						isset($_POST["dialslistoption_translate_real_aon_$i"]) ? $_POST["dialslistoption_translate_real_aon_$i"] : 0,
//						isset($_POST["dialslistoption_do_recording_$i"]) ? $_POST["dialslistoption_do_recording_$i"] : 0,
//						isset($_POST["dialslistoption_call_is_owner_$i"]) ? $_POST["dialslistoption_call_is_owner_$i"] : 0,
//						isset($_POST["dialslistoption_can_redirect_$i"]) ? $_POST["dialslistoption_can_redirect_$i"] : 0,
//						isset($_POST["dialslistoption_can_conference_$i"]) ? $_POST["dialslistoption_can_conference_$i"] : 0,
						$do_recording_curval,
						$call_is_owner_curval,
						$can_redirect_curval,
						$can_conference_curval,
						isset($_POST["dialslistoption_wait_conn_phrase_$i"]) ? trim(stripslashes($_POST["dialslistoption_wait_conn_phrase_$i"])) : null,
						isset($_POST["dialslistoption_new_dial_symbols_$i"]) ? trim(stripslashes($_POST["dialslistoption_new_dial_symbols_$i"])) : null,
						isset($_POST["dialslistoption_dial_ret_symbols_$i"]) ? trim(stripslashes($_POST["dialslistoption_dial_ret_symbols_$i"])) : null,
						isset($_POST["dialslistoption_conn_ret_symbols_$i"]) ? trim(stripslashes($_POST["dialslistoption_conn_ret_symbols_$i"])) : null,
						isset($_POST["dialslistoption_ivr_ret_symbols_$i"]) ? trim(stripslashes($_POST["dialslistoption_ivr_ret_symbols_$i"])) : null,
						isset($_POST["dialslistoption_ready_2_dial_phrase_$i"]) ? trim(stripslashes($_POST["dialslistoption_ready_2_dial_phrase_$i"])) : null,
						isset($_POST["dialslistoption_dtmf_retranslate_$i"]) ? $_POST["dialslistoption_dtmf_retranslate_$i"] : 0
						);
					if ($dbres[0]['op_result'] == 1)
						$arrDialListIDs[$i] = $dbres[0]['out_dials_id'];
				}
			}
			//$logger->log("arrDialListIDs=".print_r($arrDialListIDs, true));

			//begin_trans
			$database->transactionStart();

			//empty TB_DIALS
			foreach ($arrDialListIDs as $idl)
				$database->query("delete from tb_dials where dials_id=$idl");

			//create dials
			$arrDialsPostData = array();
			for ($id = 0; $id <= $last_id; $id++) {
				for ($idl = 0; $idl <= $last_dials_id; $idl++) {
					if (array_key_exists($idl, $arrDialListIDs) && isset($_POST["number_id_{$id}_{$idl}"]) && !array_key_exists($id, $arrDeletedDialIDs)) {
						$arrDialsPostData[] = array($arrDialListIDs[$idl],
													$_POST["number_id_{$id}_{$idl}"],
													$_POST["dials_position_{$id}_{$idl}"],
													$_POST["graph_id_{$id}_{$idl}"],
													$_POST["countlines_{$id}_{$idl}"]);
					}
				}
			}
			if ($database->updateDialsMultiple($session->ofid, $arrDialsPostData))
				$database->transactionCommit();
			else
				$database->transactionRollback();
			//end_trans
		} else {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}
		header("Location: ".$session->referrer);
	}

	/**
	* procEditGraphs - Edit office graphics page.
	*/
	function procEditGraphs(){
		global $database, $session, $form, $logger;

		// access level control
		if( !($session->checkUserRight('graphs.php','W')) ){
			$session->only_read_message=MSG_READONLY;
			header("Location: ".$session->referrer);
			return;
		}

		//$retval = $session->editNumbers($_POST['curpass'], $_POST['newpass'], $_POST['email']);
		$retval = true;

		if ($retval) {
			$session->edit_graphs = true;
			//$logger->log("procEditGraphs:ref=".$session->referrer);
			//$logger->log("procEditGraphs:post=".print_r($_POST, true));

			$last_id = $_POST["last_id"];
			$last_graph_id = $_POST["last_graph_id"];
			$last_db_graph_id = $_POST["last_db_graph_id"];

			//get deleted dials
			$arrDeletedGraphIDs = array();
			$arrTmp = explode(",", trim($_POST['hidChangedIDHolder'], ','));
			foreach ($arrTmp as $id_ex) {
				if (preg_match('/^(?P<id>[-]*\d+)_(\d+)$/', $id_ex, $matches) == 1 && $matches['id'] < 0)
					$arrDeletedGraphIDs[abs($matches['id'])] = true;
			}
			//$logger->log("arrDeletedGraphIDs=".print_r($arrDeletedGraphIDs, true));

			//create new graph_lists
			$arrGraphListIDs = array();
			for ($i = 0; $i <= $last_graph_id; $i++) {
				if (isset($_POST["graph_name_$i"])) {
					if ((strlen(trim($_POST["graph_name_$i"])) == 0) && ($i > $last_db_graph_id))
						continue;
					$dbres = $database->updateGraphList($session->ofid,
						$i > $last_db_graph_id ? -1 : $i,
						stripslashes($_POST["graph_name_$i"]));
					if ($dbres[0]['op_result'] == 1)
						$arrGraphListIDs[$i] = $dbres[0]['out_graph_id'];
				}
			}
			//$logger->log("arrGraphListIDs=".print_r($arrGraphListIDs, true));

			//begin_trans
			$database->transactionStart();

			//empty TB_GRAPHICS
			foreach ($arrGraphListIDs as $idl) {
				$database->query("delete from tb_graphics where graph_id=$idl");
			}

			//create graphs
			$arrGraphsPostData = array();
			for ($id = 0; $id <= $last_id; $id++) {
				for ($idl = 0; $idl <= $last_graph_id; $idl++) {
					if (array_key_exists($idl, $arrGraphListIDs) && isset($_POST["daygroup_id_{$id}_{$idl}"]) && !array_key_exists($id, $arrDeletedGraphIDs)) {
						$arrGraphsPostData[] = array($arrGraphListIDs[$idl],
													$_POST["daygroup_id_{$id}_{$idl}"],
													$_POST["start_time_h_{$id}_{$idl}"] * 100 + $_POST["start_time_m_{$id}_{$idl}"],
													$_POST["end_time_h_{$id}_{$idl}"] * 100 + $_POST["end_time_m_{$id}_{$idl}"]);
					}
				}
			}
			if (!$arrGraphsPostData || ($database->updateGraphsMultiple($session->ofid, $arrGraphsPostData)))
				$database->transactionCommit();
			else
				$database->transactionRollback();
			//end_trans
		} else {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}
		header("Location: ".$session->referrer);
	}

	/**
	 * procEditDayGroups - Edit office day groups page.
	 */
	function procEditDayGroups(){
		global $database, $session, $form, $logger;

		// access level control
		if(!($session->checkUserRight('daygroups.php','W'))){
			$session->only_read_message=MSG_READONLY;
			header("Location: ".$session->referrer);
			return;
		}

		$retval = true;
		if ($retval) {
			$session->edit_daygroups = true;
			//$logger->log("procEditDayGroups:ref=".$session->referrer);
			//$logger->log("procEditDayGroups:post=".print_r($_POST, true));

			$last_id = $_POST["last_id"];
			$last_daygroup_id = $_POST["last_daygroup_id"];
			$last_db_daygroup_id = $_POST["last_db_daygroup_id"];

			//get deleted
			$arrDeletedIDs = array();
			$arrTmp = explode(",", trim($_POST['hidChangedIDHolder'], ','));
			foreach ($arrTmp as $id_ex) {
				if (preg_match('/^(?P<id>[-]*\d+)_(\d+)$/', $id_ex, $matches) == 1 && $matches['id'] < 0)
					$arrDeletedIDs[abs($matches['id'])] = true;
			}
			//$logger->log("arrDeletedIDs=".print_r($arrDeletedIDs, true));

			//create new day_groups
			$arrDayGroupsIDs = array();
			for ($i = 0; $i <= $last_daygroup_id; $i++) {
				if (isset($_POST["daygroup_name_$i"])) {
					if ((strlen(trim($_POST["daygroup_name_$i"])) == 0) && ($i > $last_db_daygroup_id))
						continue;
					$dbres = $database->updateDayGroup($session->ofid,
														$i > $last_db_daygroup_id ? -1 : $i,
														stripslashes($_POST["daygroup_name_$i"]));
					if ($dbres[0]['op_result'] == 1)
						$arrDayGroupsIDs[$i] = $dbres[0]['out_daygroup_id'];
				}
			}
			//$logger->log("arrDayGroupsIDs=".print_r($arrDayGroupsIDs, true));

			//weekdays
			for ($i = 0; $i <= $last_daygroup_id; $i++) {
				if (isset($_POST["daygroup_name_$i"])) {
					$weekdays_mask = 0;
					for ($day_id = 0; $day_id <= 6; $day_id++) {
						if (isset($_POST["weekday_{$i}_{$day_id}"]))
							$weekdays_mask = $weekdays_mask | pow(2, $day_id);
					}
					$dbres = $database->updateWeekDays_Mask($arrDayGroupsIDs[$i], $weekdays_mask);
				}
			}

			//begin_trans
			$database->transactionStart();

			//empty TB_HOLLYDAYS
			foreach ($arrDayGroupsIDs as $idl)
				$database->query("delete from tb_hollydays where daygroup_id=$idl");

			//create hollydays
			$arrDaysPostData = array();
			for ($id = 0; $id <= $last_id; $id++) {
				for ($idl = 0; $idl <= $last_daygroup_id; $idl++) {
					if (array_key_exists($idl, $arrDayGroupsIDs) &&
						isset($_POST["hollyday_{$id}_{$idl}"]) &&
						!array_key_exists($id, $arrDeletedIDs)) {
						$arrDaysPostData[] = array($_POST["hollyday_{$id}_{$idl}"],
													$arrDayGroupsIDs[$idl],
													stripslashes($_POST["hollyday_name_{$id}_{$idl}"]));
					}
				}
			}

			if (!$arrDaysPostData || ($database->updateDaysMultiple($session->ofid, $arrDaysPostData)))
				$database->transactionCommit();
			else
				$database->transactionRollback();
			//end_trans
		} else {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}
		header("Location: ".$session->referrer);
	}

	/**
	 * procChangelog
	 */
	function procChangelog() {
		global $session, $form;

		$retval = true;
		if ($retval) {
			$session->edit_changelog = true;
		} else {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}
		header("Location: ".$session->referrer);
	}

	/**
	 * procEditOfficeParams
	 */
	function procEditOfficeParams() {
		global $database, $database_tar, $session, $form;

		// access level control
		if(!($session->checkUserRight('setup.php','W'))){
			$session->only_read_message=MSG_READONLY;
			header("Location: ".$session->referrer);
			return;
		}

		$retval = true;
		if ($retval) {
			$session->edit_main = true;

			$database->setOfficeParam($session->ofid,
										PARAM_EMAIL_NOTIFY_FAX_ADDRESS,
										$_POST[PARAM_EMAIL_NOTIFY_FAX_ADDRESS]);
			$database->setOfficeParam($session->ofid,
										PARAM_EMAIL_NOTIFY_FAX_ENABLED,
										intval(isset($_POST[PARAM_EMAIL_NOTIFY_FAX_ENABLED]) && $_POST[PARAM_EMAIL_NOTIFY_FAX_ENABLED] != 0));
			$database->setOfficeParam($session->ofid,
										PARAM_EMAIL_NOTIFY_VOICE_ADDRESS,
										$_POST[PARAM_EMAIL_NOTIFY_VOICE_ADDRESS]);
			$database->setOfficeParam($session->ofid,
										PARAM_EMAIL_NOTIFY_VOICE_ENABLED,
										intval(isset($_POST[PARAM_EMAIL_NOTIFY_VOICE_ENABLED]) && $_POST[PARAM_EMAIL_NOTIFY_VOICE_ENABLED] != 0));
			$database->setOfficeParam($session->ofid,
										PARAM_EMAIL_STATS_ADDRESS,
										$_POST[PARAM_EMAIL_STATS_ADDRESS]);

			$database->setOfficeParam($session->ofid,
										PARAM_NOTIFY_LOWBALANCE_ENABLED,
										intval(isset($_POST[PARAM_NOTIFY_LOWBALANCE_ENABLED]) && $_POST[PARAM_NOTIFY_LOWBALANCE_ENABLED] != 0
												&& is_numeric($_POST[PARAM_NOTIFY_LOWBALANCE_VALUE])
												&& (!empty($_POST[PARAM_NOTIFY_LOWBALANCE_ADDRESS]) || !empty($_POST[PARAM_NOTIFY_LOWBALANCE_PHONES]))
										));
			$database->setOfficeParam($session->ofid,
										PARAM_NOTIFY_LOWBALANCE_VALUE,
										trim($_POST[PARAM_NOTIFY_LOWBALANCE_VALUE]));
			$database->setOfficeParam($session->ofid,
										PARAM_NOTIFY_LOWBALANCE_ADDRESS,
										preg_replace('/\s[\s]+/', '', $_POST[PARAM_NOTIFY_LOWBALANCE_ADDRESS]));
			$database->setOfficeParam($session->ofid,
										PARAM_NOTIFY_LOWBALANCE_PHONES,
										preg_replace('/[^\d;]/', '', $_POST[PARAM_NOTIFY_LOWBALANCE_PHONES]));
			//update tm notify task
			$ofparams = $database->getOfficeParams($session->ofid);
			$num = DB_TAR_DEBUG ? DB_TAR_DEBUG_NUMBER : DB_TAR_FEDERAL_PREFIX . $session->ofnumber;
			$database_tar->updateLowBalanceNotifyTask($num,
				$ofparams[PARAM_NOTIFY_LOWBALANCE_VALUE]['pvalue'],
				$ofparams[PARAM_NOTIFY_LOWBALANCE_ADDRESS]['pvalue'],
				$ofparams[PARAM_NOTIFY_LOWBALANCE_PHONES]['pvalue'],
				'Ваш баланс менее ' . $ofparams[PARAM_NOTIFY_LOWBALANCE_VALUE]['pvalue'],
				!isset($ofparams[PARAM_NOTIFY_LOWBALANCE_ENABLED]) || $ofparams[PARAM_NOTIFY_LOWBALANCE_ENABLED]['pvalue'] == 0);
		} else {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}
		header("Location: ".$session->referrer);
	}

	/**
	 * procEditOfficeNotifyParams
	 */
	function procEditOfficeNotifyParams() {
		global $database, $database_tar, $session, $form;

		$retval = true;
		if ($retval) {
			$session->edit_notify = true;

			$database->setOfficeParam($session->ofid,
										PARAM_NOTIFY_LOWBALANCE_ENABLED,
										intval(isset($_POST[PARAM_NOTIFY_LOWBALANCE_ENABLED]) && $_POST[PARAM_NOTIFY_LOWBALANCE_ENABLED] != 0
												&& is_numeric($_POST[PARAM_NOTIFY_LOWBALANCE_VALUE])
												&& (!empty($_POST[PARAM_NOTIFY_LOWBALANCE_ADDRESS]) || !empty($_POST[PARAM_NOTIFY_LOWBALANCE_PHONES]))
										));
			$database->setOfficeParam($session->ofid,
										PARAM_NOTIFY_LOWBALANCE_VALUE,
										trim($_POST[PARAM_NOTIFY_LOWBALANCE_VALUE]));
			$database->setOfficeParam($session->ofid,
										PARAM_NOTIFY_LOWBALANCE_ADDRESS,
										preg_replace('/\s[\s]+/', '', $_POST[PARAM_NOTIFY_LOWBALANCE_ADDRESS]));
			$database->setOfficeParam($session->ofid,
										PARAM_NOTIFY_LOWBALANCE_PHONES,
										preg_replace('/[^\d;]/', '', $_POST[PARAM_NOTIFY_LOWBALANCE_PHONES]));
			//update tm notify task
			$ofparams = $database->getOfficeParams($session->ofid);
			$num = DB_TAR_DEBUG ? DB_TAR_DEBUG_NUMBER : DB_TAR_FEDERAL_PREFIX . $session->ofnumber;
			$database_tar->updateLowBalanceNotifyTask($num,
				$ofparams[PARAM_NOTIFY_LOWBALANCE_VALUE]['pvalue'],
				$ofparams[PARAM_NOTIFY_LOWBALANCE_ADDRESS]['pvalue'],
				$ofparams[PARAM_NOTIFY_LOWBALANCE_PHONES]['pvalue'],
				'Ваш баланс меньше ' . $ofparams[PARAM_NOTIFY_LOWBALANCE_VALUE]['pvalue'],
				!isset($ofparams[PARAM_NOTIFY_LOWBALANCE_ENABLED]) || $ofparams[PARAM_NOTIFY_LOWBALANCE_ENABLED]['pvalue'] == 0);
		} else {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}
		header("Location: ".$session->referrer);
	}

	/**
	 * procEditOffices - Edit office page.
	 * @param $mode
	 */
	function procEditOffices($mode) {
		global $database, $database_dynmenu, $session, $form, $logger, $database_tar;

		//$logger->log("procEditOffices($mode):".print_r($_POST, true));

		$session->edit_offices = true;

		switch ($mode) {
			case 'show':
				$session->edit_offices_show_id = $_POST['officeselector'];
				break;

			case 'delete':
				// access level control
				if(!($session->checkUserRight('adm_offices_make','W'))){
					$session->only_read_message=MSG_READONLY;
					break;
				}

				$newid = $database->deleteOffice($_POST['officeselector']);
				if ($newid < 0 || $newid === null) {
					$form->setError('officesearch', "* Ошибка удаления офиса.");
					if (is_numeric($newid))
						$session->edit_offices_show_id = abs($newid);
				} else
					$session->edit_offices_show_id = null;
				break;

			case 'search':
				if (strlen(trim($_POST['officesearch'])) == 0) {
					$form->setError('officesearch', "* Ошибка! Не задан номер телефона для поиска.");
					break;
				}

				$newid = $database->searchOffice($_POST['officesearch']);
				$session->edit_offices_show_id = is_numeric($newid) ? $newid : false;

				if ($session->edit_offices_show_id === false)
					$form->setError('officesearch', "Офис с указанным номером телефона ({$_POST['officesearch']}) не найден.");

				break;

			case 'blank':
			case 'clone':
				// access level control
				if(!($session->checkUserRight('adm_offices_make','W'))){
					$session->only_read_message=MSG_READONLY;
					break;
				}

				if (strlen(trim($_POST['officecreate_number'])) == 0) {
					$form->setError('officecreate', "* Ошибка! Должны быть заполнены все обязательные поля формы.");
					break;
				}
				if (!is_numeric($_POST['officecreate_number'])) {
					$form->setError('officecreate', "* Ошибка! Телефонный номер содержит странные символы.");
					break;
				}

				if ($mode == 'blank' || !is_numeric($_POST['officeselector']))
					$newid = $database->createOfficeBlank($_POST['officecreate_number'], $_POST['officecreate_name']);
				else {
					$newid = $database->createOfficeClone($_POST['officeselector'], $_POST['officeoption_of_menu'],
						$_POST['officecreate_number']);
					if (is_numeric($newid) && $newid >= 0) {
						$database->setOfficeDescription($newid, $_POST['officecreate_name']);
						$new_menuid = $database_dynmenu->cloneMenu($_POST['officeoption_of_menu'], 'Сценарий офиса ' . $_POST['officecreate_number']);
						if ($new_menuid >= 0)
							$database->setOfficeMenu($newid, $new_menuid);
					}
				}

				if ($newid < 0) {
					$form->setError('officecreate', "* Ошибка! Уже существует офис с указанным номером телефона.");
					$session->edit_offices_show_id = abs($newid);
				} else
					$session->edit_offices_show_id = is_numeric($newid) ? $newid : $_POST['officeselector'];
				break;

			case 'save':
				// access level control
				/*if(!($session->checkUserRight('adm_offices.php','W'))){
					$session->only_read_message=MSG_READONLY;
					break;
				}*/
				if( !(($session->checkUserRight('adm_offices.php','W')) || ($session->checkUserRight('acc_users.php','W'))) ){
					$session->only_read_message=MSG_READONLY;
					break;
				}



				$officeid = $_POST['officeselector'];
				//$officenum = $_POST['officeoption_of_number'];

				// при добавлении пользователя владельцем офиса (когда номер офиса известен заранее из сессии)
				$officenum = $session->ofnumber;
				// при добавлении пользователя администратором системы (когда номер офиса определяется переменной)
				if(empty($officenum)) { $officenum = $_POST['officeoption_of_number']; }

				$err = '';
				

				//process main office params
				if ($_POST['hidChangedOfficeIDHolder'] == 1) {
					$database->setOfficeDescription($officeid, $_POST['office_name']);
					$database->setOfficeMenu($officeid, $_POST['officeoption_of_menu']);

					$database_tar->setOfficeBox($_POST['officeoption_of_number'],$_POST['officeoption_maxsize'],$_POST['officeoption_boxloop']);
					$database_tar->setOfficeSIP($_POST['officeoption_of_number'],$_POST['officeoption_sipcount']);
					
					$newid = $database->setOfficeNumber($officeid, $_POST['officeoption_of_number'], $_POST['officeoption_of_number_prefix'], $_POST['officeoption_of_autoanswer']);
					if ($newid === null)
						$err .= "* Внутренняя ошибка изменения номера телефона.<br>";
					elseif ($newid < 0 && $newid != -$officeid)
						$err .= "* Ошибка изменения номера телефона. Уже зарегистрирован офис с номером {$_POST['officeoption_of_number']}.<br>";
				}

				//process office users
				$last_db_officeuser_id = $_POST["last_db_officeuser_id"];
				$last_officeuser_id = $_POST["last_officeuser_id"];

				$uids = explode(',', trim($_POST['hidChangedUserIDHolder'], ','));
				foreach ($uids as $uid) {
					if (preg_match('/^([-]*\d+)$/', $uid) === 1) {
						if (!($uid[0] == '-' && $uid > $last_db_officeuser_id)) {
							$psw = $_POST['user_pass_'.abs($uid)];
							if ($_POST['user_pass_'.abs($uid)].$_POST['user_pass2_'.abs($uid)] == '<unchanged><unchanged>')
								$psw = null;
							elseif ($_POST['user_pass_'.abs($uid)] != '<unchanged>' &&
								$_POST['user_pass_'.abs($uid)] != '' &&
								$_POST['user_pass_'.abs($uid)] != $_POST['user_pass2_'.abs($uid)]) {
								$psw = null;
								$err .= "* Пароль пользователя '{$_POST['user_name_'.abs($uid)]}' не совпадает с подтверждением.<br>";
							} elseif ($_POST['user_pass_'.abs($uid)].$_POST['user_pass2_'.abs($uid)] == '')
								$err .= "* Пароль пользователя '{$_POST['user_name_'.abs($uid)]}' не задан.<br>";

							$user_name_by_id = $database->UserNameByID($uid);

							$database->modifyOfficeUser($officeid,
								abs($uid) <= $last_db_officeuser_id ? $uid : null,
								$_POST['user_name_'.abs($uid)], $_POST['user_role_'.abs($uid)], $psw, $_POST['user_mail_'.abs($uid)]);

							$database_tar->modifyAccountWeb($officenum,
								abs($uid) <= $last_db_officeuser_id ? $uid : null,
								$_POST['user_name_'.abs($uid)], $psw, $_POST['user_mail_'.abs($uid)], $user_name_by_id);
						}
					}
				}

				if ($err)
					$form->setError('officesearch', $err);

				break;

			case 'save_number':
				$rowcounter=$_POST['hidOfficeNumberCounterHolder'];


				for ($i = 1; $i <= $rowcounter; $i++) {
				if($_POST['rowtype_ofnum_'.abs($i)]!='view'){
					$database->modifyOfficeNumber(
						(int)$_POST['of_number_id_'.abs($i)],
						(int)$_POST['officeselector'],
						$_POST['of_number_'.abs($i)],
						$_POST['of_number_prefix_'.abs($i)],
						(int)$_POST['of_default_num_'.abs($i)],
						$_POST['rowtype_ofnum_'.abs($i)]
					);
				}
				}


/*
				for ($i = 1; $i <= $rowcounter; $i++) {

				$result = '';
				$result = $database->checkOfficeNumber(
					(int)$_POST['of_number_id_'.abs($i)],
					(int)$_POST['officeselector'],
					$_POST['of_number_'.abs($i)],
					$_POST['rowtype_ofnum_'.abs($i)]
					);
				if(!empty($result)){
//					$form->setError('officecreate', "* Ошибка! Уже существует офис с указанным номером телефона.");
					exit();
				}
				else{
				if($_POST['rowtype_ofnum_'.abs($i)]!='view'){
					$database->modifyOfficeNumber(
						(int)$_POST['of_number_id_'.abs($i)],
						(int)$_POST['officeselector'],
						$_POST['of_number_'.abs($i)],
						$_POST['of_number_prefix_'.abs($i)],
						(int)$_POST['of_default_num_'.abs($i)],
						$_POST['rowtype_ofnum_'.abs($i)]
					);
				}
				}

				}
*/

				if ($err)
					$form->setError('office_number_table_error', $err);

				break;
				
				
			case 'save_office_role':
				$rowcounter=$_POST['hidOfficeRoleCounterHolder'];

				for ($i = 1; $i <= $rowcounter; $i++) {
				if($_POST['rowtype_ofrole_'.abs($i)]!='view'){
					$database->modifyOfficeRole(
						(int)$_POST['of_role_'.abs($i)],
						(int)$_POST['of_role_id_'.abs($i)],
						(int)$_POST['officeselector'],
						$_POST['rowtype_ofrole_'.abs($i)]
					);
				}
				}

				if ($err)
					$form->setError('office_number_table_error', $err);

				break;
				
		}

		if ($form->num_errors > 0) {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}

		header("Location: ".$session->referrer);
	}

	/**
	* procEditAdminUsers - Edit system admins list.
	*/
	function procEditAdminUsers() {
		global $database, $session, $form, $logger;

		// access level control
		if(!($session->checkUserRight('adm_users.php','W'))){
			$session->only_read_message=MSG_READONLY;
			header("Location: ".$session->referrer);
			exit;
		}

		$logger->log("procEditAdminUsers:".print_r($_POST, true));

		$session->edit_admusers = true;
		$err = '';

		//process office users
		$last_db_admuser_id = $_POST["last_db_admuser_id"];
		$last_admuser_id = $_POST["last_admuser_id"];

		$uids = explode(',', trim($_POST['hidChangedUserIDHolder'], ','));
		foreach ($uids as $uid) {
			if (preg_match('/^([-]*\d+)$/', $uid) === 1) {
				if (!($uid[0] == '-' && $uid > $last_db_admuser_id)) {
					if ("$uid" === "-{$session->userid}") {
						$usr = $_POST['user_name_'.abs($uid)] != $session->username ?
							"{$session->username} / {$_POST['user_name_'.abs($uid)]}" : $session->username;
						$err .= "* Пользователь '$usr' не может удалять самого себя.<br>";
						continue;
					}
					$psw = $_POST['user_pass_'.abs($uid)];
					if ($_POST['user_pass_'.abs($uid)].$_POST['user_pass2_'.abs($uid)] == '<unchanged><unchanged>')
						$psw = null;
					elseif ($_POST['user_pass_'.abs($uid)] != '<unchanged>' &&
						$_POST['user_pass_'.abs($uid)] != '' &&
						$_POST['user_pass_'.abs($uid)] != $_POST['user_pass2_'.abs($uid)]) {
						$psw = null;
						$err .= "* Пароль пользователя '{$_POST['user_name_'.abs($uid)]}' не совпадает с подтверждением.<br>";
					} elseif ($_POST['user_pass_'.abs($uid)].$_POST['user_pass2_'.abs($uid)] == '')
						$err .= "* Пароль пользователя '{$_POST['user_name_'.abs($uid)]}' не задан.<br>";

					$database->modifyOfficeUser(null,
						abs($uid) <= $last_db_admuser_id ? $uid : null,
						$_POST['user_name_'.abs($uid)], 0, $psw, '');

					if ("$uid" === "{$session->userid}" && $_POST['user_name_'.abs($uid)] != $session->username) {
						$logger->log("procEditAdminUsers: current username changed to '{$_POST['user_name_'.abs($uid)]}'!");
						$session->username = $_POST['user_name_'.abs($uid)];
						setcookie(COOKIE_NAME_LOGINNAME, $session->username, time()+COOKIE_EXPIRE, COOKIE_PATH);
					}
				}
			}
		}

		if ($err)
			$form->setError('admuseredit', $err);


		if ($form->num_errors > 0) {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}

		header("Location: ".$session->referrer);
	}

	/**
	 * procEditInfo - Edit params from main page.
	 * @param $mode
	 */
	function procEditInfo($mode) {
		global $database, $session, $form, $logger;

		//$logger->log("procEditInfo:".print_r($_POST, true));

		if ($mode == 'save') {
			$session->edit_info = true;
			$err = '';

			$psw = $_POST['user_pass'];
			$umail = $_POST['user_mail'];

			if ($_POST['user_pass'].$_POST['user_pass2'] == '<unchanged><unchanged>')
				$psw = null;
			elseif ($_POST['user_pass'] != '<unchanged>' &&
				$_POST['user_pass'] != '' &&
				$_POST['user_pass'] != $_POST['user_pass2']) {
				$psw = null;
				$err .= "* Пароль пользователя не совпадает с подтверждением.<br>";
			} elseif ($_POST['user_pass'].$_POST['user_pass2'] == '')
				$err .= "* Пароль пользователя не задан.<br>";

			if ($err)
				$form->setError('useredit', $err);
			else
			if ($psw)
				$database->modifyOfficeUser($session->ofid,
					$session->userid, $session->username, $session->userrole, $psw, $umail);
			elseif ($umail)
				$database->modifyOfficeUser($session->ofid,
					$session->userid, $session->username, $session->userrole, null, $umail);
		}

		if ($form->num_errors > 0) {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}

		header("Location: ".$session->referrer);
	}

	/**
	 * proc_stats
	 *
	 * @return bool
	 */
	function proc_stats() {
		global $session, $database_tar, $logger;

		//$logger->log('proc_stats():POST' . var_export($_POST, true), PEAR_LOG_DEBUG);
		$flagsin = (isset($_POST['serv']) && is_numeric($_POST['serv'])) ? $_POST['serv'] : DB_TAR_SERVICETYPE_ALLTYPES;

		$is_newfilters = $session->updateStatFilters($flagsin);

		$page = $_POST['page'];
		if ($is_newfilters || !$page)
			$page = 1;
		$this->jsonres = array('page' => $page);
		$this->jsonres['rows'] = array();
		$this->jsonres['total'] = 0;

		if (!$database_tar->isAccountExist(DB_TAR_DEBUG ? DB_TAR_DEBUG_NUMBER : DB_TAR_FEDERAL_PREFIX . $session->ofnumber)) {
			$this->jsonres['is_invalidaccount'] = true;
			$this->int_send_array_as_json($this->jsonres);
			return true;
		}

		$totalcnt = 0;
		$totalvol = 0;
		$totalpay = 0.0;
		$report = $database_tar->get_stats($flagsin, $page, $_POST['rp'], $_POST['sortname'], $_POST['sortorder'], $_POST['qtype'], $_POST['query'],
			$totalcnt, $totalvol, $totalpay);
		if (!empty($report)) {
			$this->jsonres['total'] = $totalcnt;
			$this->jsonres['totalvol'] = $totalvol;
			$this->jsonres['totalpay'] = format_money($totalpay);
			foreach ($report as $row) {
				$serv = $row['flagsout'];
				if ($serv < 0) {
					$this->jsonres['total'] = 0;
					$this->jsonres['is_invalidaccount'] = true;
					break;
				}
				if (!is_string($row['creattime'])) {
					$this->jsonres['total']--;
					continue;
				}

				$dt = date_parse($row['creattime']);
				$createtime = sprintf("%04d.%02d.%02d %02d:%02d:%02d",
					$dt['year'], $dt['month'], $dt['day'], $dt['hour'], $dt['minute'], $dt['second']);

				$calltype = isset($row['calltype']) ? $row['calltype'] : -1;

				$record_title = '';
				if (!empty($row['recordid']))
				switch ($serv) {
					case DB_TAR_SERVICETYPE_MTR:
						$record_title = base64_encode($serv . '|' . $row['creattime'] . '|' . $row['numbera'] . ' ' . $row['numberb']);
						$this->jsonres['is_needplayer'] = true;
						break;
					case DB_TAR_SERVICETYPE_VOICE:
					case DB_TAR_SERVICETYPE_VOICE_SENT:
						$record_title = base64_encode($serv . '|' . $row['creattime'] . '|' . $row['numbera'] . ' ' . $row['numberb']);
						$this->jsonres['is_needplayer'] = true;
						break;
					case DB_TAR_SERVICETYPE_FAX:
					case DB_TAR_SERVICETYPE_FAX_SENT:
						$record_title = base64_encode($serv . '|' . $row['creattime'] . '|' . $row['numbera'] . ' ' . $row['numberb']);
						break;
				}

				$cell = array(
					json_encode_safe(array('ct' => $calltype, 'serv' => $serv, 'recid' => $row['recordid'], 'rect' => $record_title)),
					$createtime
				);
				switch ($flagsin) {
					case DB_TAR_SERVICETYPE_VOICE:
					case DB_TAR_SERVICETYPE_FAX:
						array_push($cell,
							addslashes(stripsiptags($row['numbera'])),
							format_seconds($row['realvolume']),
							format_money($row['pay']),
							addslashes($row['geographyname'])
						);
						break;
					case DB_TAR_SERVICETYPE_VOICE_SENT:
					case DB_TAR_SERVICETYPE_FAX_SENT:
						array_push($cell,
							addslashes(stripsiptags($row['numberb'])),
							format_seconds($row['realvolume']),
							format_money($row['pay']),
							addslashes($row['geographyname'])
						);
						break;
					default:
						array_push($cell,
							addslashes(stripsiptags($row['numbera'])),
							addslashes(stripsiptags($row['numberb'])),
							format_seconds($row['realvolume']),
							format_seconds($row['payablevolume']),
							format_money($row['pay']),
							addslashes($row['geographyname']),
							addslashes($row['calluri'])
						);
				}

				$this->jsonres['rows'][] = array(
					'id' => 's_' . $row['sessionid'] . '_' . $session->generateRandStr(6),
					'cell' => $cell
				);
			} //for each report row
		}

		$this->int_send_array_as_json($this->jsonres);
		return true;
	}

	/**
	 * proc_mblist
	 *
	 * @return bool
	 */
	function proc_mblist() {
		global $session, $database_tar, $logger;

		//$logger->log('proc_mblist():POST' . var_export($_POST, true), PEAR_LOG_DEBUG);
		$is_newfilters = $session->updateStatFilters(DB_TAR_SERVICETYPE_MB);

		$page = $_POST['page'];
		if ($is_newfilters || !$page)
			$page = 1;
		$this->jsonres = array('page' => $page);
		$this->jsonres['rows'] = array();
		$this->jsonres['total'] = 0;

		if (!$session->isAdmin() &&
			!$database_tar->isAccountExist(DB_TAR_DEBUG ? DB_TAR_DEBUG_NUMBER : DB_TAR_FEDERAL_PREFIX . $session->ofnumber)) {
			$this->jsonres['is_invalidaccount'] = true;
			$this->int_send_array_as_json($this->jsonres);
			return true;
		}

		$totalcnt = 0;
		$totalvol = 0;
		$report = $database_tar->get_mblist($page, $_POST['rp'], $_POST['sortname'], $_POST['sortorder'], $_POST['qtype'], $_POST['query'],
			$totalcnt, $totalvol);
		if (!empty($report)) {
			$this->jsonres['total'] = $totalcnt;
			$this->jsonres['totalvol'] = format_bytes($totalvol * FILESERVER_AUDIO_BYTE_SIZE);
			foreach ($report as $row) {
				if ($row['flagsout'] < 0) {
					$this->jsonres['total'] = 0;
					$this->jsonres['is_invalidaccount'] = true;
					break;
				}
				if (!is_string($row['createdate'])) {
					$this->jsonres['total']--;
					continue;
				}

				$dt = date_parse($row['createdate']);
				$createtime = sprintf("%04d.%02d.%02d %02d:%02d:%02d",
					$dt['year'], $dt['month'], $dt['day'], $dt['hour'], $dt['minute'], $dt['second']);

				$messagetypeid = isset($row['messagetypeid']) ? $row['messagetypeid'] : -1;

				if ($messagetypeid == DB_TAR_MESSAGETYPE_SYNTH && !$session->isAdmin() && !$session->isLocalAdmin()) {
					$this->jsonres['total']--;
					continue;
				}

				$record_title = '';
				if (!empty($row['recordid']))
				switch ($messagetypeid) {
					case DB_TAR_MESSAGETYPE_SYNTH:
					case DB_TAR_MESSAGETYPE_VOICE:
					case DB_TAR_MESSAGETYPE_CALLREC:
						$record_title = base64_encode($messagetypeid . '|' . $row['createdate'] . '|' . $row['numbera'] . ' ');
						$this->jsonres['is_needplayer'] = true;
						break;
					case DB_TAR_MESSAGETYPE_FAX:
						$record_title = base64_encode($messagetypeid . '|' . $row['createdate'] . '|' . $row['numbera'] . ' ');
						break;
				}

				$cell = array(
					json_encode_safe(array(
						'typeid' => $messagetypeid,
						'mid' => $row['messageid'],
						'recid' => $row['recordid'],
						'rect' => $record_title)),
					$row['recordid'],
					$createtime,
					$messagetypeid,
					$row['messagesize'] < 0 ? '-' : format_bytes($row['messagesize'] * FILESERVER_AUDIO_BYTE_SIZE),
					addslashes(stripsiptags($row['numbera']))
				);

				$this->jsonres['rows'][] = array(
					'id' => 's_' . $row['recordid'] . '_' . $row['messageid'] . '_' . $session->generateRandStr(6),
					'cell' => $cell
				);
			} //for each report row
		}

		$this->int_send_array_as_json($this->jsonres);
		return true;
	}

	/**
	 * proc_delfile
	 *
	 * @return bool
	 */
	function proc_delfile() {
		global $logger, $session, $database_tar, $database, $fileserver_control;

		$logger->log("Deleting files: " . print_r($_POST, true), PEAR_LOG_DEBUG);

		$this->jsonres['ids'] = $_POST['ids'];
		$this->jsonres['mids'] = $_POST['mids'];
		$this->jsonres['ttl'] = $_POST['ttl'];

		$idlist = explode(',', $_POST['ids']);
		$ididx = 0;
		foreach ($idlist as $id) {
			$tmplist = explode(',', $_POST['mids']);
			$mid = ($ididx < count($tmplist)) ? $tmplist[$ididx] : $tmplist[0];
			$ididx++;

			$msg = "Deleting file $id from FileServer...";
			$res = $fileserver_control->DeleteFile($id);
			if ($res != FS_ERROR_OK)
				$logger->log($msg . 'FAIL: ' . $fileserver_control->ErrorDescription($res), PEAR_LOG_ERR);
			else {
				$logger->log($msg . 'OK', PEAR_LOG_DEBUG);
				//changelog
				if (!$session->isAdmin())
					$database->logOfficeChange(CL_OF_FILE_DELETEFS, $session->ofid, 0, "Удалён файл с файлового сервера: идентификатор $id, сообщение $mid.");
			}

			$msg = "Deleting file $id (messageid $mid) from billing...";
			$res = $database_tar->deleteMBMessage($id, $mid);
			if ($res == -1)
				$logger->log($msg . "FAIL: $res", PEAR_LOG_ERR);
			else {
				$logger->log($msg . 'OK', PEAR_LOG_DEBUG);
				//changelog
				if (!$session->isAdmin())
					$database->logOfficeChange(CL_OF_FILE_DELETETAR, $session->ofid, 0, "Удалён файл из биллинга: идентификатор $id, сообщение $mid.");
			}
		}

		$this->int_send_array_as_json($this->jsonres);
		return true;
	}

	/**
	 * proc_mblist_del
	 *
	 * @return bool
	 */
	function proc_mblist_del() {
		global $session, $database, $database_tar, $fileserver_control, $logger;

		$logger->log('proc_mblist_del():POST' . var_export($_POST, true), PEAR_LOG_DEBUG);
		$session->updateStatFilters(DB_TAR_SERVICETYPE_MB);

		$this->jsonres['total'] = 0;

		if (!$session->isAdmin() &&
			!$database_tar->isAccountExist(DB_TAR_DEBUG ? DB_TAR_DEBUG_NUMBER : DB_TAR_FEDERAL_PREFIX . $session->ofnumber)) {
			$this->jsonres['is_invalidaccount'] = true;
			$this->int_send_array_as_json($this->jsonres);
			return true;
		}

		$deleted_on_fileserver = 0;
		$deleted_on_billing = 0;
		$report = $database_tar->get_mblist_del();
		$this->jsonres['total'] = count($report);
		if (!empty($report)) {
			foreach ($report as $row) {
				if ($row['flagsout'] < 0) {
					$this->jsonres['total'] = 0;
					$this->jsonres['is_invalidaccount'] = true;
					break;
				}
				if (!is_string($row['createdate'])) {
					$this->jsonres['total']--;
					continue;
				}

				$messagetypeid = isset($row['messagetypeid']) ? $row['messagetypeid'] : -1;
				if ($messagetypeid == DB_TAR_MESSAGETYPE_SYNTH && !$session->isAdmin() && !$session->isLocalAdmin()) {
					$this->jsonres['total']--;
					continue;
				}

				$id = $row['recordid'];
				$mid = $row['messageid'];

				$msg = "Deleting file $id from FileServer...";
				$res = $fileserver_control->DeleteFile($id);
				if ($res != FS_ERROR_OK)
					$logger->log($msg . 'FAIL: ' . $fileserver_control->ErrorDescription($res), PEAR_LOG_ERR);
				else {
					//$logger->log($msg . 'OK', PEAR_LOG_DEBUG);
					$deleted_on_fileserver++;
				}

				$msg = "Deleting file $id (messageid $mid) from billing...";
				$res = $database_tar->deleteMBMessage($id, $mid);
				if ($res == -1)
					$logger->log($msg . "FAIL: $res", PEAR_LOG_ERR);
				else {
					//$logger->log($msg . 'OK', PEAR_LOG_DEBUG);
					$deleted_on_billing++;
				}
			} //for each report row

			//changelog
			if (!$session->isAdmin()) {
				$msg = "период с {$session->filters[DB_TAR_SERVICETYPE_MB]['sf_startdate']} по {$session->filters[DB_TAR_SERVICETYPE_MB]['sf_enddate']}, удалено файлов";
				$database->logOfficeChange(CL_OF_FILE_DELETEFS, $session->ofid, 0, "Групповое удаление: $msg $deleted_on_fileserver.");
				$database->logOfficeChange(CL_OF_FILE_DELETETAR, $session->ofid, 0, "Групповое удаление: $msg $deleted_on_billing.");
			}
		}

		$this->int_send_array_as_json($this->jsonres);
		return true;
	}


	// upload files from fileserver by combining them into one .tar file -----------------------------------------------------------
	function proc_mblist_save() {
		global $session, $database, $database_tar, $fileserver_control, $logger;
		$startdate = $_REQUEST['sf_startdate'];
		$stopdate = $_REQUEST['sf_enddate'];
//		$tarfile_name = 'files_'.str_replace('.','',$startdate).'_'.str_replace('.','',$stopdate).'.tar';
//		$tarfile_name = 'files_'.str_replace('.','',$startdate).'_'.str_replace('.','',$stopdate).'.zip';
		$sf_format = $_REQUEST['sf_format'];

		// temp directory name
		$path = './upload/f'.$session->userwebid.'/';
		// make temp directory
		if(!is_dir($path)){ mkdir($path, 0700, true); }

		// change current directory (otherwise files will be added into .tar with full path)
		$current_path = getcwd();
		chdir($path);

		// get files list, and receive these files from fileserver into specific host directory
		$report = $database_tar->get_mblist_save();
		
/*	
		//$tar_object = new Archive_Tar($path.'myArchive.tar');
		$tar_object = new Archive_Tar($tarfile_name);
		$tar_object->setErrorHandling(PEAR_ERROR_PRINT);  
		$tar_object->create();
		if (!empty($report)) {
			//foreach ($report as $row) {
			foreach ($report as $key => $row){
				$id = $row['recordid'];
				$file_name = $row['recordpath'];
				//$v_list[$key] = $path.$file_name;
				
				$msg = "Receiving file $id from FileServer...";
				$res = $fileserver_control->ReceiveFile($id,$file_name);
				if ($res != FS_ERROR_OK){
					$logger->log($msg . 'FAIL: ' . $fileserver_control->ErrorDescription($res), PEAR_LOG_ERR);
				} else {
					// file convertation and putting in .tar
					//$tar_object->add($file_name);
					//$outfile = System::mktemp('aout_');
					$outfile = str_ireplace('.fsf','.mp3',$file_name);
					$cnvt = AUDIO_CONVERT_CALL_FMT;
					$cnvt = str_ireplace('%infile%', $file_name, $cnvt);
					$cnvt = str_ireplace('%outfile%', $outfile, $cnvt);
					$cnvt = str_ireplace('%artist%', '', $cnvt);
					$cnvt = str_ireplace('%title%', '', $cnvt);
					$logger->log('file convert '.$file_name.' into ' . $outfile, PEAR_LOG_DEBUG);
					//$logger->log("$cnvt", PEAR_LOG_DEBUG);
					exec($cnvt);
					//$outfile = $file_name;
					$tar_object->add($outfile);
				}
				//$tar_object->create($v_list);		
			}
		// return to old current path
		chdir($current_path);
		}
*/

		if($sf_format=='zip') {
			$tarfile_name = 'files_'.str_replace('.','',$startdate).'_'.str_replace('.','',$stopdate).'.zip';
			$tar_object = new Archive_Zip($tarfile_name);
			unlink($tarfile_name);
		} else {
			$tarfile_name = 'files_'.str_replace('.','',$startdate).'_'.str_replace('.','',$stopdate).'.tar';
			$tar_object = new Archive_Tar($tarfile_name);
			$tar_object->setErrorHandling(PEAR_ERROR_PRINT);  
		}
		$tar_object->create();
		if (!empty($report)) {
			//foreach ($report as $row) {
			foreach ($report as $key => $row){
				$id = $row['recordid'];
				$file_name = $row['recordpath'];
				//$v_list[$key] = $path.$file_name;
				
				$msg = "Receiving file $id from FileServer...";
				$res = $fileserver_control->ReceiveFile($id,$file_name);
				if ($res != FS_ERROR_OK){
					$logger->log($msg . 'FAIL: ' . $fileserver_control->ErrorDescription($res), PEAR_LOG_ERR);
				} else {
					// file convertation and putting in .tar
					//$tar_object->add($file_name);
					//$outfile = System::mktemp('aout_');
					$outfile = str_ireplace('.fsf','.mp3',$file_name);
					$cnvt = AUDIO_CONVERT_CALL_FMT;
					$cnvt = str_ireplace('%infile%', $file_name, $cnvt);
					$cnvt = str_ireplace('%outfile%', $outfile, $cnvt);
					$cnvt = str_ireplace('%artist%', '', $cnvt);
					$cnvt = str_ireplace('%title%', '', $cnvt);
					$logger->log('file convert '.$file_name.' into ' . $outfile, PEAR_LOG_DEBUG);
					//$logger->log("$cnvt", PEAR_LOG_DEBUG);
					exec($cnvt);
					//$outfile = $file_name;
					$tar_object->add($outfile);
				}
				//$tar_object->create($v_list);		
			}
		// return to old current path
		chdir($current_path);
		}
	
		
		// clear temporary files except .tar file for download
		if(is_dir($path)){ 
			$objects = scandir($path);
			 foreach ($objects as $object) {
			   if ($object != "." && $object != ".." && $object != $tarfile_name) {
				 if (filetype(dir) == "dir") rrmdir($path."/".$object); else unlink($path."/".$object);
			   }
			 }
			//reset($objects);
			//rmdir($path); 
		}

		// clear upload directory
//		$this->clearUploadDir('upload','upload',2);
		

		$jsonres = array('filename' => $path.$tarfile_name, 'path' => $path);
		echo json_encode($jsonres);
	}
	
	// directory clearing, delete files that oldest than $daysold days (upperdir is needed for don't remove main directory)
    function clearUploadDir($dir,$upperdir,$daysold){
		$objs = glob($dir."/*");
        foreach($objs as $obj) {
			if( (time()-filemtime($obj))/86400 > $daysold ){
				is_dir($obj) ? $this->clearUploadDir($obj,$upperdir) : unlink($obj);
			}
        }
		if ($dir != $upperdir) { rmdir($dir); }
    }	

	
	
	/**
	 * proc_activecalls
	 *
	 * @return bool
	 */
	function proc_activecalls() {
		global $session, $database_tar, $logger;

		$this->jsonres = array('page' => 1);
		$this->jsonres['rows'] = array();
		$this->jsonres['total'] = 0;

		if (!$database_tar->isAccountExist(DB_TAR_DEBUG ? DB_TAR_DEBUG_NUMBER : DB_TAR_FEDERAL_PREFIX . $session->ofnumber)) {
			$this->jsonres['is_invalidaccount'] = true;
			$this->jsonres['error'] = "Информация недоступна. Офис <span class=\"hlblack underlined\">$session->ofnumber</span> не зарегистрирован в подсистеме биллинга.";
			$this->int_send_array_as_json($this->jsonres);
			return true;
		}

		$report = $database_tar->getActiveCalls(DB_TAR_DEBUG ? DB_TAR_DEBUG_NUMBER : DB_TAR_FEDERAL_PREFIX . $session->ofnumber);
		if (!empty($report)) {
			$this->jsonres['total'] = count($report);

			foreach ($report as $row) {
				$sessionid = $row['sessionid'];
				if ($sessionid <= 0) {
					$this->jsonres['total'] = 0;
					break;
				}

				$dt = date_parse($row['calltime']);
				$calltime = sprintf("%04d.%02d.%02d %02d:%02d:%02d",
					$dt['year'], $dt['month'], $dt['day'], $dt['hour'], $dt['minute'], $dt['second']);

				$calltype = isset($row['calltype']) ? $row['calltype'] : -1;

				$this->jsonres['rows'][] = array(
					'id' => 's_' . $sessionid . '_' . $session->generateRandStr(6),
					'cell' => array(
						$calltype,
						$calltime,
						format_seconds($row['realvolume']),
						addslashes(stripsiptags($row['numbera'])),
						addslashes($row['ingeographyname']),
						addslashes(stripsiptags($row['numberb']))
					)
				);
			} //for each report row
		} elseif ($report === null) {
			$this->jsonres['error'] = "Ошибка при работе с БД биллинга! Администратору системы необходимо проверить параметры подключения к БД.";
		}

		$this->int_send_array_as_json($this->jsonres);
		return true;
	}



	/**
	* procEditUserActionGroup - Edit system action group.
	*/
	function procEditUserActionGroup() {
		global $database, $session, $form, $logger;
//		$logger->log("procEditUserActionGroup():".print_r($_POST, true));

		// access level control
		if(!($session->checkUserRight('right_group.php','W'))){
			$session->only_read_message=MSG_READONLY;
			header("Location: ".$session->referrer);
			exit;
		}

		$err = '';
		$rowcounter=$_POST['hidGroupCounterHolder'];
		for ($i = 1; $i <= $rowcounter; $i++) {
		if($_POST['rowtype_'.abs($i)]!='view'){
			$database->modifyUserActionGroup(
				(int)$_POST['actgroup_ord_'.abs($i)],
				$_POST['actgroup_name_'.abs($i)],
				(int)$_POST['actgroup_visible_'.abs($i)],
				(int)$_POST['actgroup_id_'.abs($i)],
				$_POST['rowtype_'.abs($i)]
			);
		} }


		if ($err)
		$form->setError('action_table_error', $err);



		if ($form->num_errors > 0) {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}
		header("Location: ".$session->referrer);
	}



//*********************************************************************************
	function procEditUserAction($mode) {
		global $database, $session, $form, $logger;

		$logger->log("procEditUserAction($mode):".print_r($_POST, true));

		$session->edit_offices = true;

		switch ($mode) {
			case 'show':
				$session->groupactions_show_id = $_POST['groupselector'];
				break;

			case 'save':
				$officeid = $_POST['groupselector'];
				$err = '';

				$rowcounter=$_POST['hidActionCounterHolder'];
				for ($i = 1; $i <= $rowcounter; $i++) {
				if($_POST['rowtype_'.abs($i)]!='view'){
					$database->modifyUserAction(
						$_POST['act_id_'.abs($i)],
						$_POST['groupselector'],
						$_POST['act_name_'.abs($i)],
						(int)$_POST['act_ord_'.abs($i)],
						$_POST['act_hint_'.abs($i)],
						$_POST['action_'.abs($i)],
						(int)$_POST['act_visible_'.abs($i)],
						(int)$_POST['act_system_'.abs($i)],
						$_POST['rowtype_'.abs($i)]
					);
				} }

				if ($err)
					$form->setError('action_table_error', $err);

				break;
		}
		if ($form->num_errors > 0) {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}
		header("Location: ".$session->referrer);
	}

/*--------------------------------------------------------------------------------------------------------
									 Process: SYSTEM ROLES OF USERS
--------------------------------------------------------------------------------------------------------*/
	function procEditUserRole($mode) {
		global $database, $session, $form, $logger;
//		$logger->log("procEditUserRole($mode):".print_r($_POST, true));

		switch ($mode) {
			case 'show':
				$session->role_show_id = $_POST['roleselector'];
				break;

			case 'edit_role':
				$session->edit_role = $_POST['hidEditRoleMode'];
				break;

			case 'save_role':
				// access level control
				if(!($session->checkUserRight('right_role.php','W'))){
					$session->only_read_message=MSG_READONLY;
					header("Location: ".$session->referrer);
					exit;
				}

				$err = '';
				$rowcounter=$_POST['hidRoleCounterHolder'];
				for ($i = 1; $i <= $rowcounter; $i++) {
				if($_POST['rowtype_'.abs($i)]!='view'){
					$database->modifyUserRole(
						(int)$_POST['role_id_'.abs($i)],
						$_POST['role_name_'.abs($i)],
						(int)$_POST['user_manual_id_'.abs($i)],
						$_POST['rowtype_'.abs($i)]
					);
				} }

				if ($err)
					$form->setError('action_table_error', $err);

				break;

			case 'save_action':
				// access level control
				if(!($session->checkUserRight('right_role.php','W'))){
					$session->only_read_message=MSG_READONLY;
					header("Location: ".$session->referrer);
					exit;
				}

				$err = '';
				$rowcounter=$_POST['hidActionCounterHolder'];
				for ($i = 1; $i <= $rowcounter; $i++) {
				$key1=(isset($_POST['key1_'.abs($i)])&&($_POST['key1_'.abs($i)]==1))?1:0;
				$key2=(isset($_POST['key2_'.abs($i)])&&($_POST['key2_'.abs($i)]==1))?1:0;
				$key3=(isset($_POST['key3_'.abs($i)])&&($_POST['key3_'.abs($i)]==1))?1:0;
				$key4=(isset($_POST['key4_'.abs($i)])&&($_POST['key4_'.abs($i)]==1))?1:0;
				if($_POST['act_rowtype_'.abs($i)]!='view'){
					$right_level=8*$key1+4*$key2+2*$key3+1*$key4;
					$database->modifyUserRoleAction(
						(int)$_POST['roleact_id_'.abs($i)],
						(int)$_POST['act_id_'.abs($i)],
						$right_level,
						$_POST['act_rowtype_'.abs($i)]
					);
				} }

				if ($err)
					$form->setError('action_table_error', $err);

				break;

		}
		if ($form->num_errors > 0) {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}
		header("Location: ".$session->referrer);
	}

	/**
	* procEditUserAdmin - system administrator control.
	*/
	function procEditUserAdmin() {
		global $database, $session, $form, $logger;
		//$logger->log("procEditUserAdmin():".print_r($_POST, true));

		// access level control
		if(!($session->checkUserRight('right_user.php','W'))){
			$session->only_read_message=MSG_READONLY;
			header("Location: ".$session->referrer);
			exit;
		}

		$err = '';
		$rowcounter=$_POST['hidUserCounterHolder'];
		for ($i = 1; $i <= $rowcounter; $i++) {
		if($_POST['rowtype_'.abs($i)]!='view'){

			if($_POST['rowtype_'.abs($i)]!='delete'){
				$psw = $_POST['user_pass_'.abs($i)];
				$psw2 = $_POST['user_pass2_'.abs($i)];
				if ($psw.$psw2 == '<unchanged><unchanged>') $psw = null;
				elseif (($psw!='<unchanged>')&&($psw != '')&&($psw != $psw2)) {
					$psw = null;
					$err .= "* Пароль пользователя ".$_POST['user_name_'.abs($i)]." не совпадает с подтверждением.<br>";
				} elseif ($psw.$psw2 == '')
					$err .= "* Пароль пользователя ".$_POST['user_name_'.abs($i)]." не задан.<br>";
			}

			$database->modifyUserAdmin(
				addslashes(stripsiptags($_POST['user_name_'.abs($i)])),
				(int)$_POST['user_role_'.abs($i)],
				//$_POST['user_pass_'.abs($i)],
				$psw,
				(int)$_POST['user_id_'.abs($i)],
				addslashes(stripsiptags($_POST['user_mail_'.abs($i)])),
				$_POST['rowtype_'.abs($i)]
			);

		} }

		if ($err) $form->setError('admuser_table_error', $err);

		if ($form->num_errors > 0) {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}
		header("Location: ".$session->referrer);
	}


/*
	function checkReadLevel($action){
		if(!($session->checkUserRight($action,'W'))){
			$session->only_read_message='Форма доступна только для чтения';
		//	header("Location: ".$session->referrer, true, 302);
			exit(header("Location: ".$action));
		}
	}
*/

// ******************************************************************************************
//								page: acc_sip_user.php
// ******************************************************************************************

// таблица sip счетов (упрощенная, для обычного пользователя) 
	function proc_user_sipaccount_full(){
		global $database_tar, $session, $logger;
	
		$accountid = (int)$session->acc_accountid;
		$emitterkcid = (int)$session->acc_emitterkcid;

		$q = <<<EOS
		select 
			a.status,
			c.name, 
			c.sip_id, 
			c.username,
			c.secret, 
			c.context, 
			c.host,
			c.port,
			c.type,
			c.nat,
			case when coalesce(s.ipaddr,'')='' or s.ipaddr='0.0.0.0' then 0 else 1 end as ipaddr_status,
			a.addinfo,
			
c.accountcode,
c.disallow,
c.allow,
c.allowoverlap,
c.allowsubscribe,
c.allowtransfer,
c.amaflags,
c.autoframing,
c.auth,
c.buggymwi,
c.callgroup,
c.callerid,
c.cid_number,
c.fullname,
c.calllimit,
c.callingpres,
c.canreinvite,
c.defaultip,
c.dtmfmode,
c.fromuser,
c.fromdomain,
c.fullcontact,
c.g726nonstandard,
c.insecure,
c.ipaddr,
c.language,
c.lastms,
c.mailbox,
c.maxcallbitrate,
c.mohsuggest,
c.md5secret,
c.musiconhold,
c.outboundproxy,
c.deny,
c.permit,
c.pickupgroup,
c.progressinband,
c.promiscredir,
c.qualify,
c.regexten,
c.regseconds,
c.rfc2833compensate,
c.rtptimeout,
c.rtpholdtimeout,
c.sendrpid,
c.setvar,
c.subscribecontext,
c.subscribemwi,
c.t38pt_udptl,
c.trustrpid,
c.useclientcode,
c.usereqphone,
c.videosupport,
c.vmexten,
c.busylevel,
c.callcounter,
c.transport,
coalesce(a.innersip,0) as innersip
			
		from tbsipaccounts a inner join tbsipconnections c on a.sip_id=c.sip_id 
		left join tbsipsessions s on s.sip_id=c.sip_id 
		where a.emitterkcid=$emitterkcid and a.accountid=$accountid;
EOS;
		
		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_sipaccount($emitterkcid,$accountid):". getPEARErrorInfo($result), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
			
				$sip_param = "'".implode("|",$row)."'"; // строка передаваемая в процедуру редактирования
			
				if($row['status'] == 0){ 
					$status_html = "<img src='./images/house_blue.PNG'>"; 
					$status_edt = 'деактивировать';
				}
				if($row['status'] == -5){ 
					$status_html = "<img src='./images/house_red.PNG'>"; 
					$status_edt = 'активировать';
				}
				if($row['ipaddr_status'] == 1){ 
					$status_html = "<img src='./images/house_green.PNG'>"; 
				}

				$tabrow[$key] = array(
					//$row['status'],
					$status_html.$row['sip_id'],
					
					empty($row['name'])?'&nbsp;':$row['name'],
					empty($row['username'])?'&nbsp;':$row['username'],
					empty($row['type'])?'&nbsp;':$row['type'],
					empty($row['host'])?'&nbsp;':$row['host'],
					empty($row['port'])?'&nbsp;':$row['port'],
					empty($row['nat'])?'&nbsp;':$row['nat'],
					
					
					'<li class="ui-state-default ui-corner-all" title="'.$status_edt.'" style="margin:1px;padding:2;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="if (confirm(\'Сменить статус SIP счета - '.$row['name'].'?\')) {frm_sip_account_act('.$sip_param.');} else {return false;}">
					<span class="ui-icon ui-icon-home" style="margin:0;"></span></li>
					
					<li class="ui-state-default ui-corner-all" title="редактировать" style="margin:1px;padding:2;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="frm_sip_account_edt('.$sip_param.')">
					<span class="ui-icon ui-icon-pencil" style="margin:0;"></span></li>
					
					<li class="ui-state-default ui-corner-all" title="удалить" style="margin:1px;padding:2;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="if (confirm(\'Удалить SIP счет - '.$row['name'].'?\')) {frm_sip_account_del('.$row['sip_id'].');} else {return false;}">
					<span class="ui-icon ui-icon-close" style="margin:0;"></span></li>'

				);
			}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}

	// удаление sip счета ------------------------------------------------------------------
	function proc_user_sipaccount_del(){
		global $database_tar, $session, $logger;
	
		$accountid = (int)$session->acc_accountid;
		$emitterkcid = (int)$session->acc_emitterkcid;
		$sip_id = $_REQUEST['sip_id'];

		$q = "select * from sip_delete_account($sip_id);";
		$res = $database_tar->getQueryResultAsArray($q);

		$jsonres = array('ok' => 'yes');
		echo json_encode($res);
	}

	
	// добавление нового sip счета ------------------------------------------------------------------
	function proc_user_sipaccount_add_full(){
		global $database_tar, $session, $logger;
	
		$accountid = (int)$session->acc_accountid;
		$emitterkcid = (int)$session->acc_emitterkcid;

		$NAME = $_REQUEST['NAME'];
		$USERNAME = $_REQUEST['USERNAME'];
		$SECRET = $_REQUEST['SECRET'];
		$SECRET = iconv("UTF-8", "windows-1251",$_REQUEST['SECRET']);
		//$SECRET = iconv("UTF-8", "cp1251",$_REQUEST['SECRET']);
		//$strcode = mb_detect_encoding($SECRET);

		$CONTEXT = $_REQUEST['CONTEXT'];
		$PTYPE = $_REQUEST['PTYPE'];
		$HOST = $_REQUEST['HOST'];
		$PORT = $_REQUEST['PORT'];
		$NAT = $_REQUEST['NAT'];
		$COMMENT = $_REQUEST['COMMENT'];
		$INNERSIP = $_REQUEST['INNERSIP'];
		
		//$INSECURE = 'port';
		//$ALLOW = 'g729,alaw,ulaw';
		//$CALLERID = $session->ofmainparams['of_number_prefix'].$session->ofnumber;
		//$CANREINVITE = 'no';
		//$T38PT_UDPTL = '';

		
$accountcode = $_REQUEST['accountcode'];
$disallow = $_REQUEST['disallow'];
$allow = $_REQUEST['allow'];
$allowoverlap = $_REQUEST['allowoverlap'];
$allowsubscribe = $_REQUEST['allowsubscribe'];
$allowtransfer = $_REQUEST['allowtransfer'];
$amaflags = $_REQUEST['amaflags'];
$autoframing = $_REQUEST['autoframing'];
$auth = $_REQUEST['auth'];
$buggymwi = $_REQUEST['buggymwi'];
$callgroup = $_REQUEST['callgroup'];
$callerid = $_REQUEST['callerid'];
$cid_number = $_REQUEST['cid_number'];
$fullname = $_REQUEST['fullname'];
$calllimit = $_REQUEST['calllimit'];
$callingpres = $_REQUEST['callingpres'];
$canreinvite = $_REQUEST['canreinvite'];
$defaultip = $_REQUEST['defaultip'];
$dtmfmode = $_REQUEST['dtmfmode'];
$fromuser = $_REQUEST['fromuser'];
$fromdomain = $_REQUEST['fromdomain'];
$fullcontact = $_REQUEST['fullcontact'];
$g726nonstandard = $_REQUEST['g726nonstandard'];
$insecure = $_REQUEST['insecure'];
$ipaddr = $_REQUEST['ipaddr'];
$language = $_REQUEST['language'];
$lastms = $_REQUEST['lastms'];
$mailbox = $_REQUEST['mailbox'];
$maxcallbitrate = $_REQUEST['maxcallbitrate'];
$mohsuggest = $_REQUEST['mohsuggest'];
$md5secret = $_REQUEST['md5secret'];
$musiconhold = $_REQUEST['musiconhold'];
$outboundproxy = $_REQUEST['outboundproxy'];
$deny = $_REQUEST['deny'];
$permit = $_REQUEST['permit'];
$pickupgroup = $_REQUEST['pickupgroup'];
$progressinband = $_REQUEST['progressinband'];
$promiscredir = $_REQUEST['promiscredir'];
$qualify = $_REQUEST['qualify'];
$regexten = $_REQUEST['regexten'];
$regseconds = $_REQUEST['regseconds'];
$rfc2833compensate = $_REQUEST['rfc2833compensate'];
$rtptimeout = $_REQUEST['rtptimeout'];
$rtpholdtimeout = $_REQUEST['rtpholdtimeout'];
$sendrpid = $_REQUEST['sendrpid'];
$setvar = $_REQUEST['setvar'];
$subscribecontext = $_REQUEST['subscribecontext'];
$subscribemwi = $_REQUEST['subscribemwi'];
$t38pt_udptl = $_REQUEST['t38pt_udptl'];
$trustrpid = $_REQUEST['trustrpid'];
$useclientcode = $_REQUEST['useclientcode'];
$usereqphone = $_REQUEST['usereqphone'];
$videosupport = $_REQUEST['videosupport'];
$vmexten = $_REQUEST['vmexten'];
$busylevel = $_REQUEST['busylevel'];
$callcounter = $_REQUEST['callcounter'];
$transport = $_REQUEST['transport'];
		
		$q = <<<EOS
		select * 
        from sip_create_account( 
        $emitterkcid, 
		$accountid, 
		'$accountcode', 
		'$disallow', 
		'$allow', 
        '$allowoverlap', 
		'$allowsubscribe', 
		'$allowtransfer', 
		'$amaflags', 
		'$autoframing', 
		'$auth', 
		'$buggymwi', 
		'$callgroup', 
		'$callerid', 
		'$cid_number', 
		'$fullname', 
		'$calllimit', 
		'$callingpres', 
		'$canreinvite', 
		'$CONTEXT', 
        '$defaultip', 
		'$dtmfmode', 
		'$fromuser', 
		'$fromdomain', 
		'$fullcontact', 
		'$g726nonstandard', 
		'$HOST', 
		'$insecure', 
		'$ipaddr', 
		'$language', 
		'$lastms',
		'$mailbox',		
		'$maxcallbitrate', 
		'$mohsuggest', 
		'$md5secret', 
		'$musiconhold', 
        '$NAME', 
		'$NAT', 
		'$outboundproxy', 
		'$deny', 
		'$permit', 
		'$pickupgroup', 
		'$PORT', 
		'$progressinband', 
		'$promiscredir', 
		'$qualify', 
		'$regexten', 
		'$regseconds', 
		'$rfc2833compensate', 
		'$rtptimeout', 
		'$rtpholdtimeout', 
        '$SECRET', 
		'$sendrpid', 
		'$setvar', 
		'$subscribecontext', 
		'$subscribemwi', 
		'$t38pt_udptl', 
		'$trustrpid', 
		'$PTYPE', 
		'$useclientcode', 
		'$USERNAME', 
		'$usereqphone', 
		'$videosupport', 
		'$vmexten', 
		'$busylevel', 
		'$callcounter', 
		'$transport' 
        );
EOS;

		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res))
			$logger->log("proc_user_sipaccount_add()". getPEARErrorInfo($res), PEAR_LOG_ERR);

		$SIP_ID = $res[0]['sip_id'];
		$q = <<<EOS
		update tbsipaccounts set addinfo='$COMMENT',innersip=$INNERSIP where sip_id=$SIP_ID;
EOS;
		$res = $database_tar->query($q);
			
		//$jsonres = array('ok' => 'yes', 'strcode' => $strcode);
		$jsonres = array('ok'=>'yes');
		echo json_encode($jsonres);
	}

/*	
	// редактирование sip счета ------------------------------------------------------------------
	function proc_user_sipaccount_edt(){
		global $database_tar, $session, $logger;
	
		$accountid = (int)$session->acc_accountid;
		$emitterkcid = (int)$session->acc_emitterkcid;

		$SIP_ID = $_REQUEST['SIP_ID'];
		$NAME = $_REQUEST['NAME'];
		$SECRET = $_REQUEST['SECRET'];
		//$SECRET = iconv("UTF-8", "windows-1251",$_REQUEST['SECRET']);

		$q = <<<EOS
		update tbsipconnections set name='$NAME', username='$NAME', secret='$SECRET' where sip_id=$SIP_ID;
EOS;
		$res = $database_tar->query($q);

		$q = <<<EOS
		update tbsipsessions set name='$NAME', username='$NAME', secret='$SECRET' where sip_id=$SIP_ID;
EOS;
		$res = $database_tar->query($q);
		
		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}
*/

	// редактирование sip счета ------------------------------------------------------------------
	function proc_user_sipaccount_edt_full(){
		global $database_tar, $session, $logger;

		$SIP_ID = $_REQUEST['SIP_ID'];
		$NAME = $_REQUEST['NAME'];
		$USERNAME = $_REQUEST['USERNAME'];
		$SECRET = $_REQUEST['SECRET'];
		$SECRET = iconv("UTF-8", "windows-1251",$_REQUEST['SECRET']);

		$CONTEXT = $_REQUEST['CONTEXT'];
		$PTYPE = $_REQUEST['PTYPE'];
		$HOST = $_REQUEST['HOST'];
		$PORT = $_REQUEST['PORT'];
		$NAT = $_REQUEST['NAT'];
		$COMMENT = $_REQUEST['COMMENT'];
		$INNERSIP = $_REQUEST['INNERSIP'];
		
$accountcode = $_REQUEST['accountcode'];
$disallow = $_REQUEST['disallow'];
$allow = $_REQUEST['allow'];
$allowoverlap = $_REQUEST['allowoverlap'];
$allowsubscribe = $_REQUEST['allowsubscribe'];
$allowtransfer = $_REQUEST['allowtransfer'];
$amaflags = $_REQUEST['amaflags'];
$autoframing = $_REQUEST['autoframing'];
$auth = $_REQUEST['auth'];
$buggymwi = $_REQUEST['buggymwi'];
$callgroup = $_REQUEST['callgroup'];
$callerid = $_REQUEST['callerid'];
$cid_number = $_REQUEST['cid_number'];
$fullname = $_REQUEST['fullname'];
$calllimit = $_REQUEST['calllimit'];
$callingpres = $_REQUEST['callingpres'];
$canreinvite = $_REQUEST['canreinvite'];
$defaultip = $_REQUEST['defaultip'];
$dtmfmode = $_REQUEST['dtmfmode'];
$fromuser = $_REQUEST['fromuser'];
$fromdomain = $_REQUEST['fromdomain'];
$fullcontact = $_REQUEST['fullcontact'];
$g726nonstandard = $_REQUEST['g726nonstandard'];
$insecure = $_REQUEST['insecure'];
$ipaddr = $_REQUEST['ipaddr'];
$language = $_REQUEST['language'];
$lastms = $_REQUEST['lastms'];
$mailbox = $_REQUEST['mailbox'];
$maxcallbitrate = $_REQUEST['maxcallbitrate'];
$mohsuggest = $_REQUEST['mohsuggest'];
$md5secret = $_REQUEST['md5secret'];
$musiconhold = $_REQUEST['musiconhold'];
$outboundproxy = $_REQUEST['outboundproxy'];
$deny = $_REQUEST['deny'];
$permit = $_REQUEST['permit'];
$pickupgroup = $_REQUEST['pickupgroup'];
$progressinband = $_REQUEST['progressinband'];
$promiscredir = $_REQUEST['promiscredir'];
$qualify = $_REQUEST['qualify'];
$regexten = $_REQUEST['regexten'];
$regseconds = $_REQUEST['regseconds'];
$rfc2833compensate = $_REQUEST['rfc2833compensate'];
$rtptimeout = $_REQUEST['rtptimeout'];
$rtpholdtimeout = $_REQUEST['rtpholdtimeout'];
$sendrpid = $_REQUEST['sendrpid'];
$setvar = $_REQUEST['setvar'];
$subscribecontext = $_REQUEST['subscribecontext'];
$subscribemwi = $_REQUEST['subscribemwi'];
$t38pt_udptl = $_REQUEST['t38pt_udptl'];
$trustrpid = $_REQUEST['trustrpid'];
$useclientcode = $_REQUEST['useclientcode'];
$usereqphone = $_REQUEST['usereqphone'];
$videosupport = $_REQUEST['videosupport'];
$vmexten = $_REQUEST['vmexten'];
$busylevel = $_REQUEST['busylevel'];
$callcounter = $_REQUEST['callcounter'];
$transport = $_REQUEST['transport'];
		
		$q = <<<EOS
		select * 
        from sip_update_account( 
        $SIP_ID, 
		'$accountcode', 
		'$disallow', 
		'$allow', 
        '$allowoverlap', 
		'$allowsubscribe', 
		'$allowtransfer', 
		'$amaflags', 
		'$autoframing', 
		'$auth', 
		'$buggymwi', 
		'$callgroup', 
		'$callerid', 
		'$cid_number', 
		'$fullname', 
		'$calllimit', 
		'$callingpres', 
		'$canreinvite', 
		'$CONTEXT', 
        '$defaultip', 
		'$dtmfmode', 
		'$fromuser', 
		'$fromdomain', 
		'$fullcontact', 
		'$g726nonstandard', 
		'$HOST', 
		'$insecure', 
		'$ipaddr', 
		'$language', 
		'$lastms',
		'$mailbox',		
		'$maxcallbitrate', 
		'$mohsuggest', 
		'$md5secret', 
		'$musiconhold', 
        '$NAME', 
		'$NAT', 
		'$outboundproxy', 
		'$deny', 
		'$permit', 
		'$pickupgroup', 
		'$PORT', 
		'$progressinband', 
		'$promiscredir', 
		'$qualify', 
		'$regexten', 
		'$regseconds', 
		'$rfc2833compensate', 
		'$rtptimeout', 
		'$rtpholdtimeout', 
        '$SECRET', 
		'$sendrpid', 
		'$setvar', 
		'$subscribecontext', 
		'$subscribemwi', 
		'$t38pt_udptl', 
		'$trustrpid', 
		'$PTYPE', 
		'$useclientcode', 
		'$USERNAME', 
		'$usereqphone', 
		'$videosupport', 
		'$vmexten', 
		'$busylevel', 
		'$callcounter', 
		'$transport' 
        );
EOS;
		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res))
			$logger->log("proc_user_sipaccount_edt()". getPEARErrorInfo($res), PEAR_LOG_ERR);

		$q = <<<EOS
		update tbsipaccounts set addinfo='$COMMENT',innersip=$INNERSIP where sip_id=$SIP_ID;
EOS;
		$res = $database_tar->query($q);

			
		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}






	// определение свободного номера, создание пароля для нового сип-счета --------------------------------
	function proc_user_sipaccount_freenumber(){
		global $database_tar, $session, $logger;

		$q = <<<EOS
        select '55'||right('00000'||cast(cast(v1.name as integer) as varchar(10)),5) as name from
        (select first 1 v1.name+1 as name from
		-- ----------------------------------------------------- в firebird 2.5 лучше использовать similar to '%[0-9]%' 
        (select cast(right(name,5) as integer) as name from tbsipconnections where name like '55%' and char_length(name)=7) v1
        left join
        (select cast(right(name,5) as integer) as name from tbsipconnections where name like '55%' and char_length(name)=7) v2
        on v1.name = v2.name-1
        where v2.name is null
        order by v1.name) as v1
EOS;
		$res = $database_tar->getQueryResultAsArray($q);

		$freenumber = $res[0]['name'];
		//$userpass = strtoupper($this->generateRandStr(8));
		$userpass = $this->generateRandStr(8);
		
		$res = array('ok'=>'yes', 'freenumber'=>$freenumber, 'userpass'=>$userpass);
		echo json_encode($res);
	}

	// определение свободного номера, создание пароля для нового сип-счета --------------------------------
	function proc_user_sipaccount_getnumber(){
		global $database_tar, $session, $logger;

		$first_num = SIP_RANGE_FIRST;
		$last_num = SIP_RANGE_LAST;
		if(empty($first_num)) $first_num = 'null'; 
		if(empty($last_num)) $last_num = 'null'; 
		
		$q = <<<EOS
        select new_sipaccount from get_free_sipaccount($first_num,$last_num);
EOS;
		$res = $database_tar->getQueryResultAsArray($q);
		//$logger->log("$q", PEAR_LOG_DEBUG);

		$freenumber = $res[0]['new_sipaccount'];
		
		$res = array('ok'=>'yes', 'freenumber'=>$freenumber);
		echo json_encode($res);
	}
	
	
	
	

	// формирование нового пароля сип-счета --------------------------------
	function proc_user_sipaccount_password(){
		global $database_tar, $session, $logger;
		$userpass = $this->generateRandStr(8);
		$res = array('ok'=>'yes', 'userpass'=>$userpass);
		echo json_encode($res);
	}
	
	
	// активация/деактивация sip счета ------------------------------------------------------------------
	function proc_user_sipaccount_act(){
		global $database_tar, $session, $logger;
	
		$accountid = (int)$session->acc_accountid;
		$emitterkcid = (int)$session->acc_emitterkcid;
		$SIP_ID = $_REQUEST['SIP_ID'];

		$q = <<<EOS
		update tbsipaccounts 
		set status = (select first 1 case when status=0 then -5 else 0 end status from tbsipaccounts where sip_id=$SIP_ID) 
		where sip_id=$SIP_ID;
EOS;

		$res = $database_tar->query($q);

		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($res);
	}
	
	
// ******************************************************************************************
//								(end) page: acc_sip_user.php
// ******************************************************************************************

	// случайный генератор строки -----------------------------------------------------------
	function generateUserPass($len = 128) {
		return sha1($this->generateRandStr($len));
	}
	function generateRandStr($length) {
		$randstr = "";
		for ($i=0; $i<$length; $i++) {
			$randnum = mt_rand(0,61);
			if($randnum < 10){
				$randstr .= chr($randnum+48);
			} else if ($randnum < 36) {
				$randstr .= chr($randnum+55);
			} else{
				$randstr .= chr($randnum+61);
			}
		}
		return $randstr;
	}


	/* возвращает кол-во sip счетов */
	function check_sipcount(){
		global $database_tar, $session, $logger;
		
		$acc_accountid = $session->acc_accountid;
		$acc_emitterkcid = $session->acc_emitterkcid;
		$acc_sipcount = $session->acc_sipcount;
	
		$q="select count(*) as cnt from tbsipaccounts where emitterkcid=$acc_emitterkcid and accountid=$acc_accountid;";
		$res = $database_tar->getQueryResultAsArray($q);

		if($res[0]['cnt']>=$acc_sipcount) {
			$jsonres = array('ok' => 'yes', 'sipcount' => 0, 'acc_accountid' => $acc_accountid, 'acc_emitterkcid' => $acc_emitterkcid);
		} else {
			$jsonres = array('ok' => 'yes', 'sipcount' => 1, 'acc_accountid' => $acc_accountid, 'acc_emitterkcid' => $acc_emitterkcid);
		}
		echo json_encode($jsonres);
	}

	
	/* Общие запросы */
	
	// Принадлежность ЛС ------------------------------------------------------------------
	function proc_rpt_account_owner(){
		global $database, $session, $logger;

		$f_account = $_REQUEST['f_account'];
		$f_number = $_REQUEST['f_number'];
		
//		$pq = $database_tar->prepare('select accountgts,fio from tbgts where accountgts like ?',array('text'));
//		$result = $database_tar->execute($pq, array($user_account));
		$pq = $database->prepare('select 
		account,
		fio,
		emitterkcid,
		accountid,
		number,
		address,
		treaty_date,
		status,
		status_time,
		docum
		from rpt_client_bynumber(?,?)',array('text','text'));
		$result = $database->execute($pq, array($f_account,$f_number));

		foreach($result as $key => $row){
			$row_param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				$row['account'],
				$row['fio'],
				'				
				<li class="ui-state-default ui-corner-all" title="параметры" style="margin:1px;padding:2;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
				onclick="frm_open_dialog('.$row_param.')">
				<span class="ui-icon ui-icon-script" style="margin:0;"></span></li>
				',
				$row['emitterkcid'],
				$row['accountid'],
				$row['number'],
				$row['address'],
				$row['treaty_date'],
				$row['status'],
				$row['status_time'],
				$row['docum']
			);
		}

		$res = array('draw' => 1, 'recordsTotal' => count($result), 'recordsFiltered' => count($res), 'data' => $tabrow );
		echo json_encode($res);
	}
	
	// Реквизиты абонента ------------------------------------------------------------------
	function proc_rpt_name_owner(){
		global $database, $session, $logger;

		$f_fio = $_REQUEST['f_fio'];
		$f_address = $_REQUEST['f_address'];
		$f_docum = $_REQUEST['f_docum'];
		
		$pq = $database->prepare('select 
		account,
		fio,
		emitterkcid,
		accountid,
		number,
		address,
		treaty_date,
		status,
		status_time,
		docum
		from rpt_client_byname(?,?,?)',array('text','text','text'));
		$result = $database->execute($pq, array($f_fio,$f_address,$f_docum));

		foreach($result as $key => $row){
			$row_param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				$row['account'],
				$row['fio'],
				'				
				<li class="ui-state-default ui-corner-all" title="параметры" style="margin:1px;padding:2;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
				onclick="frm_open_dialog('.$row_param.')">
				<span class="ui-icon ui-icon-script" style="margin:0;"></span></li>
				',
				$row['emitterkcid'],
				$row['accountid'],
				$row['number'],
				$row['address'],
				$row['treaty_date'],
				$row['status'],
				$row['status_time'],
				$row['docum']
				
			);
		}

		$res = array('draw' => 1, 'recordsTotal' => count($result), 'recordsFiltered' => count($res), 'data' => $tabrow );
		echo json_encode($res);
	}

	
	// телефонные номера счета ------------------------------------------------------------------
	function proc_rpt_account_phone(){
		global $database_tar, $session, $logger;

		$emitterkcid = $_REQUEST['emitterkcid'];
		$accountid = $_REQUEST['accountid'];
		
		$pq = $database_tar->prepare('select 
		numbera
		from tbphones where emitterkcid=? and accountid=?',array('integer','integer'));
		$result = $database_tar->execute($pq, array($emitterkcid,$accountid));

		foreach($result as $key => $row){
			$tabrow[$key] = array(
				$row['numbera']
			);
		}
		
		$res = array('tabrow' => $tabrow );
		echo json_encode($res);
	}
	
	// Информация о пополнении баланса счета клиента ------------------------------------------------------------------
	function proc_rpt_client_payment(){
		global $database, $session, $logger;

		$f_account = $_REQUEST['f_account'];
		$f_number = $_REQUEST['f_number'];
		$date1 = $_REQUEST['date1'];
		$date2 = $_REQUEST['date2'];
		
//		$pq = $database_tar->prepare('select accountgts,fio from tbgts where accountgts like ?',array('text'));
//		$result = $database_tar->execute($pq, array($user_account));
		$pq = $database->prepare('select 
		account,
		fio,
		emitterkcid,
		accountid,
		adddate,
		summ,
        addby,
        addinfo,
        opid,
        transid,
        currencyname
		from rpt_client_payment(?,?,?,?)',array('text','text','text','text'));
		$result = $database->execute($pq, array($f_account,$f_number,$date1,$date2));

		$logger->log("proc_rpt_client_payment($f_account,$f_number,$date1,$date2)", PEAR_LOG_DEBUG);
		
		
		foreach($result as $key => $row){
			$row_param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				$row['account'],
				$row['fio'],
				$row['adddate'],
				$row['summ'],
				'				
				<li class="ui-state-default ui-corner-all" title="параметры" style="margin:1px;padding:2;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
				onclick="frm_open_dialog('.$row_param.')">
				<span class="ui-icon ui-icon-script" style="margin:0;"></span></li>
				',
				$row['addby'],
				$row['addinfo'],
				$row['opid'],
				$row['transid'],
				$row['currencyname'],
				$row['emitterkcid'],
				$row['accountid']

			);
		}

		$res = array('draw' => 1, 'recordsTotal' => count($result), 'recordsFiltered' => count($res), 'data' => $tabrow );
		echo json_encode($res);
	}

	
	// Информация о смене статусов аккаунтов ------------------------------------------------------------------
	function proc_rpt_account_status(){
		global $database_tar, $session, $logger;

		$date1 = $_REQUEST['date1'];
		$date2 = $_REQUEST['date2'];
		
		if( !empty($date1) || !empty($date2) ){
		
		$q = $database_tar->prepare('select 
		accountgts,
		fio,
		operatedate,
		status,
		document,
		notify_address,
		emitterkcid,
		accountid
		from rpt_account_status(?,?)',array('text','text'));
		$res = $database_tar->execute($q, array($date1,$date2));
		//$res = $database_tar->execute($q, array('01.09.2012','30.09.2012'));

		//$logger->log("$q", PEAR_LOG_DEBUG);
		
		
		foreach($res as $key => $row){
			$row_param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				$row['accountgts'],
				$row['fio'],
				$row['operatedate'],
				$row['status'],
				'				
				<li class="ui-state-default ui-corner-all" title="параметры" style="margin:1px;padding:2;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
				onclick="frm_open_dialog('.$row_param.')">
				<span class="ui-icon ui-icon-script" style="margin:0;"></span></li>
				',
				$row['document'],
				$row['notify_address'],
				$row['emitterkcid'],
				$row['accountid']

			);
		}

		}
		
		if(empty($res)){ $tabrow[0] = array('','','','','','','','','');	}
		$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		echo json_encode($res);
	}
	
	
	
	
	
	// Информация о связях клиента ------------------------------------------------------------------
	function proc_rpt_client_connection(){
		global $database_tar, $session, $logger;

		$f_number = $_REQUEST['f_number'];
		$date1 = $_REQUEST['date1'];
		$date2 = $_REQUEST['date2'];
		
		$pq = $database_tar->prepare('select 
		sessionid,
		creattime,
		numbera,
		numberb,
		realvolume, 
		payablevolume, 
		geographyname,
		distancename,
		pay,
		recordid,
		termreason,
		cause,
		answerdelay,
		flagsout,
		case when calltype=301 then "входящий" when calltype=201 then "исходящий" when  calltype=100 then "пропущенный" end as calltype,
		serviceblockid,
		floatcash1,
		floatcash2,
		floatgraph
		from rpt_client_connection(?,?,?)',array('text','text','text'));
		$result = $database_tar->execute($pq, array($f_number,$date1,$date2));

		$logger->log("rpt_client_connection($f_number,$date1,$date2)", PEAR_LOG_DEBUG);

		foreach($result as $key => $row){
			$row_param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				$row['creattime'],
				$row['realvolume'],
				$row['numbera'],
				$row['numberb'],
				$row['calltype']
			);
		}

		$res = array('draw' => 1, 'recordsTotal' => count($result), 'recordsFiltered' => count($res), 'data' => $tabrow );
		echo json_encode($res);
	}

	// Запрос о связях с внешним номером ------------------------------------------------------------------
	function proc_rpt_external_number(){
		global $database_tar, $session, $logger;

		$f_number = $_REQUEST['f_number'];
		$date1 = $_REQUEST['date1'];
		$date2 = $_REQUEST['date2'];
		
		$pq = $database_tar->prepare('select 
		createtime,
		realvolume,
		numbera,
		dialnumber,
		sessionid
		from rpt_external_number(?,?,?)',array('text','text','text'));
		$result = $database_tar->execute($pq, array($f_number,$date1,$date2));

		$logger->log("rpt_client_connection($f_number,$date1,$date2)", PEAR_LOG_DEBUG);

		foreach($result as $key => $row){
			$row_param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				$row['createtime'],
				$row['realvolume'],
				$row['numbera'],
				$row['dialnumber'],
				$row['sessionid']
			);
		}

		$res = array('draw' => 1, 'recordsTotal' => count($result), 'recordsFiltered' => count($res), 'data' => $tabrow );
		echo json_encode($res);
	}

	/* проверяет существование сип-аккаунта */
	function proc_user_sipaccount_exists(){
		global $database_tar, $session, $logger;
		
		$sipaccount = $_REQUEST['sipaccount'];
	
		$q="select count(*) as cnt from tbsipconnections where trim(name)=trim('$sipaccount');";
		$res = $database_tar->getQueryResultAsArray($q);

		$logger->log("$q", PEAR_LOG_DEBUG);

		
		if($res[0]['cnt']>0) {
			$jsonres = array('ok' => 'yes', 'sipaccount' => 1);
		} else {
			$jsonres = array('ok' => 'yes', 'sipaccount' => 0);
		}
		echo json_encode($jsonres);
	}
	
	
// таблица sip счетов (упрощенная, для обычного пользователя) 
	function proc_user_sipaccount(){
		global $database_tar, $session, $logger;
	
		$accountid = (int)$session->acc_accountid;
		$emitterkcid = (int)$session->acc_emitterkcid;

		// case when s.ipaddr is not null then 1 else a.status end as status,
		// case when s.ipaddr is not null then 1 else 0 end as ipaddr
		
		$q = <<<EOS
		select 
			a.status,
			c.name, 
			c.sip_id, 
			c.username,
			c.secret, 
			c.context, 
			c.host,
			c.port,
			c.ipaddr,
			c.type,
			c.nat,
			case when coalesce(s.ipaddr,'')='' or s.ipaddr='0.0.0.0' then 0 else 1 end as ipaddr
		from tbsipaccounts a inner join tbsipconnections c on a.sip_id=c.sip_id 
		left join tbsipsessions s on s.sip_id=c.sip_id 
		where a.emitterkcid=$emitterkcid and a.accountid=$accountid;
EOS;
		
		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_sipaccount($emitterkcid,$accountid):". getPEARErrorInfo($result), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
			
				$sip_param = "'".implode("|",$row)."'"; // строка передаваемая в процедуру редактирования
			
				if($row['status'] == 0){ 
					$status_html = "<img src='./images/house_blue.PNG'>"; 
					$status_edt = 'деактивировать';
				}
				if($row['status'] == -5){ 
					$status_html = "<img src='./images/house_red.PNG'>"; 
					$status_edt = 'активировать';
				}
				if($row['ipaddr'] == 1){ 
					$status_html = "<img src='./images/house_green.PNG'>"; 
				}

				$tabrow[$key] = array(
					//$row['status'],
					$status_html,
					
					empty($row['name'])?'&nbsp;':$row['name'],
					
					'<li class="ui-state-default ui-corner-all" title="'.$status_edt.'" style="margin:1px;padding:2;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="if (confirm(\'Сменить статус SIP счета - '.$row['name'].'?\')) {frm_sip_account_act('.$sip_param.');} else {return false;}">
					<span class="ui-icon ui-icon-home" style="margin:0;"></span></li>
					
					<li class="ui-state-default ui-corner-all" title="редактировать" style="margin:1px;padding:2;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="frm_sip_account_edt('.$sip_param.')">
					<span class="ui-icon ui-icon-pencil" style="margin:0;"></span></li>
					
					<li class="ui-state-default ui-corner-all" title="удалить" style="margin:1px;padding:2;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="if (confirm(\'Удалить SIP счет - '.$row['name'].'?\')) {frm_sip_account_del('.$row['sip_id'].');} else {return false;}">
					<span class="ui-icon ui-icon-close" style="margin:0;"></span></li>'

				);
			}
			if(empty($res)){ $tabrow[0] = array('','','');	}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}

	// добавление нового sip счета ------------------------------------------------------------------
	function proc_user_sipaccount_add(){
		global $database_tar, $session, $logger;
	
		$accountid = (int)$session->acc_accountid;
		$emitterkcid = (int)$session->acc_emitterkcid;

		$NAME = $_REQUEST['NAME'];
		$SECRET = $_REQUEST['SECRET'];
		$SECRET = iconv("UTF-8", "windows-1251",$_REQUEST['SECRET']);
		//$SECRET = iconv("UTF-8", "cp1251",$_REQUEST['SECRET']);
		//$strcode = mb_detect_encoding($SECRET);

		$USERNAME = $NAME;

		$CONTEXT = '';
		$HOST = 'dynamic';
		$INSECURE = 'port';
		$NAT = 'yes';
		$PORT = '5060';
		$PTYPE = 'friend';
		
		$ALLOW = 'g729,alaw,ulaw';
		$CALLERID = $session->ofmainparams['of_number_prefix'].$session->ofnumber;
		$CANREINVITE = 'no';
		$T38PT_UDPTL = '';

		$q = <<<EOS
		select * 
        from sip_create_account( 
        $emitterkcid, 
		$accountid, 
		null, 
		null, 
		'$ALLOW', 
        null, 
		null, 
		null, 
		null, 
		null, 
		null, 
		null, 
		null, 
		'$CALLERID', 
		null, 
		null, 
		null, 
		null, 
		'$CANREINVITE', 
		null, 
        null, null, null, null, null, null, 
		'$HOST', 
		'$INSECURE', 
		null, null, null, null, null, null, null, null, 
        '$NAME', 
		'$NAT', 
		null, null, null, null, 
		'$PORT', 
		null, null, null, null, null, null, null, null, 
        '$SECRET', 
		null, null, null, null, 
		'$T38PT_UDPTL', 
		null, 
		null, 
		null, 
		'$USERNAME', 
		null, 
		null, 
		null, 
		null, 
		null, 
		null 
        );
EOS;

		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res))
			$logger->log("proc_user_sipaccount_add()". getPEARErrorInfo($result), PEAR_LOG_ERR);

			
		//$jsonres = array('ok' => 'yes', 'strcode' => $strcode);
		$jsonres = array('ok'=>'yes');
		echo json_encode($jsonres);
	}

	// редактирование sip счета ------------------------------------------------------------------
	function proc_user_sipaccount_edt(){
		global $database_tar, $session, $logger;
	
		$accountid = (int)$session->acc_accountid;
		$emitterkcid = (int)$session->acc_emitterkcid;

		$SIP_ID = $_REQUEST['SIP_ID'];
		$NAME = $_REQUEST['NAME'];
		$SECRET = $_REQUEST['SECRET'];
		//$SECRET = iconv("UTF-8", "windows-1251",$_REQUEST['SECRET']);

		$q = <<<EOS
		update tbsipconnections set name='$NAME', username='$NAME', secret='$SECRET' where sip_id=$SIP_ID;
EOS;
		$res = $database_tar->query($q);

		$q = <<<EOS
		update tbsipsessions set name='$NAME', username='$NAME', secret='$SECRET' where sip_id=$SIP_ID;
EOS;
		$res = $database_tar->query($q);
		
		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}


// sip-account templates ///////////////////////////////////////////////////////////////////////////	
	
// таблица шаблонов sip счетов 
	function proc_user_sipaccount_def(){
		global $database_tar, $session, $logger;
	
		$q = <<<EOS
		select 
			c.def_id, 
			c.defname, 
			c.name, 
			c.username,
			c.secret, 
			c.context, 
			c.host,
			c.port,
			c.type,
			c.nat,
			
c.accountcode,
c.disallow,
c.allow,
c.allowoverlap,
c.allowsubscribe,
c.allowtransfer,
c.amaflags,
c.autoframing,
c.auth,
c.buggymwi,
c.callgroup,
c.callerid,
c.cid_number,
c.fullname,
c.calllimit,
c.callingpres,
c.canreinvite,
c.defaultip,
c.dtmfmode,
c.fromuser,
c.fromdomain,
c.fullcontact,
c.g726nonstandard,
c.insecure,
c.ipaddr,
c.language,
c.lastms,
c.mailbox,
c.maxcallbitrate,
c.mohsuggest,
c.md5secret,
c.musiconhold,
c.outboundproxy,
c.deny,
c.permit,
c.pickupgroup,
c.progressinband,
c.promiscredir,
c.qualify,
c.regexten,
c.regseconds,
c.rfc2833compensate,
c.rtptimeout,
c.rtpholdtimeout,
c.sendrpid,
c.setvar,
c.subscribecontext,
c.subscribemwi,
c.t38pt_udptl,
c.trustrpid,
c.useclientcode,
c.usereqphone,
c.videosupport,
c.vmexten,
c.busylevel,
c.callcounter,
c.transport
			
		from tbsipdefaults c
EOS;
		
		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_user_sipaccount_def():". getPEARErrorInfo($result), PEAR_LOG_ERR);
			return false;
		} else {
			$tabrow = array();
			foreach($res as $key => $row){
			
				$sip_param = "'".implode("|",$row)."'"; // строка передаваемая в процедуру редактирования
			
				$tabrow[$key] = array(
					
					empty($row['def_id'])?'&nbsp;':$row['def_id'],
					empty($row['defname'])?'&nbsp;':$row['defname'],
					//empty($row['name'])?'&nbsp;':$row['name'],
					//empty($row['username'])?'&nbsp;':$row['username'],
					empty($row['type'])?'&nbsp;':$row['type'],
					empty($row['host'])?'&nbsp;':$row['host'],
					empty($row['port'])?'&nbsp;':$row['port'],
					empty($row['nat'])?'&nbsp;':$row['nat'],
					
					'<li class="ui-state-default ui-corner-all" title="редактировать" style="margin:1px;padding:2;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="frm_sip_account_edt('.$sip_param.')">
					<span class="ui-icon ui-icon-pencil" style="margin:0;"></span></li>
					
					<li class="ui-state-default ui-corner-all" title="удалить" style="margin:1px;padding:2;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="if (confirm(\'Удалить шаблон SIP счета - '.$row['defname'].'?\')) {frm_sip_account_del('.$row['def_id'].');} else {return false;}">
					<span class="ui-icon ui-icon-close" style="margin:0;"></span></li>'

				);
			}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}
	
	// удаление шаблона sip счета ------------------------------------------------------------------
	function proc_user_sipaccount_del_def(){
		global $database_tar, $session, $logger;
	
		$def_id = $_REQUEST['def_id'];

//		$q = "select * from sip_delete_account($sip_id);";
//		$res = $database_tar->getQueryResultAsArray($q);
		$q = "delete from tbsipdefaults where def_id = $def_id;";
		$res = $database_tar->query($q);

		$jsonres = array('ok' => 'yes');
		echo json_encode($res);
	}

	
	// добавление нового шаблона sip счета ------------------------------------------------------------------
	function proc_user_sipaccount_add_def(){
		global $database_tar, $session, $logger;
	
		//$NAME = $_REQUEST['NAME'];
		$DEFNAME = $_REQUEST['DEFNAME'];
		//$USERNAME = $_REQUEST['USERNAME'];
		//$SECRET = $_REQUEST['SECRET'];
		//$SECRET = iconv("UTF-8", "windows-1251",$_REQUEST['SECRET']);
		//$SECRET = iconv("UTF-8", "cp1251",$_REQUEST['SECRET']);
		//$strcode = mb_detect_encoding($SECRET);

		$CONTEXT = $_REQUEST['CONTEXT'];
		$PTYPE = $_REQUEST['PTYPE'];
		$HOST = $_REQUEST['HOST'];
		$PORT = $_REQUEST['PORT'];
		$NAT = $_REQUEST['NAT'];
		$COMMENT = $_REQUEST['COMMENT'];
		
		//$INSECURE = 'port';
		//$ALLOW = 'g729,alaw,ulaw';
		//$CALLERID = $session->ofmainparams['of_number_prefix'].$session->ofnumber;
		//$CANREINVITE = 'no';
		//$T38PT_UDPTL = '';

		
$accountcode = $_REQUEST['accountcode'];
$disallow = $_REQUEST['disallow'];
$allow = $_REQUEST['allow'];
$allowoverlap = $_REQUEST['allowoverlap'];
$allowsubscribe = $_REQUEST['allowsubscribe'];
$allowtransfer = $_REQUEST['allowtransfer'];
$amaflags = $_REQUEST['amaflags'];
$autoframing = $_REQUEST['autoframing'];
$auth = $_REQUEST['auth'];
$buggymwi = $_REQUEST['buggymwi'];
$callgroup = $_REQUEST['callgroup'];
$callerid = $_REQUEST['callerid'];
$cid_number = $_REQUEST['cid_number'];
$fullname = $_REQUEST['fullname'];
$calllimit = $_REQUEST['calllimit'];
$callingpres = $_REQUEST['callingpres'];
$canreinvite = $_REQUEST['canreinvite'];
$defaultip = $_REQUEST['defaultip'];
$dtmfmode = $_REQUEST['dtmfmode'];
$fromuser = $_REQUEST['fromuser'];
$fromdomain = $_REQUEST['fromdomain'];
$fullcontact = $_REQUEST['fullcontact'];
$g726nonstandard = $_REQUEST['g726nonstandard'];
$insecure = $_REQUEST['insecure'];
$ipaddr = $_REQUEST['ipaddr'];
$language = $_REQUEST['language'];
$lastms = $_REQUEST['lastms'];
$mailbox = $_REQUEST['mailbox'];
$maxcallbitrate = $_REQUEST['maxcallbitrate'];
$mohsuggest = $_REQUEST['mohsuggest'];
$md5secret = $_REQUEST['md5secret'];
$musiconhold = $_REQUEST['musiconhold'];
$outboundproxy = $_REQUEST['outboundproxy'];
$deny = $_REQUEST['deny'];
$permit = $_REQUEST['permit'];
$pickupgroup = $_REQUEST['pickupgroup'];
$progressinband = $_REQUEST['progressinband'];
$promiscredir = $_REQUEST['promiscredir'];
$qualify = $_REQUEST['qualify'];
$regexten = $_REQUEST['regexten'];
$regseconds = $_REQUEST['regseconds'];
$rfc2833compensate = $_REQUEST['rfc2833compensate'];
$rtptimeout = $_REQUEST['rtptimeout'];
$rtpholdtimeout = $_REQUEST['rtpholdtimeout'];
$sendrpid = $_REQUEST['sendrpid'];
$setvar = $_REQUEST['setvar'];
$subscribecontext = $_REQUEST['subscribecontext'];
$subscribemwi = $_REQUEST['subscribemwi'];
$t38pt_udptl = $_REQUEST['t38pt_udptl'];
$trustrpid = $_REQUEST['trustrpid'];
$useclientcode = $_REQUEST['useclientcode'];
$usereqphone = $_REQUEST['usereqphone'];
$videosupport = $_REQUEST['videosupport'];
$vmexten = $_REQUEST['vmexten'];
$busylevel = $_REQUEST['busylevel'];
$callcounter = $_REQUEST['callcounter'];
$transport = $_REQUEST['transport'];
		
		$q = <<<EOS
		select * 
        from sip_create_template( 
        '$DEFNAME', 
		'$accountcode', 
		'$disallow', 
		'$allow', 
        '$allowoverlap', 
		'$allowsubscribe', 
		'$allowtransfer', 
		'$amaflags', 
		'$autoframing', 
		'$auth', 
		'$buggymwi', 
		'$callgroup', 
		'$callerid', 
		'$cid_number', 
		'$fullname', 
		$calllimit, 
		'$callingpres', 
		'$canreinvite', 
		'$CONTEXT', 
        '$defaultip', 
		'$dtmfmode', 
		'$fromuser', 
		'$fromdomain', 
		'$fullcontact', 
		'$g726nonstandard', 
		'$HOST', 
		'$insecure', 
		'$ipaddr', 
		'$language', 
		'$lastms',
		'$mailbox',		
		$maxcallbitrate, 
		'$mohsuggest', 
		'$md5secret', 
		'$musiconhold', 
        '$NAME', 
		'$NAT', 
		'$outboundproxy', 
		'$deny', 
		'$permit', 
		'$pickupgroup', 
		'$PORT', 
		'$progressinband', 
		'$promiscredir', 
		'$qualify', 
		'$regexten', 
		$regseconds, 
		'$rfc2833compensate', 
		'$rtptimeout', 
		'$rtpholdtimeout', 
        '$SECRET', 
		'$sendrpid', 
		'$setvar', 
		'$subscribecontext', 
		'$subscribemwi', 
		'$t38pt_udptl', 
		'$trustrpid', 
		'$PTYPE', 
		'$useclientcode', 
		'$USERNAME', 
		'$usereqphone', 
		'$videosupport', 
		'$vmexten', 
		'$busylevel', 
		'$callcounter', 
		'$transport' 
        );
EOS;

		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res))
			$logger->log("proc_user_sipaccount_add()". getPEARErrorInfo($res), PEAR_LOG_ERR);

//		$logger->log("$q", PEAR_LOG_ERR);
			
			
		$DEF_ID = $res[0]['def_id'];
			
		//$jsonres = array('ok' => 'yes', 'strcode' => $strcode);
		$jsonres = array('ok'=>'yes');
		echo json_encode($jsonres);
	}

	// редактирование sip счета ------------------------------------------------------------------
	function proc_user_sipaccount_edt_def(){
		global $database_tar, $session, $logger;

		$DEF_ID = $_REQUEST['DEF_ID'];
		$DEFNAME = $_REQUEST['DEFNAME'];
//		$NAME = $_REQUEST['NAME'];
//		$USERNAME = $_REQUEST['USERNAME'];
//		$SECRET = $_REQUEST['SECRET'];
//		$SECRET = iconv("UTF-8", "windows-1251",$_REQUEST['SECRET']);

		$CONTEXT = $_REQUEST['CONTEXT'];
		$PTYPE = $_REQUEST['PTYPE'];
		$HOST = $_REQUEST['HOST'];
		$PORT = $_REQUEST['PORT'];
		$NAT = $_REQUEST['NAT'];
		$COMMENT = $_REQUEST['COMMENT'];
		
$accountcode = $_REQUEST['accountcode'];
$disallow = $_REQUEST['disallow'];
$allow = $_REQUEST['allow'];
$allowoverlap = $_REQUEST['allowoverlap'];
$allowsubscribe = $_REQUEST['allowsubscribe'];
$allowtransfer = $_REQUEST['allowtransfer'];
$amaflags = $_REQUEST['amaflags'];
$autoframing = $_REQUEST['autoframing'];
$auth = $_REQUEST['auth'];
$buggymwi = $_REQUEST['buggymwi'];
$callgroup = $_REQUEST['callgroup'];
$callerid = $_REQUEST['callerid'];
$cid_number = $_REQUEST['cid_number'];
$fullname = $_REQUEST['fullname'];
$calllimit = $_REQUEST['calllimit'];
$callingpres = $_REQUEST['callingpres'];
$canreinvite = $_REQUEST['canreinvite'];
$defaultip = $_REQUEST['defaultip'];
$dtmfmode = $_REQUEST['dtmfmode'];
$fromuser = $_REQUEST['fromuser'];
$fromdomain = $_REQUEST['fromdomain'];
$fullcontact = $_REQUEST['fullcontact'];
$g726nonstandard = $_REQUEST['g726nonstandard'];
$insecure = $_REQUEST['insecure'];
$ipaddr = $_REQUEST['ipaddr'];
$language = $_REQUEST['language'];
$lastms = $_REQUEST['lastms'];
$mailbox = $_REQUEST['mailbox'];
$maxcallbitrate = $_REQUEST['maxcallbitrate'];
$mohsuggest = $_REQUEST['mohsuggest'];
$md5secret = $_REQUEST['md5secret'];
$musiconhold = $_REQUEST['musiconhold'];
$outboundproxy = $_REQUEST['outboundproxy'];
$deny = $_REQUEST['deny'];
$permit = $_REQUEST['permit'];
$pickupgroup = $_REQUEST['pickupgroup'];
$progressinband = $_REQUEST['progressinband'];
$promiscredir = $_REQUEST['promiscredir'];
$qualify = $_REQUEST['qualify'];
$regexten = $_REQUEST['regexten'];
$regseconds = $_REQUEST['regseconds'];
$rfc2833compensate = $_REQUEST['rfc2833compensate'];
$rtptimeout = $_REQUEST['rtptimeout'];
$rtpholdtimeout = $_REQUEST['rtpholdtimeout'];
$sendrpid = $_REQUEST['sendrpid'];
$setvar = $_REQUEST['setvar'];
$subscribecontext = $_REQUEST['subscribecontext'];
$subscribemwi = $_REQUEST['subscribemwi'];
$t38pt_udptl = $_REQUEST['t38pt_udptl'];
$trustrpid = $_REQUEST['trustrpid'];
$useclientcode = $_REQUEST['useclientcode'];
$usereqphone = $_REQUEST['usereqphone'];
$videosupport = $_REQUEST['videosupport'];
$vmexten = $_REQUEST['vmexten'];
$busylevel = $_REQUEST['busylevel'];
$callcounter = $_REQUEST['callcounter'];
$transport = $_REQUEST['transport'];
		
		$q = <<<EOS
		select * 
        from sip_update_template( 
        $DEF_ID, 
		'$DEFNAME',
		'$accountcode', 
		'$disallow', 
		'$allow', 
        '$allowoverlap', 
		'$allowsubscribe', 
		'$allowtransfer', 
		'$amaflags', 
		'$autoframing', 
		'$auth', 
		'$buggymwi', 
		'$callgroup', 
		'$callerid', 
		'$cid_number', 
		'$fullname', 
		'$calllimit', 
		'$callingpres', 
		'$canreinvite', 
		'$CONTEXT', 
        '$defaultip', 
		'$dtmfmode', 
		'$fromuser', 
		'$fromdomain', 
		'$fullcontact', 
		'$g726nonstandard', 
		'$HOST', 
		'$insecure', 
		'$ipaddr', 
		'$language', 
		'$lastms',
		'$mailbox',		
		'$maxcallbitrate', 
		'$mohsuggest', 
		'$md5secret', 
		'$musiconhold', 
        '$NAME', 
		'$NAT', 
		'$outboundproxy', 
		'$deny', 
		'$permit', 
		'$pickupgroup', 
		'$PORT', 
		'$progressinband', 
		'$promiscredir', 
		'$qualify', 
		'$regexten', 
		'$regseconds', 
		'$rfc2833compensate', 
		'$rtptimeout', 
		'$rtpholdtimeout', 
        '$SECRET', 
		'$sendrpid', 
		'$setvar', 
		'$subscribecontext', 
		'$subscribemwi', 
		'$t38pt_udptl', 
		'$trustrpid', 
		'$PTYPE', 
		'$useclientcode', 
		'$USERNAME', 
		'$usereqphone', 
		'$videosupport', 
		'$vmexten', 
		'$busylevel', 
		'$callcounter', 
		'$transport' 
        );
EOS;
		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res))
			$logger->log("proc_user_sipaccount_edt()". getPEARErrorInfo($res), PEAR_LOG_ERR);

//$logger->log("$q", PEAR_LOG_ERR);
		
		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}

	
// шаблоны sip счетов
	function proc_user_sip_template_list(){
		global $database_tar, $session, $logger;
	
		$q = <<<EOS
		select 
			c.defname, 
			c.def_id 
		from tbsipdefaults c;
EOS;

$logger->log("$q", PEAR_LOG_ERR);
		
		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_user_sip_template_list():". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {

			foreach($res as $key => $row){
				$tabrow[$key] = array(
					$row['defname'],
					$row['def_id']
				);
			}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}
	
// параметры шаблона sip счета
	function proc_user_sip_template(){
		global $database_tar, $session, $logger;
	
		$def_id = $_REQUEST['def_id'];
	
		$q = <<<EOS
		select 
			c.defname, 
			c.def_id, 
			c.username,
			c.secret, 
			c.context, 
			c.host,
			c.port,
			c.type,
			c.nat,
			
c.accountcode,
c.disallow,
c.allow,
c.allowoverlap,
c.allowsubscribe,
c.allowtransfer,
c.amaflags,
c.autoframing,
c.auth,
c.buggymwi,
c.callgroup,
c.callerid,
c.cid_number,
c.fullname,
c.calllimit,
c.callingpres,
c.canreinvite,
c.defaultip,
c.dtmfmode,
c.fromuser,
c.fromdomain,
c.fullcontact,
c.g726nonstandard,
c.insecure,
c.ipaddr,
c.language,
c.lastms,
c.mailbox,
c.maxcallbitrate,
c.mohsuggest,
c.md5secret,
c.musiconhold,
c.outboundproxy,
c.deny,
c.permit,
c.pickupgroup,
c.progressinband,
c.promiscredir,
c.qualify,
c.regexten,
c.regseconds,
c.rfc2833compensate,
c.rtptimeout,
c.rtpholdtimeout,
c.sendrpid,
c.setvar,
c.subscribecontext,
c.subscribemwi,
c.t38pt_udptl,
c.trustrpid,
c.useclientcode,
c.usereqphone,
c.videosupport,
c.vmexten,
c.busylevel,
c.callcounter,
c.transport
			
		from tbsipdefaults c where def_id = $def_id;
EOS;

//$logger->log("$q", PEAR_LOG_ERR);
		
		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_user_sip_template():". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {

			foreach($res as $key => $row){
				$tabrow[$key] = array(
					'defname' => $row['defname'],
					'def_id' => $row['def_id'],
					'username' => $row['username'],
					'secret' => $row['secret'], 
					'context' => $row['context'], 
					'host' => $row['host'],
					'port' => $row['port'],
					'type' => $row['type'],
					'nat' => $row['nat'],
					'accountcode' => $row['accountcode'],
					'disallow' => $row['disallow'],
					'allow' => $row['allow'],
					'allowoverlap' => $row['allowoverlap'],
					'allowsubscribe' => $row['allowsubscribe'],
					'allowtransfer' => $row['allowtransfer'],
					'amaflags' => $row['amaflags'],
					'autoframing' => $row['autoframing'],
					'auth' => $row['auth'],
					'buggymwi' => $row['buggymwi'],
					'callgroup' => $row['callgroup'],
					'callerid' => $row['callerid'],
					'cid_number' => $row['cid_number'],
					'fullname' => $row['fullname'],
					'calllimit' => $row['calllimit'],
					'callingpres' => $row['callingpres'],
					'canreinvite' => $row['canreinvite'],
					'defaultip' => $row['defaultip'],
					'dtmfmode' => $row['dtmfmode'],
					'fromuser' => $row['fromuser'],
					'fromdomain' => $row['fromdomain'],
					'fullcontact' => $row['fullcontact'],
					'g726nonstandard' => $row['g726nonstandard'],
					'insecure' => $row['insecure'],
					'ipaddr' => $row['ipaddr'],
					'language' => $row['language'],
					'lastms' => $row['lastms'],
					'mailbox' => $row['mailbox'],
					'maxcallbitrate' => $row['maxcallbitrate'],
					'mohsuggest' => $row['mohsuggest'],
					'md5secret' => $row['md5secret'],
					'musiconhold' => $row['musiconhold'],
					'outboundproxy' => $row['outboundproxy'],
					'deny' => $row['deny'],
					'permit' => $row['permit'],
					'pickupgroup' => $row['pickupgroup'],
					'progressinband' => $row['progressinband'],
					'promiscredir' => $row['promiscredir'],
					'qualify' => $row['qualify'],
					'regexten' => $row['regexten'],
					'regseconds' => $row['regseconds'],
					'rfc2833compensate' => $row['rfc2833compensate'],
					'rtptimeout' => $row['rtptimeout'],
					'rtpholdtimeout' => $row['rtpholdtimeout'],
					'sendrpid' => $row['sendrpid'],
					'setvar' => $row['setvar'],
					'subscribecontext' => $row['subscribecontext'],
					'subscribemwi' => $row['subscribemwi'],
					't38pt_udptl' => $row['t38pt_udptl'],
					'trustrpid' => $row['trustrpid'],
					'useclientcode' => $row['useclientcode'],
					'usereqphone' => $row['usereqphone'],
					'videosupport' => $row['videosupport'],
					'vmexten' => $row['vmexten'],
					'busylevel' => $row['busylevel'],
					'callcounter' => $row['callcounter'],
					'transport' => $row['transport']
				);
			}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}


// ******************************************************************************************
//								page: acc_user.php	Пользователи 
// ******************************************************************************************

// список пользователей
	function proc_acc_users(){
		global $database, $session, $logger;
	
		$ofid = (int)$session->ofid;

		$q = <<<EOS
		select 
			u.user_id,
			u.user_name,
			r.role_name,
			u.user_mail,
			u.user_password,
			r.role_id
		from tb_office_users u left join tb_userroles r on u.user_role = r.role_id
		where of_id=$ofid;
EOS;
		
		$res = $database->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_acc_users".getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
				$rowset = "'".implode("|",$row)."'";
			
				$tabrow[$key] = array(
					'user_id' => empty($row['user_id'])?'&nbsp;':$row['user_id'],
					'user_name' => empty($row['user_name'])?'&nbsp;':$row['user_name'],
					'role_name' => empty($row['role_name'])?'&nbsp;':$row['role_name'],
					'user_mail' => empty($row['user_mail'])?'&nbsp;':$row['user_mail'],
					'user_password' => empty($row['user_password'])?'&nbsp;':$row['user_password'],
					
					'control' => '<li class="ui-state-default ui-corner-all" title="редактировать" style="margin:1px;padding:2;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="frm_dialog_user_edt('.$rowset.')">
					<span class="ui-icon ui-icon-pencil" style="margin:0;"></span></li>
					
					<li class="ui-state-default ui-corner-all" title="удалить" style="margin:1px;padding:2;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="if (confirm(\'Удалить пользователя - '.$row['user_name'].'?\')) {frm_user_del('.$row['user_id'].');} else {return false;}">
					<span class="ui-icon ui-icon-close" style="margin:0;"></span></li>'

				);
			}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}
	
// список доступных офису ролей
	function proc_office_roles(){
		global $database, $session, $logger;
	
		$ofid = (int)$session->ofid;

		$res = $database->getOfficeRoleList($ofid);
		if (PEAR::isError($res)) {
			$logger->log("proc_office_roles():". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {

			foreach($res as $key => $row){
				$tabrow[$key] = array(
					$row['role_name'],
					$row['role_id']
				);
			}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}

// добавление пользователя	
	function proc_acc_users_add(){
		global $database, $session, $logger;
	
		$of_id = (int)$session->ofid;
		$txt_user_name = $_REQUEST['txt_user_name'];
		$txt_role_name = $_REQUEST['txt_role_name'];
		$txt_user_mail = $_REQUEST['txt_user_mail'];
		$txt_user_password = $_REQUEST['txt_user_password'];

		$q = <<<EOS
		insert into tb_office_users (USER_NAME,USER_PASSWORD,USER_ROLE,OF_ID,ADD_DATE,USER_MAIL) values 
		('$txt_user_name','$txt_user_password',$txt_role_name,$of_id, CURRENT_TIMESTAMP,'$txt_user_mail');
EOS;

		$res = $database->getQueryResultAsArray($q);
		if (PEAR::isError($res))
			$logger->log("proc_acc_users_add('$txt_user_name','$txt_user_password',$txt_role_name,$of_id, CURRENT_TIMESTAMP,$txt_user_mail)". getPEARErrorInfo($result), PEAR_LOG_ERR);
			
		$jsonres = array('ok'=>'yes');
		echo json_encode($jsonres);
	}
	
// редактирование пользователя	
	function proc_acc_users_edt(){
		global $database, $session, $logger;
	
		$of_id = (int)$session->ofid;
		$txt_user_id = $_REQUEST['txt_user_id'];
		$txt_user_name = $_REQUEST['txt_user_name'];
		$txt_role_name = $_REQUEST['txt_role_name'];
		$txt_user_mail = $_REQUEST['txt_user_mail'];
		$txt_user_password = $_REQUEST['txt_user_password'];

		$q = <<<EOS
		update tb_office_users set 
		USER_NAME = '$txt_user_name',
		USER_PASSWORD = '$txt_user_password',
		USER_ROLE = $txt_role_name,
		USER_MAIL = '$txt_user_mail'
		where
		user_id = $txt_user_id;
EOS;

		$res = $database->getQueryResultAsArray($q);
		if (PEAR::isError($res))
			$logger->log("proc_acc_users_edt('$txt_user_name','$txt_user_password',$txt_role_name,$of_id,$txt_user_mail)". getPEARErrorInfo($result), PEAR_LOG_ERR);
			
		$jsonres = array('ok'=>'yes');
		echo json_encode($jsonres);
	}
	
	// удаление пользователя
	function proc_acc_users_del(){
		global $database, $session, $logger;
	
		$user_id = $_REQUEST['user_id'];

		$q = "delete from tb_office_users where user_id = $user_id;";
		$res = $database->query($q);

		$jsonres = array('ok' => 'yes');
		echo json_encode($res);
	}
	
	
	
	
// ******************************************************************************************
//								
// ******************************************************************************************
	

	function procPbxEditDayGroups(){
		global $database_tar, $session, $form, $logger;

		// access level control
		/*if(!($session->checkUserRight('pbx_daygroups.php','W'))){
			$session->only_read_message=MSG_READONLY;
			header("Location: ".$session->referrer);
			return;
		}*/

		$retval = true;
		if ($retval) {
			$session->edit_daygroups = true;
			//$logger->log("procEditDayGroups:ref=".$session->referrer);
			//$logger->log("procEditDayGroups:post=".print_r($_POST, true));

			$last_id = $_POST["last_id"];
			$last_daygroup_id = $_POST["last_daygroup_id"];
			$last_db_daygroup_id = $_POST["last_db_daygroup_id"];

			//get deleted
			$arrDeletedIDs = array();
			$arrTmp = explode(",", trim($_POST['hidChangedIDHolder'], ','));
			foreach ($arrTmp as $id_ex) {
				if (preg_match('/^(?P<id>[-]*\d+)_(\d+)$/', $id_ex, $matches) == 1 && $matches['id'] < 0)
					$arrDeletedIDs[abs($matches['id'])] = true;
			}
			//$logger->log("arrDeletedIDs=".print_r($arrDeletedIDs, true));

			//create new day_groups
			$arrDayGroupsIDs = array();
			for ($i = 0; $i <= $last_daygroup_id; $i++) {
				if (isset($_POST["daygroup_name_$i"])) {
					if ((strlen(trim($_POST["daygroup_name_$i"])) == 0) && ($i > $last_db_daygroup_id))
						continue;
					$dbres = $database_tar->updateDayGroup(
														$i > $last_db_daygroup_id ? -1 : $i,
														stripslashes($_POST["daygroup_name_$i"]));
					if ($dbres[0]['op_result'] == 1)
						$arrDayGroupsIDs[$i] = $dbres[0]['out_daygroup_id'];
				}
			}
			//$logger->log("arrDayGroupsIDs=".print_r($arrDayGroupsIDs, true));

			//weekdays
			for ($i = 0; $i <= $last_daygroup_id; $i++) {
				if (isset($_POST["daygroup_name_$i"])) {
					$weekdays_mask = 0;
					for ($day_id = 0; $day_id <= 6; $day_id++) {
						if (isset($_POST["weekday_{$i}_{$day_id}"]))
							$weekdays_mask = $weekdays_mask | pow(2, $day_id);
					}
					$dbres = $database_tar->updateWeekDays_Mask($arrDayGroupsIDs[$i], $weekdays_mask);
				}
			}

			//begin_trans
			/*$database->transactionStart();

			//empty TB_HOLLYDAYS
			foreach ($arrDayGroupsIDs as $idl)
				$database->query("delete from tb_hollydays where daygroup_id=$idl");

			//create hollydays
			$arrDaysPostData = array();
			for ($id = 0; $id <= $last_id; $id++) {
				for ($idl = 0; $idl <= $last_daygroup_id; $idl++) {
					if (array_key_exists($idl, $arrDayGroupsIDs) &&
						isset($_POST["hollyday_{$id}_{$idl}"]) &&
						!array_key_exists($id, $arrDeletedIDs)) {
						$arrDaysPostData[] = array($_POST["hollyday_{$id}_{$idl}"],
													$arrDayGroupsIDs[$idl],
													stripslashes($_POST["hollyday_name_{$id}_{$idl}"]));
					}
				}
			}

			if (!$arrDaysPostData || ($database->updateDaysMultiple($session->ofid, $arrDaysPostData)))
				$database->transactionCommit();
			else
				$database->transactionRollback();
			//end_trans*/
		} else {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}
		header("Location: ".$session->referrer);
	}


// ******************************************************************************************
//	IP-PBX							
// ******************************************************************************************


// таблица маршрутизации ---------------------------------------------------------------------------
	function proc_pbx_router_table(){
		global $database_tar, $session, $logger;
	
		$q = <<<EOS
		select
		siprouter_name,
		siprouter_id
		from tbsiprouter;
EOS;
		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_pbx_router_table: $q". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
				$param = "'".implode("|",$row)."'"; // строка передаваемая в процедуру редактирования
			
				$tabrow[$key] = array(
					$row['siprouter_name'],
					$row['siprouter_id'],

					'<li class="ui-state-default ui-corner-all" title="Параметры" style="margin:1px;padding:0;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="frm_sip_view('.$param.')">
					<span class="ui-icon ui-icon-script" style="margin:0;"></span></li>

					<li class="ui-state-default ui-corner-all" title="Редактировать" style="margin:1px;padding:0;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="frm_router_edt('.$param.')">
					<span class="ui-icon ui-icon-pencil" style="margin:0;"></span></li>
					
					<li class="ui-state-default ui-corner-all" title="Удалить" style="margin:1px;padding:0;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="if (confirm(\'Удалить таблицу маршрутизации - '.$row['siprouter_name'].'?\')) {frm_router_del('.$row['siprouter_id'].');} else {return false;}">
					<span class="ui-icon ui-icon-close" style="margin:0;"></span></li>'


				);
			}
			if(empty($res)){ $tabrow[0] = array('','','');	}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}

	
// маршруты ---------------------------------------------------------------------------
	function proc_pbx_routerpath_table(){
		global $database_tar, $session, $logger;

		$router_id = $_REQUEST['router_id'];
		
		$q = <<<EOS
		select
		p.number,
		p.number_out,
		p.aon,
		p.aon_out,
		g.graphname,
		
		p.siprouterpath_id,
		p.siprouter_id,
		p.graphid,
		p.router_order,

		dial_mode,
		wait_answer_pause,
		redial_pause,
		redial_count,
		do_recording,
		menu_id,
		out_type

		from tbsiprouterpath p left join tbgraphs g on p.graphid=g.graphid
		where p.siprouter_id=$router_id
		order by p.router_order;
EOS;

		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_pbx_routerpath_table: $q". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
				$param = "'".implode("@@",$row)."'"; // строка передаваемая в процедуру редактирования
			
				$tabrow[$key] = array(

					'<img src="./images/movedn.gif" style="cursor:pointer;" onclick="do_move_path_down('.$row['siprouterpath_id'].')">
					<img src="./images/moveup.gif" style="cursor:pointer;" onclick="do_move_path_up('.$row['siprouterpath_id'].')">',

					$row['number'],
					$row['number_out'],
					$row['aon'],
					$row['aon_out'],
					$row['graphname'],
					$row['siprouterpath_id'],
					$row['siprouter_id'],
					$row['graphid'],
					$row['router_order'],

					'<li class="ui-state-default ui-corner-all" title="Параметры" style="margin:1px;padding:0;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="frm_path_view('.$param.')">
					<span class="ui-icon ui-icon-script" style="margin:0;"></span></li>
					
					<li class="ui-state-default ui-corner-all" title="Редактировать" style="margin:1px;padding:0;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="frm_path_edt('.$param.')">
					<span class="ui-icon ui-icon-pencil" style="margin:0;"></span></li>
					
					<li class="ui-state-default ui-corner-all" title="Удалить" style="margin:1px;padding:0;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="if (confirm(\'Удалить маршрут - '.$row['router_order'].'?\')) {frm_path_del('.$row['siprouterpath_id'].');} else {return false;}">
					<span class="ui-icon ui-icon-close" style="margin:0;"></span></li>',

					$row['dial_mode'],
					$row['wait_answer_pause'],
					$row['redial_pause'],
					$row['redial_count'],
					$row['do_recording'],
					$row['menu_id'],
					$row['select_out_type']
					
				);
			}
			if(empty($res)){ $tabrow[0] = array('','','','','','','','','','',''    ,'','','','','','','');	}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}

// временные графики ---------------------------------------------------------------------------
	function proc_pbx_graph_list(){
		global $database_tar, $session, $logger;
	
		$q = <<<EOS
		select
		graphname,
		graphid
		from tbgraphs;
EOS;
		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_pbx_graph_list: $q". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
				$param = "'".implode("|",$row)."'";
			
				$tabrow[$key] = array(
					$row['graphname'],
					$row['graphid']
				);
			}
			if(empty($res)){ $tabrow[0] = array('','');	}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}
	
	// добавление таблицы маршрутизации ------------------------------------------------------------------
	function proc_pbx_router_add(){
		global $database_tar, $session, $logger;
	
		$router_name = $_REQUEST['router_name'];

		$q = <<<EOS
		insert into tbsiprouter (siprouter_name) values ('$router_name');
EOS;

		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_router_add($q)". getPEARErrorInfo($result), PEAR_LOG_ERR);
			
		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}

	// редактирование таблицы маршрутизации ------------------------------------------------------------------
	function proc_pbx_router_edt(){
		global $database_tar, $session, $logger;
	
		$router_name = $_REQUEST['router_name'];
		$router_id = $_REQUEST['router_id'];

		$q = <<<EOS
		update tbsiprouter set 
			siprouter_name ='$router_name' 
		where siprouter_id=$router_id;
EOS;
		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_router_edt($q)". getPEARErrorInfo($result), PEAR_LOG_ERR);

		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}

	// удаление таблицы маршрутизации ------------------------------------------------------------------
	function proc_pbx_router_del(){
		global $database_tar, $session, $logger;
	
		$router_id = $_REQUEST['router_id'];

		$q = <<<EOS
		delete from tbsiprouter where siprouter_id=$router_id;
EOS;
		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_router_del($q)". getPEARErrorInfo($result), PEAR_LOG_ERR);
		
		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}

// ******************************************************************************************
//								
// ******************************************************************************************

	// добавление маршрута ------------------------------------------------------------------
	function proc_pbx_routerpath_add(){
		global $database_tar, $session, $logger;
	
		$txt_number = $_REQUEST['txt_number'];
		$txt_number_out = $_REQUEST['txt_number_out'];
		$txt_aon = $_REQUEST['txt_aon'];
		$txt_aon_out = $_REQUEST['txt_aon_out'];
		$txt_graph = $_REQUEST['txt_graph'];
		$txt_router_id = $_REQUEST['txt_router_id'];
		$txt_peer = explode('|',$_REQUEST['txt_peer']);

		$select_dialmode = $_REQUEST['select_dialmode'];
		$txt_answer_pause = $_REQUEST['txt_answer_pause'];
		$txt_redial_pause = $_REQUEST['txt_redial_pause'];
		$txt_redial_count = $_REQUEST['txt_redial_count'];
		$txt_recording = $_REQUEST['txt_recording'];
		$select_out_type = $_REQUEST['select_out_type'];
		$select_menu_list = $_REQUEST['select_menu_list'];
		
		if(empty($select_dialmode)) $select_dialmode = 1;
		if(empty($txt_answer_pause)) $txt_answer_pause = 0;
		if(empty($txt_redial_pause)) $txt_redial_pause = 0;
		if(empty($txt_redial_count)) $txt_redial_count = 0;
		if(empty($txt_recording)) $txt_recording = 1;
		if(empty($select_menu_list)) $select_menu_list = '';
		
		$q = <<<EOS
		insert into tbsiprouterpath (siprouter_id,number,number_out,aon,aon_out,graphid,
		dial_mode,
		wait_answer_pause,
		redial_pause,
		redial_count,
		do_recording,
		menu_id,
		out_type
		) 
		values (
			$txt_router_id,
			'$txt_number',
			'$txt_number_out',
			'$txt_aon',
			'$txt_aon_out',
			$txt_graph,

		$select_dialmode,
		$txt_answer_pause,
		$txt_redial_pause,
		$txt_redial_count,
		$txt_recording,
		case when $select_out_type=1 then null else $select_menu_list end,
		$select_out_type
		);
EOS;

		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_routerpath_add($q)". getPEARErrorInfo($result), PEAR_LOG_ERR);

		$q = <<<EOS
		select max(siprouterpath_id) as siprouterpath_id from tbsiprouterpath where siprouter_id=$txt_router_id;
EOS;
		$res = $database_tar->getQueryResultAsArray($q);
		$siprouterpath_id = $res[0]['siprouterpath_id'];
		foreach ($txt_peer as $key => $value) {
		$q = <<<EOS
		insert into tbsipout (sip_id,siprouterpath_id) values ($value,$siprouterpath_id)
EOS;
		$res = $database_tar->query($q);
		}

			
		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}

	// редактирование маршрута ------------------------------------------------------------------
	function proc_pbx_routerpath_edt(){
		global $database_tar, $session, $logger;
	
		$txt_number = $_REQUEST['txt_number'];
		$txt_number_out = $_REQUEST['txt_number_out'];
		$txt_aon = $_REQUEST['txt_aon'];
		$txt_aon_out = $_REQUEST['txt_aon_out'];
		$txt_graph = $_REQUEST['txt_graph'];
		$txt_path_id = $_REQUEST['txt_path_id'];
		//$txt_router_id = $_REQUEST['txt_router_id'];
		//siprouter_id = $txt_router_id,
		$txt_peer = explode('|',$_REQUEST['txt_peer']);

		$select_dialmode = $_REQUEST['select_dialmode'];
		$txt_answer_pause = $_REQUEST['txt_answer_pause'];
		$txt_redial_pause = $_REQUEST['txt_redial_pause'];
		$txt_redial_count = $_REQUEST['txt_redial_count'];
		$txt_recording = $_REQUEST['txt_recording'];
		$select_out_type = $_REQUEST['select_out_type'];
		$select_menu_list = $_REQUEST['select_menu_list'];
		
		if(empty($select_dialmode)) $select_dialmode = 1;
		if(empty($txt_answer_pause)) $txt_answer_pause = 0;
		if(empty($txt_redial_pause)) $txt_redial_pause = 0;
		if(empty($txt_redial_count)) $txt_redial_count = 0;
		if(empty($txt_recording)) $txt_recording = 1;
		if(empty($select_menu_list)) $select_menu_list = '';
		
		$q = <<<EOS
		update tbsiprouterpath set 
		number = '$txt_number',
		number_out = '$txt_number_out',
		aon = '$txt_aon',
		aon_out = '$txt_aon_out',
		graphid = $txt_graph,
		dial_mode = $select_dialmode,
		wait_answer_pause = $txt_answer_pause,
		redial_pause = $txt_redial_pause,
		redial_count = $txt_redial_count,
		do_recording = $txt_recording,
		menu_id = case when $select_out_type=1 then null else $select_menu_list end,
		out_type = $select_out_type
		where siprouterpath_id=$txt_path_id;
EOS;
		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_routerpath_edt($q)". getPEARErrorInfo($result), PEAR_LOG_ERR);
			
			
		$q = <<<EOS
		delete from tbsipout where siprouterpath_id=$txt_path_id;
EOS;
		$res = $database_tar->query($q);
		foreach ($txt_peer as $key => $value) {
		$q = <<<EOS
		insert into tbsipout (sip_id,siprouterpath_id) values ($value,$txt_path_id)
EOS;
		$res = $database_tar->query($q);
		}
			
			
			
		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}

	// удаление маршрута ------------------------------------------------------------------
	function proc_pbx_routerpath_del(){
		global $database_tar, $session, $logger;
	
		$txt_path_id = $_REQUEST['txt_path_id'];

		$q = <<<EOS
		delete from tbsipout where siprouterpath_id=$txt_path_id;
EOS;
		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_routerpath_del($q)". getPEARErrorInfo($result), PEAR_LOG_ERR);

		$q = <<<EOS
		delete from tbsiprouterpath where siprouterpath_id=$txt_path_id;
EOS;
		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_routerpath_del($q)". getPEARErrorInfo($result), PEAR_LOG_ERR);
		
		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}


// получение блоков номера (тестирование номера) ---------------------------------------------------------------------------
	function proc_pbx_pathnumber_test(){
		global $database_tar, $session, $logger;
	
		$txt_number = $_REQUEST['txt_number'];
		$txt_test_number = $_REQUEST['txt_test_number'];

/*		$q = <<<EOS
		select snum from rt_number_compare('$txt_test_number','$txt_number',1);
EOS;*/
		$q = <<<EOS
		select snum from rt_number_pass_two('$txt_test_number','$txt_number',1);
EOS;
		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_pbx_pathnumber_test: $q". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
		
				$tabrow[$key] = array(
					$row['snum']
				);
			}
			if(empty($res)){ $tabrow[0] = array('');	}
			$jsonres = array('data' => $tabrow );
		}
	
		echo json_encode($jsonres);
	}
// трансляция номера (тестирование номера) ---------------------------------------------------------------------------
	function proc_pbx_numbertranslate_test(){
		global $database_tar, $session, $logger;
	
		$txt_number = $_REQUEST['txt_number'];
		$txt_test_number = $_REQUEST['txt_test_number'];
		$txt_number_out = $_REQUEST['txt_number_out'];

		$q = <<<EOS
		select snum from rt_number_translate('$txt_test_number','$txt_number','$txt_number_out');
EOS;
		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("pbx_numbertranslate_test: $q". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
		
				$tabrow[$key] = array(
					$row['snum']
				);
			}
			if(empty($res)){ $tabrow[0] = array('');	}
			$jsonres = array('data' => $tabrow );
		}
	
		echo json_encode($jsonres);
	}



// выходные sip-аккаунты маршрутов ---------------------------------------------------------------------------
	function proc_pbx_pathpeer_table(){
		global $database_tar, $session, $logger;

		$path_id = $_REQUEST['path_id'];
		if(!$path_id) {$path_id=-1;}
		
		$q = <<<EOS
        select
        c.name,
        case when o.sip_id is null then 0 else 1 end as sipkey,
        a.sip_id,
        1 as siprouterpath_id
        from
        tbsipaccounts a inner join tbsipconnections c on a.sip_id=c.sip_id
        left join
        (select * from tbsipout where siprouterpath_id=$path_id) as o on a.sip_id=o.sip_id
EOS;

		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_pbx_pathpeer_table: $q". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
				$param = "'".implode("@@",$row)."'"; // строка передаваемая в процедуру редактирования
			
				if($row['sipkey']=='1'){ $chk='checked="checked" value="1"'; } else { $chk='  value="0"'; }

				$tabrow[$key] = array(

					$row['name'],
					'<input type="checkbox" style="margin:0;" '.$chk.' onclick="if(this.checked) this.value=1; else this.value=0; ">',
					$row['sip_id'],
					$row['siprouterpath_id']
				);
			}
			if(empty($res)){ $tabrow[0] = array('','','','');	}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}


	
	// изменение приоритета маршрута ------------------------------------------------------------------
	function proc_pbx_routerpath_moveup(){
		global $database_tar, $session, $logger;
	
		$path_id = $_REQUEST['path_id'];

		$q = <<<EOS
		execute procedure rt_routerpath_moveup($path_id);
EOS;
		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_routerpath_moveup($q)". getPEARErrorInfo($result), PEAR_LOG_ERR);
		
		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}
	// изменение приоритета маршрута ------------------------------------------------------------------
	function proc_pbx_routerpath_movedown(){
		global $database_tar, $session, $logger;
	
		$path_id = $_REQUEST['path_id'];

		$q = <<<EOS
		execute procedure rt_routerpath_movedown($path_id);
EOS;
		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_routerpath_movedown($q)". getPEARErrorInfo($result), PEAR_LOG_ERR);
		
		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}
	
// sip-аккаунты  маршрута -----------------------------------------------------------------------
	function proc_pbx_routerpath_view(){
		global $database_tar, $session, $logger;

		$txt_path_id = $_REQUEST['txt_path_id'];
		
		$q = <<<EOS
		select
		c.name
		from tbsipout o inner join tbsipaccounts a on o.sip_id=a.sip_id
		inner join tbsipconnections c on a.sip_id=c.sip_id
		where o.siprouterpath_id=$txt_path_id
		order by c.name;
EOS;

		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_pbx_routerpath_view: $q". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
				$tabrow[$key] = array(
					$row['name']
				);
			}
			if(empty($res)){ $tabrow[0] = array('');	}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
		echo json_encode($res);
	}
	

// таблицы маршрутизации сип-аккаунтов ---------------------------------------------------------------------------
	function proc_pbx_sip_route_list(){
		global $database_tar, $session, $logger;
	
		$q = <<<EOS
		select
		c.name,
		r.siprouter_name,
		c.sip_id,
		r.siprouter_id
		from tbsipaccounts a inner join tbsipconnections c on a.sip_id=c.sip_id
		left join tbsiprouter r on a.siprouter_id=r.siprouter_id
EOS;
		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_pbx_sip_route_list: $q". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
				$param = "'".implode("|",$row)."'"; // строка передаваемая в процедуру редактирования
			
				$tabrow[$key] = array(
					$row['name'],
					$row['siprouter_name'],
					$row['sip_id'],
					$row['siprouter_id'],

					'<li class="ui-state-default ui-corner-all" title="Редактировать" style="margin:1px;padding:0;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="frm_router_edt('.$param.')">
					<span class="ui-icon ui-icon-pencil" style="margin:0;"></span></li>'

				);
			}
			if(empty($res)){ $tabrow[0] = array('','','');	}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}

	// присвоение таблицы маршрутизации сип-аккаунту ------------------------------------------------------------------
	function proc_pbx_sip_route_edt(){
		global $database_tar, $session, $logger;
	
		$txt_sip_id = $_REQUEST['txt_sip_id'];
		$txt_router_id = $_REQUEST['txt_router_id'];

		$q = <<<EOS
		update tbsipaccounts set 
			siprouter_id ='$txt_router_id' 
		where sip_id=$txt_sip_id;
EOS;
		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_sip_route_edt($q)". getPEARErrorInfo($result), PEAR_LOG_ERR);

		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}

	
	// временные графики - редактирование
	function proc_pbx_EditGraphs(){
		global $database_tar, $session, $form, $logger;

		// access level control
		if( !($session->checkUserRight('pbx_graphs.php','W')) ){
			$session->only_read_message=MSG_READONLY;
			header("Location: ".$session->referrer);
			return;
		}

		//$retval = $session->editNumbers($_POST['curpass'], $_POST['newpass'], $_POST['email']);
		$retval = true;

		if ($retval) {
			$session->edit_graphs = true;
			//$logger->log("procEditGraphs:ref=".$session->referrer);
			//$logger->log("procEditGraphs:post=".print_r($_POST, true));

			$last_id = $_POST["last_id"];
			$last_graph_id = $_POST["last_graph_id"];
			$last_db_graph_id = $_POST["last_db_graph_id"];

			//get deleted dials
			$arrDeletedGraphIDs = array();
			$arrTmp = explode(",", trim($_POST['hidChangedIDHolder'], ','));
			foreach ($arrTmp as $id_ex) {
				if (preg_match('/^(?P<id>[-]*\d+)_(\d+)$/', $id_ex, $matches) == 1 && $matches['id'] < 0)
					$arrDeletedGraphIDs[abs($matches['id'])] = true;
			}
			//$logger->log("arrDeletedGraphIDs=".print_r($arrDeletedGraphIDs, true));

			//create new graph_lists
			$arrGraphListIDs = array();
		//$logger->log("QQQQQQQQQQQ  $last_graph_id", PEAR_LOG_DEBUG);
			for ($i = 0; $i <= $last_graph_id; $i++) {
				if (isset($_POST["graph_name_$i"])) {
					if ((strlen(trim($_POST["graph_name_$i"])) == 0) && ($i > $last_db_graph_id))
						continue;
					/*$dbres = $database->updateGraphList($session->ofid,
						$i > $last_db_graph_id ? -1 : $i,
						stripslashes($_POST["graph_name_$i"]));*/
					$dbres = $database_tar->updateGraphList(
						$i > $last_db_graph_id ? -1 : $i,
						stripslashes($_POST["graph_name_$i"]));
					if ($dbres[0]['op_result'] == 1)
						$arrGraphListIDs[$i] = $dbres[0]['out_graph_id'];
//$logger->log("QQQQQQQQQQQ $arrGraphListIDs[$i]", PEAR_LOG_DEBUG);
				}
			$id = $arrGraphListIDs[$i];
//			$logger->log("GRAPHID = $id");
			}
//			$logger->log("arrGraphListIDs=".print_r($arrGraphListIDs, true));

			//begin_trans
			//$database->transactionStart();
			
			//empty TB_GRAPHICS
			foreach ($arrGraphListIDs as $idl) {
				$database_tar->query("delete from tbgraphics where graphid=$idl");
			}

			//create graphs
			$arrGraphsPostData = array();
			for ($id = 0; $id <= $last_id; $id++) {
				for ($idl = 0; $idl <= $last_graph_id; $idl++) {
				
//$z0 = $arrGraphListIDs[$idl];
//$z1 = $_POST["daygroup_id_{$id}_{$idl}"];
//$z2 = $_POST["start_time_h_{$id}_{$idl}"] * 100 + $_POST["start_time_m_{$id}_{$idl}"];
//$z3 = $_POST["end_time_h_{$id}_{$idl}"] * 100 + $_POST["end_time_m_{$id}_{$idl}"];
//$logger->log("$id   $idl:   $z0   $z1   $z2   $z3", PEAR_LOG_DEBUG);
					if (array_key_exists($idl, $arrGraphListIDs) && isset($_POST["daygroup_id_{$id}_{$idl}"]) && !array_key_exists($id, $arrDeletedGraphIDs)) {
						$arrGraphsPostData[] = array($arrGraphListIDs[$idl],
//						$arrGraphsPostData[] = array($idl,
													$_POST["daygroup_id_{$id}_{$idl}"],
													$_POST["start_time_h_{$id}_{$idl}"] * 100 + $_POST["start_time_m_{$id}_{$idl}"],
													$_POST["end_time_h_{$id}_{$idl}"] * 100 + $_POST["end_time_m_{$id}_{$idl}"]);
					}
				}
			}
			//if (!$arrGraphsPostData || ($database->updateGraphsMultiple($session->ofid, $arrGraphsPostData)))
			//	$database->transactionCommit();
			//else
			//	$database->transactionRollback();

/*			foreach ($arrGraphsPostData as $row) {
					$z0 = $row[0];
					$z1 = $row[1];
					$z2 = $row[2];
					$z3 = $row[3];
					$logger->log("$z0   $z1   $z2   $z3", PEAR_LOG_DEBUG);
			}*/
			
//			$database_tar->updateGraphsMultiple($session->ofid, $arrGraphsPostData);
			$database_tar->updateGraphsMultiple($arrGraphsPostData);
			
			
			//end_trans
		} else {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}
		header("Location: ".$session->referrer);
	}
	
	

// ******************************************************************************************
//								pbx sip-accounts
// ******************************************************************************************

// таблица sip счетов
	function proc_pbx_user_sipaccount_full(){
		global $database_tar, $session, $logger;
	
		$q = <<<EOS
		select 
			a.status,
			c.name, 
			c.sip_id, 
			c.username,
			c.secret, 
			c.context, 
			c.host,
			c.port,
			c.type,
			c.nat,
			case when coalesce(s.ipaddr,'')='' or s.ipaddr='0.0.0.0' then 0 else 1 end as ipaddr_status,
			a.addinfo,
			
c.accountcode,
c.disallow,
c.allow,
c.allowoverlap,
c.allowsubscribe,
c.allowtransfer,
c.amaflags,
c.autoframing,
c.auth,
c.buggymwi,
c.callgroup,
c.callerid,
c.cid_number,
c.fullname,
c.calllimit,
c.callingpres,
c.canreinvite,
c.defaultip,
c.dtmfmode,
c.fromuser,
c.fromdomain,
c.fullcontact,
c.g726nonstandard,
c.insecure,
c.ipaddr,
c.language,
c.lastms,
c.mailbox,
c.maxcallbitrate,
c.mohsuggest,
c.md5secret,
c.musiconhold,
c.outboundproxy,
c.deny,
c.permit,
c.pickupgroup,
c.progressinband,
c.promiscredir,
c.qualify,
c.regexten,
c.regseconds,
c.rfc2833compensate,
c.rtptimeout,
c.rtpholdtimeout,
c.sendrpid,
c.setvar,
c.subscribecontext,
c.subscribemwi,
c.t38pt_udptl,
c.trustrpid,
c.useclientcode,
c.usereqphone,
c.videosupport,
c.vmexten,
c.busylevel,
c.callcounter,
c.transport,
coalesce(a.innersip,0) as innersip
			
		from tbsipaccounts a inner join tbsipconnections c on a.sip_id=c.sip_id 
		left join tbsipsessions s on s.sip_id=c.sip_id 
EOS;
		
		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("$q:". getPEARErrorInfo($result), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
			
				$sip_param = "'".implode("|",$row)."'"; // строка передаваемая в процедуру редактирования
			
				if($row['status'] == 0){ 
					$status_html = "<img src='./images/house_blue.PNG'>"; 
					$status_edt = 'деактивировать';
				}
				if($row['status'] == -5){ 
					$status_html = "<img src='./images/house_red.PNG'>"; 
					$status_edt = 'активировать';
				}
				if($row['ipaddr_status'] == 1){ 
					$status_html = "<img src='./images/house_green.PNG'>"; 
				}

				$tabrow[$key] = array(
					//$row['status'],
					$status_html.$row['sip_id'],
					
					empty($row['name'])?'&nbsp;':$row['name'],
					empty($row['username'])?'&nbsp;':$row['username'],
					empty($row['type'])?'&nbsp;':$row['type'],
					empty($row['host'])?'&nbsp;':$row['host'],
					empty($row['port'])?'&nbsp;':$row['port'],
					empty($row['nat'])?'&nbsp;':$row['nat'],
					
					
					'<li class="ui-state-default ui-corner-all" title="'.$status_edt.'" style="margin:1px;padding:2;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="if (confirm(\'Сменить статус SIP счета - '.$row['name'].'?\')) {frm_sip_account_act('.$sip_param.');} else {return false;}">
					<span class="ui-icon ui-icon-home" style="margin:0;"></span></li>
					
					<li class="ui-state-default ui-corner-all" title="редактировать" style="margin:1px;padding:2;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="frm_sip_account_edt('.$sip_param.')">
					<span class="ui-icon ui-icon-pencil" style="margin:0;"></span></li>
					
					<li class="ui-state-default ui-corner-all" title="удалить" style="margin:1px;padding:2;width:16px; position:relative; cursor:pointer; float: left;  list-style:none;"
					onclick="if (confirm(\'Удалить SIP аккаунт - '.$row['name'].'?\n\n Внимание! Информация по аккаунту будет удалена.\n Аккаунт будет удален из таблиц маршрутизации.\')) {frm_sip_account_del('.$row['sip_id'].');} else {return false;}">
					<span class="ui-icon ui-icon-close" style="margin:0;"></span></li>'

				);
			}
			if(empty($res)){ $tabrow[0] = array('','','','','','','','');	}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}

// шаблоны sip счетов (список)
	function proc_pbx_user_sip_template_list(){
		global $database_tar, $session, $logger;
	
		$q = <<<EOS
		select 
			c.defname, 
			c.def_id 
		from tbsipdefaults c;
EOS;

		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_user_sip_template_list($q):". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {

			foreach($res as $key => $row){
				$tabrow[$key] = array(
					$row['defname'],
					$row['def_id']
				);
			}
			if(empty($res)){$tabrow[0] = array('','');}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}
// ******************************************************************************************
//								END pbx sip-accounts
// ******************************************************************************************

// sip-аккаунты, использующие таблицу маршрутизации -----------------------------------------------------------------------
	function proc_pbx_table_sip_view(){
		global $database_tar, $session, $logger;

		$txt_tab_id = $_REQUEST['txt_tab_id'];
		
		$q = <<<EOS
		select
		c.name
		from
		tbsipaccounts a inner join tbsipconnections c on a.sip_id=c.sip_id 
		where a.siprouter_id = $txt_tab_id
		order by c.name;
EOS;

		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_pbx_table_sip_view: $q". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
				$tabrow[$key] = array(
					$row['name']
				);
			}
			if(empty($res)){ $tabrow[0] = array('');	}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
		echo json_encode($res);
	}

// меню, список сервисов ---------------------------------------------------------------------------
	function proc_pbx_menu_list(){
		global $database_dynmenu, $session, $logger;
	
		$q = <<<EOS
		select
		menu_id,
		menu_name
		from tb_menus
		order by menu_name;
EOS;
		$res = $database_dynmenu->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_pbx_menu_list: $q". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
				$param = "'".implode("|",$row)."'";
			
				$tabrow[$key] = array(
					$row['menu_id'],
					//$row['menu_name']
					$row['menu_id'].'&nbsp;&nbsp;&nbsp;'.$row['menu_name']
				);
			}
			if(empty($res)){ $tabrow[0] = array('','');	}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}
	
// pbx группы доступа к информации по сип аккаунтам ---------------------------------------------------------------------------
	function proc_pbx_accessgroup_list(){
		global $database_tar, $session, $logger;
	
		$q = <<<EOS
		select
		accessgroup_name,
		accessgroup_id 
		from tbaccessgroup;
EOS;
		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_pbx_accessgroup_list: $q". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
				$param = "'".implode("|",$row)."'";
			
				$tabrow[$key] = array(
					$row['accessgroup_name'],
					$row['accessgroup_id'],
					$param
				);
			}
			if(empty($res)){ $tabrow[0] = array('','');	}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}

// pbx сип аккаунты группы доступа ---------------------------------------------------------------------------
	function proc_pbx_sip_accessgroup(){
		global $database_tar, $session, $logger;
	
		$group_id = $_REQUEST['group_id'];
	
		$q = <<<EOS
		select
		v2.name,
		v1.sipaccess_id 
		from tbsipaccess v1 inner join tbsipconnections v2 on v1.sip_id=v2.sip_id where v1.accessgroup_id=$group_id
		order by v2.name;
EOS;
		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_pbx_sip_accessgroup: $q". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
				$param = "'".implode("|",$row)."'";
			
				$tabrow[$key] = array(
					$row['name'],
					$row['sipaccess_id']
				);
			}
			if(empty($res)){ $tabrow[0] = array('','');	}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}

	// удаление группы доступа ------------------------------------------------------------------
	function proc_pbx_accessgroup_del(){
		global $database_tar, $session, $logger;
	
		$accessgroup_id = $_REQUEST['accessgroup_id'];

		$q = <<<EOS
		delete from tbsipaccess where accessgroup_id =$accessgroup_id ;
EOS;
		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_accessgroup_del($q)". getPEARErrorInfo($result), PEAR_LOG_ERR);

		$q = <<<EOS
		delete from tbaccountaccess where accessgroup_id=$accessgroup_id;
EOS;
		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_accessgroup_del($q)". getPEARErrorInfo($result), PEAR_LOG_ERR);

		$q = <<<EOS
		delete from tbaccessgroup where accessgroup_id=$accessgroup_id;
EOS;
		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_accessgroup_del($q)". getPEARErrorInfo($result), PEAR_LOG_ERR);
			
		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}

// pbx пользователи группы доступа ---------------------------------------------------------------------------
	function proc_pbx_user_accessgroup(){
		global $database_tar, $session, $logger;
	
		$group_id = $_REQUEST['group_id'];
	
		$q = <<<EOS
		select
		login,
		accountaccess_id
		from tbaccountaccess where accessgroup_id=$group_id
		order by login;
EOS;
		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_pbx_sip_accessgroup: $q". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
				$param = "'".implode("|",$row)."'";
			
				$tabrow[$key] = array(
					$row['login'],
					$row['accountaccess_id']
				);
			}
			if(empty($res)){ $tabrow[0] = array('','');	}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}

	// добавление группы ------------------------------------------------------------------
	function proc_pbx_accessgroup_add(){
		global $database_tar, $session, $logger;
	
		$accessgroup_name = $_REQUEST['accessgroup_name'];

		$q = <<<EOS
		insert into tbaccessgroup (accessgroup_name) values ('$accessgroup_name');
EOS;

		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_accessgroup_add($q)". getPEARErrorInfo($res), PEAR_LOG_ERR);
			
		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}

	// редактирование группы ------------------------------------------------------------------
	function proc_pbx_accessgroup_edt(){
		global $database_tar, $session, $logger;
	
		$accessgroup_name = $_REQUEST['accessgroup_name'];
		$accessgroup_id = $_REQUEST['accessgroup_id'];

		$q = <<<EOS
		update tbaccessgroup set 
			accessgroup_name ='$accessgroup_name' 
		where accessgroup_id=$accessgroup_id;
EOS;
		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_accessgroup_edt($q)". getPEARErrorInfo($res), PEAR_LOG_ERR);

		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}

// список sip-аккаунтов группы, редактирование ---------------------------------------------------------------------------
	function proc_pbx_sip_accessgroup_table(){
		global $database_tar, $session, $logger;

		$accessgroup_id = $_REQUEST['accessgroup_id'];
//		if(!$path_id) {$path_id=-1;}
		
		$q = <<<EOS
        select
        c.name,
        a.sip_id,
        case when g.sip_id is null then 0 else 1 end as sipkey
        from
        tbsipaccounts a inner join tbsipconnections c on a.sip_id=c.sip_id 
        left join
        (select g.sip_id from tbsipaccess g where g.accessgroup_id = $accessgroup_id) as g
        on a.sip_id=g.sip_id
EOS;

		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_pbx_sip_accessgroup_table: $q". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
				$param = "'".implode("@@",$row)."'"; // строка передаваемая в процедуру редактирования
			
				if($row['sipkey']=='1'){ $chk='checked="checked" value="1"'; } else { $chk='  value="0"'; }

				$tabrow[$key] = array(

					$row['name'],
					'<input type="checkbox" style="margin:0;" '.$chk.' onclick="if(this.checked) this.value=1; else this.value=0; ">',
					$row['sip_id']
				);
			}
			if(empty($res)){ $tabrow[0] = array('','','','');	}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}


	
	// добавление sip аккаунтов в группу ------------------------------------------------------------------
	function proc_pbx_sip_accessgroup_add(){
		global $database_tar, $session, $logger;
	
		$txt_accessgroup_id = $_REQUEST['txt_accessgroup_id'];
		$txt_sip_list = explode('|',$_REQUEST['txt_sip_list']);
		
		if(empty($txt_accessgroup_id)) $txt_accessgroup_id = -1;
		if(empty($txt_sip_list)) $txt_sip_list = '';
		
		$q = <<<EOS
		delete from tbsipaccess where accessgroup_id = $txt_accessgroup_id;
EOS;
		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_sip_accessgroup_add($q)". getPEARErrorInfo($result), PEAR_LOG_ERR);

//		$logger->log("$q", PEAR_DEBUG);
		foreach ($txt_sip_list as $key => $value) {
		$q = <<<EOS
		insert into tbsipaccess (accessgroup_id,sip_id) values ($txt_accessgroup_id,$value)
EOS;
		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_sip_accessgroup_add($q)". getPEARErrorInfo($result), PEAR_LOG_ERR);
		}

			
		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}
	

// список пользователей группы, редактирование ---------------------------------------------------------------------------
	function proc_pbx_user_accessgroup_table(){
		global $database_tar, $session, $logger;

		$accessgroup_id = $_REQUEST['accessgroup_id'];
//		if(!$path_id) {$path_id=-1;}
		
		$q = <<<EOS
		select
		w.login,
		case when g.accountaccess_id is null then 0 else 1 end as userkey
		from
		tbaccountweb w
		left join
		(select * from tbaccountaccess g where g.accessgroup_id=$accessgroup_id) as g
		on w.login = g.login
EOS;

		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)) {
			$logger->log("proc_pbx_user_accessgroup_table: $q". getPEARErrorInfo($res), PEAR_LOG_ERR);
			return false;
		} else {
			foreach($res as $key => $row){
				$param = "'".implode("@@",$row)."'"; // строка передаваемая в процедуру редактирования
			
				if($row['userkey']=='1'){ $chk='checked="checked" value="1"'; } else { $chk='  value="0"'; }

				$tabrow[$key] = array(

					$row['login'],
					'<input type="checkbox" style="margin:0;" '.$chk.' onclick="if(this.checked) this.value=1; else this.value=0; ">'
				);
			}
			if(empty($res)){ $tabrow[0] = array('','','');	}
			$res = array('draw' => 1, 'recordsTotal' => count($res), 'recordsFiltered' => count($res), 'data' => $tabrow );
		}
	
		echo json_encode($res);
	}


	
	// добавление пользователей в группу ------------------------------------------------------------------
	function proc_pbx_user_accessgroup_add(){
		global $database_tar, $session, $logger;
	
		$txt_accessgroup_id = $_REQUEST['txt_accessgroup_id'];
		$txt_user_list = explode('|',$_REQUEST['txt_user_list']);
		
		if(empty($txt_accessgroup_id)) $txt_accessgroup_id = -1;
		if(empty($txt_user_list)) $txt_user_list = '';
		
		$q = <<<EOS
		delete from tbaccountaccess where accessgroup_id = $txt_accessgroup_id;
EOS;
		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_user_accessgroup_add($q)". getPEARErrorInfo($result), PEAR_LOG_ERR);

//		$logger->log("$q", PEAR_DEBUG);
		foreach ($txt_user_list as $key => $value) {
		$q = <<<EOS
		insert into tbaccountaccess (accessgroup_id,login) values ($txt_accessgroup_id,'$value')
EOS;
		$res = $database_tar->query($q);
		if (PEAR::isError($res))
			$logger->log("proc_pbx_user_accessgroup_add($q)". getPEARErrorInfo($result), PEAR_LOG_ERR);
		}

			
		if($res) { $jsonres = array('ok' => 'yes'); }
		echo json_encode($jsonres);
	}

	// Пользователи системы PBX (отличие - параллельно создает пользователей в ВО и в биллинге tbaccountweb)
	function procEditUserAdmin_pbx() {
		global $database, $database_tar, $session, $form, $logger;
		//$logger->log("procEditUserAdmin():".print_r($_POST, true));

		// access level control
		if(!($session->checkUserRight('right_user.php','W'))){
			$session->only_read_message=MSG_READONLY;
			header("Location: ".$session->referrer);
			exit;
		}

		$err = '';
		$rowcounter=$_POST['hidUserCounterHolder'];
		for ($i = 1; $i <= $rowcounter; $i++) {
		if($_POST['rowtype_'.abs($i)]!='view'){

			if($_POST['rowtype_'.abs($i)]!='delete'){
				$psw = $_POST['user_pass_'.abs($i)];
				$psw2 = $_POST['user_pass2_'.abs($i)];
				if ($psw.$psw2 == '<unchanged><unchanged>') $psw = null;
				elseif (($psw!='<unchanged>')&&($psw != '')&&($psw != $psw2)) {
					$psw = null;
					$err .= "* Пароль пользователя ".$_POST['user_name_'.abs($i)]." не совпадает с подтверждением.<br>";
				} elseif ($psw.$psw2 == '')
					$err .= "* Пароль пользователя ".$_POST['user_name_'.abs($i)]." не задан.<br>";
			}

			$database->modifyUserAdmin(
				addslashes(stripsiptags($_POST['user_name_'.abs($i)])),
				(int)$_POST['user_role_'.abs($i)],
				//$_POST['user_pass_'.abs($i)],
				$psw,
				(int)$_POST['user_id_'.abs($i)],
				addslashes(stripsiptags($_POST['user_mail_'.abs($i)])),
				$_POST['rowtype_'.abs($i)]
			);
			$database_tar->modifyUserAdmin(
				addslashes(stripsiptags($_POST['user_name_'.abs($i)])),
				(int)$_POST['user_role_'.abs($i)],
				//$_POST['user_pass_'.abs($i)],
				$psw,
				(int)$_POST['user_id_'.abs($i)],
				addslashes(stripsiptags($_POST['user_mail_'.abs($i)])),
				$_POST['rowtype_'.abs($i)],
				addslashes(stripsiptags($_POST['user_name_old_'.abs($i)]))
			);

		} }

		if ($err) $form->setError('admuser_table_error', $err);

		if ($form->num_errors > 0) {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}
		header("Location: ".$session->referrer);
	}

	function proc_pbx_stats() {
		global $session, $database_tar, $logger;

		//$zz = $_REQUEST['sf_sipaccount'];
		//$logger->log("$zz", PEAR_LOG_DEBUG);

		//$logger->log('proc_stats():POST' . var_export($_POST, true), PEAR_LOG_DEBUG);
		$flagsin = (isset($_POST['serv']) && is_numeric($_POST['serv'])) ? $_POST['serv'] : DB_TAR_SERVICETYPE_ALLTYPES;

		$is_newfilters = $session->updateStatFilters($flagsin);
		
		
		$page = $_POST['page'];
		if ($is_newfilters || !$page)
			$page = 1;
		$this->jsonres = array('page' => $page);
		$this->jsonres['rows'] = array();
		$this->jsonres['total'] = 0;

		if (!$database_tar->isAccountExist(DB_TAR_DEBUG ? DB_TAR_DEBUG_NUMBER : DB_TAR_FEDERAL_PREFIX . $session->ofnumber)) {
			$this->jsonres['is_invalidaccount'] = true;
			$this->int_send_array_as_json($this->jsonres);
			return true;
		}

		$totalcnt = 0;
		$totalvol = 0;
		$totalpay = 0.0;
		$report = $database_tar->get_pbx_stats($flagsin, $page, $_POST['rp'], $_POST['sortname'], $_POST['sortorder'], $_POST['qtype'], $_POST['query'],
			$totalcnt, $totalvol, $totalpay);
		if (!empty($report)) {
			$this->jsonres['total'] = $totalcnt;
			$this->jsonres['totalvol'] = $totalvol;
			$this->jsonres['totalpay'] = format_money($totalpay);
			foreach ($report as $row) {
				$serv = $row['flagsout'];
				if ($serv < 0) {
					$this->jsonres['total'] = 0;
					$this->jsonres['is_invalidaccount'] = true;
					break;
				}
				if (!is_string($row['creattime'])) {
					$this->jsonres['total']--;
					continue;
				}

				$dt = date_parse($row['creattime']);
				$createtime = sprintf("%04d.%02d.%02d %02d:%02d:%02d",
					$dt['year'], $dt['month'], $dt['day'], $dt['hour'], $dt['minute'], $dt['second']);

				$calltype = isset($row['calltype']) ? $row['calltype'] : -1;

				$record_title = '';
				if (!empty($row['recordid']))
				switch ($serv) {
					case DB_TAR_SERVICETYPE_MTR:
						$record_title = base64_encode($serv . '|' . $row['creattime'] . '|' . $row['numbera'] . ' ' . $row['numberb']);
						$this->jsonres['is_needplayer'] = true;
						break;
					case DB_TAR_SERVICETYPE_VOICE:
					case DB_TAR_SERVICETYPE_VOICE_SENT:
						$record_title = base64_encode($serv . '|' . $row['creattime'] . '|' . $row['numbera'] . ' ' . $row['numberb']);
						$this->jsonres['is_needplayer'] = true;
						break;
					case DB_TAR_SERVICETYPE_FAX:
					case DB_TAR_SERVICETYPE_FAX_SENT:
						$record_title = base64_encode($serv . '|' . $row['creattime'] . '|' . $row['numbera'] . ' ' . $row['numberb']);
						break;
				}

				$cell = array(
					json_encode_safe(array('ct' => $calltype, 'serv' => $serv, 'recid' => $row['recordid'], 'rect' => $record_title)),
					$createtime
				);
				switch ($flagsin) {
					case DB_TAR_SERVICETYPE_VOICE:
					case DB_TAR_SERVICETYPE_FAX:
						array_push($cell,
							addslashes(stripsiptags($row['numbera'])),
							format_seconds($row['realvolume']),
							format_money($row['pay']),
							addslashes($row['geographyname'])
						);
						break;
					case DB_TAR_SERVICETYPE_VOICE_SENT:
					case DB_TAR_SERVICETYPE_FAX_SENT:
						array_push($cell,
							addslashes(stripsiptags($row['numberb'])),
							format_seconds($row['realvolume']),
							format_money($row['pay']),
							addslashes($row['geographyname'])
						);
						break;
					default:
						array_push($cell,
							addslashes(stripsiptags($row['numbera'])),
							addslashes(stripsiptags($row['numberb'])),
							format_seconds($row['realvolume']),
							format_seconds($row['payablevolume']),
							format_money($row['pay']),
							addslashes($row['geographyname']),
							addslashes($row['calluri'])
						);
				}

				$this->jsonres['rows'][] = array(
					'id' => 's_' . $row['sessionid'] . '_' . $session->generateRandStr(6),
					'cell' => $cell
				);
			} //for each report row
		}

		$this->int_send_array_as_json($this->jsonres);
		return true;
	}
	
	function proc_pbx_user_sipaccount_del(){
		global $database_tar, $session, $logger;
	
		$sip_id = $_REQUEST['sip_id'];

		$q = "select * from sip_delete_account($sip_id);";
			$logger->log("$q", PEAR_LOG_ERR);
		$res = $database_tar->getQueryResultAsArray($q);
		if (PEAR::isError($res)){
			$logger->log("proc_pbx_user_sipaccount_del($q)". getPEARErrorInfo($res), PEAR_LOG_ERR);
		}
		
		$jsonres = array('ok' => 'yes');
		echo json_encode($res);
	}

	
	
}; /* class end */






$process = new Process;

?>
